#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<utility>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<climits>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<random>
using namespace std;
//#define int long long
mt19937 azino(777);
struct fenwick {
	vector<int> f;
	int n;
	void add(int i, int val) {
		for (; i < n; i |= (i + 1)) f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i) {
			ans += f[i];
		}
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
	fenwick(vector<int> a) {
		n = a.size();
		f.assign(n, 0);
		for (int i = 0; i < n; ++i) {
			add(i, a[i]);
		}
	}
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
};
void solve() {
	int a, b;
	cin >> a >> b;
	cout << a * b << '\n';
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}