#include <bits/stdc++.h>

#define ipair pair <int, int>
#define dpair pair <int, pair <int, int> >
#define npair pair <node*, node*>

#define ll long long

using namespace std;

struct node
{
    node *left = nullptr;
    node *right = nullptr;

    int pr = (rand() << 15) + rand();
    int val, sz = 1;

    node(int v) : val(v) {}
};

int get_sz(node* n)
{
    return n ? n->sz : 0;
}

void update(node* n)
{
    n->sz = get_sz(n->left) + get_sz(n->right) + 1;
}

node* merge(node* lhs, node* rhs)
{
    if (!lhs || !rhs) return lhs ? lhs : rhs;

    if (lhs->pr > rhs->pr)
    {
        lhs->right = merge(lhs->right, rhs);
        update(lhs);
        return lhs;
    } else
    {
        rhs->left = merge(lhs, rhs->left);
        update(rhs);
        return rhs;
    }
}

npair split(node* n, int val)
{
    if (!n) return {nullptr, nullptr};

    if (get_sz(n->left) + 1 <= val)
    {
        node *left, *right;
        tie(left, right) = split(n->right, val - 1 - get_sz(n->left));
        n->right = left;
        update(n);
        return {n, right};
    } else
    {
        node *left, *right;
        tie(left, right) = split(n->left, val);
        n->left = right;
        update(n);
        return {left, n};
    }
}

vector <int> seg;
vector <int> changed;

void build(int pos, int left, int right)
{
    if (left == right)
    {
        // seg[pos] = ;
    } else
    {
        int mid = (left + right) / 2;
        build(pos * 2 + 1, left, mid);
        build(pos * 2 + 2, mid + 1, right);

        // seg[pos] = ;
    }
}

void push(int pos, int left, int right)
{

}

void add(int pos, int left, int right, int bleft, int bright, int val)
{
    push(pos, left, right);

    if (bleft <= left && right <= bright)
    {

    } else if (bleft > right || left > bright)
        return;
    else
    {
        int mid = (left + right) / 2;
        add(pos * 2 + 1, left, mid, bleft, bright, val);
        add(pos * 2 + 2, mid + 1, right, bleft, bright, val);
        // seg[pos] = ;
    }
}



int rsq(int pos, int left, int right, int bleft, int bright)
{
    push(pos, left, right);

    if (bleft <= left && right <= bright)
        return seg[pos];
    else if (bleft > right || left > bright)
        return 0;
    else
    {
        int mid = (left + right) / 2;
        return rsq(pos * 2 + 1, left, mid, bleft, bright) +
               rsq(pos * 2 + 2, mid + 1, right, bleft, bright);
    }
}

int nod(int a, int b)
{
    while (a * b)
        if (a > b)
            a %= b;
        else
            b %= a;
    return a + b;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--)
    {
        ll a, b;
        cin >> a >> b;
        cout << a * b << "\n";
    }
}
