#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define P pair
typedef P<ll, ll> Pll;
typedef P<ld, ld> Pld;
typedef P<string, string> Pss;

#define all(a) a.begin(), a.end()
#define len(a) (ll)(a.size())

#define yes "YES\n"
#define no "NO\n"

struct SegmentTree{
	vector < ll > tree;
	vector < ll > a;

	SegmentTree(vector<ll> _a){
		this->tree.assign(len(_a)*4, 0);
		this->a = _a;

		build(1, 0, len(_a)-1);
	}

	void build(ll node, ll l, ll r){
		if(l == r){
			tree[node] = a[l];
			return;
		}

		ll m = (l + r) / 2;
		build(node*2, l, m);
		build(node*2+1, m+1, r);

		tree[node] = tree[node*2] + tree[node*2+1];
	}

	ll get(ll node, ll _l, ll _r, ll l, ll r){
		if(_l > r or _r < l)
			return 0;

		if(l <= _l and _r <= r)
			return tree[node];
		

		ll m = (_l + _r) / 2;
		return get(node*2, _l, m, l, r) + get(node*2+1, m+1, _r, l, r);
	}
};

void solve(){
	ll a, b;
	cin >> a >> b;
	if(a > b)
		swap(a, b);

	cout << a*b << endl;
	return;
}

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	cin >> t;
	while(t--){
		solve();
	}
	return 0;
}