#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>

//#define int long long
#define ll long long
#define ld long double
#define accuracy(x) fixed << setprecision(x)

const int INF = (int)1e9;
const long long LINF = (long long)1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1.0);

using namespace std;

void fast_io()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void file_in(string& filename)
{
    freopen(filename.c_str(), "r", stdin);
}

void file_out(string& filename)
{
    freopen(filename.c_str(), "w", stdout);
}

ld my_difftime(clock_t start, clock_t end)
{
    return (ld)(end - start) / ((ld)CLOCKS_PER_SEC / 1000);
}

void sleep(ld milliseconds)
{
    clock_t start = clock();
    for (clock_t end = clock(); my_difftime(start, end) < milliseconds; end = clock()) {}
}


signed main()
{
#ifndef LOCAL
    fast_io();
#else
    clock_t start = clock();
#endif

    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        int a, b;
        cin >> a >> b;
        cout << a * b << '\n';
    }

#ifdef LOCAL
    cerr << "TIME: " << accuracy(2) << my_difftime(start, clock()) << '\n';
#endif

}