#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	ll t, n, m;
	bool w;
	cin >> t;
	while (t--) {
		cin >> n;
		vector <ll> a(n), dis(n);
		set <ll> st;
		for (ll i = 0; i < n; i++) {
			cin >> a[i];
			if (i == 0) {
				dis[i] = 0;
			}
			else {
				dis[i] = a[i] - a[i - 1];
				st.insert(dis[i]);
			}
		}
		if (st.size() > 2) {
			cout << "-1\n";
			continue;
		}
		if (st.size() == 2 && !((*st.begin()) < 0 && (*st.rbegin()) >= 0)) {
			cout << "-1\n";
			continue;
		}
		if (st.size() == 2) {
			m = -(*st.begin()) + (*st.rbegin());
			w = false;
			for (ll i = 0; i < a.size(); i++) {
				if (a[i] >= m) {
					w = true;
				}
			}
			if (w) {
				cout << "-1\n";
				continue;
			}
			cout << m << " " << (m + a[1] - a[0]) % m << "\n";
		}
		if (st.size() <= 1) {
			cout << "0\n";
		}
	}
}