#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <cstring>
#include <immintrin.h>
#include <cstdint>
#include <iomanip>
#include <random>
#include <queue>
#include <stack>

bool test(int32_t* arr, int32_t n, int32_t m, int32_t delta) {
    if(arr[0] >= m)
	return false;
    for(int32_t i = 0; i < n - 1; i++) {
	if((arr[i] + delta) % m != arr[i + 1])
	    return false;
    }
    return true;
}

int main() {
    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0; t < num_tests; t++) {
	int32_t n;
	std::cin >> n;

	int32_t* arr = new int32_t[n];
	for(int32_t i = 0 ; i < n;  i++)
	    std::cin >> arr[i];

	if(n == 1) {
	    std::cout << 0 << "\n";
	    continue;
	}

	//what c do we have?
	int32_t c = -1, m = -1;
	for(int32_t i = 0 ; i < n - 1; i++) {
	    if(arr[i + 1] >= arr[i]) {
		c = arr[i + 1] - arr[i];
		break;
	    }
	}

	if(c == -1) {
	    m = arr[0] + 1;
	    c = m - arr[0] + arr[1];
	    if(test(arr, n, m, c))
		std::cout << 0 << "\n";
	    else
		std::cout << -1 << "\n";
	    continue;
	}

	for(int32_t i = 0; i < n - 1; i++) {
	    if(arr[i + 1] < arr[i]) {
		m = arr[i] + (c - arr[i + 1]);
		break;
	    }
	}
	if(m == -1) {
	    if(test(arr, n, 1'000'000'005, c))
		std::cout << 0 << "\n";
	    else
		std::cout << -1 << "\n";
	    continue;
	}

	if(test(arr, n, m, c))
	    std::cout << m << " " << c << "\n";
	else
	    std::cout << -1 << "\n";
    }
    return 0;
}










