#include <bits/stdc++.h>

#define ll long long
#define fi first
#define se second
#define vec vector
#define all(x) x.begin(), x.end()

using namespace std;

//#define int long long
//#define endl "\n"

struct ST{
    int sz;
    vec<int> tree, ad;
    ST (vec<int>& v) {
        sz = 1;
        while (v.size() > sz) sz *= 2;
        tree.resize(sz * 2, INT_MAX);
        ad.resize(sz * 2, 0);
        for (int i = 0; i < v.size(); ++i) {
            tree[i + sz] = v[i];
        }
        for (int i = sz - 1; i > 0; --i) {
            tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    int get_val(int id) {
        return tree[id] + ad[id];
    }
    void push(int id) {
        tree[id] += ad[id];
        ad[id * 2] += ad[id];
        ad[id * 2 + 1] += ad[id];
        ad[id] = 0;
    }
    int get_ans(int id, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq) return INT_MAX;
        if (lq <= l && r <= rq) return get_val(id);

        push(id);
        int la = get_ans(id * 2, l, (l + r) / 2, lq, rq);
        int ra = get_ans(id * 2 + 1, (l + r) / 2, r, lq, rq);
        return min(la, ra);
    }
    void add_val(int id, int l, int r, int lq, int rq, int val) {
        if (rq <= l || r <= lq) return;
        if (lq <= l && r <= rq) {ad[id] += val; return;}

        push(id);
        add_val(id * 2, l, (l + r) / 2, lq, rq, val);
        add_val(id * 2 + 1, (l + r) / 2, r, lq, rq, val);
        tree[id] = min(get_val(id * 2), get_val(id * 2 + 1));
    }
    void pr() {
        int x = 0, y = 1;
        for (int i = 1; i < tree.size(); ++i) {
            cout << "{ " << tree[i] << ' ' << ad[i] << " } ";
            x++;
            if (x == y) {
                x = 0;
                y *= 2;
                cout << endl;
            }
        }
    }
};



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        int n; cin >> n;
        vec<int> v(n);
        for (auto& it: v) cin >> it;
        int a = -1, b = -1;
        bool f = false;
        bool f2 = false;
        int mx = -1;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(mx, v[i]);
            if (f2 && v[i] != v[i + 1]) {
                f = true;
                break;
            }
            if (v[i] == v[i + 1]) {
                f2 = true;
                if (a != -1 || b != -1) {
                    f = true;
                    break;
                }
            } else if (v[i] < v[i + 1]) {
                if (a == -1) a = v[i + 1] - v[i];
                else {
                    if (a != v[i + 1] - v[i]) {
                        f = true;
                        break;
                    }
                }
            } else {
                if (b == -1) b = v[i] - v[i + 1];
                else {
                    if (b != v[i] - v[i + 1]) {
                        f = true;
                        break;
                    }
                }
            }
        }
        mx = max(mx, v.back());
        if (f) cout << -1 << endl;
        else if (a == -1 || b == -1) cout << 0 << endl;
        else if (a + b < mx) cout << -1 << endl;
        else cout << a + b << ' ' << a << endl;
    }
}
/*
8
2 3 9 0 8 5 1 3
*/







