#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

typedef long long ll;


int rem(int a, int mod) {
    if (a >= 0) return a % mod;
    else return mod + a % mod;
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, rem(a, b));
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int q = 0; q != t; ++q) {
        int n;
        cin >> n;
        vector<int> a(n);
        int max_el = 0;
        for (int& i : a) {
            cin >> i;
            max_el = max(max_el, i);
        }
        if (n == 1 || n == 2) {
            cout << 0 << endl;
            continue;
        }

        vector<int> diff(n - 2);
        bool zero = true;
        bool imposs = false;
        for (int i = 0; i != n - 2; ++i) {
            diff[i] = a[i+2] - 2 * a[i + 1] + a[i];
            if (diff[i] != 0) zero = false;
            if (abs(diff[i]) <= max_el && diff[i] != 0) imposs = true;
        }
        if (zero) {
            cout << 0 << endl;
            continue;
        }
        if (imposs) {
            cout << -1 << endl;
            continue;
        }
        int mod = 0;
        for (int d : diff) {
            mod = gcd(abs(d), mod);
        }
        if (mod <= max_el) {
            cout << -1 << endl;
            continue;
        }
        else {
            cout << mod << ' ';
            cout << rem(a[2] - a[1], mod) << endl;
        }
    }
}