#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <queue>
#include <numeric>
#include <random>
/*
#pragma GCC optimise("Ofast,O2,O3")
*/
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n;
        cin >> n;
        vector<int> A(n);
        for (int i = 0; i < n; ++i) {
            cin >> A[i];
        }
        set<int> C, delta;
        for (int i = 1; i < n; ++i) {
            if (A[i - 1] <= A[i]) {
                C.insert(A[i] - A[i - 1]);
            } else {
                delta.insert(A[i - 1] - A[i]);
            }
        }
        if (C.size() > 1 || delta.size() > 1) {
            cout << "-1\n";
            continue;
        }
        if (C.empty() || delta.empty()) {
            cout << "0\n";
            continue;
        }
        int c = *C.begin();
        int m = *delta.begin() + c;
        vector<int> B(n);
        B[0] = A[0] % m;
        for (int i = 1; i < n; ++i) {
            B[i] = (B[i - 1] + c) % m;
        }
        if (A != B) {
            cout << "-1\n";
            continue;
        }
        cout << m << " " << c << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}
