#ifdef MANSON
#define BUGO(x) cerr << #x << "->" << (x) << endl;
#define BUGOARR(a) {cerr << #a << "->{ "; for (auto i: a) cerr << i << ' '; cerr << "}" << endl;}
#else
#define BUGO(x) ;
#define BUGOARR(a) {}
#endif
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <set>
using namespace std;
using llong = long long;
ostream& operator<<(ostream& out, const pair<int, int>& p) {
    return out << '{' << p.first << ", " << p.second << '}';
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        static vector<int> a; a.resize(n);
        for (int& i: a) cin >> i;
        int eq = 0;
        for (int i = 0; i + 1 < n; ++i)
            if (a[i] == a[i + 1])
                ++eq;
        if (eq) {
            if (eq == n - 1)
                cout << "0\n";
            else
                cout << "-1\n";
            continue;
        }
        int delta = -1;
        bool ujs = false;
        for (int i = 0; i + 1 < n; ++i)
            if (a[i] < a[i + 1])
                if (delta == -1)
                    delta = a[i + 1] - a[i];
                else if (delta != a[i + 1] - a[i])
                    ujs = true;
        int m = -1;
        if (delta != -1)
        {
            for (int i = 0; i + 1 < n; ++i)
                if (a[i] > a[i + 1]) {
                    int curm = a[i] + delta - a[i + 1];
                    if (curm <= 0 || delta >= curm)
                        ujs = true;
                    if (m == -1)
                        m = curm;
                    else if (m != curm)
                        ujs = true;
                }
            if (m != -1)
                for (int i = 0; i < n; ++i)
                    if (a[i] >= m)
                        ujs = true;
        }
        else
        {
            set<int> diff;
            for (int i = 0; i + 1 < n; ++i)
                diff.insert(a[i + 1] - a[i]);
            if (diff.size() > 1)
                cout << "-1\n";
            else
                cout << "0\n";
            continue;
        }
        if (ujs) {
            cout << "-1\n";
            continue;
        }
        if (m == -1)
            cout << "0\n";
        else
            cout << m << ' ' << delta << '\n';
    }
}
