#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<ll, ll>
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)

const ll INF = 2e9;
const ll inf = 2e18;
const ll MAXN = 2e5;

istream& operator >>(istream &in, pii x) {
    in >> x.first >> x.second;
    return in;
}

template <class T>
istream& operator >>(istream &in, vector<T> &a) {
    for (T &i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> a) {
    for (T i : a) {
        out << i << " ";
    }
    out << "\n";
    return out;
}

void solve() {
    ll delta = -1, c = -1;
    ll n; cin >> n;
    vi a(n); cin >> a;
    for (ll i = 0; i < n - 1; ++i) {
        if (a[i + 1] >= a[i] && c == -1) c = a[i + 1] - a[i];
        else if (a[i + 1] >= a[i] && c != a[i + 1] - a[i]) {
            cout << "-1\n";
            return;
        }
        if (a[i + 1] < a[i] && delta == -1) delta = a[i] - a[i + 1];
        else if (a[i + 1] < a[i] && delta != a[i] - a[i + 1]) {
            cout << "-1\n";
            return;
        } 
    }
    if (c != -1 && delta != -1) {
        for (ll i = 0; i < n; ++i) {
            if (a[i] >= delta + c) {
                cout << "-1\n";
                return;
            }
        }
        cout << delta + c << " " << c << "\n";
        return;
    }
    cout << "0\n";
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif

    ll t; cin >> t;
    while (t--)
    solve();

    return 0;
}