#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()
#define rall(a) a.rebgin(), a.rend()
#define SOLVE int t; cin >> t; while (t--) solve();
#define int long long
#define max(a, b) (a > b ? a : b)
#define min(a, b) (a < b ? a : b)

using namespace std;

void print(vector<int> &a) {
    for (int i : a)
        cout << i << ' ';
    cout << '\n';
}

void print(vector<pair<int, int>> &a) {
    for (auto i : a)
        cout << i.first << ':' << i.second << ' ';
    cout << '\n';
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int c = -1;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] <= a[i + 1]) {
            if (c == -1)
                c = a[i + 1] - a[i];
            else {
                if (a[i + 1] - a[i] != c) {
                    cout << -1 << '\n';
                    return;
                }
            }
        }
    }
    int d = -1;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i + 1] < a[i]) {
            if (d == -1)
                d = a[i] - a[i + 1];
            else {
                if (d != a[i] - a[i + 1]) {
                    cout << -1 << '\n';
                    return;
                }
            }
        }
    }
    if (d == -1 || c == -1) {
        cout << 0 << '\n';
        return;
    }
    int m = d + c;
    for (int i = 0; i < n; ++i) {
        if (a[i] >= m) {
            cout << -1 << '\n';
            return;
        }
    }
    cout << d + c << ' ' << c << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    SOLVE
}
