#pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,sse4")
// #pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long
#define ull unsigned long long
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a).begin(), (a).end()
#define gsz(a) ((int)(a).size())
#define orset tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
// #define LOCAL
#ifdef LOCAL
#define dbg(x) cerr << #x << ": " << (x) << endl
#define print(x) cerr << (x) << endl
#else
#define dbg(x) 0
#define print(x) 0
#endif

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e6 + 10;
const int inf = 1e18 + 10;
const int mod = 1e9 + 7;

int t;
int n;
int a[N];

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> t;

	while(t--)
	{
		cin >> n;

		bool alleq = true;

		for(int i = 0; i < n; ++i)
		{
			cin >> a[i];

			if(i && a[i] != a[i - 1])
				alleq = false;
		}

		if(n == 1 || alleq)
		{
			cout << 0 << endl;
			continue;
		}

		int c = -1;

		for(int i = 1; i < n; ++i)
			if(a[i] - a[i - 1] >= 0)
				c = a[i] - a[i - 1];

		if(c == -1)
		{
			int d = a[1] - a[0];
			bool ok = true;

			for(int i = 1; i < n; ++i)
				if(a[i] - a[i - 1] != d)
					ok = false;

			if(ok)
				cout << 0 << endl;
			else
				cout << -1 << endl;
		}
		else
		{
			int m = -1;
			bool ok = true;

			for(int i = 1; i < n; ++i)
				if(a[i] - a[i - 1] < 0)
				{
					m = (a[i - 1] - a[i]) + c;
				}
				else
				{
					if(a[i - 1] + c != a[i])
						ok = false;
				}

			if(m != -1)
			{
				if(c >= m || m <= a[0])
					ok = false;

				for(int i = 0; i + 1 < n; ++i)
					if((a[i] + c) % m != a[i + 1])
						ok = false;
			}

			if(!ok)
			{
				cout << -1 << endl;
				continue;
			}

			if(m == -1)
				cout << 0 << endl;
			else
				cout << m << " " << c << endl;
		}
	}
}

// (a1 + c) % m = a2
// (a2 + c) % m = a3
// a1 + c - m = a2
// a2 + c - m = a3
// c = a2 - a1 + m
// a1 - a2 = a2 - a3

// m = a1 + c - a2


