#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef pair<int, int> pii;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define all(x) (x).begin(), (x).end()
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - x.begin())

const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ll INFLL = 1e18;

ll inq(ll x, ll y)
{
    if (y == 0) return 1;
    ll l = inq(x, y / 2);
    l = l * l % MOD;
    if (y % 2) l = l * x % MOD;
    return l;
}

void solve()
{
    int n;
    cin >> n;
    vi a(n);
    forn(i, n) cin >> a[i];

    if (n == 1)
    {
        cout << 0 << "\n";
        return;
    }

    set<int> pd, nd;
    int cnt = 0;
    for (int i = 0; i + 1 < n; i++)
    {
        if (a[i + 1] > a[i])
        {
            pd.insert(a[i + 1] - a[i]);
        }
        if (a[i + 1] < a[i])
        {
            nd.insert(a[i + 1] - a[i]);
        }
        if (a[i + 1] == a[i]) cnt++;
    }
    if (pd.size() > 1 || nd.size() > 1)
    {
        cout << -1 << "\n";
        return;
    }
    if (cnt == n - 1)
    {
        cout << 0 << "\n";
        return;
    }
    if (cnt > 0)
    {
        cout << -1 << "\n";
        return;
    }
    if (pd.size() == 0 || nd.size() == 0)
    {
        cout << 0 << "\n";
        return;
    }
    int x = a[0];
    int m = *pd.begin() - *nd.begin();
    int d = *pd.begin();
    for (int i = 0; i < n; i++)
    {
        x = x % m;
        if (a[i] != x)
        {
            cout << -1 << "\n";
            return;
        }
        x = (x + d) % m;
    }
    cout << m << " " << d << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    cout << "\n";
    while (t--)
    {
        solve();
    }
}
