#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define int int32_t
#define ll int64_t

#define uint uint32_t
#define ull uint64_t

#define many_tests

void ios() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> a(n);
    int max = 0;
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        max = std::max(max, a[i]);
    }
    std::set<int> d;
    for (int i = 0; i + 1 < n; ++i) {
        d.insert(a[i + 1] - a[i]);
    }
    if (d.size() <= 1) {
        std::cout << 0 << '\n';
    } else if (d.size() > 2 || *d.begin() >= 0 || *(--d.end()) <= 0 || *(--d.end()) - *d.begin() <= max) {
        std::cout << -1 << '\n';
    } else {
        std::cout << *(--d.end()) - *d.begin() << ' ' << *(--d.end()) << '\n';
    }

}

int main() {
#ifdef many_tests
    int ttt;
    std::cin >> ttt;
    while (ttt-- > 0) {
        solve();
    }
#else
    solve();
#endif
    return 0;
}