#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vii = vector<int>;
using vll = vector<ll>;

const ll INF = 1e18;
const int N = 2e5 + 5;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

ll a[N];

void solve() {
   int n; cin >> n;
   set<int> difs;
   for (int i = 0; i < n; ++i) cin >> a[i];
   ll max_m = 0;
   for (int i = 0; i < n; ++i)
       max_m = max(a[i], max_m);
   for (int i = 0; i < n - 1; ++i)
       difs.insert(a[i + 1] - a[i]);

   if (difs.size() >= 3) {
       cout << -1 << '\n';
   }
   else if (difs.size() == 2) {
       ll a1 = *difs.begin(), b1 = *(next(difs.begin()));
       if ((a1 > 0 && b1 > 0) || (a1 < 0 && b1 < 0)) {
           cout << -1 << '\n';
       }
       else {
           ll m = abs(a1) + abs(b1);
           if (max_m >= m || a[0] >= m) {
               cout << -1 << '\n';
           }
           else {
               ll c = max(a1, b1);
               for (int i = 1; i < n; ++i) {
                   if (a[i] != (a[i - 1] + c) % m) {
                       cout << -1 << '\n';
                       return;
                   }
               }
               cout << m << " " << c << '\n';
           }
       }
   }
   else {
       cout << 0 << '\n';
   }
}

int main() {
    optimize();

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }

    return 0;
}