#include <bits/stdc++.h>

using namespace std;

#define int long long
#define fi first
#define se second

const int maxn = 2e5 + 5;
const int MOD = 1e9 + 7;
const int inf = 1e18;

struct node {
    int l = -1, r = -1;
    int mn = inf;
};

int n;
vector<int> a;
int pt = 0;
node tree[maxn];

int build(int l, int r) {
    if (l == r - 1) {
        node A;
        A.mn = a[l];
        tree[pt] = A;
        pt++;
        return pt - 1;
    }
    node A;
    int m = (l + r) / 2;
    A.l = build(l, m);
    A.r = build(m, r);
    A.mn = min(tree[A.l].mn, tree[A.r].mn);
    tree[pt] = A;
    pt++;
    return pt - 1;
}

int get(int root, int l, int r, int ql, int qr) {
    if (ql <= l && qr >= r) {
        return tree[root].mn;
    }
    int m = (l + r) / 2;
    int r1 = inf, r2 = inf;
    if (ql < m) {
        r1 = get(tree[root].l, l, m, ql, min(m, qr));
    }
    if (qr > m) {
        r2 = get(tree[root].r, m, r, max(ql, m), qr);
    }
    return min(r1, r2);
}




signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> s(n);
        for (int i = 0; i < n; ++i) {
            cin >> s[i];
        }
        if (n == 1) {
            cout << "0\n";
            continue;
        }
        bool fl = 1;
        bool rav = 0;
        for (int i = 1; i < n; ++i) {
            if (s[i] != s[i - 1]) {
                fl = false;
            } else {
                rav = 1;
            }
        }
        if (rav) {
            if (fl) {
                cout << "0\n";
                continue;
            } else {
                cout << "-1\n";
                continue;
            }
        }
        int dl = -1;
        fl = true;
        bool um = 0, uv = 0;
        for (int i = 1; i < n; ++i) {
            if (s[i] > s[i - 1]) {
                uv = 1;
                if (dl == -1) {
                    dl = s[i] - s[i - 1];
                } else {
                    if (dl != s[i] - s[i - 1]) {
                        fl = false;
                        break;
                    }
                }
            } else {
                um = 1;
            }
        }
        if (!fl) {
            cout << "-1\n";
            continue;
        }
        if (!um) {
            cout << "0\n";
            continue;
        }
        if (!uv) {
            int dl2 = s[0] - s[1];
            fl = 1;
            for (int i = 1; i < n; ++i) {
                if (s[i - 1] - s[i] != dl2) {
                    fl = false;
                    break;
                }
            }
            if (!fl) {
                cout << "-1\n";
                continue;
            } else {
                cout << "0\n";
                continue;
            }
        } else {
            int c;
            for (int i = 1; i < n; ++i) {
                if (s[i] > s[i - 1]) {
                    c = s[i] - s[i - 1];
                    break;
                }
            }
            int st = s[0];
            int now = st;
            int m;
            for (int i = 1; i < n; ++i) {
                if (s[i] < s[i - 1]) {
                    m = s[i - 1] + c - s[i];
                    break;
                }
            }
            if (m <= st) {
                cout << "-1\n";
                continue;
            }
            fl = 1;
            for (int i = 1; i < n; ++i) {
                now = (now + c) % m;
                if (now != s[i]) {
                    fl = false;
                    break;
                }
            }
            if (fl) {
                cout << m << " " << c << "\n";
            } else {
                cout << "-1\n";
            }
        }
    }
}

