#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <queue>

using namespace std;

void resolve()
{
	int n;
	cin >> n;
	vector<long long> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int q = 0;
	for (int i = 1; i < n; i++)
		q += v[i] == v[i - 1];
	if (q == n - 1)
	{
		cout << 0;
		return;
	}
	if (q > 0)
	{
		cout << -1;
		return;
	}
	int c = -1, m = -1;
	for (int i = 1; i < n; i++)
	{
		if (v[i] > v[i - 1])
		{
			if (c != -1 && c != v[i] - v[i - 1])
			{
				cout << -1;
				return;
			}
			c = v[i] - v[i - 1];
		}
	}
	vector<int> k;
	for (int i = 1; i < n; i++)
		if (v[i] < v[i - 1])
		{
			if (m != -1 && v[i - 1] + c - v[i] != m)
			{
				cout << -1;
				return;
			}
			m = v[i - 1] + c - v[i];
		}
	if (c == -1 || m == -1)
	{
		cout << 0;
		return;
	}
	for (int i = 0; i < n; i++)
	{
		if (v[i] >= m)
		{
			cout << -1;
			return;
		}
	}
	cout << m << ' ' << c;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		resolve();
		cout << '\n';
	}
}