#include <bits/stdc++.h>

using namespace std;

#define int long long
#define f first
#define s second
#define ld long double
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define forn(i, n) for(long long i = 0; i < (long long) n; i++)
#define coutall(data) for(auto i : data) cout << i << " "; cout << "\n";
const ld EPS = 0.000001;
const int MOD = 1e9 + 7;
const int INF = 1e18;
const int MAXPOWER = 63;
const int MAXVALUE = 9223372036854775807LL;
const int MAXN = 2e5;

mt19937 rnd(time(nullptr));

std::pair<int,int> operator+(const std::pair<int, int>& x, const std::pair<int, int>& y) {
    return std::make_pair(x.first+y.first, x.second+y.second);
}
std::pair<int,int> operator-(const std::pair<int, int>& x, const std::pair<int, int>& y) {
    return std::make_pair(x.first-y.first, x.second-y.second);
}

int binpow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 1) {
        return (((binpow(a, n - 1) % MOD) * a) % MOD);
    } else {
        int b = (binpow(a, n / 2) % MOD);
        return ((b * b) % MOD);
    }
}

void speed_up() {
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(8);
}

signed main() {
    speed_up();
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector <int> a(n);
        for (int i = 0 ; i <n; i++) cin >> a[i];
        int c = -1, mc = -1;
        bool broken = false;
        for (int i = 0; i < n - 1; i++) {
            if (a[i + 1] >= a[i]) {
                if (c == -1) {
                    c = a[i + 1] - a[i];
                } else if (a[i + 1] - a[i] != c) {
                    broken = true;
                    break;
                }
            } else {
                if (mc == -1) {
                    mc = a[i] - a[i + 1];
                } else if (a[i] - a[i + 1] != mc) {
                    broken = true;
                    break;
                }
            }
        }
        if (broken) {
            cout << "-1\n";
            continue;
        }
        if (mc == -1 || c == -1) {
            cout << "0\n";
        } else {
            bool flag = true;
            int m = mc + c;
            for (int i = 0; i < n; i++) {
                if (a[i] >= m) {
                    flag = false;
                }
            }
            if (flag)
                cout << m << " " << c << "\n";
            else
                cout << "-1\n";
        }
    }
}
