#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

long long gcd(long long a, long long b) {
  while (b != 0) {
    a %= b;
    swap(a, b);
  }
  return a;
}

int main(){
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int t;
  cin >> t;
  while (t--) {
    int n;
    cin >> n;
    vector<long long> A(n);
    for (int i = 0; i < n; ++i)
      cin >> A[i];
    if (n <= 2) {
      cout << 0 << '\n';
      continue;
    }
    long long mn = 0;
    for (int i = 0; i < n; ++i)
      mn = max(mn, A[i]);
    vector<long long> B(n - 1);
    for (int i = 0; i + 1 < n; ++i)
      B[i] = A[i + 1] - A[i];
    long long kek = 0;
    for (int i = 1; i < B.size(); ++i)
      kek = gcd(kek, abs(B[i] - B[i - 1]));
    if (kek == 0)
      cout << 0 << '\n';
    else if (kek > mn) {
      cout << kek << ' ';
      cout << (A[1] - A[0] + kek) % kek << '\n';
    } else {
      cout << -1 << '\n';
    }
  }
  return 0;
}
