#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <random>


#define speed ios_base::sync_with_stdio(0);
#pragma warning(disable:4996)
#define ll long long

using namespace std;
mt19937_64 rnd(228);

int main() {

	speed;

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int t;
	cin >> t;
	for (int test = 0; test < t; test++) {
		int n;
		cin >> n;
		vector <ll> a(n);
		for (int i = 0; i < n; i++)
			cin >> a[i];
		set <ll> c_up;
		set <ll> c_down;

		for (int i = 1; i < n; i++) {
			if (a[i] >= a[i - 1])
				c_up.insert(a[i] - a[i - 1]);
			else
				c_down.insert(a[i - 1] - a[i]);
		}

		if (c_up.size() + c_down.size() <= 1) {
			cout << 0 << '\n';
			continue;
		}
		
		if (c_up.size() > 1 || c_down.size() > 1) {
			cout << -1 << '\n';
			continue;
		}

		if (c_up.size() == 1 && c_down.size() == 1) {
			ll c1 = *(c_up.begin()), c2 = *(c_down.begin());
			ll m = c1 + c2, c = c1;
			bool f = true;
			for (int i = 0; i < n; i++)
				if (m <= a[i])
					f = false;
			if (f)
				cout << m << ' ' << c << '\n';
			else
				cout << -1 << '\n';
			continue;
		}


	}

	return 0;
}
