#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <time.h>
#include <math.h>
#include <fstream>
#define all(x) x.begin(), x.end()
#define make_pair mp
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 7, N = 3e5 + 6;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }


ll n, m, k, t;





void solve()
{
	cin >> n;
	vector<ll> arr(n);

	ll maxi = 0;

	set<int> minus, plus;

	bool zero = false;

	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		maxi = max(maxi, arr[i]);
		if (i) {
			if (arr[i] - arr[i - 1] < 0) {
				minus.insert(arr[i] - arr[i - 1]);
			}
			if (arr[i] - arr[i - 1] > 0) {
				plus.insert(arr[i] - arr[i - 1]);
			}
			if (arr[i] - arr[i - 1] == 0) {
				zero = true;
			}
		}
	}

	if (n == 1) {
		cout << 0 << '\n';
		return;
	}

	if ((zero && (plus.size() || minus.size())) ||  plus.size() > 1 || minus.size() > 1) {
		cout << -1 << '\n';
		return;
	}

	int num = 0;
	if (zero) {
		num++;
	}
	if (plus.size()) {
		num++;
	}
	if (minus.size()) {
		num++;
	}

	if (num == 1) {
		cout << 0 << '\n';
		return;
	}

	ll ans = *plus.begin() - *minus.begin();

	if (!zero && plus.size() == 1 && minus.size() == 1 && ans > maxi) {
		cout << ans << " " << *plus.begin() << '\n';
	}
	else {
		cout << -1 <<'\n';
	}
	return;

}




signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(NULL), cout.tie(NULL);
	

	cin >> t;
	while (t--) {
		solve();
	}


}

