#include <iostream>
using namespace std;
using ll = long long;

const ll MAXN = 1e5 + 123;
ll a[MAXN];

ll mmod(ll a, ll m){
	return (m + (a % m)) % m;
}

ll gcd(ll a, ll b){
	if(!b)
		return a;
	return gcd(b, a % b);
}

ll lca(ll a, ll b){
	return a * b / gcd(a, b);
}

void solve(){
	ll n;
	cin >> n;
	for(ll i = 0; i < n; i++)
		cin >> a[i];
	ll maxdiv = 0;
	ll minm = 0;
	for(ll i = 0; i < n; i++){
		minm = max(minm, a[i] + 1);
	}
	for(ll i = 0; i + 2 < n; i++){
		maxdiv = gcd(maxdiv, abs(a[i] + a[i + 2] - 2 * a[i + 1]));
	}
	if(maxdiv == 0){
		cout << 0;
		return;
	}
	if(maxdiv < minm){
		cout << -1;
	} else {
		ll c = mmod(a[1] - a[0], maxdiv);
		while(c < 0)
			c += maxdiv;
		cout << maxdiv << ' ' << mmod(a[1] - a[0], maxdiv);
	}
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll t;
	cin >> t;
	while(t--){
		solve();
		cout << '\n';
	}
}
