#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll bpow(ll a, ll p, ll md) {
	if (p == 0) return 1ll;
	if (p % 2) return (bpow(a, p - 1, md) * a) % md;
	ll b = bpow(a, p / 2, md);
	return (b * b) % md;
}

const ll SZ = 2e5 + 100, MOD = 1e9 + 7, INF = 1e9 * 1e9 + 100;



int main() {
	fastInp;

	ll a, b;
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<ll> vec(n);

		for (auto& c : vec) cin >> c;

		ll dif = 0, ind = -1, m = -1;
		bool f = 1, f2 = 1;
		vector<ll> difs;
		ll c = vec[1] - vec[0];

		for (int i = 0; i < n - 1; i++) {
			if (vec[i + 1] - vec[i] != c) f2 = 0;
		}
		
		if (f2) {
			cout << "0\n";
			continue;
		}

		pair<ll, ll> dif1 = { -1, -1 };
		for (int i = 1; i < n; i++) {
			if (vec[i] - vec[i - 1] < 0) {
				if (dif1.first != -1 && dif1.first != vec[i] - vec[i - 1]) f = 0;
				dif1.first = vec[i] - vec[i - 1];
			}
			else {
				if (dif1.second != -1 && dif1.second != vec[i] - vec[i - 1]) f = 0;
				dif1.second = vec[i] - vec[i - 1];
			}
		}

		ll md = abs(dif1.first) + abs(dif1.second);

		for (int i = 0; i < n; i++) {
			if (md <= vec[i]) f = 0;
		}
		if (f) {
			cout << md << " " << dif1.second << "\n";
		}
		else {
			cout << "-1\n";
		}
	}

	return 0;
}