#include <bits/stdc++.h>

#define endl '\n'
#define pb push_back
#define fi first
#define se second
#define ll long long int
#define pll pair<ll, ll>
#define all(v) v.begin(), v.end()

using namespace std;

ostream& operator<< (ostream& a, const vector<ll>& v) {
  for (ll x : v) cout << x << " ";
  cout << '\n';
  return a;
}

ostream& operator<< (ostream& a, const pll& v) {
  cout << "{ " << v.fi << ", " << v.se << " }" << '\n';
  return a;
}

ostream& operator<< (ostream& a, const vector<pll>& v) {
  for (pll x : v) cout << x << " ";
  cout << '\n';
  return a;
}

#ifdef HOME
  #define dbg(x) cout << #x << " :: " << x;
#else
  #define dbg(x)
#endif

mt19937 rnd(clock() + 228);

const ll INF = (ll)1e18;
const ll mod = 1000 * 1000 * 1000 + 7;
const ll maxn = (ll)2e5 + 10, L = 22;

int main() {
#ifdef HOME
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
  ll T = 1;
  cin >> T;
  while (T--) {
    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
      cin >> a[i];
    }
    bool x = 1, y = 1;
    for (ll i = 1; i < n; ++i) {
      if (a[i - 1] > a[i])
        x = 0;
      else if (a[i - 1] < a[i])
        y = 0;
    }
    bool ok = 1;
    ll mx = 0;
    //map<ll, ll> led, red;
    set<ll> led, red;
    for (ll i = 0; i < n; ++i) {
       mx = max(mx, a[i]);
       /*if (i < n - 1 && (led[a[i]] && led[a[i]] != a[i + 1]))
         ok = 0;
       if (i && (red[a[i]] && red[a[i]] != a[i - 1]))
         ok = 0;
       if (i < n - 1)
          led[a[i]] = a[i + 1]; 
       if (i)
         red[a[i]] = a[i - 1];*/
       if (i < n - 1)
         led.insert(a[i] - a[i + 1]);
    }
    if (led.size() > 2 || (led.size() == 2 && (x || y))) {
      cout << "-1\n";
      continue;
    }
    if (x || y) {
      cout << "0\n";
      continue;
    }
    ll m, c;
    m = c = -1;
    ll t1, t2;
    for (ll i = 0; i + 1 < n; ++i) {
      if (a[i + 1] > a[i]) {
        c = a[i + 1] - a[i];
      } else if (a[i + 1] < a[i]) {
        t1 = a[i];
        t2 = a[i + 1];
      }
    }
    m = t1 - t2 + c;
    if (mx < m) {
      vector<ll> b(n);
      b[0] = a[0];
      for (ll i = 1; i < n; ++i) {
        b[i] = (b[i - 1] + c) % m;
      }
      if (b == a)
        cout << m << " " << c << endl;
      else
        cout << "-1\n";
    }
    else
      cout << -1 << endl;
  }
  return 0;
}

















































