#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long ll;
typedef long double ld;

using namespace std;

void solve() {
	ll n, delta = -1, max_ = 0;
	cin >> n;
	vector<ll> a(n);
	for(int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<ll> possible;
	for(int i = 0; i < n; ++i) {
		if(i > 0 && a[i] > a[i - 1]) {
			if(delta == -1)
				delta = a[i] - a[i - 1]; // c
			if(delta != a[i] - a[i - 1]) {
				cout << -1;
				return;
			}
		}
		else if(i > 0) {
			possible.push_back(a[i] - a[i - 1]); // c - m
		}
		max_ = max(max_, a[i]);
	}

	for(int i = 1; i < possible.size(); ++i) {
		if(possible[i] != possible[i - 1]) {
			cout << -1;
			return;
		}
	}
	if(delta == -1 || possible.size() == 0)  {
		cout << 0;
		return;
	}
	if(delta - possible[0] <= max_)
		cout << -1;
	else
		cout << delta - possible[0] << ' ' << delta;
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while(t--) {
		solve();
		cout << '\n';
	}
	return 0;
}