﻿#include <iostream>
#include <iomanip>
#include <string>
#include <deque>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <assert.h>
#include <bitset>
#include <queue>
#include <stack>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;
using ul = unsigned long long;

#define print(h) for (auto ijkl:h) cout << ijkl << " "; cout << "\n";
#define ve vector
#define vll ve <ll> 

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vll a(n);
        ll ma = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            ma = max(ma, a[i]);
        }
        ll c = a[1] - a[0];
        ll ans = 0;
        bool f = false;
        for (int i = 1; i < n; ++i) {
            ll k = a[i] - (a[i - 1] + c);
            if (k < 0) {
                k *= -1;
            }
            ans = gcd(ans, k);
        }
        if (ans == 0) {
            cout << 0 << "\n";
        }
        else {
            if (ans <= ma) {
                cout << -1 << "\n";
            }
            else {
                if (c < 0) {
                    c += ans;
                }
                cout << ans << " " << c << "\n";
            }
        }
    }

    return 0;
}
