#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<fstream>
#include<algorithm>
#include<math.h>
#include<cmath>
#include<vector>
#include<set>
#include<queue>
#include<map>
#include<string>

#define int long long
#define ll long long
#define ld long double
#define pii pair<int,int>
#define endl '\n'
#define range(i,n) for(int i=0;i<n;i++)
#define BE(v) v.begin(), v.end()
#define cint(a) int a; cin>>a;

using namespace std;

int maxeq(int& a, int b)
{
	a = max(a, b);
	return a;
}

int mineq(int& a, int b)
{
	a = min(a, b);
	return a;
}

pii operator+=(pii& a, pii b)
{
	a.first += b.first;
	a.second += b.second;
	return a;
}

pii operator+(pii a, pii b)
{
	return a += b;
}

pii operator-=(pii& a, pii b)
{
	a.first -= b.first;
	a.second -= b.second;
	return a;
}

pii operator-(pii a, pii b)
{
	return a -= b;
}

int gcd(int a, int b)
{
	while (b != 0)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}

const int bes = 2e9;
const int N = 2e5;
const ll mod = 1e9 + 7;

int a[N];
int ch[N];

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cint(t);
	while (t--)
	{
		cint(n);
		range(i, n)
		{
			cin >> a[i];
		}
		if (n == 1)
		{
			cout << 0 << endl;
			continue;
		}
		int s = a[0];
		int c = a[1] - a[0];
		int m = 0;
		int b = s;
		for (int i = 1; i < n; i++)
		{
			b += c;
			m = gcd(m, abs(a[i] - b));
		}
		if (m == 0)
		{
			cout << 0 << endl;
			continue;
		}
		c = (c%m + m) % m;
		bool ok = true;
		ch[0] = s % m;
		if (ch[0] != a[0])
		{
			ok = false;
		}
		for (int i = 1; i < n; i++)
		{
			ch[i] = (ch[i - 1] + c) % m;
			if (ch[i] != a[i])
			{
				ok = false;
			}
		}
		if (ok)
		{
			cout << m << " " << c << endl;
		}
		else
		{
			cout << -1 << endl;
		}
	}
}