#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;
#define int long long

int binpow(int a, int n){
    if (n == 0) return 1;
    if (n%2 == 0){
        int b = binpow(a, n/2);
        return b*b;
    }
    return a*binpow(a, n-1);
}

int gcd(int a, int b){
    if (b == 0) return a;
    return gcd(b, a%b);
}

tuple<int, int, int> gcdex(int a, int b){
    if (b == 0) return {a, 1, 0};
    int x, y, g;
    tie(g, x, y) = gcdex(b, a%b);
    return {g, y, x-(a/b)*y};
}

int32_t main(){
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--){
        int n, diff = -1, _diff = 1, lol = -1;
        cin >> n;
        bool ok = true;
        vector<int> a(n);
        for (int i = 0; i < n; ++i){
            cin >> a[i];
            if (i != 0){
                if (a[i]-a[i-1] >= 0){
                    if (diff == -1) diff = a[i]-a[i-1];
                    else if (diff != a[i]-a[i-1]) ok = false;
                }else{
                    lol = i;
                    if (_diff == 1) _diff = a[i]-a[i-1];
                    else if (_diff != a[i]-a[i-1]) ok = false;
                }
            }
        }
        if (!ok){
            cout << -1 << '\n';
            continue;
        }
        if (diff == -1 || _diff == 1){
            cout << 0 << '\n';
            continue;
        }
        int m = (a[lol-1]+diff)-a[lol];
        if (a[0] >= m) ok = false;
        for (int i = 1; i < n; ++i){
            if (a[i] >= m || (a[i-1]+diff)%m != a[i]){
                ok = false;
                break;
            }
        }
        if (ok){
            cout << m << ' ' << diff << '\n';
        }else{
            cout << -1 << '\n';
        }
    }
    return 0;
}