#include <iostream>
#include <bits/stdc++.h>

using namespace std;

vector <int> dijkstra(vector <vector <pair <int, int>>>& g, int start){
    vector <int> d(g.size() + 1, 1000000000);
    d[start] = 0;
    set <pair <int, int>> s;
    s.insert(make_pair(0, start));
    while (!s.empty()){
        int len = s.begin()->first;
        int u = s.begin()->second;
        s.erase(s.begin());
        for (auto v: g[u]){
            if (len + v.second < d[v.first]){
                s.erase(make_pair(d[v.first], v.first));
                d[v.first] = len + v.second;
                s.insert(make_pair(d[v.first], v.first));
            }
        }
    }
    return d;
}


main(){
    int t, n, s, c, m;
    cin >> t;
    for (; t > 0; --t){
        cin >> n;
        m = -1; c = -1;
        bool possible = true;
        vector <int> v(n);
        for (int i = 0; i < n; ++i) {
            cin >> v[i];
            if (i != 0){
                if (v[i] - v[i - 1] >= 0) {
                    if (c == -1) c = v[i] - v[i - 1];
                    else {
                        if (v[i] - v[i - 1] != c){
                            possible = false;
                        }
                    }
                }
            }
        }
        if (n == 1) cout << "0\n";
        else {
            s = v[0];
            if (c == -1){
                for (int i = 1; i < n; ++i){
                    if (v[i] - v[i - 1] != v[1] - v[0]){
                        possible = false;
                        break;
                    }
                }
                c = v[1] - v[0];
            }
            else {
                for (int i = 1; i < n; ++i){
                    if (v[i] - v[i - 1] >= 0 && v[i] - v[i - 1] != c){
                        possible = false;
                        break;
                    }
                    else if (v[i] - v[i - 1] < 0){
                        if (m == -1) m = abs(v[i] - v[i - 1]) + c;
                        else {
                            if (abs(v[i] - v[i - 1]) + c != m){
                                possible = false;
                                break;
                            }
                        }
                    }
                }
            }
            if (m != -1) {
                for (int i = 0; i < n; ++i){
                    if (v[i] >= m){
                        possible = false;
                        break;
                    }
                }
            }
            if (!possible) cout << "-1\n";
            else {
                if (m == -1) cout << "0\n";
                else {cout << m << " " << c << "\n";}
            }
        }
    }
}