#include <bits/stdc++.h>

using namespace std;

void solve() {
  int n;
  cin >> n;
  vector<int> a(n);
  for (auto &e : a)
    cin >> e;
  if (n == 1) {
    cout << 0 << '\n';
    return;
  }
  map<int, int> go_after;
  go_after[a[0]] = a[1];
  for (int i = 1; i < n; i++) {
    if (go_after.count(a[i - 1])) {
      if (a[i] != go_after[a[i - 1]]) {
        cout << -1 << '\n';
        return;
      }
    } else {
      go_after[a[i - 1]] = a[i];
    }
  }

  int c_up = -1;
  int c_down = -1;
  for (int i = 0; i < n - 1; i++) {
    if (a[i] < a[i + 1]) {
      if (c_up == -1) {
        c_up = a[i + 1] - a[i];
      } else if (a[i] + c_up != a[i + 1]) {
        cout << -1 << '\n';
        return;
      }
    } else {
      if (c_down == -1) {
        c_down = a[i] - a[i + 1];
      } else if (a[i] - c_down != a[i + 1]) {
        cout << -1 << '\n';
        return;
      }
    }
  }
  if (c_up == -1 || c_down == -1) {
    cout << 0 << '\n';
  } else {
    int m = c_down + c_up;
    int c = c_up;

    if (a[0] >= m) {
      cout << -1 << '\n';
      return;
    }
    for (int i = 0; i < n - 1; i++) {
      if ((a[i] + c) % m != a[i + 1]) {
        cout << -1 << '\n';
        return;
      }
    }
    cout << m << ' ' << c_up << '\n';
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}