#include <iostream>
#include <set>;

using namespace std;
typedef long long ll;

int n;
ll a[100010];

inline void solve()
{
	cin >> n;

	for (int i = 1; i <= n; ++i) cin >> a[i];

	set <int> pl;
	set <int> min;
	bool eq = false;

	for (int i = 1; i < n; ++i)
	{ 
		if (a[i + 1] == a[i])
		{
			eq = true;
		}
		else if (a[i + 1] > a[i])
		{
			pl.insert(a[i + 1] - a[i]);
		}
		else
		{
			min.insert(a[i] - a[i + 1]);
		}
	}

	if (eq)
	{
		for (int i = 1; i < n; ++i)
		{
			if (a[i] != a[i + 1])
			{
				cout << -1 << '\n';
				return;
			}
		}

		cout << 0 << '\n';
		return;
	}

	if (min.size() >= 2 || pl.size() >= 2)
	{
		cout << -1 << '\n';
		return;
	}

	if (min.empty())
	{
		cout << 0 << '\n';
		return;
	}
	

	if (min.size() && pl.size())
	{
		ll c = *pl.begin();
		ll m = c + *min.begin();

		bool ok = true;
		if (c >= m) ok = false;
		if (a[1] >= m) ok = false;

		for (int i = 2; i <= n; ++i)
		{
			if ((a[i - 1] + c) % m != a[i])
			{
				ok = false;
				break;
			}
		}

		if (!ok)
		{
			cout << -1 << '\n';
			return;
		}
		cout << m << ' ' << c << '\n';
		return;
	}

	cout << 0 << '\n';
}

signed main()
{
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}