#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 500010;
const int MOD = 1000000007;

ll a[N];

ll mod(ll x, ll m) {
	x %= m;
	if (x < 0)
		x += m;
	return x;
}

signed main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int t;

	cin >> t;

	while (t--) {
		int n;
		cin >> n;

		for (int i = 1; i <= n; ++i) {
			cin >> a[i];
		}
		if (n <= 2) {
			cout << "0\n";
			continue;
		}
		ll s = a[1];
		ll c = -1;
		for (int i = 2; i <= n; ++i) {
			if (a[i] - a[i - 1] >= 0) {
				c = a[i] - a[i - 1];
				break;
			}
		}
		if (c == -1) {
			c = a[2] - a[1];
			bool ok = true;
			for (int i = 2; i <= n; ++i) {
				if (a[i] != (a[i - 1] + c))
					ok = false;
			}
			if (ok) {
				cout << "0\n";
			}
			else {
				cout << "-1\n";
			}
			continue;
		}
		ll m = -1;
		for (int i = 2; i <= n; ++i) {
			if (a[i] - a[i - 1] < 0) {
				m = a[i - 1] - a[i] + c;
				break;
			}
		}
		if (m == -1) {
			m = (ll)MOD * 10ll;
		}
		c %= m;
		bool ok = true;
		if (s >= m) {
			ok = false;
		}
		for (int i = 2; i <= n; ++i) {
			if (a[i] != (a[i - 1] + c) % m)
				ok = false;
		}

		if (ok) {
			if (m == (ll)MOD * 10ll) {
				cout << "0\n";
			}
			else {
				cout << m << ' ' << c << '\n';
			}
		}
		else {
			cout << "-1\n";
		}

	}

}