#include <iostream>
#include <stdio.h>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <numeric>
#include <utility>
#include <random>
#include <cmath>
#include <algorithm>

using namespace std;

typedef int64_t ll;
#define endl "\n"

void solve() {
    int n; cin >> n;
    if (n == 1) {
        cout << 0 << endl;
        return;
    }
    vector<int> ar(n);
    for (auto& it : ar) cin >> it;
    vector<pair<int, int>> kk(n - 1);
    for (int i = 0; i + 1 < n; ++i) {
        kk[i] = {ar[i], ar[i + 1]};
    }
    sort(kk.begin(), kk.end());
    int posdif = -1, negdif = -1;
    for (int i = 0; i + 1 < n; ++i) {
        int nxt = (i + 1) % (n - 1);
        if (kk[i].first == kk[nxt].first && kk[i].second != kk[nxt].second) {
            cout << -1 << endl;
            return;
        }
        if (kk[i].first > kk[i].second) {
            int curnegdif = kk[i].first - kk[i].second;
            if (negdif == -1) negdif = curnegdif;
            else if (negdif != curnegdif) {
                cout << -1 << endl;
                return;
            }
        } else {
            int curposdif = kk[i].second - kk[i].first;
            if (posdif == -1) posdif = curposdif;
            else if (posdif != curposdif) {
                cout << -1 << endl;
                return;
            }
        }
    }
    if (posdif == -1 || negdif == -1) {
        cout << 0 << endl;
        return;
    }
    if (ar[0] > (posdif + negdif)) {
        cout << -1 << endl;
        return;
    }
    for (int i = 0; i + 1 < n; ++i) {
        if ((ar[i] + posdif) % (posdif + negdif) != ar[i + 1]) {
            cout << -1 << endl;
            return;
        }
    }
    cout << posdif + negdif << " " << posdif << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q; cin >> q;
    while (q--) solve();
}
