#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <time.h>

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define pb push_back
#define forin for(int i = 0; i < n; ++i)

const bool is_debug = true;
#define debug(x) if(is_debug) cout << x << '\n'

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class T>
ostream& operator << (ostream &a, vector<T> x) {
    for(auto element: x) {
        a << element << ' ';
    }
    return a;
}

template<class T>
istream& operator >> (istream &a, vector<T> x) {
    for(auto &element: x) {
        a >> x;
    }
    return a;
}

mt19937 rnd(time(0));

signed main() {
    int t;
    cin >> t;
    for(int q = 0; q < t; ++q) {
        int n;
        cin >> n;
        vector<int> a(n);
        for(int i = 0; i < n; ++i) cin >> a[i];
        int k1 = -1, k2 = -1;
        bool tr = true;
        for(int i = 1; i < n; ++i) {
            if(a[i] >= a[i-1]) {
                if(k1 == -1) {
                    k1 = a[i] - a[i-1];
                }else if(k1 != a[i] - a[i-1]) {
                    tr = false;
                    break;
                }
            }else{
                if(k2 == -1) {
                    k2 = a[i-1] - a[i];
                }else if(k2 != a[i - 1] - a[i]){
                    tr = false;
                    break;
                }
            }
        }
        if(!tr || (k1 == 0 && k2 != -1)) {
            cout << -1 << '\n';
            continue;
        }
        if(k1 == -1 || k2 == -1) {
            cout << 0 << '\n';
            continue;
        }
        for(int i = 0; i < n; ++i) {
            if(a[i] >= k1 + k2) {
                tr = false;
                break;
            }
        }
        if(tr)
            cout << k1 + k2 << ' ' << k1 << '\n';
        else
            cout << -1 << '\n';
    }
    return 0;
}
