#include <bits/stdc++.h>

using namespace std;

typedef vector<vector<int>> graph;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define F first
#define S second
#define pii pair<int, int>

const int INF = 1e18;


void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> d(n);
    for (int i = 1; i < n; i++) {
        d[i] = a[i] - a[i - 1];
    }
    int mx = -INF, mn = INF;
    for (int i = 1; i < n; i++) {
        mx = max(mx, d[i]);
        mn = min(mn, d[i]);
    }
    int c = mx;
    int m;
    for (int i = 1; i < n; i++) {
        if (d[i] == mn) {
            m = (a[i - 1] + c) - a[i];
        }
    }
//    cout << '!';
    if (m == 0) {
        cout << 0;
        return;
    }
    for (int i = 1; i < n; i++) {
        if ((a[i - 1] + c) % m != a[i] || m <= a[0]) {
            cout << -1;
            return;
        }
    }
    cout << m << ' ' << c;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(10);
    int q = 1;
    cin >> q;
    while(q--) {
        solve();
        cout << endl;
    }
    return 0;
}
