#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>
#include <map>

#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define siz(a) int(a.size())

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;
using vll = vector<ll>;

template<class T> bool ckmin(T &a, T b) {return a > b ? a = b, true : false;}
template<class T> bool ckmax(T &a, T b) {return a < b ? a = b, true : false;}

const int N = 2e5 + 7;
const int INF = 1e9;
const ll LINF = 1e18;


void solve() {
    int n; cin >> n;
    vi a(n); for(auto &x:a) cin >> x;
    int f = 1;
    for (int i = 2; i < n; ++i) {
        if (a[i] - a[i - 1] != a[i - 1] - a[i - 2]) f = 0;
    }
    if(f) {cout << "0\n"; return;}
    set<int> st;
    for (int i = 1; i < n; ++i) {
        if(a[i] >= a[i - 1]) st.insert(a[i] - a[i - 1]);
    }
    if(st.size() != 1) {cout << "-1\n"; return;}
    int c = *st.begin();
    set<int> ans;
    //cout << "C " << c << "\n";
    for (int i = 1; i < n; ++i) {
        if(a[i] - a[i-1] < 0) {
            ans.insert(c - a[i] + a[i - 1]);
        }
        else {
            if(a[i-1] + c != a[i]) {cout << "-1\n"; return;}
        }
    }
    if(ans.size() != 1) {cout << "-1\n"; return;}
    int m = *ans.begin();
    if(a[0] >= m) {cout << "-1\n"; return;}
    for (int i = 1; i < n; ++i) {
        if((a[i - 1] + c) % m != a[i]){cout << "-1\n"; return;}
    }
    cout << *ans.begin() << " " << c << "\n";
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while(t--) solve();
    return 0;
}
