#include <bits/stdc++.h>

using namespace std;

mt19937 sd(228);
mt19937 gd(chrono::high_resolution_clock::now().time_since_epoch().count());
uniform_int_distribution <int> gen(1, 100);

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef MY_PC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;

    cin >> t;

    while (t--) {
        int n;

        cin >> n;

        vector <int> a(n);

        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        set <int> m;
        for (int i = 1; i < n; i++) {
            m.insert(a[i] - a[i - 1]);
        }
        if (m.empty() || m.size() == 1) {
            cout << 0 << endl;
            continue;
        }
        if (m.size() > 2) {
            cout << -1 << endl;
            continue;
        }
        vector <int> b(m.begin(), m.end());
        if (b[0] >= 0 || b[1] <= 0) {
            cout << -1 << endl;
            continue;
        }

        int mp = abs(b[0]) + abs(b[1]);
        int cp = abs(b[1]);
        int cntr = a[0] % mp;
        vector <int> c(n);
        c[0] = cntr;
        for (int i = 1; i < n; i++) {
            c[i] = (c[i - 1] + cp) % mp;
        }
        if (a == c) {
            cout << mp << " " << cp << endl;
        } else {
            cout << -1 << endl;
        }
    }
}