#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <map>
// @princebelkovetz
// plz god help me D:
using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';
struct segtree {
	int size;
	vector <int> tree;
	segtree(int n) {
		size = 1;
		while (size < n) size *= 2;
		tree.resize(2 * size - 1);
	}
	int get(int v, int lx, int rx, int l, int r) {
		if (l <= lx and rx <= r) return tree[v];
		if (rx <= l or r <= lx) return 0;
		int m = (lx + rx) / 2;
		int s1 = get(2 * v + 1, lx, m, l, r);
		int s2 = get(2 * v + 2, m, rx, l, r);
		return s1 + s2;
	}
	int get(int l, int r) {
		return get(0, 0, size, l, r);
	}
	void upd(int v, int lx, int rx, int i, int x) {
		if (lx + 1 == rx) {
			tree[v] = x;
			return;
		}
		int m = (lx + rx) / 2;
		if (i < m) upd(2 * v + 1, lx, m, i, x);
		else upd(2 * v + 2, m, rx, i, x);
		tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
	}
	void upd(int i, int x) {
		upd(0, 0, size, i, x);
	}
};
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);
	int tt; cin >> tt;
	while (tt --> 0) {
		int n; cin >> n;
		vector <int> a(n);
		for (auto& x : a) cin >> x;
		if (n == 1) {
			cout << "0\n";
			continue;
		}
		int dif = -1;
		for (int i = 0; i < n - 1; ++i) {
			if (a[i] < a[i + 1]) dif = a[i + 1] - a[i];
		}
		if (dif == -1) {
			set <int> d;
			for (int i = 0; i < n - 1; ++i)
				d.insert(a[i + 1] - a[i]);
			if (d.size() == 1) {
				cout << "0\n";
			}
			else cout << "-1\n";
		}
		else {
			int md = 0;
			for (int i = 0; i < n - 1; ++i) {
				if (a[i] >= a[i + 1]) {
					md = a[i] + dif - a[i + 1];
				}
			}
			if (!md) md = 1e9 + 7;
			int cur = a[0];
			bool c = (cur < md);
			for (int i = 1; i < n; ++i) {
				cur = (cur + dif) % md;
				if (cur != a[i]) c = false;
			}
			if (md == 1e9 + 7 and c) cout << "0\n";
			else if (c and dif < md) cout << md << ' ' << dif << '\n';
			else cout << -1 << '\n';
		}

	}
}