#include <iostream>
#include <vector>

using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
    }
    bool flag1 = false;
    bool flag2 = false;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] <= a[i + 1]) {
            flag1 = true;
        } else {
            flag2 = true;
        }
    }
    if (!(flag1 && flag2)) {
        int c = a[1] - a[0];
        for (int i = 1; i < n - 1; ++i) {
            if (a[i + 1] - a[i] != c) {
                cout << -1 << "\n";
                return;
            }
        }
        cout << 0 << "\n";
        return;
    }
    int c = 0;
    pair<int, int> b;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i + 1] - a[i] >= 0) {
            c = a[i + 1] - a[i];
        } else if (a[i + 1] < a[i]) {
            b = {a[i], a[i + 1]};
        }
    }
    int m = b.first + c - b.second;
    if (m <= 0) {
        cout << -1 << "\n";
        return;
    }
    if (a[0] >= m){
        cout << -1 << "\n";
        return;
    }
    for (int i = 0; i < n - 1; ++i) {
        if (a[i + 1] != (a[i] + c) % m) {
            cout << -1 << "\n";
            return;
        }
    }
    cout << m << " " << c << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}