#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <deque>
#include <random>
#include <queue>

std::mt19937 rnd(123);

#define int long long
#define ll long long
#define ld long double
#define pii pair<int, int>
#define vi vector<int>
#define all(v) v.begin(), v.end()

using namespace std;

const int INF = 2e9 + 1;

void solve() {
    int n;
    cin >> n;
    vi a(n);
    for (auto &i : a) {
        cin >> i;
    }
    if (n == 1) {
        cout << "0\n";
        return;
    }
    int dd = a[1] - a[0];
    vector<int> xx(n);
    xx[0] = a[0];
    bool pr = false;
    for (int i = 1; i < n; ++i) {
        xx[i] = xx[i - 1] + dd;
        if (xx[i] != a[i]) {
            pr = true;
            break;
        }
    }
    if (!pr) {
        cout << "0\n";
        return;
    }
    int s = a[0];
    int uk = -1;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i] > a[i + 1]) {
            uk = i;
            break;
        }
    }
    if (uk == -1) {
        int del = a[1] - a[0];
        for (int i = 0; i < n - 1; ++i) {
            if (a[i + 1] - a[i] != del) {
                cout << "-1\n";
                return;
            }
        }
        cout << "0\n";
        return;
    }
    int uu = -1;
    for (int i = 0; i < n - 1; ++i) {
        if (a[i + 1] > a[i]) {
            uu = i;
            break;
        }
    }
    int m, c;
    if (uu != -1) {
        c = a[uu + 1] - a[uu];
        m = a[uk] + c - a[uk + 1];
        if (s >= m || c >= m) {
            cout << "-1\n";
            return;
        }
        vi b(n);
        b[0] = s;
        for (int i = 1; i < n; ++i) {
            b[i] = (b[i - 1] + c) % m;
        }
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                cout << "-1\n";
                return;
            }
        }
        cout << m << ' ' << c << '\n';
    } else {
        m = a[0] + 1;
        c = a[uk + 1] + m - a[uk];
        if (s >= m || c >= m) {
            cout << "-1\n";
            return;
        }
        vi b(n);
        b[0] = s;
        for (int i = 1; i < n; ++i) {
            b[i] = (b[i - 1] + c) % m;
        }
        for (int i = 0; i < n; ++i) {
            if (a[i] != b[i]) {
                cout << "-1\n";
                return;
            }
        }
        cout << m << ' ' << c << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int ttt = 1;
    cin >> ttt;
    while (ttt--) {
        solve();
    }
}