#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <vector>

#define int long long
#define f first
#define s second
#define pb push_back
#define pii pair <int, int>

using namespace std;

const int N = 1e6 + 5;
const int INF = 1e18 + 7;

int a[N];

signed main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    int t;
    cin >> t;
    while (t--){
        int n, cnt1 = 1, cnt2 = 1;
        cin >> n;
        for (int i = 0; i < n; i++){
            cin >> a[i];   
            if (i > 0 && a[i] > a[i - 1])
                cnt1++;
            if (i > 0 && a[i] == a[i - 1])
                cnt2++;
        }
        if (cnt1 == n || cnt2 == n){
            int r = a[1] - a[0];
            bool f = true;
            for (int i = 2; i < n; i++)
                if (a[i] - a[i - 1] != r){
                    f = false;
                    break;
                }
            if (!f)
                cout << -1 << '\n';
            else
                cout << 0 << '\n';
            continue;
        }
        if (cnt2 > 1){
            cout << -1 << '\n';
            continue;
        }

        bool f = true;
        int m = INF, c = -1, r = -1;
        for (int i = 1; i < n; i++){
            if (a[i] > a[i - 1])
                c = a[i] - a[i - 1];
            if (a[i] < a[i - 1]){
                if (r != -1 && r != a[i - 1] - a[i]){
                    f = false;
                    break;
                }
                r = a[i - 1] - a[i];
            }
        }

        m = c + r;
        if (c == -1 && f){
            cout << 0 << '\n';
            continue;
        }

        if (a[0] % m != a[0])
            f = false;
        for (int i = 1; i < n; i++){
            if ((a[i - 1] + c) % m != a[i]){
                f = false;
                break;
            }
        }

        if (!f)
            cout << -1 << '\n';
        else
            cout << m << ' ' << c << '\n';
    }
    return 0;
}