#include <iostream>

using namespace std;

#define int long long
const int SZ = 1e5 + 4;

int n;
int a[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
}

void solve() {
    int c = -1;
    for (int i = 1; i < n; ++i) {
        if (a[i] >= a[i - 1]) {
            if (c != -1 && c != a[i] - a[i - 1]) {
                cout << -1 << "\n";
                return;
            }
            c = a[i] - a[i - 1];
        }
    }

    if (c == -1) {
        int d = a[1] - a[0];
        for (int i = 2; i < n; ++i) {
            if (a[i] - a[i - 1] != d) {
                cout << -1 << "\n";
                return;
            }
        }
        cout << 0 << "\n";
        return;
    }

    int m = -1;

    for (int i = 1; i < n; ++i) {
        if (a[i] < a[i - 1]) {
            if (m != -1 && a[i] + m != a[i - 1] + c) {
                cout << -1 << "\n";
                return;
            }
            m = a[i - 1] + c - a[i];
        }
    }

    if (m == -1) {
        cout << 0 << "\n";
        return;
    }

    for (int i = 0; i < n; ++i) {
        if (a[i] >= m) {
            cout << -1 << "\n";
            return;
        }
    }

    cout << m << " " << c << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        read();
        solve();
    }

    return 0;
}