#include <iostream>
#include <algorithm>
#include <cmath>
#include <chrono>
#include <random>
#include <fstream>


#include <set>
#include <deque>
#include <vector>
#include <string>


using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<vector<int>> vvi;
typedef vector<vector<bool>> vvb;

//#define endl '\n'
#define here cout << "here" << endl;
#define out(a) cout << a << " ";
#define endss cout << endl;
#define print(x) for(auto &&xx: x) out(xx) endss
#define all(a) (a).begin(), (a).end()
#define IO

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
int rand(int l, int r) {return uniform_int_distribution<int> (l, r)(rng);}

void kekw(const string& s) {
    vector<char> c = {' ', char(1), char(2), char(3), char(4), char(5), char(6)};
    cout << c[1];
    for(int i = 0; i < s.size(); ++i) cout << c[6];
    cout << c[2] << endl;
    cout << c[5] << s << c[5] << endl;
    cout << c[3];
    for(int i = 0; i < s.size(); ++i) cout << c[6];
    cout << c[4] << endl;
}


pii solve(int n, vi &v) {
    bool end = false;
    bool up = false, down = false;
    int dif_up = -1, dif_down = -1;
    for (int i = 1; i < n; ++i) {
        up = up || (v[i] >= v[i - 1]);
        down = down || (v[i] < v[i - 1]);
        if (v[i] >= v[i - 1] && dif_up != -1 && dif_up != v[i] - v[i - 1]) {
            end = true;
        }
        if (v[i] >= v[i - 1]) dif_up = v[i] - v[i - 1];

        if (v[i] < v[i - 1] && dif_down != -1 && dif_down != v[i - 1] - v[i]) {
            end = true;
        }
        if (v[i] < v[i - 1]) dif_down = v[i - 1] - v[i];
    }
    if (end) {
        cout << -1 << endl;
        return {-1, -2};
    } else if (!up || !down) {
        cout << 0 << endl;
        return {0, -2};
    } else {
        int max_val = -1, m = -1;
        for (int i = 0; i < n; ++i) {
            max_val = max(max_val, v[i]);
            if (i != 0) {
                if (v[i] < v[i - 1]) {
                    int m_ = v[i - 1] + dif_up - v[i];
                    if (m == -1) m = m_;
                    else end = end || (m != m_);
                }
                if (m != -1) {
                    end = end || ((v[i - 1] + dif_up) % m != v[i]);
                }
            }
        }
        for(int i = 1; i < n; ++i){
            if(v[i] != (v[i - 1] + dif_up) % m){
                cout << -1 << endl;
                return {-1, -2};
            }
        }
        if (end || m <= v[0]) {
            cout << -1 << endl;
            return {-1, -2};
        } else {
            cout << m << ' ' << dif_up << endl;
            return {m, dif_up};
        }
    }

}



void gen(){
    int n = rand(1, 1000);
    int m = rand(1, 100000);
    int s = rand(0, 100000);
    int c = rand(0, m - 1);
    vi v(n);
    v[0] = s % m;
    for(int i = 1; i < n; ++i){
        v[i] = (c + v[i - 1]) % m;
    }
    pii res = solve(n, v);

    if(res.first != 0) {
        if (res.first == -1 || res.first != m || res.second >= res.first || v[0] >= res.first) {
            out(n)
            out(m)
            out(c)
            out(s)
            endss
            out(res.first)
            endss
            print(v)
            exit(1);
        }
        for (int i = 1; i < n; ++i) {
            if (v[i] != (v[i - 1] + res.second) % res.first){
                out(n) out(m) out(c) out(s) endss
                out(res.first) endss
                print(v)
                exit(1);
            }
        }
    }
}

void get(){
    int n;
    cin >> n;
    vi v(n);
    for(int i = 0; i < n; ++i){
        cin >> v[i];
    }
    solve(n, v);
}

int main(){
    int t;
    cin >> t;
    while (t--) {
        get();
        //gen();
    }
    return 0;
}