﻿#include <unordered_map>
#include <unordered_set>
#include <type_traits>
#include <functional>
#include <algorithm>
#include <iterator>
#include <iostream>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <sstream>
#include <fstream>
#include <utility>
#include <vector>
#include <string>
#include <bitset>
#include <cstdio>
#include <math.h>
#include <stack>
#include <ctime>
#include <queue>
#include <cmath>
#include <list>
#include <set>
#include <map>

using namespace std;

#define SZ(v)			ll((v).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   numeric_limits<type>::max()
#define TYPEMIN(type)   numeric_limits<type>::min()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef vector<char> vc;
typedef vector<vc> vvc;

const ll INF = 1000000007LL;
const ll MAXN = 150000LL;
const double EPS = 1e-9;

typedef bool (*fn) (ll);

bool equals(const double a, const double b) { return fabs(a - b) < EPS; }

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0); cerr.tie(0);
	ll t; cin >> t;
	while (t--)
	{
		ll n, m; cin >> n >> m;
		vvl arr;
		vl stepeni(n);
		for (ll i = 0LL; i < m; i++)
		{
			ll k; cin >> k;
			if (k == 1LL)
			{
				vl q(1LL); cin >> q[0LL];
				q[0LL]--; stepeni[q[0LL]]++;
				arr.push_back(q);
				continue;
			}
			vl q(k);
			for (ll& x : q) { cin >> x; x--; }
			arr.push_back(q);
		}
		vl ans(m);
		for (ll i = 0LL; i < m; i++)
		{
			if ((ll)arr[i].size() == 1LL)
			{
				ans[i] = arr[i][0LL];
				continue;
			}
			ll jMin = 0LL;
			for (ll j = 1LL; j < (ll)arr[i].size(); j++) { if (stepeni[arr[i][j]] < stepeni[arr[i][jMin]]) { jMin = j; } }
			stepeni[arr[i][jMin]]++;
			ans[i] = arr[i][jMin];
		}
		bool win = true;
		for (ll x : stepeni)
		{
			if (x > m - m / 2LL)
			{
				win = false;
				break;
			}
		}
		if (!win)
		{
			cout << "NO" << endl;
			continue;
		}
		cout << "YES" << endl;
		for (ll x : ans) { cout << x + 1LL << " "; }
		cout << endl;
	}
	return 0;
}
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////