#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse3,sse4,popcnt,abm,mmx")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
#include <stack>
#include <queue>
#include <deque>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>-

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

// template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//  order_of_key (k) : Number of items strictly smaller than k .
//  find_by_order(k) : K-th element in a set (counting from zero).
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define pb push_back
#define ppb pop_back
#define mkp make_pair
#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define show(a) cerr << #a <<" -> "<< a <<" "
#define nl cerr <<"\n"
//#define int ll

const int N = 2e5 + 5;
const int oo = 1e9 + 5;

int n, m, cnt[N], done[N], sz[N];
vector <int> vec[N], pos[N];
set <pii> st;
bool del[N];

void solve() {
    for (int i = 1; i <= m; ++i) {
        vec[i].clear();
        done[i] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        pos[i].clear();
        cnt[i] = 0;
        del[i] = 0;
    }

    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int k;
        cin >> k;
        sz[i] = k;
        for (int j = 1; j <= k; ++j) {
            int x;
            cin >> x;
            vec[i].pb(x);
            ++cnt[x];
            pos[x].pb(i);
        }
    }
    for (int i = 1; i <= n; ++i) {
        st.insert({cnt[i], i});
    }
    while (sz(st)) {
        int v = st.begin() -> S;
        st.erase(st.begin());
        del[v] = 1;
        vector <pii> order;
        for (int day : pos[v]) {
            if (done[day] != 0) { continue; }
            order.pb({sz[day], day});
        }
        sort(all(order));

        int res = 0;
        for (pii x : order) {
            int day = x.S;
            for (int other : vec[day]) {
                if (del[other]) { continue; }
                st.erase({cnt[other], other});
                --cnt[other];
                st.insert({cnt[other], other});
            }
            done[day] = v;
            ++res;
            if (res == (m + 1) / 2) { break; }
        }

        for (int day : pos[v]) { --sz[day]; }
    }
    for (int i = 1; i <= m; ++i) {
        if (!done[i]) { cout << "NO\n"; return; }
    }
    cout << "YES\n";
    for (int i = 1; i <= m; ++i) { cout << done[i] <<" "; }
    cout << "\n";
}

 main () {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int tests = 1;
	cin >> tests;
	while (tests --) {
		solve();
	}
	return 0;
}
/*
    Just Chalish!
*/
