#include <bits\stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int INF = 1e9 + 7;
const ld EPS = 1e-6;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> free(m);
    vector<vector<int>> used(n);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        free[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> free[i][j];
            used[free[i][j] - 1].push_back(i);
        }
    }
    int ind = 0;

    for (int i = 1; i < n; i++) {
        if (used[i].size() > used[ind].size()) ind = i;
    }
    if (used[ind].size() > (m + 1) / 2) {
        vector<bool> wh(m);
        int counter = 0;
        for (auto i : used[ind]) {
            if (free[i].size() == 1) {
                wh[i] = true;
                counter++;
            }
        }
        if (counter > (m + 1) / 2) {
            cout << "NO" << '\n';
            return;
        }
        cout << "YES" << '\n';
        for (auto i : used[ind]) {
            if (!wh[i] && counter < (m + 1) / 2) {
                wh[i] = true;
                counter++;
            }
        }
        for (int i = 0; i < m; i++) {
            if (wh[i]) cout << ind + 1 << ' ';
            else {
                if (free[i][0] == ind + 1) {
                    cout << free[i][1] << ' ';
                } else {
                    cout << free[i][0] << ' ';
                }
            }
        }
        cout << '\n';
    } else {
        cout << "YES" << '\n';
        for (int i = 0; i < m; i++)
            cout << free[i][0] << ' ';
        cout << '\n';
    }
}


signed main() {
    ios::sync_with_stdio(false);
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    int t;
    cin >> t;
    for (int rq = 0; rq < t; ++rq) solve();
}