#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <cmath>
#include <assert.h>
#include <queue>
#include <cstring>
#include <bitset>
#include <random>

using namespace std;

template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define next next288
#define left left228
#define right right228

const int N = 100 * 1000 + 228;

int n, m;
int k[N], play[N];
vector<int> f[N];

void solve() {
    cin >> n >> m;

    for (int i = 1; i <= m; ++i) {
        play[i] = 0;
    }

    map<int, int> cnt;

    for (int i = 1; i <= m; ++i) {
        cin >> k[i];
        f[i].resize(k[i], 0);
        for (int j = 0; j < k[i]; ++j) {
            cin >> f[i][j];
        }
    }


    for (int i = 1; i <= m; ++i) {
        if (k[i] == 0) {
            cout << "NO\n";
            return ;
        }
        if (k[i] == 1) {
            ++cnt[ f[i][0] ];
            play[i] = f[i][0];
        }
    }
    for (int i = 1; i <= m; ++i) {
        if (k[i] > 1) {
            if (cnt[f[i][0]] < cnt
                [f[i][1]]) {
                play[i] = f[i][0];
            } else {
                play[i] = f[i][1];
            }
            ++cnt[ play[i] ];
        }
    }

    for (auto p : cnt) {
        if (p.second > (m + 1) / 2) {
            cout << "NO\n";
            return ;
        }
    }
    cout << "YES\n";
    for (int i = 1; i <= m; ++i) {
        cout << play[i] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}