#include <bits/stdc++.h>

#define X first
#define Y second
#define endl '\n'

#define int long long

using namespace std;

int gcd(int a, int b){
    if (b == 0)
        return a;
    return gcd(b, a % b);
}


void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> indexes(n + 1);
    vector<int> cnt (m);

    for (int i = 0; i < m; ++i){
        cin >> cnt[i];
        for (int j = 0; j < cnt[i]; ++j){
            int c;
            cin >> c;
            indexes[c].push_back(i);
        }
    }

    for (int i = 0; i < indexes.size(); ++i){
        int q = indexes[i].size();
        for (int j = 0; j < indexes[i].size(); ++j){
            if (q <= (m + 1) / 2)
                break;
            if (cnt[indexes[i][j]] > 1){
                --cnt[indexes[i][j]];
                --q;
                indexes[i][j] = -1;
            }
        }

        if (q > (m + 1) / 2){
            cout << "NO" << endl;
            return;
        }
    }

    for (int i = 0; i < indexes.size(); ++i){
        for (int j : indexes[i]){
            if (j != -1 && cnt[j] > 0)
                cnt[j] = -i;
        }
    }
    cout << "YES" << endl;
    for (int i : cnt)
        cout << -i << " ";
    cout << endl;
}

signed main(){
#ifdef MY
freopen("in.txt", "r", stdin);
#endif // MY
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    while (n--)
        solve();
}
