//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")

#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <stack>
#include <bitset>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#if DEBUG
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    solve();
}

#define int long long

const int N = 2e5 + 100, INF = 1e18, MOD = 998244353, BASE = 228, MOD1 = 1e9 + 7, BASE1 = 131;// 998244353
const double EPS = 0.0000001;

int t, cnt[N], ans[N], n, m;
vector<int> a[N];

void solve() {
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            cnt[i] = 0;
        }
        for (int i = 0; i < m; i++) {
            ans[i] = -1;
            a[i].clear();
        }
        for (int i = 0; i < m; i++) {
            int k;
            cin >> k;
            a[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> a[i][j];
                a[i][j]--;
            }
        }
        for (int i = 0; i < m; i++) {
            if (a[i].size() == 1) {
                cnt[a[i][0]]++;
                ans[i] = a[i][0];
            }
        }
        for (int i = 0; i < m; i++) {
            if (ans[i] != -1) continue;
            int mn = INF, pos = -1;
            for (int x : a[i]) {
                if (cnt[x] < mn) {
                    mn = cnt[x];
                    pos = x;
                }
            }
            cnt[pos]++;
            ans[i] = pos;
        }
        bool ok = true;
        for (int i = 0; i < n; i++) {
            if (cnt[i] > m / 2 + m % 2) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << "YES" << '\n';
            for (int i = 0; i < m; i++) {
                cout << ans[i] + 1 << " ";
            }
            cout << '\n';
        } else {
            cout << "NO" << '\n';
        }

    }
}