#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
using namespace std;

#define ll long long
#define pll pair<ll, ll>
#define vll vector<ll>
#define pii pair<int, int>
#define vpll vector<pll >
#define vpii vector<pii >
#define vii vector<int>
#define f first
#define s second
#define mp make_pair
#define pb push_back
#define ld long double

#define endl '\n'
#define inf (ll)((ll)1e18 + 17)
#define eps (ld)(1e-12)

#define MOD (ll)((ll)1e9 + 7)
#define MOD2 (ll)((ll)1e9 + 13)

ostream& operator<<(ostream& os, vll& x)
{
	for(ll t : x)
		os << t << " ";
	return os;
}

ostream& operator<<(ostream& os, vii& x)
{
	for(int t : x)
		os << t << " ";
	return os;
}

ostream& operator<<(ostream& os, pll& x)
{
	os << x.f << " " << x.s << endl;
	return os;
}

istream& operator>>(istream& is, pll& x)
{
	is >> x.f >> x.s;
	return is;
}

ostream& operator<<(ostream& os, pii& x)
{
	os << x.f << " " << x.s << endl;
	return os;
}

istream& operator>>(istream& is, pii& x)
{
	is >> x.f >> x.s;
	return is;
}
/*
struct Node
{
	ll l, r, val, ad;

	Node()
	{
		l = -1;
		r = -1;
		val = -inf;
	}
};

struct SegmentTree
{
	vector<Node> d;

	void create(ll n)
	{
		d.resize(4 * n);
		build(1, 0, n);
	}

	void update(int i)
	{
		if(d[i].l != d[i].r - 1)
		{
			d[i * 2].ad += d[i].ad;
			d[i * 2 + 1].ad += d[i].ad;
		}

		d[i].val += d[i].ad;
		d[i].ad = 0;
	}

	void build(int i, int l, int r)
	{
		if(l >= r)
			return;

		d[i].l = l;
		d[i].r = r;

		if(d[i].l == d[i].r - 1)
			return;

		int m = l + (r - l) / 2;
		build(i * 2, l, m);
		build(i * 2 + 1, m, r);
	}

	ll get(int i, int l, int r)
	{
		update(i);
		if(l >= d[i].r || r <= d[i].l)
			return -inf;

		update(i);
		if(d[i].l >= l && d[i].r <= r)
			return d[i].val;

		return max(get(i * 2, l, r), get(i * 2 + 1, l, r));
	}

	void ad(int i, int l, int r, int x)
	{
		update(i);
		if(l >= d[i].r || r <= d[i].l)
			return;

		update(i);
		if(d[i].l >= l && d[i].r <= r)
		{
			d[i].ad += x;
			update(i);
			return;
		}

		ad(i * 2, l, r, x);
		ad(i * 2 + 1, l, r, x);
		d[i].val = max(d[i * 2].val, d[i * 2 + 1].val);
	}
};*/

int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ll t;
	cin >> t;

	for(int counter = 0; counter < t; counter++)
	{
		ll n, m;
		cin >> n >> m;

		vector<vll > nodes(n);
		vector<vll > nodesRev(m);

		vll answ(m, -1);
		vll unUsed(n, (m + 1) / 2);

		//cerr << nodes.size() << " " << nodesRev.size() << " " << answ.size() << " " << unUsed.size() << endl;

		bool isBad = 0;
		for(int i = 0; i < m; i++)
		{
		//	cerr << "i " << i << endl;
			int k;
			cin >> k;

			for(int j = 0; j < k; j++)
			{
				int x;
				cin >> x;
				x--;
				nodesRev[i].pb(x);
				nodes[x].pb(i);
			}

			if(k == 1)
			{
				if(unUsed[nodesRev[i][0]] == 0)
				{
					isBad = 1;
				}
				unUsed[nodesRev[i][0]]--;
				answ[i] = nodesRev[i][0];
			}
		}

	//	cerr << "here" << endl;

		if(isBad)
		{
			cout << "NO" << endl;
			continue;
		}

		for(int i = 0; i < n; i++)
		{
			int cnt = 0;
			for(ll j : nodes[i])
			{
				if(answ[j] == -1)
					cnt++;
			}
			if(cnt <= unUsed[i])
			{
				for(ll j : nodes[i])
				{
					if(answ[j] == -1)
					{
						answ[j] = i;
						unUsed[i]--;
					}
				}
			}
		}

		for(int i = 0; i < m; i++)
		{
			if(answ[i] != -1)
				continue;

			for(ll j : nodesRev[i])
			{
				if(unUsed[j] > 0)
				{
					answ[i] = j;
					unUsed[j]--;
					break;
				}
			}
			if(answ[i] == -1)
			{
				isBad = 1;
				break;
			}
		}
		if(isBad)
		{
			cout << "NO" << endl;
			continue;
		}
		cout << "YES" << endl;
		for(int i = 0; i < m; i++)
			cout << answ[i] + 1 << " ";
		cout << endl;
	}
	return 0;
}









