#include<bits/stdc++.h>

#define int long long
#define f first
#define s second
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define psum(a, b) partial_sum(all((a)), (b).begin())
#define FOR(i, n) for(int (i) = 0; (i) < (n); (i)++)
#define rep(i, l, r) for(int (i) = (l); (i) < (r); (i)++)
#define sz(x) (int)x.size()
#define rz resize

#define endl '\n'

using namespace std;

void input(vec<int> &a)
{
    for(auto &i : a)
        cin >> i;
}

void output(vec<int> &a)
{
    for(auto &i : a)
        cout << i << ' ';
    cout << endl;
}

mt19937 rnd(time(0));

void solve()
{
    int n, m;
    cin >> n >> m;

    vec<vec<int>> a (n);
    vec<vec<int>> days (m);
    vec<int> ans (m, -1);
    vec<int> cnt (n, 0);

    FOR(i, m)
    {
        int x;
        cin >> x;

        FOR(j, x)
        {
            int k;
            cin >> k;
            k--;
            days[i].pb(k);
        }

        random_shuffle(all(days[i]));
    }

    FOR(i, m)
    {
        if(sz(days[i]) == 1)
        {
            ans[i] = days[i][0] + 1;
            cnt[days[i][0]]++;
        }
    }

    int ban = (m + 1) / 2;
    int mx = *max_element(all(cnt));

    if(mx > ban)
    {
        cout << "NO" << endl;
        return;
    }

    auto cmp = [&](int a, int b)
    {
        if(cnt[a] < cnt[b])
        {
            return 1;
        }
        return 0;
    };

    int el = -1;

    FOR(i, m)
    {
        sort(all(days[i]), cmp);
        if(ans[i] == -1)
        {
            if(days[i][0] != el)
            {
                ans[i] = days[i][0] + 1;
                cnt[days[i][0]]++;
            }
            else
            {
                ans[i] = days[i][1] + 1;
                cnt[days[i][1]]++;
            }

            if(cnt[days[i][0]] > mx)
            {
                mx = cnt[days[i][0]];
            }

            if(cnt[days[i][1]] > mx)
            {
                mx = cnt[days[i][1]];
            }
        }

        if(mx == ban)
        {
            mx = 1e18;
            FOR(j, n)
            {
                if(cnt[j] == ban)
                {
                    el = j;
                    break;
                }
            }
        }
    }

    for(auto i : ans)
    {
        if(i == -1)
        {
            cout << "NO" << endl;
            return;
        }
    }

    cout << "YES" << endl;
    output(ans);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int q = 1;
    cin >> q;

    while(q--)
    {
        solve();
    }
}

/// один манул
/// два манула
/// три манула
/// четыре манула
/// пять манулов
/// шесть манулов
/// семь манулов
/// восемь манулов
/// девять манулов
/// десять манулов
/// одиннадцать манулов
/// двенадцать манулов
/// тринадцать манулов
/// четырнадцать манулов
/// пятнадцать манулов
/// шестнадцать манулов
/// семнадцать манулов
/// восемнадцать манулов
/// девятнадцать манулов
/// двадцать манулов
/// двадцать один манул
/// двадцать два манула
/// двадцать три манула
/// двадцать четыре манула
/// двадцать пять манулов
/// двадцать шесть манулов
/// двадцать семь манулов
/// двадцать восемь манулов
/// двадцать девять манулов
/// тридцать манулов
/// тридцать один манул
/// тридцать два манула
/// тридцать три манула
/// тридцать четыре манула
/// тридцать пять манулов
/// тридцать шесть манулов
/// тридцать семь манулов
/// тридцать восемь манулов
/// тридцать девять манулов
/// сорок манулов
/// сорок один манул
/// сорок два манула
/// сорок три манула
/// сорок четыре манула
/// сорок пять манулов
/// сорок шесть манулов
/// сорок семь манулов
/// сорок восемь манулов
/// сорок девять манулов
/// пятьдесят манулов
/// пятьдесят один манул
/// пятьдесят два манула
/// пятьдесят три манула
/// пятьдесят четыре манула
/// пятьдесят пять манулов
/// пятьдесят шесть манулов
/// пятьдесят семь манулов
/// пятьдесят восемь манулов
/// пятьдесят девять манулов
/// шестьдесят манулов
/// шестьдесят один манул
/// шестьдесят два манула
/// шестьдесят три манула
/// шестьдесят четыре манула
/// шестьдесят пять манулов
/// шестьдесят шесть манулов
/// шестьдесят семь манулов
/// шестьдесят восемь манулов
/// шестьдесят девять манулов
/// семьдесят манулов
/// семьдесят один манул
/// семьдесят два манула
/// семьдесят три манула
/// семьдесят четыре манула
/// семьдесят пять манулов
/// семьдесят шесть манулов
/// семьдесят семь манулов
/// семьдесят восемь манулов
/// семьдесят девять манулов
/// восемдесят манулов
/// восемдесят один манул
/// восемдесят два манула
/// восемдесят три манула
/// восемдесят четыре манула
/// восемдесят пять манулов
/// восемдесят шесть манулов
/// восемдесят семь манулов
/// восемдесят восемь манулов
/// восемдесят девять манулов
/// девяносто манулов
/// девяносто один манул
/// девяносто два манула
/// девяносто три манула
/// девяносто четыре манула
/// девяносто пять манулов
/// девяносто шесть манулов
/// девяносто семь манулов
/// девяносто восемь манулов
/// девяносто девять манулов
/// сто манулов
/// сто один манул
/// сто два манула
/// сто три манула
/// сто четыре манула
/// сто пять манулов
/// сто шесть манулов
/// сто семь манулов
/// сто восемь манулов
/// сто девять манулов
/// сто десять манулов
/// сто одиннадцать манулов
/// сто двенадцать манулов
/// сто тринадцать манулов
/// сто четырнадцать манулов
/// сто пятнадцать манулов
/// сто шестнадцать манулов
/// сто семнадцать манулов
/// сто восемнадцать манулов
/// сто девятнадцать манулов
/// сто двадцать манулов
/// сто двадцать один манул
/// сто двадцать два манула
/// сто двадцать три манула
/// сто двадцать четыре манула
/// сто двадцать пять манулов
/// сто двадцать шесть манулов
/// сто двадцать семь манулов
/// сто двадцать восемь манулов
/// сто двадцать девять манулов
/// сто тридцать манулов
/// сто тридцать один манул
/// сто тридцать два манула
/// сто тридцать три манула
/// сто тридцать четыре манула
/// сто тридцать пять манулов
/// сто тридцать шесть манулов
/// сто тридцать семь манулов
/// сто тридцать восемь манулов
/// сто тридцать девять манулов
/// сто сорок манулов
/// сто сорок один манул
/// сто сорок два манула
/// сто сорок три манула
/// сто сорок четыре манула
/// сто сорок пять манулов
/// сто сорок шесть манулов
/// сто сорок семь манулов
/// сто сорок восемь манулов
/// сто сорок девять манулов
/// сто пятьдесят манулов
/// сто пятьдесят один манул
/// сто пятьдесят два манула
/// сто пятьдесят три манула
/// сто пятьдесят четыре манула
/// сто пятьдесят пять манулов
/// сто пятьдесят шесть манулов
/// сто пятьдесят семь манулов
/// сто пятьдесят восемь манулов
/// сто пятьдесят девять манулов
/// сто шестьдесят манулов
/// сто шестьдесят один манул
/// сто шестьдесят два манула
/// сто шестьдесят три манула
/// сто шестьдесят четыре манула
/// сто шестьдесят пять манулов
/// сто шестьдесят шесть манулов
/// сто шестьдесят семь манулов
/// сто шестьдесят восемь манулов
/// сто шестьдесят девять манулов
/// сто семьдесят манулов
/// сто семьдесят один манул
/// сто семьдесят два манула
/// сто семьдесят три манула
/// сто семьдесят четыре манула
/// сто семьдесят пять манулов
/// сто семьдесят шесть манулов
/// сто семьдесят семь манулов
/// сто семьдесят восемь манулов
/// сто семьдесят девять манулов
/// сто восемдесят манулов
/// сто восемдесят один манул
/// сто восемдесят два манула
/// сто восемдесят три манула
/// сто восемдесят четыре манула
/// сто восемдесят пять манулов
/// сто восемдесят шесть манулов
/// сто восемдесят семь манулов
/// сто восемдесят восемь манулов
/// сто восемдесят девять манулов
/// сто девяносто манулов
/// сто девяносто один манул
/// сто девяносто два манула
/// сто девяносто три манула
/// сто девяносто четыре манула
/// сто девяносто пять манулов
/// сто девяносто шесть манулов
/// сто девяносто семь манулов
/// сто девяносто восемь манулов
/// сто девяносто девять манулов
/// двести манулов
/// двести один манул
/// двести два манула
/// двести три манула
/// двести четыре манула
/// двести пять манулов
/// двести шесть манулов
/// двести семь манулов
/// двести восемь манулов
/// двести девять манулов
/// двести десять манулов
/// двести одиннадцать манулов
/// двести двенадцать манулов
/// двести тринадцать манулов
/// двести четырнадцать манулов
/// двести пятнадцать манулов
/// двести шестнадцать манулов
/// двести семнадцать манулов
/// двести восемнадцать манулов
/// двести девятнадцать манулов
/// двести двадцать манулов
/// двести двадцать один манул
/// двести двадцать два манула
/// двести двадцать три манула
/// двести двадцать четыре манула
/// двести двадцать пять манулов
/// двести двадцать шесть манулов
/// двести двадцать семь манулов
/// двести двадцать восемь манулов
/// двести двадцать девять манулов
/// двести тридцать манулов
/// двести тридцать один манул
/// двести тридцать два манула
/// двести тридцать три манула
/// двести тридцать четыре манула
/// двести тридцать пять манулов
/// двести тридцать шесть манулов
/// двести тридцать семь манулов
/// двести тридцать восемь манулов
/// двести тридцать девять манулов
/// двести сорок манулов
/// двести сорок один манул
/// двести сорок два манула
/// двести сорок три манула
/// двести сорок четыре манула
/// двести сорок пять манулов
/// двести сорок шесть манулов
/// двести сорок семь манулов
/// двести сорок восемь манулов
/// двести сорок девять манулов
/// двести пятьдесят манулов
/// двести пятьдесят один манул
/// двести пятьдесят два манула
/// двести пятьдесят три манула
/// двести пятьдесят четыре манула
/// двести пятьдесят пять манулов
/// двести пятьдесят шесть манулов
/// двести пятьдесят семь манулов
/// двести пятьдесят восемь манулов
/// двести пятьдесят девять манулов
/// двести шестьдесят манулов
/// двести шестьдесят один манул
/// двести шестьдесят два манула
/// двести шестьдесят три манула
/// двести шестьдесят четыре манула
/// двести шестьдесят пять манулов
/// двести шестьдесят шесть манулов
/// двести шестьдесят семь манулов
/// двести шестьдесят восемь манулов
/// двести шестьдесят девять манулов
/// двести семьдесят манулов
/// двести семьдесят один манул
/// двести семьдесят два манула
/// двести семьдесят три манула
/// двести семьдесят четыре манула
/// двести семьдесят пять манулов
/// двести семьдесят шесть манулов
/// двести семьдесят семь манулов
/// двести семьдесят восемь манулов
/// двести семьдесят девять манулов
/// двести восемдесят манулов
/// двести восемдесят один манул
/// двести восемдесят два манула
/// двести восемдесят три манула
/// двести восемдесят четыре манула
/// двести восемдесят пять манулов
/// двести восемдесят шесть манулов
/// двести восемдесят семь манулов
/// двести восемдесят восемь манулов
/// двести восемдесят девять манулов
/// двести девяносто манулов
/// двести девяносто один манул
/// двести девяносто два манула
/// двести девяносто три манула
/// двести девяносто четыре манула
/// двести девяносто пять манулов
/// двести девяносто шесть манулов
/// двести девяносто семь манулов
/// двести девяносто восемь манулов
/// двести девяносто девять манулов
/// триста манулов...
