#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>
#define endl '\n'
#define fixstd() ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)
#define precision(n) cout.setf(ios::fixed), cout.precision(n)
#define int int64_t
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
#define sz(arr) int(arr.size())
#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define write(s) cout << s << endl
#define debug(s, val) cout << s << ": " << val << endl;
#define out(s) write(s), exit(0)
#define cline() cout << endl
#define yesno(fl) (fl ? "YES" : "NO")
#define read(arr) for (auto &el: arr) cin >> el
#define print(arr) {for (auto el: arr) cout << el << ' '; cline();}
#define inc(arr) for (auto &el: arr) ++el
#define dec(arr) for (auto &el: arr) --el
#define sqr(val) ((val) * (val))
#define pprint(A) for (auto &line: A) print(line)
#define cprint(D) {for (auto p: D) cout << p.fi << ',' << p.se << ' '; cline()}
#define jumpout() assert(NULL)
#define uniq(arr) sort(all(arr)), arr.resize(unique(all(arr)) - arr.begin())
using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
typedef string str;
typedef long double ld;
typedef pair<int, int> col;
typedef pair<ld, ld> cold;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> treap;

int n, m, lim;
vector<vector<int>> G;
vector<int> res, cnt;
stack<int> S;

void init() {
	lim = (m >> 1) + (m & 1);
	G.clear(), G.resize(m);
	res.resize(m);
	cnt.assign(n, 0);
	for (; !S.empty(); S.pop());
}

void init2() {
	for (; !S.empty(); S.pop())
		--cnt[S.top()];
}

inline int choice(const vector<int> &arr) {
	return arr[abs(rand() << 16ll | rand()) % sz(arr)];
}

int go(int ind) {
	if (sz(G[ind]) == 1) return G[ind][0];
	vector<int> tmp;
	for (int val: G[ind]) {
		if (cnt[val] == lim) continue;
		tmp.pb(val);
	}
	if (tmp.empty()) return -1;
	int cur = choice(tmp);
	++cnt[cur];
	S.push(cur);
	return cur;
}

bool check() {
	for (int i = 0; i < m; ++i) {
		int ans = go(i);
		if (ans == -1) return false;
		res[i] = ans;
	}
	return true;
}

bool solve() {
	for (auto &line: G) {
		if (sz(line) > 1) continue;
		++cnt[line[0]];
	}
	if (*max_element(all(cnt)) > lim) return false; // it's strong enough
	while (true) {
		init2();
		bool ans = check();
		if (ans) return true;
	}
	return false;
}

signed main() {
	fixstd();
	srand(time(NULL));
	int q; cin >> q;
	for (; q; --q) {
		cin >> n >> m, init();
		for (int i = 0; i < m; ++i) { // it's ok
			int k; cin >> k;
			G[i].resize(k);
			read(G[i]);
			dec(G[i]);
		}
		bool ans = solve();
		write(yesno(ans));
		inc(res);
		if (ans) print(res);
	}
}
