#include <bits/stdc++.h>
#include <intrin.h>
#include <chrono>
#include <ctime>

using namespace std;
typedef long long ll;
typedef long double ld;
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()
#define rep(i, n) for(int i = 0; i < (n); ++i)
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


/*ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b, a % b);
}


ll ext_gcd(ll a, ll b, ll &x, ll &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    ll x1;
    ll y1;
    ll g = ext_gcd(b % a, a, x1, y1);
    y = x1;
    x = y1 - (b / a) * x1;
    return g;

}*/

vector<vector<int>> meet;
vector<vector<int>> days;
int best_id = -1;
auto cmp = [](int a, int b) {
    return days[a].size() < days[b].size();
};

inline void SOLVE() {
    int n, m;
    cin >> n >> m;
    int ban = (m + 1) / 2;
    best_id = -1;
    days.assign(max(n, m), {});
    meet.assign(max(n, m), {});
    rep(i, m) {
        int k;
        cin >> k;
        rep(j, k) {
            int x;
            cin >> x;
            x--;
            days[i].pb(x);
            meet[x].pb(i);
        }
    }
    rep(i, n) {
        if (meet[i].size() > ban) {
            best_id = i;
            break;
        }
    }

    if (best_id == -1) {
        cout << "YES\n";
        rep(i, m) {
            cout << days[i][0] + 1 << ' ';
        }
        cout << "\n";
    } else {
        vector<int> ans(max(n, m), -1);
        sort(all(meet[best_id]), cmp);
        for (int i = 0; i < ban; ++i) {
            ans[meet[best_id][i]] = best_id;
        }
        rep(i, m) {
            if (ans[i] == -1) {
                int ins = -1;
                for (int e : days[i]) {
                    if (e != best_id) {
                        ins = e;
                        break;
                    }
                }
                ans[i] = ins;
                if (ans[i] == -1) {
                    cout << "NO\n";
                    return;
                }
            }
        }
        cout << "YES\n";
        rep(i, m) {
            cout << ans[i] + 1 << ' ';
        }
        cout << '\n';
    }
}


inline void IO() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
}

int main() {
#ifdef GOSHA
    freopen("../IO/input.txt", "r", stdin);
    freopen("../IO/output.txt", "w", stdout);
#endif
    IO();
    int T = 1;
    cin >> T;
    while (T--) {
        SOLVE();
    }
}
