#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef pair<int, int> pii;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define all(x) (x).begin(), (x).end()
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - x.begin())

const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ll INFLL = 1e18;

ll inq(ll x, ll y)
{
    if (y == 0) return 1;
    ll l = inq(x, y / 2);
    l = l * l % MOD;
    if (y % 2) l = l * x % MOD;
    return l;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int> > a(m);
    vector<vector<int> > pos(n);
    vector<int> musthave(n);
    for (int i = 0; i < m; i++)
    {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++)
        {
            int x;
            cin >> x;
            x--;
            a[i].push_back(x);
            pos[x].push_back(i);
            if (k == 1) musthave[x]++;
        }
    }
    int t = -1;
    int lim = (m + 1) / 2;
    for (int i = 0; i < n; i++)
    {
        if (pos[i].size() >= lim)
        {
            t = i;
        }
        if (musthave[i] > lim)
        {
            cout << "NO\n";
            return;
        }
    }
    if (t == -1)
    {
        cout << "YES\n";
        for (int i = 0; i < m; i++)
        {
            cout << a[i][0] + 1 << " ";
        }
        cout << "\n";
        return;
    }
    vector<int> ans(m, -1);
    for (int i = 0; i < m; i++)
    {
        if (a[i].size() == 1)
        {
            ans[i] = a[i][0];
            if (ans[i] == t) lim--;
        }
    }
    for (int i = 0; i < pos[t].size(); i++)
    {
        int x = pos[t][i];
        if (ans[x] == -1 && lim > 0)
        {
            ans[x] = t;
            lim--;
        }
    }
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < a[i].size(); j++)
        {
            if (ans[i] == -1 && a[i][j] != t)
            {
                ans[i] = a[i][j];
            }
        }
        assert(ans[i] != -1);
    }
    cout << "YES\n";
    for (int i = 0; i < m; i++) cout << ans[i] + 1 << " ";
    cout << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    cout << "\n";
    while (t--)
    {
        solve();
    }
}
