#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define int int32_t
#define ll int64_t

#define uint uint32_t
#define ull uint64_t

#define many_tests

void ios() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<int>> f(m);
    std::vector<std::vector<int>> in(n);
    std::vector<int> uniqueCnt(n, 0);
    std::vector<int> stupidAns(m);
    for (int i = 0; i < m; ++i) {
        int k;
        std::cin >> k;
        f[i].resize(k);
        for (int j = 0; j < k; ++j) {
            std::cin >> f[i][j];
            --f[i][j];
            in[f[i][j]].push_back(i);
        }
        if (k == 1) ++uniqueCnt[f[i][0]];
        stupidAns[i] = f[i][0];
    }

    int pos = -1;

    for (int i = 0; i < n; ++i) {
        if (uniqueCnt[i] > (m + 1) / 2) {
            std::cout << "NO\n";
            return;
        }
        if (in[i].size() > (m + 1) / 2) {
            pos = i;
        }
    }

    std::cout << "YES\n";

    if (pos == -1) {
        for (auto &elem : stupidAns) std::cout << elem + 1 << ' ';
        std::cout << '\n';
    } else {
        int should = in[pos].size() - (m + 1) / 2;
        std::vector<int> ans(m, -1);
        for (auto &ind : in[pos]) ans[ind] = pos;
        for (int i = 0; i < m; ++i) {
            if (ans[i] == -1) {
                ans[i] = f[i][0];
            } else if (should != 0) {
                if (f[i][0] != pos) {
                    ans[i] = f[i][0];
                    --should;
                } else if (f[i].size() > 1 && f[i][1] != pos) {
                    ans[i] = f[i][1];
                    --should;
                }
            }
        }

        for (auto &elem : ans) std::cout << elem + 1 << ' ';
        std::cout << '\n';
    }
}

int main() {
    ios();
#ifdef many_tests
    int ttt;
    std::cin >> ttt;
    while (ttt-- > 0) {
        solve();
    }
#else
    solve();
#endif
    return 0;
}