#include<bits/stdc++.h>

using namespace std;

//#define int long long

using ll = long long;

namespace {
    template<typename T>
    ostream &operator<<(ostream &os, const vector<T> &v) {
        for (auto &e : v) os << e << (is_integral_v<T> && !is_same_v<T, char> ? " " : "");
        return os << '\n';
    }

    template<typename T>
    istream &operator>>(istream &is, vector<T> &v) {
        for (auto &e : v) is >> e;
        return is;
    }

    template<typename F, typename S>
    ostream &operator<<(ostream &os, const pair<F, S> &v) {
        os << v.first << " " << v.second << '\n';
        return os;
    }

    template<typename F, typename S>
    istream &operator>>(istream &is, const pair<F, S> &v) {
        is >> v.first >> v.second;
        return is;
    }
}

void solve();

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> f(m);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        f[i].resize(k);
        cin >> f[i];
    }
    vector<int> probably_answer(m);
    for (int i = 0; i < m; ++i) probably_answer[i] = f[i].front();
    vector<int> count(n + 1);
    for (int fr : probably_answer) count[fr]++;
    if (auto iter = max_element(count.begin(), count.end()); *iter <= (m + 1) / 2) {
        cout << "YES\n" << probably_answer;
        return;
    } else {
        int cnt = *iter;
        for (int i = 0; i < m; ++i) {
            if (probably_answer[i] == iter - count.begin() && f[i].size() > 1 && cnt > (m + 1) / 2) {
                probably_answer[i] = f[i][1];
                cnt--;
            }
        }
        if (cnt > (m + 1) / 2) cout << "NO\n"; else cout << "YES\n" << probably_answer;
    }
}