#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <math.h>
#include <cmath>
#include <complex>
#include <algorithm>

using namespace std;

#define rep(i, n) for (ll i = 0; i < n; i++)
#define reep(i, a, n) for (ll i = a; i < n; i++)
#define per(i, n) for (ll i = n - 1; i >= 0; i--)

#define all(x) x.begin(), x.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define sz(x) (int)x.size()
#define len() length()

#define ff first
#define ss second

#define print2(a, b) cout << a << ' ' << b << endl
#define print3(a, b, c) cout << a << ' ' << b << ' ' << c << endl
#define print4(a, b, c, d) cout << a << ' ' << b << ' ' << c << '' << d << endl
#define printvec(a)       \
    for (auto _ : a)      \
        cout << _ << ' '; \
    cout << endl

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main()
{
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);

    int n = 1;

    cin >> n;

    rep(i, n) solve();
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<vi> a(m);
    vector<vi> b(n);
    vi used(n);
    rep(i, m)
    {
        int k;
        cin >> k;
        a[i].resize(k);
        rep(j, k) cin >> a[i][j];
        rep(j, k) a[i][j]--;
        rep(j, k) b[a[i][j]].pb(i);
    }
    vi ans(m, -1);
    rep(i, m)
    {
        if (sz(a[i]) == 1)
        {
            used[a[i][0]]++;
            ans[i] = a[i][0];
        }
    }
    rep(i, n)
    {
        for (auto c : b[i])
        {
            if (used[i] >= (m + 1) / 2)
                break;
            if (ans[c] == -1)
            {
                ans[c] = i;
                used[i]++;
            }
        }
    }
    //printvec(ans);
    rep(i, n)
    {
        if (used[i] > (m + 1) / 2)
        {
            cout << "NO" << endl;
            return;
        }
    }
    rep(i, m)
    {
        if (ans[i] == -1)
        {
            cout << "NO" << endl;
            return;
        }
    }
    cout << "YES\n";
    rep(i, m)
    {
        cout << ans[i] + 1 << ' ';
    }
    cout << endl;
}