﻿#include <iostream>
#include <string>
#include <math.h>
#include <cstring>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <assert.h>
#include <istream>
#include <ostream>
#include <vector>
#include <algorithm>

#define ll long long
#define ld long double

#define int long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

#define all(a) a.begin(), a.end()
#define mysort(a) sort(all(a))
#define myreverse(a) reverse(all(a))
#define myunique(a) unique(all(a))
#define superunique(a) a.resize(myunique(a) - a.begin())

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define FOD(i, r, l) for (int i = r; i >= l; i--)


using namespace std;

template <class T1, class T2>
istream& operator>>(istream & in, pair<T1, T2>&val) {
    return in >> val.ft >> val.sd;
}

template <class T1, class T2>
ostream& operator<<(ostream & out, pair<T1, T2>&val) {
    return out << val.ft << ' ' << val.sd;
}

template <class T1>
istream& operator>>(istream& in, vector<T1>& val) {
    FOR(i, 0, val.size())
        in >> val[i];
    return in;
}

template <class T1>
ostream& operator<<(ostream& out, vector<T1>& val) {
    FOR(i, 0, val.size())
        out << val[i] << ' ';
    out << '\n';
    return out;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> friends(m);
    vector<int> cnt(n);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        friends[i].resize(k);
        FOR(j, 0, k) {
            cin >> friends[i][j];
            friends[i][j]--;
            cnt[friends[i][j]]++;
        }
    }
    vector<int> ans(m, -1);
    int cap = (m - 1) / 2 + 1;
    int unans = 0;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < friends[i].size(); j++) {
            if (cnt[friends[i][j]] <= cap)
                ans[i] = friends[i][j] + 1;
        }
        if (ans[i] == -1)
            unans++;
    }
    int overcap = 0;
    for (int i = 0; i < n; i++)
        if (cnt[i] > cap)
            overcap++;
    if (unans <= overcap * cap) {
        cout << "YES\n";
        vector<int> used(n);
        for (int i = 0; i < m; i++)
            if (ans[i] == -1) {
                int cntover = 0;
                for (int j = 0; j < friends[i].size(); j++)
                    if (cnt[friends[i][j]] > cap)
                        cntover++;
                if (cntover == 1)
                    for (int j = 0; j < friends[i].size(); j++)
                        if (cnt[friends[i][j]] > cap) {
                            ans[i] = friends[i][j] + 1;
                            used[friends[i][j]]++;
                        }
            }
        for (int i = 0; i < m; i++)
            if (ans[i] == -1)
                for (int j = 0; j < friends[i].size(); j++)
                    if (cnt[friends[i][j]] > cap && used[friends[i][j]] < cap) {
                        ans[i] = friends[i][j] + 1;
                        used[friends[i][j]]++;
                        break;
                    }

        cout << ans;
    }
    else
        cout << "NO\n";
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}