#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define int ll
#define ull unsigned long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define pb push_back
#define pii pair<int, int>

tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

mt19937_64 gen(time(0));

#ifdef SashOK
    const int M = 1e3 + 7;
#else
    const int M = 1e5 + 7;
#endif // SashOK
const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const ull HESH = 31;

vector<int> koll;

bool comp(int a, int b){
    return koll[a] < koll[b];
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> g[m];
    vector<int> gg[n + 2];
    vector<int> used(m, 0);
    koll.clear();
    koll.resize(n + 2, 0);
    for(int i = 0; i < m; i++){
        int sz;
        cin >> sz;
        for(int j = 0; j < sz; j++){
            int x;
            cin >> x;
            g[i].pb(x);
            gg[x].pb(i);
            koll[x]++;
        }
    }
    priority_queue<pii> q;
    for(int i = 0; i <= n; i++){
        q.push({(int)gg[i].size(), i});
    }
    for(int i = 0; i < m; i++){
        sort(g[i].begin(), g[i].end(), comp);
    }
    koll.clear();
    koll.resize(n + 2, 0);
    for(int i = 0; i < m; i++){
        if(g[i].size() == 1){
            if(koll[g[i][0]] + 1 > m / 2 + (m & 1)){
                cout << "NO\n";
                return;
            }
            koll[g[i][0]]++;
            used[i] = g[i][0];
        }
    }
    cerr << "LOL\n";
    while(!q.empty()){
        int sz = q.top().F;
        int v = q.top().S;
        q.pop();
//        cerr << sz << ' ' << v << endl;
//        if(sz == 0)continue;
        for(int i = 0; i < sz; i++){
//            cerr << v << '\n';
            if(koll[v] + 1 > m / 2 + (m & 1))break;
            if(used[gg[v][i]] == 0){
                used[gg[v][i]] = v;
                koll[v]++;
            }
        }
    }
    int f = 1;
    for(int i = 0; i < m; i++){
//        cout << used[i] << ' ';
//        for(auto to:g[i]){
//            if(koll[to] + 1 > m / 2 + (m & 1))continue;
//            used[i] = to;
//            koll[to]++;
//            break;
//        }
        if(used[i] == 0){f = 0;break;}
    }
//    cout << endl;
    if(!f){cout << "NO\n";return;}
    cout << "YES\n";
    for(int i = 0; i < m; i++){
        cout << used[i] << ' ';
    }
    cout << endl;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef SashOK
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // SashOK
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}
