#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define len(v) (int)(v).size()
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define yes cout << "YES" << "\n";
#define no cout << "NO" << "\n";
#define int long long

struct segtree {
    vector<int> tree;
    int len;

    void init(int n) {
        len = n;
        tree.assign(4 * n, 0);
    }

    int make(int a, int b) {

    }

    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a[lx];
            return;
        }
        int m = (lx + rx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        tree[x] = tree[2 * x + 2] + tree[2 * x + 1];
    }

    void build(vector<int> &a) {
        init(len(a));
        build(a, 0, 0, len);
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (lx >= r || rx <= l) return 0;
        if (rx <= r && lx >= l) return tree[x];
        int m = (lx + rx) / 2;
        int x1 = get(l, r, 2 * x + 1, lx, m);
        int x2 = get(l, r, 2 * x + 2, m, rx);
        return x1 + x2;
    }

    int get(int l, int r) {
        return get(l, r, 0, 0, len);
    }


};


int len_num(int a) {
    if (a == 0) return 1;
    int cnt = 0;
    while (a != 0) {
        cnt++;
        a /= 10;
    }
    return cnt;
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int binpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int b = binpow(a, n / 2);
        return b * b;
    } else {
        return binpow(a, n - 1) * a;
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        map<int, vector<int>> free;
        map<int,int> waste;
        bool ok = 1;
        for (int i = 0; i < m; ++i) {
            int k;
            cin >> k;
            if (k == 1){
                int x;cin>>x;
                waste[x]++;
                if (waste[x] > (m+1)/2) ok = 0;
                free[i].emplace_back(x);
                continue;
            }
            for (int j = 0; j < k; ++j) {
                int x;cin >> x;
                free[i].emplace_back(x);
            }
        }
        vector<int> ans;
        for (int i = 0;i < m;++i){
            int waste_min = 1e9;
            int play_with = -1;
            if (len(free[i]) == 1){
                ans.emplace_back(free[i][0]);
                continue;
            }
            for (auto man : free[i]){
                if (waste[man] < waste_min){
                    waste_min = waste[man];
                    play_with = man;
                }
            }
            if (waste[play_with]+1 > (m+1)/2){
                ans.clear();
                break;
            }
            waste[play_with]++;
            ans.emplace_back(play_with);
        }
        if (len(ans) == 0 || !ok){
            no;
        }
        else{
            yes;
            for (auto i : ans){
                cout << i << " ";
            }
            cout <<"\n";
        }
    }
    return 0;
}