#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

const int MAXN = 1e5 + 123;
vector<int> fr[MAXN];
int cnt_deter[MAXN];

void solve(){
	int n, m;
	cin >> n >> m;
	for(int i = 0; i < n; i++)
		cnt_deter[i] = 0;
	for(int i = 0; i < m; i++){
		int k;
		cin >> k;
		fr[i].resize(k);
		for(auto& x : fr[i]){
			cin >> x;
			x--;
		}
		if(k == 1){
			cnt_deter[fr[i][0]]++;
		}
	}
	for(int i = 0; i < n; i++){
		if(cnt_deter[i] > (m + 1) / 2){
			cout << "NO";
			return;
		}
	}
	cout << "YES\n";
	for(int i = 0; i < m; i++){
		if(fr[i].size() > 1){
			if(cnt_deter[fr[i][0]] + 1 <= (m + 1) / 2){
				cout << fr[i][0] + 1 << ' ';
				cnt_deter[fr[i][0]]++;
			} else {
				cout << fr[i][1] + 1 << ' ';
				cnt_deter[fr[i][1]]++;
			}
		} else {
			cout << fr[i][0] + 1 << ' ';
		}
	}
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int t;
	cin >> t;
	while(t--){
		solve();
		cout << '\n';
	}
}
