#include <stdio.h>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <cassert>

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	const int UNDEF = -1;
	int nT;
	scanf("%d", &nT);
	for (int t = 0; t < nT; t++) {
		int nFriends, nDays;
		scanf("%d %d", &nFriends, &nDays);
		std::vector<int> chosedId(nDays, UNDEF);
		std::vector<int> have(nFriends + 1, 0);
		std::vector<int> used(nFriends + 1, 0);
		std::vector<std::vector<int>> a(nDays);
		for (int iDay = 0; iDay < nDays; iDay++) {
			int n;
			scanf("%d", &n);
			for (int i = 0; i < n; i++) {
				int curFriend;
				scanf("%d", &curFriend);
				a[iDay].push_back(curFriend);
				have[curFriend]++;
				if (n == 1) {
					used[curFriend]++;
					chosedId[iDay] = curFriend;
				}
			}
		}

		bool isPossible = true;
		for (int iDay = 0; iDay < nDays; iDay++) {
			for (int iFriend = 0; iFriend < (int)a[iDay].size(); iFriend++) {
				int curFriend = a[iDay][iFriend];
				if (chosedId[iDay] == UNDEF && 
					(used[curFriend] + 1) <= (nDays + 1) / 2
				) {
					used[curFriend]++;
					chosedId[iDay] = curFriend;
				}
				 
				if (used[curFriend] > (nDays + 1) / 2) {
					isPossible = false;
					break;
				}
			}

			if (!isPossible) {
				break;
			}
		}
		

		if (isPossible) {
			printf("YES\n");
			for (int item : chosedId) {
				printf("%d ", item);
			}
			printf("\n");
		} else {
			printf("NO\n");
		}
	}
	return 0;
}