#include <bits/stdc++.h>

#define endl '\n'
#define pb push_back
#define fi first
#define se second
#define ll long long int
#define pll pair<ll, ll>
#define all(v) v.begin(), v.end()

using namespace std;

ostream& operator<< (ostream& a, const vector<ll>& v) {
  for (ll x : v) cout << x << " ";
  cout << '\n';
  return a;
}

ostream& operator<< (ostream& a, const pll& v) {
  cout << "{ " << v.fi << ", " << v.se << " }" << '\n';
  return a;
}

ostream& operator<< (ostream& a, const vector<pll>& v) {
  for (pll x : v) cout << x << " ";
  cout << '\n';
  return a;
}

#ifdef HOME
  #define dbg(x) cout << #x << " :: " << x;
#else
  #define dbg(x)
#endif

mt19937 rnd(clock() + 228);

const ll INF = (ll)1e18;
const ll mod = 1000 * 1000 * 1000 + 7;
const ll maxn = (ll)2e5 + 10, L = 22;

int main() {
#ifdef HOME
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
  ll T = 1;
  cin >> T;
  while (T--) {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(m);
    vector<ll> cnt(n + 1);
    for (ll i = 0; i < m; ++i) {
      ll k;
      cin >> k;
      a[i].resize(k);
      for (ll j = 0; j < k; ++j)
        cin >> a[i][j];
      if (k == 1)
        ++cnt[a[i][0]];
    }
    vector<ll> ans(m);
    for (ll i = 0; i < m; ++i) {
      if (a[i].size() == 1) {
        ans[i] = a[i][0];
        continue;
      }
      dbg(cnt);
      dbg(a[i]);
      ll mn = INF, wht = -1;
      for (ll x : a[i]) {
        if (cnt[x] < mn) {
          mn = cnt[x];
          wht = x;
        }
      }
      ans[i] = wht;
      ++cnt[wht];
    }
    ll mx = 0;
    for (ll x : cnt)
      mx = max(mx, x);
    if (mx > (m + 1) / 2) {
      cout << "NO\n";
    } else {
      cout << "YES\n" << ans << endl;
    }
  }
  return 0;
}

















































