#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <iostream>
#include <algorithm>

#define ll long long
#define f first
#define s second
#define pii pair <int, int>
#define pb push_back

using namespace std;

const int N = 1e6 * 2 + 100;
const int INF = 1e9 + 100;

int used[N], dp[N];
vector <vector <int> > v(N);
vector <int> p;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int q;
	cin >> q;

	while (q--) {
		int n, m, ans = 1;
		cin >> n >> m;
		p.clear();

		for (int i = 0; i <= n; i++)
			dp[i] = 0;

		for (int i = 0; i < m; i++)
		{
			int k, a;
			cin >> k;
			v[i].clear();
			if (k == 1)
			{
				cin >> a;
				dp[a]++;
				v[i].push_back(a);
			}
			else
				for (int j = 0; j < k; j++) {
					cin >> a;
					v[i].push_back(a);
				}
		}

		for (int i = 0; i <= n; i++)
			if (dp[i] > m / 2 + m % 2)
				ans = 0;

		for (int i = 0; i < m; i++) {
			pii mi = { INF, 0 };
			for (int j = 0; j < v[i].size(); j++) {
				if (dp[v[i][j]] < mi.first)
					mi = { dp[v[i][j]], j };
			}
			if (v[i].size() > 1)
				dp[v[i][mi.second]]++;
			p.pb(v[i][mi.second]);

		}

		if (ans) {
			cout << "YES\n";
			for (int i = 0; i < p.size(); i++)
				cout << p[i] << " ";
			cout << "\n";
		}
		else
			cout << "NO\n";
	}

}