#include <iostream>
#include <vector>

#define ll long long
#define ld double
#define ft first
#define sd second
#define pb push_back

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector <ll> days[m], cnt(n), ans(m);
        for (ll i = 0; i < m; ++i) {
            ll k;
            cin >> k;
            for (ll j = 0; j < k; ++j) {
                ll x;
                cin >> x;
                --x;
                days[i].pb(x);
            }
            if (k == 1) {
                ++cnt[days[i][0]];
                ans[i] = days[i][0];
            }
        }

        for (ll i = 0; i < m; ++i) {
            if (days[i].size() != 1) {
                ll ind = -1;
                for (auto &j: days[i]) {
                    if (ind == -1 || cnt[j] < cnt[ind])
                        ind = j;
                }
                ++cnt[ind];
                ans[i] = ind;
            }
        }
        bool good = 1;
        for (ll i = 0; i < n; ++i) {
            if (cnt[i] > (m + 1) / 2) {
                good = 0;
                break;
            }
        }
        if (good) {
            cout << "YES\n";
            for (ll i = 0; i < m; ++i) {
                cout << ans[i] + 1 << ' ';
            }
            cout << '\n';
        }
        else {
            cout << "NO\n";
        }
    }
    return 0;
}
