#include <bits/stdc++.h>
#include <immintrin.h>

using namespace std;

void IO(){
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

template <typename T, typename D>
istream& operator>>(istream& in, pair<T, D>& a) {
    in >> a.first >> a.second;
    return in;
}

template <typename T, typename D>
ostream& operator<<(ostream& out, const pair<T, D>& a) {
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}


typedef long long ll;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define sz(x) ((int)x.size())
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>
#define ti tuple<int,int,int>
#define mod(x, m) ((x % m + m) % m)

const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const long double PI = acos(-1);
auto seed = time(NULL);
mt19937 rnd(seed);

//#define int ll

void Solve() {
    int n, m;
    cin >> n >> m;
    vi cnt(n + 1, 0);
    int need = (m + 1) / 2;
    vector <vi> a(m);
    vi ans(m);
    forn(i, m) {
        int k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
        if (sz(a[i]) == 1) {
            cnt[a[i][0]]++;
            ans[i] = a[i][0];
        }
    }
    forn(i, m) {
        if (sz(a[i]) == 1) {continue;}
        int want = a[i][0];
        for (auto x : a[i]) {
            if (cnt[want] > cnt[x]) {
                want = x;
            }
        }
        cnt[want]++;
        ans[i] = want;
    }
    for (int i = 1; i <= n; ++i) {
        if (cnt[i] > need) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << ans << '\n';
}

signed main() {
    int start = clock();
    IO();
    int t = 1;
    cin >> t;
    while(t--) {
        Solve();
    }
#ifdef DIVAN
    cout << '\n' << "Time: " << (clock() - start + 999) / 1000 << '\n';
#endif
}
