#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using vvi = vector<vi>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, true : false; }

mt19937 rng(1337228);

struct RC {
    int32_t H = 1337228;

    template<class T>
    friend RC& operator >> (RC& rin, T& x) {
        cin >> x;
        return rin;
    }

    friend RC& operator >> (RC& rin, int& x) {
        cin >> x;
        rin.H ^= x * 1337;
        rin.H *= 3;
        return rin;
    }

    friend RC& operator >> (RC& rin, ll& x) {
        cin >> x;
        rin.H ^= x * 229;
        rin.H *= 7;
        return rin;
    }

    friend RC& operator >> (RC& rin, string& s) {
        cin >> s;
        static const int P = 97;
        for (char c : s) {
            rin.H = rin.H * P ^ c;
        }
        return rin;
    }
} rin;

void initRandom() {
    rng.seed(rin.H);
}

void solve() {
    int n, m; cin >> n >> m;
    vector<vi> v(m);
    vi f(n+1), t(m);
    for (int i = 0; i < m; ++i) {
        int k; cin >> k;
        v[i].resize(k);
        for (int& x : v[i]) {
            cin >> x;
        }
        f[t[i] = v[i][0]]++;
    }

    for (int i = 1; i <= n; ++i) {
        if (f[i] <= (m+1)/2) continue;
        for (int j = 0; j < m && f[i] > (m+1)/2; ++j) {
            if (t[j] == i && v[j].size() >= 2) {
                f[i]--;
                f[t[j] = v[j][1]]++;
            }
        }

        if (f[i] > (m+1)/2) {
            cout << "NO" << '\n';
            return;
        }
    }

    cout << "YES" << '\n';
    for (int i : t) cout << i << ' ';
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int t; cin>> t;
    while(t--) solve();
}