// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast,unroll-all-loops")
#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define pb push_back
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define all(a) a.begin(), a.end()
#define mp make_pair

using namespace std;

const int max_n = 1e5 + 5;
const int inf = 1e9;
const int log_n = 21;

void run() {
    int n, m;
    cin >> n >> m;
    int need = (m + 1) / 2;
    vector<int> cnt(n, 0);
    vector<vector<int>> g(n);
    vector<vector<int>> g_rev(m);
    rep(i, m) {
        int k;
        cin >> k;
        rep(j, k) {
            int el;
            cin >> el;
            el--;
            g[el].pb(i);
            g_rev[i].pb(el);
        }
    }
    int mx = -1;
    int id = -1;
    rep(i, n) {
        if ((int)g[i].size() > mx) {
            mx = g[i].size();
            id = i;
        }
    }
    if (g[id].size() > need) {
        sort(all(g[id]), [&g_rev](int n1, int n2){
            return g_rev[n1].size() < g_rev[n2].size();
        });
        vector<int> ans(m, -1);
        rep(i, need) {
            if (i >= g[id].size()) break;
            int el = g[id][i];
            ans[el] = id;
        }
        rep(i, m) {
            if (ans[i] != -1) continue;
            for (auto el : g_rev[i]) {
                if (el == id) continue;
                ans[i] = el;
                break;
            }
            if (ans[i] == -1) {
                cout << "NO\n";
                return;
            }
        }
        cout << "YES\n";
        for (int x : ans) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    } else {
        vector<int> ans(m, -1);
        rep(i, m) {
            ans[i] = g_rev[i][0];
        }
        cout << "YES\n";
        for (auto x : ans) {
            cout << x + 1 << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    #ifndef ONLINE_JUDGE
        // files("input.txt", "output.txt");
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        run();
    }
    return 0;
}