#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <queue>
#include <queue>
#include <queue>

using namespace std;
using ll = long long;
#define TL(x) while(x){}

#define MAXN 200010
/*
vector<int> g[MAXN];
bool used[MAXN];
int p[MAXN];

bool dfs(int from){
    used[from] = 1;
    for(int to : g[from]){
        if(!used[to] && p[to] == -1){
            p[from] = to;
            p[to] = from;
            return true;
        }
    }
    for(int to : g[from]){
        if(!used[to] && !used[p[to]]){
            if(dfs(to)){
                p[from] = to;
                p[to] = from;
                return true;
            }
        }
    }

    return false;
}
 */


int main() {

    int t;
    cin >> t;
    while(t--){
        int n,m;
        cin >> n >> m;

        map<int,int> cnt;//cnt, i
        vector<int> used(m + 1);
        fill(used.begin(), used.end(), 0);
        vector<vector<int>> from(n+1);
        vector<vector<int>> days(m+1);

        //priority_queue<pair<int, int>> q; //prior, day
        set<pair<int,int>> q;
        vector<int> size(m + 1);
        for (int i = 1; i <= m; ++i) {
            int f;
            cin >> f;
            for (int j = 0; j < f; ++j) {
                int x;
                cin >> x;

                cnt[x]++;
                from[x].push_back(i);
                days[i].push_back(x);
            }
            size[i] = f;
            q.insert({f, i});
    //            q.push({-f, i});
        }
        vector<int> usedcnt(n + 1);

        int bound = (m - 1) / 2 + 1;
        while(q.size()){
            auto top = q.begin();
            int day = top->second;
            int len = top->first;
            q.erase(top);
            if(used[day]) continue;

            for(int fr : days[day]){
                if(usedcnt[fr] < bound){
                    usedcnt[fr]++;
                    used[day] = fr;
                    size[day] = 0;
                    if(usedcnt[fr] == bound){
                        for(int daywith : from[fr]){
                            if(size[daywith]){
                                q.erase({size[daywith], daywith});
                                q.insert({--size[daywith], daywith});
                            }
                        }
                    }
                    break;
                }
            }
        }

        bool good = true;
        for (int i = 1; i <= m; ++i) {
            if (used[i] == 0) {
                good = false;
                break;
            }
        }
        if(!good){
            cout << "NO" << "\n";
            continue;
        }
        cout << "YES\n";
        for (int i = 1; i <= m; ++i) {
            cout << used[i] << " ";
        }
        cout << "\n";
        /*
        fill(p, p + n+m+10, -1);
        fill(g, g+n + m + 10, vector<int>());

        for (int i = 1; i <= m; ++i) {
            int f;
            cin >> f;
            for (int j = 0; j < f; ++j) {
                int x;
                cin >> x;
                g[n + i].push_back(x);
                g[x].push_back(n + i);
            }
        }

        for (int i = 1; i <= n; ++i) {
            fill(used, used + n + m + 10, 0);
            if(p[i] == -1){
                dfs(i);
            }
        }

        vector<bool> playedWith(n + 1);

        for (int i = 1; i <= n; ++i) {

        }

5
2 7
2 1 2
2 1 2
2 1 2
2 1 2
1 2
1 1
1 1
        2
         2
         2
         1
         2
         1
         1
         */
    }



    return 0;
}
