#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    vvi f(m);
    for (int i = 0; i < m; i++) {
      int k;
      cin >> k;
      f[i].resize(k);
      for (int j = 0; j < k; j++) {
        cin >> f[i][j];
        f[i][j]--;
      }
    }
    int limit = (m + 1) / 2;
    vi p(m);
    for (int i = 0; i < m; i++)
      p[i] = i;
    sort(p.begin(), p.end(), [&](int i, int j) {
      return f[i].size() < f[j].size();
    });
    vi cnt(n);
    vi ans(m);
    for (int id : p) {
      int fr = -1;
      for (int x : f[id])
        if (fr == -1 || cnt[x] < cnt[fr])
          fr = x;
      cnt[fr]++;
      ans[id] = fr + 1;
    }
    bool flag = true;
    for (int i = 0; i < n; i++)
      if (cnt[i] > limit)
        flag = false;
    if (flag) {
      cout << "YES\n";
      for (int x : ans)
        cout << x << ' ';
      cout << '\n';
    } else {
      cout << "NO\n";
    }
  }
  return 0;
}
