#include <bits/stdc++.h>

using namespace std;


typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;


const int MAX_N = 1e5 + 1;
int pl[MAX_N], who[MAX_N];
vector <int> fr[MAX_N];


void solve() {
    int n, m;
    cin >> n >> m;
    fill(pl, pl + n + 1, 0);
    //fill(who, who + m + 1, 0);

    for (int i = 1; i <= m; ++i) {
        int k;
        cin >> k;
        fr[i].clear();
        fr[i].resize(k);
        for (int j = 0; j < k; ++j)
            cin >> fr[i][j];
        if (k == 1) {
            who[i] = fr[i][0];
            ++pl[fr[i][0]];
        }
    }

    int mx_play = (m + 1) / 2;

    bool ok = 1;
    for (int i = 1; i <= m; ++i) {
        if (fr[i].size() == 1)
            continue;
        bool cur_ok = 0;
        for (auto e : fr[i]) {
            if (pl[e] < mx_play) {
                ++pl[e];
                who[i] = e;
                cur_ok = 1;
                break;
            }
        }
        ok &= cur_ok;
    }
    for (int i = 1; i <= n; ++i)
        ok &= pl[i] <= mx_play;
    if (!ok) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    for (int i = 1; i <= m; ++i)
        cout << who[i] << ' ';
    cout << '\n';

}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
