#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define mod(x, m) (((x) % (m) + (m)) %(m))
#define modeq(x, m) x=mod(x, m)
#define sz(x) int(x.size())

typedef int64_t int64;
typedef int64_t ll;
typedef double dbl;

void input() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(10);
#ifdef DEBUGLVL
    freopen("output.txt", "w", stdout);
#endif
}

int64 get_int() {
    char ch = getchar();
    while (!isdigit(ch)) {
        ch = getchar();
    }
    int64 ret = 0;
    while (isdigit(ch)) {
        ret = (ret * 10) + (ch - '0');
        ch = getchar();
    }
    return ret;
}

void cinArr(vector<int64> &arr) {
    for (int i = 0; i < sz(arr); i++) {
        cin >> arr[i];
    }
}

void cinArr(vector<int> &arr) {
    for (int i = 0; i < sz(arr); i++) {
        cin >> arr[i];
    }
}

void cinArr(vector<string> &arr) {
    for (int i = 0; i < sz(arr); i++) {
        cin >> arr[i];
    }
}

int64 gcd(int64 a, int64 b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int64 bin_pow(int64 a, int64 n, int64 m=INT64_MAX-1) {
    int64 ret = 1;
    while (n) {
        if (n&1) {
            ret *= a;
        }
        a *= a;
        a %= m;
        ret %= m;
        n >>= 1;
    }
    return ret;
}

bool cmp(pair<vector<int>, int> &a, pair<vector<int>, int> &b) {
    return sz(a.first) < sz(b.first);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<vector<int>, int> > arr(m);
    vector<int> ans(m);
    for (int i = 0; i < m; i++) {
        int a;
        cin >> a;
        arr[i].first.resize(a);
        cinArr(arr[i].first);
        arr[i].second = i;
    }
    vector<int> cnt(n, (m + 1) / 2);
    sort(all(arr), cmp);
    for (int i = 0; i < m; i++) {
        int mxEl = arr[i].first[0] - 1;
        for (int j = 1; j < sz(arr[i].first); j++) {
            if (cnt[mxEl] < cnt[arr[i].first[j] - 1])
                mxEl = arr[i].first[j] - 1;
        }
        if (cnt[mxEl] == 0) {
            cout << "NO\n";
            return;
        }
        ans[arr[i].second] = mxEl + 1;
        cnt[mxEl]--;
    }
    cout << "YES\n";
    for (int i = 0; i < m; i++) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int32_t main() {
    input();
    int q = 1;
//#ifdef DEBUGLVL
    cin >> q;
//#endif
    while (q--) {
        solve();
    }
    return 0;
}












