#include <iostream>
#include <vector>
#include <iomanip>
#include <string>
#include <string.h>
#include <map>
#include <set>
#define int long long
using namespace std;

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t, n, m, k, f;
    cin >> t;
    while (t --) {
        cin >> n >> m;
        vector<vector<int>> days(m);
        vector<int> cnt(n, 0), cnt2(n, 0), ans(m, 0);
        for (int i = 0; i < m; i++) {
            cin >> k;
            for (int j = 0; j < k; j++) {
                cin >> f;
                f --;
                if (k == 1) {
                    cnt[f] ++;
                    cnt2[f] ++;
                    ans[i] = f + 1;
                }
                days[i].push_back(f);
            }
        }
        int r = (m + 1) / 2;
        int mx = 0;
        for (int i = 0; i < n; i++) {
            mx = max(mx, cnt[i]);
        }
        if (mx > r){
            cout << "NO" << endl;
            continue;
        }
        bool fl = true;
        for (int i = 0; i < m; i ++){
            if (ans[i] != 0){
                continue;
            }
            int idx = 0;
            while (idx < days[i].size() && cnt[days[i][idx]] >= r){
                idx ++;
            }
            if (idx == days[i].size()){
                fl = false;
                break;
            }
            cnt[days[i][idx]]++;
        }
        if (!fl) {
            cout << "NO" << endl;
            continue;
        }
        cout << "YES" << endl;
        for (int i = 0; i < m; i ++){
            if (ans[i] != 0){
                cout << ans[i] << " ";
                continue;
            }
            int idx = 0;
            while (idx < days[i].size() && cnt2[days[i][idx]] >= r){
                idx ++;
            }
            cnt2[days[i][idx]] ++;
            cout << days[i][idx] + 1 << " ";
        }
        cout << endl;
    }
}