#include <iostream>
#include <cstring>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	for (int t1 = 0; t1 < t; t1++)
	{
		int n, m;
		cin >> n >> m;
		pair<int, int>* free = new pair<int, int>[m];
		for (int i = 0; i < m; i++)
		{
			free[i] = { -1, -1 };
			int k, f;
			cin >> k;
			for (int j = 0; j < k; j++)
			{
				cin >> f;
				f--;
				if (j == 0)
					free[i].first = f;
				else if (j == 1)
					free[i].second = f;
			}
		}
		int* cnt = new int[n];
		memset(cnt, 0, n * sizeof(int));
		for (int i = 0; i < m; i++)
			cnt[free[i].first]++;
		int mx = (m + 1) / 2;
		int bad = -1;
		for (int i = 0; i < n; i++)
		{
			if (cnt[i] > mx)
				bad = i;
		}
		if (bad != -1)
		{
			for (int i = 0; i < m && cnt[bad] > mx; i++)
			{
				if (free[i].first == bad && free[i].second != -1)
				{
					swap(free[i].first, free[i].second);
					cnt[bad]--;
					cnt[free[i].first]++;
				}
			}
			if (cnt[bad] > mx)
			{
				cout << "NO" << "\n";
				continue;
			}
		}
		cout << "YES" << "\n";
		for (int i = 0; i < m; i++)
			cout << free[i].first + 1 << " ";
		cout << "\n";
	}
}
