#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <climits>
#include <cassert>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>
#include <numeric>

#define sz(a) (int)(a).size()
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

void solve() {
	int n, m;
	cin >> n >> m;

	int limit = (m - 1) / 2 + 1;

	vector<vector<int>> f(m);
	for (int i = 0; i < m; ++i) {
		int k;
		cin >> k;
		f[i].resize(k);
		for (auto& x : f[i]) {
			cin >> x;
			--x;
		}
	}

	vector<int> c(m);
	vector<int> cnt(n);

	for (int i = 0; i < m; ++i) {
		if (sz(f[i]) == 1) {
			++cnt[f[i][0]];
			c[i] = f[i][0];
		}
	}

	for (int i = 0; i < m; ++i) {
		if (sz(f[i]) > 1) {
			int best = f[i][0];
			for (int j = 1; j < sz(f[i]); ++j) {
				if (cnt[f[i][j]] < cnt[best]) {
					best = f[i][j];
				}
			}
			++cnt[best];
			c[i] = best;
		}
	}

	int mx_cnt = *max_element(all(cnt));
	if (mx_cnt > limit) {
		cout << "NO\n";
	}
	else {
		cout << "YES\n";
		for (int i = 0; i < m; ++i) {
			cout << c[i] + 1 << " ";
		}
		cout << "\n";
	}
}

int main() {
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
	
	int t;
	cin >> t;

	while (t--) {
		solve();
	}

	return 0;
}