#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

#define sz(x) (int((x).size()))
#define pb push_back
#define ins insert
#define ers erase

template<typename T>
T gcd(T a, T b) {
    return b ? gcd(b, a % b) : a;
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll MAXN = 1e5 + 10;

vector<int> days[MAXN];
int selected[MAXN], used[MAXN];

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i <= max(n, m); i++) {
        days[i].clear();
        selected[i] = -1;
        used[i] = 0;
    }

    for (int day = 0; day < m; day++) {
        int free;
        cin >> free;

        for (int f = 0; f < free; f++) {
            int friend_;
            cin >> friend_;

            friend_--;

            days[day].pb(friend_);

            if (selected[day] == -1) {
                used[friend_]++;
                selected[day] = friend_;
            }
        }
    }

    int more_than_half = -1;
    for (int friend_ = 0; friend_ < n; friend_++) {
        if ((m + 1) / 2 < used[friend_]) {
            more_than_half = friend_;
            break;
        }
    }

    if (more_than_half != -1) {
        //cerr << more_than_half << " " << used[more_than_half] << "\n";
        for (int i = 0; i < m; i++) {
            if (selected[i] != more_than_half) {
                continue;
            }

            for (int friend_ : days[i]) {
                //cerr << i << " " << friend_ << "\n";
                if (friend_ != more_than_half) {
                    selected[i] = friend_;
                    used[friend_]++;
                    used[more_than_half]--;
                    break;
                }
            }

            if (used[more_than_half] <= (m + 1) / 2) {
                goto finish;
            }
        }

        //cerr << more_than_half << " " << used[more_than_half] << "\n";
        cout << "NO";
        return;
    }

    finish:;
    cout << "YES\n";
    for (int i = 0; i < m; i++) {
        cout << (selected[i] + 1) << " ";
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;

#ifdef _LOCAL_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> t;
#else
    cin >> t;
#endif

    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}
