//
// Created by omega_alpha on 21.03.2021
//

#include <bits/stdc++.h>
using namespace std;
//#define int long long
#define FF first
#define SS second
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define mp make_pair
#define pb push_back
#define pf push_front

using ll = long long;
using ld = long double;

const int INFI = 1e9 + 228;
const ll INFL = 1e18 + 228;
const ld INFLD = 1e18 + 228;
const ld PI = acos(-1);
const int MAXN = 2e5 + 228;

vector<pair<int, int> > DD = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
struct Edge {
    int a, b, c;
    Edge(int a, int b, int c): a(a), b(b), c(c) {};
};

vector<Edge> edges;
vector<int> g[MAXN];
void add(int a, int b, int c) {
    g[a].pb(edges.size());
    edges.pb(Edge(a, b, c));
    g[b].pb(edges.size());
    edges.pb(Edge(b, a,  0));
}
int d[MAXN];
bool bfs(int s, int t, int delta) {
    for (int i = 0; i <= t; ++i) d[i] = INFI;
    d[s] = 0;
    deque<pair<int, int> > q;
    q.pb({s, 0});
    while (!q.empty()) {
        int v = q.front().FF;
        int ras = q.front().SS;
        q.pop_front();
        for (auto u : g[v]) {
            Edge e = edges[u];
            if (d[e.b] == INFI && e.c >= delta) {
                d[e.b] = ras + 1;
                q.pb({e.b, ras + 1});
            }
        }
    }
    return d[t] != INFI;
}

int uk[MAXN];
vector<int> update;
bool dfs(int v, int t, int delta) {
    if (v == t) return true;
    while (uk[v] < g[v].size()) {
        Edge e = edges[g[v][uk[v]]];
        if (d[e.b] == d[v] + 1 && e.c >= delta && dfs(e.b, t, delta)) {
            update.pb(g[v][uk[v]]);
            return true;
        }
        ++uk[v];
    }
    return false;
}
void upd() {
    int minn = INFI;
    for (auto u : update) {
        minn = min(minn, edges[u].c);
    }
    for (auto u : update) {
        edges[u].c -= minn;
        edges[u ^ 1].c += minn;
    }
}
void run() {
    int n, m;
    cin >> n >> m;
    int s = 0;
    int t = n + m + 1;
    edges.clear();
    for (int i = 0; i <= t; ++i) g[i].clear();
    for (int i = 1; i <= m; ++i) {
        add(s, i, 1);
    }
    for (int i = m + 1; i <= n + m; ++i) {
        add(i, t, ((m + 1) / 2));
    }
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            --x;
            add(1 + i, m + 1 + x, 1);
        }
    }
    for (int delta = (1 << 30); delta > 0; delta /= 2) {
        while (bfs(s, t, delta)) {
            for (int i = 0; i <= t; ++i) uk[i] = 0;
            while (dfs(s, t, delta)) {
                upd();
                update.clear();
            }
        }
    }
    int sum = 0;
    for (auto u : g[t]) {
        sum += edges[u].c;
    }
    if (sum < m) {
        cout << "NO" << "\n";
        return;
    }
    cout << "YES" << "\n";
    for (int i = 1; i <= m; ++i) {
        for (auto u : g[i]) {
            if (edges[u].c == 0) {
                cout << edges[u].b - m << ' ';
                break;
            }
        }
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) run();
    return 0;
}

