/*######  /##   /## /######## /######## /######## /######## /######## /########  /######
| ##__  ##| ##  | ##|_____ ## |_____ ## |_____ ## |_____ ## |_____ ## |_____ ##  /##__  ##
| ##  \ ##| ##  | ##     /##/      /##/      /##/      /##/      /##/      /##/ | ##  \ ##
| #######/| ##  | ##    /##/      /##/      /##/      /##/      /##/      /##/  | ########
| ##__  ##| ##  | ##   /##/      /##/      /##/      /##/      /##/      /##/   | ##__  ##
| ##  \ ##| ##  | ##  /##/      /##/      /##/      /##/      /##/      /##/    | ##  | ##
| ##  | ##|  ######/ /######## /######## /######## /######## /######## /########| ##  | ##
|__/  |__/ \______/ |________/|________/|________/|________/|________/|________/|__/  |_*/

#include <bits/stdc++.h>

#define pb push_back
#define f first
#define s second
#define ios ios_base::sync_with_stdio(0); cin.tie(0);
#define open(name1, name2) freopen(name1, "r", stdin); freopen(name2, "w", stdout);
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937_64 rnd(time(nullptr));

#define int ll

//#pragma GCC optimize("Ofast")
//#pragma GCC target ("avx2")

//#pragma comment(linker, "/stack:200000000")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")

void solve() {
    int n, m, s, a;
    cin >> n >> m;
    set<int> f[n];
    vector<int> d[m];
    for (int i = 0; i < m; i++) {
        cin >> s;
        for (int j = 0; j < s; j++) {
            cin >> a;
            a--;
            f[a].insert(i);
            d[i].pb(a);
        }
    }
    int sz[n];
    for (int i = 0; i < n; i++) {
        sz[i] = f[i].size();
    }
    set<pair<int, int>> st;
    for (int i = 0; i < n; i++)
        st.insert({sz[i], i});
    int ans[m];
    for (int i = 0; i < m; i++)
        ans[i] = -1;
    while (!st.empty() && st.begin()->f <= (m + 1) / 2) {
        int v = st.begin()->s;
        st.erase({sz[v], v});
        for (auto u : f[v]) {
            ans[u] = v + 1;
            for (auto u1 : d[u]) {
                if (st.count({sz[u1], u1})) {
                    st.erase({sz[u1], u1});
                    f[u1].erase(u);
                    sz[u1] = f[u1].size();
                    st.insert({sz[u1], u1});
                }
            }
        }
    }
    int count[n];
    for (int i = 0; i < n; i++)
        count[i] = 0;
    for (int i = 0; i < m; i++) {
        if (ans[i] == -1 && d[i].size() == 1) {
            ans[i] = *d[i].begin() + 1;
            count[*d[i].begin()]++;
            if (count[*d[i].begin()] > (m + 1) / 2){
                cout << "NO" << endl;
                return;
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (ans[i] == -1) {
            for (auto u : d[i]) {
                if (count[u] + 1 <= (m + 1) / 2) {
                    ans[i] = u + 1;
                    count[u]++;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (ans[i] == -1) {
            cout << "NO" << endl;
            return;
        }
    }
    cout << "YES" << endl;
    for (int i = 0; i < m; i++)
        cout << ans[i] << ' ';
    cout << endl;
}

signed main() {
    ios
//    open("anime.in", "anime.out")
    int attempts = 1;
    cin >> attempts;
    cout.precision(16);
    while (attempts--) {
        solve();
    }
    return 0;
}