#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5 + 5;

int n, m;
ve<ve<int>> a;
int cnt[N];

void solve() {
    a.clear();
    cin >> n >> m;
    a.resize(m);
    fr(i, 0, m - 1) {
        int k;
        cin >> k;
        fr(j, 1, k) {
            int x;
            cin >> x;
            x--;
            a[i].pb(x);
        }
    }

    fr(i, 0, m - 1) sort(all(a[i]));

    fr(i, 0, n - 1) cnt[i] = 0;
    fr(i, 0, m - 1) {
        cnt[a[i][0]]++;
    }
    int big = (m + 1) / 2;
    int mxi = -1;
    fr(i, 0, n - 1) {
        if(cnt[i] > big) {
            mxi = i;
        }
    }
    if(mxi == -1) {
        cout << "YES\n";
        fr(i, 0, m - 1) {
            cout << a[i][0] + 1 << " ";
        }
        cout << "\n";
        return;
    }

    ve<int> ans(m);

    fr(i, 0, m - 1) ans[i] = a[i][0];

    fr(i, 0, m - 1) {
        if(cnt[a[i][0]] > big && sz(a[i]) > 1) {
            cnt[a[i][0]]--;
            cnt[a[i][1]]++;
            ans[i] = a[i][1];
        }
    }

    fr(i, 0, n - 1) {
        if(cnt[i] > big) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    fr(i, 0, m - 1) cout << ans[i] + 1 << " ";
    cout << "\n";
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int T;
    cin >> T;

    while(T--) {
        solve();
    }

    return 0;
}