//
//  main.cpp
//  techocup
//
//  Created by Stepan Kulakov on 21.03.2021.
//

#include <iostream>
#include <vector>
#include <math.h>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>

#define sz(s) (int)(s).size()
//#define int long long

const int N = 2e5, oo = 2e9;
const double eps = 1e-9;

using namespace std;

using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;
using str = string;
using vpii = vector<pii>;

int n, m;
vi a[N];

void read()
{
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        a[i].clear();
        a[i].resize(k);
        for (auto &v: a[i]) cin >> v;
    }
}

void solve()
{
    vi left(n + 1, (m + 1) / 2);
    vi ans(m, 0);
    for (int i = 0; i < m; ++i) {
        if (sz(a[i]) == 1) --left[a[i][0]], ans[i] = a[i][0];;
    }
    
    for (int i = 1; i <= n; ++i) {
        if (left[i] < 0) {
            cout << "NO\n";
            return;
        }
    }
    
    for (int i = 0; i < m; ++i) {
        if (ans[i]) continue;
        for (auto v: a[i]) {
            if (left[v]) {
                ans[i] = v;
                --left[v];
                break;;
            }
        }
    }
    
    cout << "YES\n";
    for (auto v: ans) cout << v << ' ';
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(0);cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) read(), solve();
    return 0;
}
