#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <set>


#define int long long
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define sz(a) a.size()



using namespace std;


int n, m;
vector<vector<int>> a;
vector<int> cnt;
vector<int> res;


bool get_res(int i) {
	for (int j = 0; j < m; ++j) {
		if (a[j][0] == i && a[j].size() > 1) {
			--cnt[i];
			res[j] = a[j][1];
		}
		if (!(cnt[i] > (m / 2) + m % 2)) {
			return true;
		}
	}
	return false;
}


bool get_res() {
	cnt.assign(n, false);
	res.assign(m, -1);
	for (int i = 0; i < m; ++i) {
		cnt[a[i][0]] += 1;
		res[i] = a[i][0];
	}
	for (int i = 0; i < n; ++i) {
		if (cnt[i] > (m / 2) + m % 2) {
			return get_res(i);
		}
	}
	return true;
}


int32_t main() {
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		a.resize(m);
		for(int i = 0; i < m; ++i)
		{
			int k;
			cin >> k;
			a[i].resize(k);
			for (int j = 0; j < k; ++j) {
				cin >> a[i][j];
				--a[i][j];
			}
		}
		if (!get_res()) {
			cout << "NO" << "\n";
		}
		else {
			cout << "YES" << "\n";
			for (auto c : res) {
				cout << c + 1 << " ";
			}
			cout << "\n";
		}
	}
	return 0;
}