/*
    Code written by Talant I.D.
*/
#include <bits/stdc++.h>

using namespace std;

#define sz(v) (int)v.size()

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <int> days[m];
        vector <int> which(m), left(n+1, (m+1)/2);
        set <int> friends[n+1];
        for (int i = 0; i < m; i++) {
            int x;
            cin >> x;
            days[i].resize(x);
            for (auto &to : days[i]) cin >> to;
            for (auto to : days[i]) friends[to].insert(i);
        }
        priority_queue <pair <int, int>> K;
        for (int i = 0; i < m; i++) {
            K.push(make_pair(-sz(days[i]), i));
        }
        int flag = 1;
        while (sz(K)) {
            auto v = K.top().second; K.pop();
            int ans = 0, ind = 0;
            for (auto to : days[v]) {
                if (ans < left[to]) {
                    ans = left[to];
                    ind = to;
                }
            }
            if (ans == 0) {
                flag = 0;
                break;
            }
            which[v] = ind;
            left[ind]--;
        }
        if (flag) {
            cout << "YES" << endl;
            for (auto to : which) cout << to << ' ';
            cout << endl;
        }
        else {
            cout << "NO" << endl;
        }
    }

    return 0;
}
