#include <iostream>
#include <vector>

using namespace std;

void solveOne() {
    int n, m; cin >> n >> m;
    vector<vector<int>> days(m);
    vector<int> ans(m);
    vector<int> cnt(n);
    for (int i = 0; i < m; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int d; cin >> d; d--;
            days[i].push_back(d);
        }
    }
    for (int i = 0; i < m; i++) {
        ans[i] = days[i][0];
        cnt[days[i][0]]++;
    }
    int maxFriend = 0;
    for (int i = 1; i < n; i++) {
        if (cnt[i] > cnt[maxFriend]) {
            maxFriend = i;
        }
    }
    for (int i = 0; i < m; i++) {
        if (cnt[maxFriend] <= (m + 1) / 2) {
            break;
        }
        if (days[i].size() == 1 || days[i][0] != maxFriend) {
            continue;
        }
        ans[i] = days[i][1];
        cnt[maxFriend]--;
    }
    if (cnt[maxFriend] > (m + 1) / 2) {
        cout << "NO" << endl;
    } else {
        cout << "YES" << endl;
        for (int i = 0; i < m; i++) {
            cout << ans[i] + 1 << ' ';
        }
        cout << endl;
    }
}

int main() {
    int t; cin >> t;
    while (t--) {
        solveOne();
    }
}
