#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <tuple>
#include <deque>
#include <random>
#include <iterator>
#include <cmath>
#include <algorithm>

using namespace std;

// #define int long long
#define rs resize
#define ft first
#define sd second
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

int gsd(int a, int b)
{
    if (b == 0)
    {
        return a;
    }
    return gsd(b, a % b);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        vector<int> a(n), nx(n);
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
            nx[i] = (i + 1) % n;
        }
        deque<int> q;
        for (int i = 0; i < n; i++)
        {
            if (gsd(a[i], a[(i + 1) % n]) == 1)
            {
                q.push_back(i);
            }
        }
        vector<int> ans;
        while (!q.empty() && ans.size() < n)
        {
            int u = q.front();
            q.pop_front();
            ans.push_back(nx[u]);
            if (!q.empty() && q.front() == nx[u])
            {
                q.pop_front();
            }
            nx[u] = nx[nx[u]];
            if (gsd(a[u], a[nx[u]]) == 1)
            {
                q.push_back(u);
            }
        }
        cout << ans.size() << " ";
        for (auto el : ans)
        {
            cout << el + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}