#include <bits/stdc++.h>
#define F first
#define S second
#define M ll(1e9 + 7)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define arr_all(x) (x) + 1, (x) + 1 + n
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
#define el '\n'
#define pii pair <int, int>
#define pb push_back
using namespace std;

typedef long long ll;
typedef long double ld;
typedef short int si;

const int N = 1e5 + 500;

int a[N], nxt[N], n, b[N];
bool mk[N];
int t[4 * N];

int combine(int x, int y) {
    return min(x, y);
}

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = b[l];
        return;
    }

    int md = (l + r) >> 1;

    build(v * 2, l, md);
    build(v * 2 + 1, md + 1, r);

    t[v] = combine(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int l, int r, int tl, int tr) {
    if (t[v] > 1) {
        return -1;
    }

    if (l == r) {
        return l;
    }

    if (l > r || tl > tr || tl > r || l > tr) {
        return -1;
    }

    int md = (l + r) >> 1;

    int cur = get(v * 2, l, md, tl, min(md, tr));

    if (cur == -1) {
        return get(v * 2 + 1, md + 1, r, max(md + 1, tl), tr);
    }
    return cur;
}

void upd(int v, int l, int r, int ps, int val) {
    if (l == r) {
        t[v] = val;
    }
    else {
        int md = (l + r) >> 1;

        if (ps <= md) {
            upd(v * 2, l, md, ps, val);
        }
        else {
            upd(v * 2 + 1, md + 1, r, ps, val);
        }

        t[v] = combine(t[v * 2], t[v * 2 + 1]);
    }
}

vector <int> ans;
void recalc(int x, int y) {
    if (x == y) {
        upd(1, 0, n - 1, x, 1e9);
        ans.pb(x);
        return;
    }
    nxt[x] = nxt[y];
    ans.pb(y);

    upd(1, 0, n - 1, y, 1e9);
    upd(1, 0, n - 1, x, __gcd(a[x], a[nxt[x]]));
}

void solve() {
    ans.clear();
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        nxt[i] = (i + 1) % n;
        b[i] = __gcd(a[i], a[nxt[i]]);
    }

    build(1, 0, n - 1);


    int now = 0;

    while (1) {
        int nnow = get(1, 0, n - 1, now, n - 1);

        if (nnow == -1) {
            nnow = get(1, 0, n - 1, 0, now - 1);
        }

        if (nnow == -1) {
            break;
        }

        recalc(nnow, nxt[nnow]);
        now = nxt[nnow];
    }

    cout << sz(ans) << " ";
    for (auto x : ans) {
        cout << x + 1 << " ";
    }

    cout << el;
}

int main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
//    in("input.txt");
//    out("output.txt");

//    clock tStart = clock();

    int q = 1;
    cin >> q;

    while (q--) {
        solve();
    }

//    cerr << setprecision(9) << fixed << ld(clock() - tStart) / CLOCKS_PER_SEC << el;
}
