#include <iostream>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
// #include <ext/pb_ds/assoc_container.hpp>

// using namespace __gnu_pbds;
using namespace std;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2& y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2& y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define rall(c) (c).rbegin(), (c).rend()
#define left left228
#define right right228
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;
const int MAXN = 100228;


int n;
int a[MAXN];


int gcd(int a, int b) {
	while (a) {
		b %= a;
		swap(a, b);
	}
	return b;
}


set<int> s;


int getR(int i) {
	auto f = s.upper_bound(i);
	if (f == s.end()) {
		return *s.begin();
	}
	return *f;
}


set<int> bads;

void add(int i) {
	int j = getR(i);
	if (gcd(a[i], a[j]) == 1) {
		bads.insert(i);
	}
}


void solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	s.clear();
	bads.clear();
	for (int i = 0; i < n; i++) {
		s.insert(i);
	}
	for (int i = 0; i < n; i++) {
		add(i);
	}
	vector<int> res;
	int cur = 0;
	while (!bads.empty()) {
		auto it = bads.lower_bound(cur);
		if (it == bads.end()) {
			it = bads.begin();
		}
		int i = *it;
		int j = getR(i);
		res.pb(j + 1);
		s.erase(j);
		bads.erase(i);
		bads.erase(j);
		if (s.find(i) != s.end()) {
			add(i);
		}
		cur = j;
	}	
	cout << sz(res);
	for (auto x: res) {
		cout << ' ' << x;
	}
	cout << '\n';
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}	
