#include <iostream>
#include <cmath>
#include <set>
#include <map>
#include <deque>
#include <string>
#include <vector>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b)
{
    if (a == 0){
        return b;
    }
    return gcd(b % a, a);
}

void gen()
{
    ll n;
    cin >> n;
    vector<ll> a (n);
    vector<bool> isdel(n, false);
    for (ll i = 0; i < n; ++i){
        cin >> a[i];
    }
    ll i = 1;
    vector<ll> otv;
    deque<pair<ll, ll>> prs;
    while (i < n){
        if (gcd(a[i], a[i - 1]) == 1){
            prs.push_back(make_pair(i - 1, i));
        }
        i++;
    }
    if (gcd(a[n - 1], a[0]) == 1){
        prs.push_back(make_pair(n - 1, 0));
    }
    while (prs.size() > 0){
        if (!isdel[prs[0].first]){
            pair<ll, ll> pr = prs[0];
            ll j = pr.first;
            ll i = pr.second;
            otv.push_back(i + 1);
            isdel[i] = true;
            a[i] = 0;
            ll prt = 0;
            while (a[i] == 0 && prt < n + 1){
                i = (i + 1) % n;
                prt++;
            }
            if (gcd(a[j], a[i]) == 1){
                prs.push_back(make_pair(j, i));
            }
        }
        prs.pop_front();
    }
    cout << otv.size() << ' ';
    for (ll i = 0; i < otv.size(); ++i){
        cout << otv[i] << ' ';
    }
    cout << "\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    for (ll i = 0; i < t; ++i){
        gen();
    }
}
