
#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define f first
#define s second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()
#define min(x, y) (x < y ? x : y)
#define max(x, y) (x > y ? x : y)
#define TEST ""

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

vector<pii> seg;

const int MAXN = 3e5;
int nxt[MAXN];
int prv[MAXN], nxtnu[MAXN], prnu[MAXN];

int cnt;

void del(int i) {
    cnt--;
    if (prv[i] != -1) nxt[prv[i]] = nxt[i];
    if (nxt[i] != -1) prv[nxt[i]] = prv[i];
}

void del_ind(int i) {
    if (prnu[i] != -1) nxtnu[prnu[i]] = nxtnu[i];
    if (nxtnu[i] != -1) prnu[nxtnu[i]] = prnu[i];
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> ans;
    fill(prv, prv + n * 3, -1);
    fill(nxt, nxt + n * 3, -1);
    iota(nxtnu, nxtnu + n, 1);
    for (int i = 0; i < n; i++) prnu[i] = (i - 1 + n) % n;
    nxtnu[n - 1] = 0;
    vector<pii>().swap(seg);
    int l = 0;
    for (int i = 0; i < n - 1; i++) {
        if (__gcd(a[i], a[i + 1]) == 1) {
            seg.push_back({l, i});
            l = i + 1;
        }
    }
    seg.push_back({l, n - 1});
    for (int i = 0; i < seg.size(); i++) {
        nxt[i] = (i + 1) % seg.size();
    }

    for (int i = 0; i < seg.size(); i++) {
        prv[i] = (i - 1 + seg.size()) % seg.size();
    }
//    for (auto el : seg) cout << el.f _ el.s << endl;
//    cout << endl;
    int i = 0;
    cnt = seg.size();
    while(cnt > 1) {
//      cout << "pii" _ i  _ nxt[i] _ seg[i].f _ seg[i].s << "     " << seg[nxt[i]].f _ seg[nxt[i]].s<< endl;
        if (__gcd(a[seg[i].s], a[seg[nxt[i]].f]) == 1) {
            del_ind(seg[nxt[i]].f);
//          cout << "del elem" _ seg[nxt[i]].f << endl;
            ans.push_back(seg[nxt[i]].f);
            if (seg[nxt[i]].f == seg[nxt[i]].s) del(nxt[i]);
            else {
                seg[nxt[i]].f = nxtnu[seg[nxt[i]].f];
            }
            i = nxt[i];
        } else {
//          cout << "Merge" _ i _ nxt[i] << endl;
            seg[nxt[i]].f = seg[i].f;
            i = nxt[i];
            del(prv[i]);
        }
    }
    int lef = seg[i].f, rig = seg[i].s;
    while(__gcd(a[lef], a[rig]) == 1) {
        ans.push_back(lef);
        if (lef == rig && a[lef] == 1) break;
        lef = nxtnu[lef];
    }
    cout << ans.size() << ' ';
    for (auto el : ans) cout << el + 1 << ' ';
    cout << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
//    freopen(TEST".in", "r", stdin);
//    freopen(TEST".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
/*
1
6
2 8 5 10 15 16
 */