#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (B x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
    #define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
    #define dbg(...)
#endif

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());



inline void solve() {
    int n;
    cin >> n;
    vec<int> a(n);
    for (auto &x : a)
        cin >> x;

    vec<int> prev(n);
    vec<int> nxt(n);
    for (int i = 0; i < n; i++) {
        prev[i] = (i - 1 + n) % n;
        nxt[i] = (i + 1) % n;
    }

    set<int> bad;

    auto insert = [&](int pos) {
        int g = gcd(a[pos], a[prev[pos]]);
        if (g == 1)
            bad.insert(pos);
    };

    for (int i = 0; i < n; i++)
        insert(i);

    auto cur_prev = prev;

    vec<int> ans;
    int cur_pos = 1;
    while (!bad.empty()) {
        auto it = bad.lower_bound(cur_pos);
        if (it == bad.end())
            it = bad.begin();

        int cur = *it;
        bad.erase(it);
        ans.push_back(cur);
        dbg(cur, cur_pos);

        if (nxt[cur] == cur || prev[cur] == cur)
            continue;

        prev[nxt[cur]] = prev[cur];
        nxt[prev[cur]] = nxt[cur];
        cur_pos = (nxt[cur] + 1) % n;
        if (bad.find(nxt[cur]) != bad.end())
            bad.erase(nxt[cur]);
        if (bad.find(nxt[cur]) == bad.end())
            insert(nxt[cur]);
        dbg(ans);
    }

    cout << len(ans);
    for (auto x : ans)
        cout << ' ' << x + 1;
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
