#include <bits/stdc++.h>
#define int ll
using namespace std;
using ll = long long;

int gcd(int a, int b) {
	while (a) {
		int t = b % a;
		b = a;
		a = t;
	}
	return b;
}

const int N = 2e5 + 10;
int n;
int a[N];
set<int> remain, bad;

int nx(const set<int> &s, int v) {
	assert(s.size());
	auto it = s.upper_bound(v);
	if (it == s.end()) {
		it = s.begin();
	}
	assert(it != s.end());
	return *it;
}

int pr(const set<int> &s, int v) {
	assert(s.size());
	auto it = s.lower_bound(v);
	if (it != s.begin()) {
		--it;
	} else {
		it = prev(s.end());
	}
	assert(it != s.end());
	return *it;
}

void solve() {
	cin >> n;
	remain.clear();
	bad.clear();
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		remain.insert(i);
	}
	for (int i = 0; i < n; ++i) {
		if (gcd(a[i], a[(i + n - 1) % n]) == 1) {
			bad.insert(i);
		}
	}
	int ptr = n - 1;
	vector<int> answer;
	while (bad.size()) {
		ptr = nx(bad, nx(remain, ptr));
		// cout << "ptr = " << ptr << endl;
		answer.push_back(ptr);
		remain.erase(ptr);
		bad.erase(ptr);
		if (remain.empty()) {
			break;
		}
		int l = pr(remain, ptr), r = nx(remain, ptr);
		if (gcd(a[l], a[r]) == 1) {
			// cout << "bad " << l << " " << r << endl;
			bad.insert(r);
		} else {
			bad.erase(r);
		}
	}
	cout << answer.size() << " ";
	for (int e : answer) {
		cout << e + 1 << " ";
	}
	cout << "\n";
#ifdef LC
	cout.flush();
#endif
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	int tn;
	cin >> tn;
	while (tn--) {
		solve();
	}
	return 0;
}