#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#include <map>
#include <cstdio>
#include <queue>
using namespace std;
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define pb push_back
#define forn(i, e, n) for(int i = e; i < int(n); i++)
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pt;
typedef long double ld;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 1e5 + 100;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int r[MAXN];

void solve() {
	int n;
	cin >> n;
	forn(i, 0, n) {
		r[i] = i;
	}
	vector<int> a(n);
	forn(i, 0, n) cin >> a[i];
	queue<pt> q;
	vector<bool> used(n);
	vector<int> ans;
	vector<bool> inq(n, 0);
	forn(i, 0, n) {
		if (gcd(a[i], a[(i + 1) % n]) == 1) {
			q.push(mp(i, (i + 1) % n));
			inq[(i + 1) % n] = 1;
			i++;
		}
	}
	while (!q.empty()) {
		int id1 = q.front().first;
		int id2 = q.front().second;
		r[id1] = r[id2];
		ans.push_back(id2);
		q.pop();
		inq[id2] = 0;
		used[id2] = 1;
		if (inq[id1] == 1) continue;
		int id3 = (r[id1] + 1) % n;
		if (id3 == id1) {
			if (a[id1] == 1 && used[id1] == 0) {
				ans.push_back(id1);
			}
			break;
		}
		if (gcd(a[id1], a[id3]) == 1 && used[id3] == 0) {
			inq[id3] = 1;
			q.push(mp(id1, id3));
		}
	}
	cout << sz(ans) << ' ';
	forn(i, 0, sz(ans))
		cout << ans[i] + 1 << ' ';
	cout << '\n';
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG
	int t;
	cin >> t;
	forn(i, 0, t)
		solve();
	return 0;
}
