#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <stack>
#include <valarray>
#include <stdio.h>
#include <string.h>
#include <unordered_set>
#define mxN 1000000007
#define pb push_back
#define ll long long
#define mat vector<vector<ll>>
#define all(a) a.begin(), a.end()
using namespace std;


ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    else {
        if (a > b) {
            return gcd(b, a % b);
        }
        else {
            return gcd(a, b % a);
        }
    }
}


void solve() {
    ll n, c = 0;
    cin >> n;
    vector <ll> a(n), b, ans;
    map <ll, ll> g;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        ll k = gcd(a[i], a[(i + 1) % n]);
        g[i] = k;
        if (k == 1) {
            b.pb(i);
            ++c;
        }
    }
    ll p = -1;
    while (c) {
        auto su = lower_bound(all(b), p);
        ll i = b[0];
        if (su != b.end()) {
            i = b[su - b.begin()];
        }
        auto ind = g.find(i);
        auto ind1 = ind;
        ++ind1;
        if (ind1 == g.end()) {
            ind1 = g.begin();
        }
        if ((*ind1).second == 1) {
            --c;
            b.erase(lower_bound(all(b), (*ind1).first));
        }
        ans.pb((*ind1).first);
        g.erase(ind1);
        --n;
        if (n != 0) {
            ind1 = ind;
            ++ind1;
            p = (*ind1).first;
            if (ind1 == g.end()) {
                ind1 = g.begin();
            }
            auto u = gcd(a[(*ind).first], a[(*ind1).first]);
            g[i] = u;
            if (u != 1) {
                b.erase(lower_bound(all(b), (*ind).first));
                --c;
            }
        }
    }
    cout << ans.size() << " ";
    for (auto x : ans) {
        cout << x + 1 << " ";
    }
    cout << endl;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}


/*
 ll i = b[0];
 auto f = g.find(i);
 if (f == --g.end()) {
     auto u = *g.begin();
     ans.pb(u.first);
     if (u.second == 1) {
         b.erase(lower_bound(all(b), u.first));
         --c;
     }
     g.erase(g.begin());
     --n;
     if (n != 0) {
         g[i] = gcd(a[i], a[(*g.begin()).first]);
         if (g[i] != 1) {
             b.erase(lower_bound(all(b), i));
             --c;
         }
     }
 }
 else {
     auto u = *(f++);
     ans.pb(u.first);
     if (u.second == 1) {
         b.erase(lower_bound(all(b), u.first));
         --c;
     }
     g.erase(f++);
     for (auto q : g) {
         cout << q.first << " ";
     }
     cout << endl;
     --n;
     if (n != 0) {
         if (f == --g.end()) {
             g[i] = gcd(a[i], a[(*g.begin()).first]);
             if (g[i] != 1) {
                 b.erase(lower_bound(all(b), i));
                 --c;
             }
         }
         else {
             ans.pb(u.first);
             g[i] = gcd(a[i], a[(*(f++)).first]);
             if (g[i] != 1) {
                 b.erase(lower_bound(all(b), i));
                 --c;
             }
         }
     }
 }
 */
