#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &t : a) {
        cin >> t;
    }
    set<int> al;
    for (int i = 0; i < n; i++) {
        al.insert(i);
    }
    set<int> bad;
    auto nx = [&](int pos) {
        auto it = al.upper_bound(pos);
        if (it == al.end()) {
            return *al.begin();
        } else {
            return *it;
        }
    };
    auto pr = [&](int pos) {
        auto it = al.lower_bound(pos);
        if (it == al.begin()) {
            return *al.rbegin();
        } else {
            return *prev(it);
        }
    };
    auto insert = [&](int i) {
        int nxt = nx(i);
        if (gcd(a[i], a[nxt]) == 1) {
            // cerr << i << ' ' << nxt << endl;
            bad.insert(i);
        }
    };
    auto erase = [&](int i) {
        int prv = pr(i);
        bad.erase(prv);
        bad.erase(i);
        al.erase(i);
        insert(prv);
    };
    auto next_bad = [&](int pos) {
        auto it = bad.lower_bound(pos);
        if (it == bad.end()) {
            return *bad.begin();
        } else {
            return *it;
        }
    };
    for (int i = 0; i < n; i++) {
        insert(i);
    }
    // erase(1);
    // cerr << nx(1) << endl;
    vector<int> ans;
    int pnt = 0;
    int cs = n;
    while (!bad.empty()) {
        int f = next_bad(pnt);
        f = nx(f);
        ans.push_back(f);
        cs--;
        if (!cs) {
            break;
        }
        erase(f);
        // cerr << "erasing " << f << ' ' << nx(f) << endl;
        pnt = nx(f);
        // cerr << pnt << endl;
    }
    cout << ans.size() << '\n';
    for (auto t : ans) {
        cout << t + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
