#include <iostream>
#include <vector>
#include <set>
#include <deque>
#include <bitset>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
using namespace std;
#define int long long
#define sx(x) int(x.size())
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,mmx")
const int INF = 1e18;

bool gcd(int a, int b) {
    while (b) {
         a %= b;
         swap(a, b);
    }
    return a == 1;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector <int> vec(n), pred(n), sled(n);
        for (int i = 0; i < n; ++i) {
            cin >> vec[i];
            if (i == 0) {
                pred[i] = n;
            } else {
                pred[i] = i - 1;
            }
            sled[i] = (i + 1) % n;
        }
        deque<pair<int, int>> de;
        vector <bool> have(n, true);
//        cout << gcd(1, 2) << "\n";
        for (int i = 0; i < n; ++i) {
            if (gcd(vec[i], vec[(i + 1) % n])) {
                de.push_back({i, (i + 1) % n});
//                cout << i << " " << (i + 1) % n << "\n";
                i++;
            }
        }
        vector <int> ans;
        while (!de.empty()) {
            int x, y;
             x= de.front().first;
             y = de.front().second;
             de.pop_front();
             if (have[x] and have[y]) {
//                 cout << x << " " << y << " ";
                 ans.push_back(y);
                 have[y] = false;
                 sled[x] = sled[y];
                 pred[sled[y]] = x;
                 if (pred[x] == x and sled[x] == x) {
                     continue;
                 }
//                 cout << sled[x] << "\n";
                 if (gcd(vec[x], vec[sled[x]])) {
                     de.push_back({x, sled[x]});
                 }
             }
        }
        for (int i = 0; i < n; ++i) {
            if (have[i] and vec[i] == 1) ans.push_back(i);
        }
        cout << ans.size() << " ";
        for (auto c : ans) cout << c + 1 << " ";
        cout << "\n";
    }
    return 0;
}

