#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()4

int gcd(int a, int b) {
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    queue<pair<int, int>> q;
    for (int i = 0; i < n; ++i) {
        q.push({i, (i + 1) % n});
    }
    vector<bool> used(n);
    vector<int> ans;
    set<int> s;
    for (int i = 0; i < n; ++i) {
        s.insert(i);
    }
    while (!q.empty()) {
        auto [i, j] = q.front();
        q.pop();
        if (used[i] || used[j]) {
            continue;
        }
        if (gcd(a[i], a[j]) == 1) {
            ans.pb(j);
            s.erase(j);
            used[j] = 1;
            if (!q.empty() && q.front().f == j) {
                q.pop();
            }
            auto it = s.lower_bound(j);
            if (it == s.end()) {
                it = s.begin();
            }
            if (s.size() == 0) {
                break;
            }
            q.push({i, *it});
        }
    }
    cout << ans.size() << ' ';
    for (auto i: ans) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}