﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

const int N = 2e5 + 10, INF = 1e9 + 10, MOD = 1e9 + 7;

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	int t; cin >> t;
	while (t--) {
		int n; cin >> n; vector<int> a(n, 0);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		vector<deque<int>> st; deque<int> now(1, 0);
		for (int i = 1; i < n; i++) {
			if (gcd(a[i - 1], a[i]) == 1) {
				st.push_back(now); now.clear();
			}
			now.push_back(i);
		}
		st.push_back(now);
		int u = 1, sz = st.size(); bool er = 0; vector<int> arr;
		vector<int> b;
		for (int i = 0; i < st.size(); i++) b.push_back(i);
		b.push_back(0); int alr = 0;
		while (u < b.size()) {
			if (alr > sz + 10) break;
			if (!er && gcd(a[st[b[u - 1]].back()], a[st[b[u]].front()]) == 1) {
				arr.push_back(st[b[u]].front()); st[b[u]].pop_front(); alr = 0;
				if (!st[b[u]].empty()) b.push_back(b[u]);
				else {
					sz--; er = 1;
				}
			}
			else if (!er && sz > 2 && b[u] != b[u - 1]) {
				if (st[b[u]].size() > st[b[u - 1]].size()) {
					for (auto i : st[b[u]]) st[b[u - 1]].push_back(i);
				}
				else {
					for (auto i : st[b[u]]) st[b[u - 1]].push_back(i);
				}
				b[u] = b[u - 1];
				alr = 0;
			}
			else {
				b.push_back(b[u]); er = 0; alr++;
			}
			u++;
		}
		cout << arr.size() << ' ';
		for (auto i : arr) cout << i + 1 << ' ';
		cout << '\n';
	}
}

