#include <bits/stdc++.h>
#include <immintrin.h>

using namespace std;

void IO(){
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

template <typename T, typename D>
istream& operator>>(istream& in, pair<T, D>& a) {
    in >> a.first >> a.second;
    return in;
}

template <typename T, typename D>
ostream& operator<<(ostream& out, const pair<T, D>& a) {
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}


typedef long long ll;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define sz(x) ((int)x.size())
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>
#define ti tuple<int,int,int>
#define mod(x, m) ((x % m + m) % m)
#define eb emplace_back

const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const long double PI = acos(-1);
auto seed = time(NULL);
mt19937 rnd(seed);

//#define int ll

void Solve() {
    int n;
    cin >> n;
    vi a(n), left(n), right(n);
    vector <bool> deleted(n, 0);
    cin >> a;
    set <int> bad;
    forn(i, n) {
        int j = (i + 1) % n;
        right[i] = j;
        if (__gcd(a[i], a[j]) == 1) {
            bad.insert(i);
        }
        left[i] = mod(i - 1, n);
    }
    int last = -1;
    vi ans;
    while(!bad.empty()) {
        auto it = bad.upper_bound(last);
        if (it == bad.end()) {
            last = -1;
            continue;
        }
        int i = *it;
        bad.erase(it);
        if (deleted[i]) {
            continue;
        }
        int j = right[i];
        ans.eb(j + 1);
        int nxt = right[j];
        deleted[j] = 1;
        if (__gcd(a[i], a[nxt]) == 1) {
            bad.insert(i);
        }
        right[i] = nxt;
        last = i;
    }
    cout << sz(ans) << ' ' << ans << '\n';
}

signed main() {
    int start = clock();
    IO();
    int t = 1;
    cin >> t;
    while(t--) {
        Solve();
    }
#ifdef DIVAN
    cout << '\n' << "Time: " << (clock() - start + 999) / 1000 << '\n';
#endif
}
