#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

int gcd(int a, int b) {
  return (b == 0 ? a : gcd(b, a % b));
}
 
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int t;
  cin >> t;
  while (t--) {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <int> pn(n), pd(n);
    for (int i = 0; i < n; ++i) {
      pn[i] = i;
      pd[i] = i;
    }
    function <int(int)> get_n = [&] (int a) {
      return (a == pn[a] ? a : pn[a] = get_n(pn[a]));
    };
    function <int(int)> get_d = [&] (int a) {
      return (a == pd[a] ? a : pd[a] = get_d(pd[a]));
    };
    vector <int> ans;
    int uk = 0;
    vector <int> used(n);
    int timer = 1;
    while (true) {
      uk = get_d(uk);
      //cout << uk << endl;
      uk = get_n(uk);
      //cout << uk << endl;
      if (used[uk] == timer) break;
      used[uk] = timer;
      int nxt = get_d((uk + 1) % n);
      if (gcd(a[uk], a[nxt]) == 1) {
        ans.push_back(nxt);
        int go = (nxt + 1) % n;
        if (get_d(go) == nxt) break;
        pd[nxt] = go;
        uk = go;
        ++timer;
      } else {
        if (get_n(nxt) == uk) break;
        pn[uk] = nxt;
        uk = nxt;
      }
    }   
    cout << ans.size() << ' ';
    for (auto x : ans) cout << x + 1 << ' ';
    cout << '\n';
  }
}

