#include <iostream>
#include <bitset>
#include <set>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <algorithm>

#define vc vector
#ifdef kOk
#else
#include <bits/extc++.h>
#endif

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vc<ll> vll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;
typedef vc<vpll> vvpll;

template<typename T>
void sort(T &a) {
    sort(a.begin(), a.end());
}

template<typename T>
void reverse(T &a) {
    reverse(a.begin(), a.end());
}

template<typename T>
void unique(T &a) {
    a.resize(unique(a.begin(), a.end()) - a.begin());
}

int main() {
    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vll a(n);
        for (auto &i : a) {
            cin >> i;
        }
        deque<ll> q;
        set<ll> nw;
        for (ll i = 0; i < a.size(); ++i) {
            q.push_front((i + 1) % a.size());
            nw.insert(i);
        }
        vll ans;
        ll fbd = -1;
        while (!q.empty()) {
            ll i = q.back();
            q.pop_back();
            if (!nw.count(i)) {
                continue;
            }
            if (i == fbd) {
                while (!q.empty() && q.back() == fbd){
                    q.pop_back();
                }fbd = -1;
                q.push_front(i);
                continue;
            }
            fbd = -1;
            auto y = nw.lower_bound(i);
            ll j;
            if (y == nw.begin()) {
                j = *nw.rbegin();
            } else {
                --y;
                j = *y;
            }
            if (__gcd(a[i], a[j]) == 1) {
                y = nw.upper_bound(i);
                if (y == nw.end()) {
                    q.push_front(*nw.begin());
                    fbd = q.front();
                } else {
                    q.push_front(*y);
                    fbd = q.front();
                }
                nw.erase(i);
                ans.push_back(i + 1);
            }
        }
//        if (nw.size() == 1 && a[*nw.begin()] == 1) {
//            ans.push_back(*nw.begin() + 1);
//        }
        cout << ans.size() << ' ';
        for (auto &i : ans) {
            cout << i << ' ';
        }
        cout << '\n';
    }
}