#include <iostream>
#include <set>
#include <vector>
#include <map>

using namespace std;
typedef long long ll;

int n;
int a[100010];

int gcd(int a, int b)
{
	while (b)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}


inline void solve()
{
	cin >> n;

	vector <int> ans;
	set <int> all;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		all.insert(i);
	}

	vector <pair <int, int>> segs;

	segs.push_back({ 1, 1 });

	for (int i = 2; i <= n; ++i)
	{
		if (gcd(a[segs.back().second], a[i]) != 1)
		{
			segs.back().second++;
		}
		else
		{
			segs.push_back({ i, i });
		}
	}

	while (true)
	{
		if (segs.size() == 1)
		{
			if (gcd(a[segs.back().first], a[segs.back().second]) == 1)
			{
				ans.push_back(segs.back().first);
				all.erase(segs.back().first);
				if (segs.back().first == segs.back().second) break;
				segs.back().first = *all.upper_bound(segs.back().first);
				continue;
			}
			else
			{
				break;
			}
		}
		
		vector <pair <int, int>> segb;
		segb.push_back(segs[0]);

		bool skip = false;

		for (int i = 1; i < segs.size(); ++i)
		{
			if (skip)
			{
				skip = false;
				segb.push_back(segs[i]);
				continue;
			}
			if (gcd(a[segb.back().second], a[segs[i].first]) != 1)
			{
				segb.back().second = segs[i].second;
				continue;
			}

			auto got = segs[i];
			ans.push_back(got.first);
			all.erase(got.first);
			if (got.first != got.second)
			{
				got.first = *all.upper_bound(got.first);
				segb.push_back(got);
			}
			else
			{
				skip = true;
			}
		}

		if ((!skip) && ((int)segb.size() >= 2))
		{
			auto x = segb[0];
			auto y = segb.back();

			if (gcd(a[x.first], a[y.second]) == 1)
			{
				if (x.first == x.second)
				{
					ans.push_back(x.first);
					all.erase(segb[0].first);
					segb.erase(segb.begin());
				}
				else
				{
					ans.push_back(x.first);
					all.erase(segb[0].first);
					segb[0].first = *all.upper_bound(segb[0].first);
				}
			}
		}

		segs = segb;
	}

	cout << ans.size() << ' ';
	for (auto i : ans) cout << i << ' ';
	cout << '\n';
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}