#include <iostream>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

inline int gcd(int a, int b)
{
	if (a == 0)
		return b;
	return gcd(b % a, a);
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	set<int> del;
	vector<int> ans;
	int t;
	cin >> t;
	for (int t1 = 0; t1 < t; t1++)
	{
		int n;
		cin >> n;
		int* a = new int[n], * next = new int[n];
		for (int i = 0; i < n; i++)
		{
			cin >> a[i];
			next[i] = (i + 1) % n;
		}
		for (int i = 0; i < n; i++)
			if (gcd(a[i], a[next[i]]) == 1)
				del.insert(i);
		int last = -1;
		while (!del.empty() && ans.size() < n)
		{
			auto it = del.upper_bound(last);
			if (it == del.end())
				it = del.begin();
			last = *it;
			ans.push_back(next[last]);
			del.erase(it);
			del.erase(next[last]);
			next[last] = next[next[last]];
			if (gcd(a[last], a[next[last]]) == 1)
				del.insert(last);
		}
		cout << ans.size() << " ";
		for (const auto& el : ans)
			cout << el + 1 << " ";
		cout << "\n";
		ans.clear();
		del.clear();
	}
}
