//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define int long long

using namespace std;


const int maxn = 3e5 + 10;

const int inf = 1e9 * maxn + 7;


signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t-- > 0) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        set<pair<int, int>> conf;
        for (int i = 0; i < n; ++i) {
            if (gcd(a[i], a[(i + 1) % n]) == 1)
                conf.insert({i, (i + 1) % n});
        }
        set<int> alive;
        for (int i = 0; i < n; ++i) {
            alive.insert(i);
        }
        set<int> kill;
        vector<int> ans;
        while (!conf.empty()) {
            set<pair<int, int>> new_conf;
            for (auto[i, j]: conf) {
                if (kill.count(i) || kill.count(j)) continue;
                kill.insert(j);
                ans.push_back(j);
                alive.erase(j);
                auto it = alive.upper_bound(i);
                if (it == alive.end())
                    it = alive.begin();
                int nj = *it;
                if (gcd(a[i], a[nj]) == 1)
                    new_conf.insert({i, nj});
            }
            conf = new_conf;
        }
        cout << ans.size() << " ";
        for (auto x: ans) {
            cout << x + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}
