#include <iostream>
#include <vector>
#include <set>

using namespace std;

int gcd(int a, int b)
{
    while(a)
    {
        swap(a, b);
        a %= b;
    }
    return b;
}

void solve()
{
    int n;
    cin >> n;
    vector<int> data(n), prev(n), next(n);
    for(int i = 0; i < n; i++)
    {
        cin >> data[i];
        prev[i] = (i + n - 1) % n;
        next[i] = (i + 1) % n;
    }
    set<int> bad;
    for(int i = 0; i < n; i++)
        if(gcd(data[prev[i]], data[i]) == 1)
            bad.insert(i);
    int pos = 1;
    vector<int> ans;
    while(ans.size() < n - 1 && !bad.empty())
    {
        auto it = bad.lower_bound(pos);
        if(it == bad.end())
            it = bad.begin();
        pos = *it;
        bad.erase(it);
        ans.push_back(pos);
        next[prev[pos]] = next[pos];
        prev[next[pos]] = prev[pos];
        if(gcd(data[next[pos]], data[prev[pos]]) == 1)
            bad.insert(next[pos]);
        else
            bad.erase(next[pos]);
        pos = next[next[pos]];
    }
    if(ans.size() == n - 1 && !bad.empty())
        if(data[*bad.begin()] == 1)
            ans.push_back(*bad.begin());
    cout << ans.size();
    for(int i = 0; i < ans.size(); i++)
        cout << ' ' << ans[i] + 1;
    cout << endl;
}

int main()
{
    int T;
    cin >> T;
    for(int I = 0; I < T; I++)
        solve();
    return 0;
}
