#include <bits/stdc++.h>

using namespace std;
#define MAXN 100005
int t[4 * MAXN];
int n;

void init() {
    memset(t, 0, sizeof(t));
}

void set_good(int pos, int val, int v = 1, int l = 0, int r = n) {
    if (pos < l || pos >= r) {
        return;
    }
    if (r == l + 1) {
        t[v] = val;
        return;
    }
    int m = (r + l) / 2;
    set_good(pos, val, v * 2, l, m);
    set_good(pos, val, v * 2 + 1, m, r);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int sum(int from, int to, int v = 1, int l = 0, int r = n) {
    if (from >= r || to <= l) {
        return 0;
    }
    if (from <= l && r <= to) {
        return t[v];
    }
    int m = (r + l) / 2;
    return sum(from, to, v * 2, l, m) + sum(from, to, v * 2 + 1, m, r);
}

int a[MAXN];
bool del[MAXN];
int n1[MAXN];
int pre[MAXN];

int next_undel(int pos) {
    if (del[pos] == 0) {
        return pos;
    }
    return n1[pos] = next_undel(n1[pos]);
}

vector<int> ans;

void we_del(int pos, int from) {
    ans.push_back(pos);
    if (ans.size() != n) {
        del[pos] = 1;
        int nxt = next_undel(pos);
        pre[nxt] = from;
        set_good(pos, 0);
        set_good(nxt, __gcd(a[nxt], a[from]) == 1);
    }
}

int find_bad(int l, int r) {
    if (sum(l, r) == 0) {
        return -1;
    }
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (sum(l, m) > 0) {
            r = m;
        } else {
            l = m;
        }
    }
    return l;
}

int find_bad(int l) {
    if (sum(l, n) == 0) {
        return find_bad(0, l);
    } else {
        return find_bad(l, n);
    }
}

void solve() {
    cin >> n;
    memset(a, 0, sizeof(a));
    memset(del, 0, sizeof(del));
    ans.clear();
    init();
    for (int i = 0; i < n; ++i) {
        n1[i] = (i + 1) % n;
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        pre[j] = i;
        if (__gcd(a[i], a[j]) == 1) {
            set_good(j, 1);
        }
    }
    int pos = 1;
    int last = -1;
    for (int i = 0; i < n; ++i) {
        int x = find_bad(pos);
        if (x == -1) {
            break;
        }
        if (last != -1 && next_undel(last) == x) {
            x++;
            x %= n;
            x = find_bad(x);
        }
        we_del(x, pre[x]);
        pos = x;
        last = x;
    }
    cout << ans.size() << " ";
    for (auto e:ans) {
        cout << e + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}