#include <bits/stdc++.h>

#define ll long long
#define int long long
#define pr pair<ll, ll>
#define ld long double

ll gcd(ll a, ll b){ return b ? gcd(b, a % b) : a;};

using namespace std;

const ll INF = 1e17;


void solve(){
    ll n;
    cin >> n;
    vector<ll>vec(n);
    for(ll i = 0 ; i <n;i++){
        cin >> vec[i];
    }
    set<ll>st;
    set<ll>free_pos;
    for(ll i = 0 ; i <n;i++){
        free_pos.insert(i);
    }
    vector<ll>ans;
    for(ll i = 0 ; i < n;i++){
        if(gcd(vec[i], vec[(i + 1) % n]) == 1){
            free_pos.erase((i + 1) % n);
            ans.push_back((i + 1) % n);
            st.insert(i);
            if(st.find((i + 1) % n) != st.end()){
                st.erase(st.find((i + 1) % n));
            }
            ++i;
        }
    }
    set<ll>st2;
    ll pred_pos = -1;
    while(!st.empty()){
        ll pos = pred_pos;
        if(st.upper_bound(pred_pos) != st.end()) {
            pos = *st.upper_bound(pred_pos);
        }
        else{
            pred_pos = -1;
            pos = *st.upper_bound(pred_pos);
        }
        if(free_pos.upper_bound(pos) != free_pos.end()){
            ll new_pos = *free_pos.upper_bound(pos);
            if(gcd(vec[pos], vec[new_pos]) == 1){
                ans.push_back(new_pos);
                if(free_pos.find(new_pos) != free_pos.end()) {
                    free_pos.erase(free_pos.find(new_pos));
                }
                if(st.find(new_pos) != st.end()) {
                    st.erase(st.find(new_pos));
                }
            }
            else{
                st.erase(st.find(pos));
            }
        }
        else{
            ll new_pos = *free_pos.lower_bound(0);
            if(gcd(vec[pos], vec[new_pos]) == 1){
                ans.push_back(new_pos);
                if(free_pos.find(new_pos) != free_pos.end()) {
                    free_pos.erase(free_pos.find(new_pos));
                }
                if(st.find(new_pos) != st.end()) {
                    st.erase(st.find(new_pos));
                }
            }
            else{
                st.erase(st.find(pos));
            }
        }
        pred_pos = pos;
    }
    cout << ans.size() << ' ';
    for(ll i = 0 ; i <ans.size();i++){
        cout << ans[i] + 1 << ' ';
    }
    cout << '\n';
}

int32_t main(){
    ios::sync_with_stdio(false);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t;
    cin >> t;
    while(t--){
        solve();
    }
}