#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#define int long long
using namespace std;
typedef vector<int> vi;

int gcd(int a, int b){
	return (b ? gcd(b, a%b) : a);
}

void solve(){
	int n;
	cin >> n;
	vi a(n);
	for(int i=0; i<n; i++)
		cin >> a[i];
	queue<pair<int, int> > interesting;
	set<int> lol;
	for(int i=0; i<n; i++){
		lol.insert(i);
		interesting.push(make_pair(i, (i+1)%n));
	}
	vi ans;
	while(!interesting.empty()){
		pair<int, int> cur;
		cur = interesting.front();
		interesting.pop();
		if(lol.find(cur.first) == lol.end())
			continue;
		if(gcd(a[cur.first], a[cur.second]) == 1){
			//cout << "succesed" << endl;
			ans.push_back(cur.second + 1);
			lol.erase(cur.second);
			set<int>::iterator it = lol.upper_bound(cur.first);
			if(it == lol.end())
				it = lol.begin();
			interesting.push(make_pair(cur.first, *it));
		}
	}
	cout << ans.size() << " ";
	for(int i=0; i<ans.size(); i++)
		cout << ans[i] << " ";
	cout << endl;
	
}

signed main(){
	int q = 1;
	cin >> q;
	while(q--){
		solve();
	}
	// cin >> q;
	return 0;
}