//
// Created by watemus on 21.03.2021.
//
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
using vec = vector<T>;

const int INFI = 1'000'000'228;
const ll INFL = 1'000'000'000'000'000'228;

mt19937 rnd(228);

#define int ll
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

void precalc() {

}

struct Node {
  int val;
  int id;
  bool rm = false;
  Node *nxt = nullptr;
  Node *prv = nullptr;
  Node(int val, int id) : val(val), id(id) {}
};

void rem(Node *t) {
  auto nx = t->nxt;
  auto pr = t->prv;
  nx->prv = pr;
  pr->nxt = nx;
  t->rm = true;
}

void run() {
  int n;
  cin >> n;
  vec<int> a(n);
  vec<Node*> nodes(n);
  vec<Node*> candidates;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    nodes[i] = new Node(a[i], i);
  }
  for (int i = 0; i < n; i++) {
    candidates.push_back(nodes[i % n]);
  }
  for (int i = 0; i < n; i++) {
    nodes[i]->nxt = nodes[(i + 1) % n];
    nodes[i]->prv = nodes[(i - 1 + n) % n];
  }
  vec<Node*> new_candidates;
  vec<int> who;
  int sz = n;
  while (candidates.size() && sz > 0) {
    for (auto p : candidates) {
      if (p->rm) continue;
      if (gcd(p->val, p->nxt->val) == 1) {
        sz--;
        new_candidates.push_back(p);
        who.push_back(p->nxt->id + 1);
        rem(p->nxt);
      }
    }
    candidates = new_candidates;
    new_candidates.clear();
  }
  cout << who.size() << ' ';
  for (auto el : who) {
    cout << el << ' ';
  }
  cout << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  precalc();
  int t = 1;
  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}