#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <iomanip>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int gcd(int a, int b) {
	if (!b)
		return a;
	return gcd(b, a % b);
}

void solve() {

	int n;
	cin >> n;
	vi h(n), b(n);
	for (int i = 0; i < n; ++i)
		cin >> h[i];
	for (int i = 0; i < n; ++i)
		cin >> b[i];
	vi dp(n + 1);
	vii st = { {-1, 0} };
	for (int i = 0; i < n; ++i) {
		while (st.back().first != -1 && h[st.back().first] > h[i]) {
			int x = st.back().second;
			st.pop_back();
			st.back().second = max(st.back().second, x);
		}
		dp[i + 1] = st.back().second + b[i];
		if (st.back().first != -1)
			dp[i + 1] = max(dp[i + 1], dp[st.back().first + 1]);
		st.push_back({ i, dp[i + 1] });
	}
	cout << dp[n];

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}