#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(x) x.begin(), x.end()
#define bug cout << "bug" << endl
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define F first
#define S second
#define pb push_back

const ll N = 3e5 + 5, INF = 1e15 + 7, mod = 1e9 + 7;

ll dp[N], h[N], b[N], t[N * 4];

void build(int v, int tl, int tr){
	if(tl == tr){
		t[v] = -INF;
		return;
	}
	int tm = (tl + tr) / 2;
	build(v * 2, tl, tm);
	build(v * 2 + 1, tm + 1, tr);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}

void upd(int v, int tl, int tr, ll pos, ll val){
	if(tl == tr){
		t[v] = val;
		return;
	}
	int tm = (tl + tr) / 2;
	if(pos <= tm) upd(v * 2, tl, tm, pos, val);
	else upd(v * 2 + 1, tm + 1, tr, pos, val);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}

ll get(int v, int tl, int tr, int l, int r){
	if(tl >= l && tr <= r)
		return t[v];
	if(tl > r || tr < l) return -INF;
	int tm = (tl + tr) / 2;
	ll q1 = get(v * 2, tl, tm, l, r);
	ll q2 = get(v * 2 + 1, tm + 1, tr, l, r);
	return max(q1, q2);
}

int main(){
	speed;
	ll n;
	cin >> n;
	build(1, 1, n);
	for(int i = 1; i <= n; i++)
		dp[i] = -INF;	
	for(int i = 1; i <= n; i++)
		cin >> h[i];
	for(int i = 1; i <= n; i++)
		cin >> b[i];
		
	stack <pair <ll, ll> > st;
	for(int i = 1; i <= n; i++){
		while(st.size() && st.top().F > h[i])
			st.pop();
		if(st.size() == 0){
			dp[i] = b[i];
			dp[i] = max(dp[i], get(1, 1, n, 1, i - 1) + b[i]);
		}else{
			dp[i] = max(dp[i], get(1, 1, n, st.top().S, i - 1) + b[i]);
			dp[i] = max(dp[i], dp[st.top().S]);
		}
		upd(1, 1, n, i, dp[i]);
		st.push({h[i], i});
	}
	cout << dp[n] << endl;
	
}