#include <bits/stdc++.h> 

#define ll long long
#define pb push_back
#define F first
#define S second

using namespace std;

const int N = (int)3e5 + 11;
int n, h[N], b[N];
int l[N]; ll dp[N][2];
int t[4 * N]; ll g[4 * N];

void build(int v, int l, int r){
    if(l == r)
        t[v] = h[l], g[v] = -(ll)1e17;
    else{
        int mid = (l + r) / 2;
        build(v + v, l, mid);
        build(v + v + 1, mid + 1, r);
        t[v] = min(t[v + v], t[v + v + 1]);
        g[v] = max(g[v + v], g[v + v + 1]);
    }
}

int get(int v, int l, int r, int lx, int rx){
    if(r < lx or rx < l)    
        return (int)1e9;
    if(lx <= l  and r <= rx)
        return t[v];
    int mid = (l + r) / 2;
    return min(get(v + v, l, mid, lx, rx), get(v + v + 1, mid + 1, r, lx, rx));
}

ll gett(int v, int l, int r, int lx, int rx){
    if(r < lx or rx < l)    
        return -(ll)1e17;
    if(lx <= l  and r <= rx)
        return g[v];
    int mid = (l + r) / 2;
    return max(gett(v + v, l, mid, lx, rx), gett(v + v + 1, mid + 1, r, lx, rx));
}

void upd(int v, int l, int r, int pos){
    if(l == r)
        g[v] = dp[l][1];
    else{
        int mid = (l + r) / 2;
        if(pos <= mid)
            upd(v + v, l, mid, pos);
        else
            upd(v + v + 1, mid + 1, r, pos);
        g[v] = max(g[v + v], g[v + v + 1]);    
    }    
}

int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> h[i];
    }
    for(int i = 1; i <= n; i++){
        cin >> b[i];
    }
    build(1, 1, n);
    
    l[1] = 0;
    for(int i = 2; i <= n; i++){
        int lll = 1, r = i - 1;
        int res = 0;
        while(lll <= r){
            int mid = (lll + r) / 2;
            if(h[i] > get(1, 1, n, mid, i - 1)){
                res = mid;
                lll = mid + 1;
            }
            else
                r = mid - 1;
        }
        l[i] = res;
    }
    
    dp[1][1] = b[1];
    dp[1][0] = -(ll)1e17;
    upd(1, 1, n, 1);
    for(int i = 2; i <= n; i++)
        for(int j = 0; j < 2; j++){
            if(j == 0){
                if(l[i] == 0){
                    dp[i][j] = -(ll)1e17;
                    continue;
                }
                dp[i][j] = max(dp[ l[i] ][1], dp[ l[i] ][0]);
            }
            else{
                ll k = gett(1, 1, n, (l[i] == 0 ? 1 : l[i]), i - 1);
                dp[i][j] = max(k, dp[l[i]][0]) + b[i] * 1ll;
                upd(1, 1, n, i);
            }
        }
    cout << max(dp[n][1], dp[n][0]);    
    
    return 0;
}