#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()

//#pragma GCC optimize("O3,Ofast,unroll-loops")
//#pragma GCC target("avx2")

/*const int MAXMEM = 1e8;
char mem[MAXMEM];
int mempos = 0;
inline void * operator new(size_t n)
{
    char * cur = mem + mempos;
    mempos += n;
    assert(mempos <= MAXMEM);
    return (void*)cur;
}
inline void operator delete(void*) { };*/

const int N = 3e5 + 123;
ll tree[4 * N];
void update(int v, int tl, int tr, int p, ll x)
{
    if(tl == tr)
    {
        tree[v] = x;
        return;
    }
    int tm = (tl + tr) >> 1;
    if(p <= tm)
    {
        update(v << 1, tl, tm, p, x);
    }
    else
    {
        update(1 + (v << 1), tm + 1, tr, p, x);
    }
    tree[v] = max(tree[v << 1], tree[1 + (v << 1)]);
}

const ll inf = 1e18 + 237373;

ll get(int v, int tl, int tr, int l, int r)
{
    l = max(l, tl);
    r = min(r, tr);
    if(l > tr || r < tl)
        return -inf;
    if(l == tl && r == tr)
        return tree[v];
    int tm = (tl + tr) >> 1;
    return max(get(v << 1, tl, tm, l, r), get(1 + (v << 1), tm + 1, tr, l, r));
}

signed main()
{
    ios;
    int n;
    cin >> n;
    vector<int> h(n);
    vector<ll> b(n);
    for(int &x : h)
        cin >> x;
    for(ll &x : b)
        cin >> x;
    vector<int> prev(n); ///ll - minimum in window
    vector<int> st;
    for(int i = 0; i < n; ++i)
    {
        while(!st.empty() && h[st.back()] > h[i])
            st.pop_back();
        if(st.empty())
            prev[i] = -1;
        else
            prev[i] = st.back();
        st.emplace_back(i);
    }
    vector<ll> dp(n, -inf);
    vector<pair<int, ll> > pref(n);
    pref[0] = {h[0], b[0]};
    for(int i = 1; i < n; ++i)
        pref[i] = min(pref[i - 1], make_pair(h[i], b[i]));
    vector<ll> A(n);
    dp[0] = b[0];
    update(1, 0, n - 1, 0, b[0]);
    ///A[0] = -inf;
    //cout << dp[0] << ' ';
    for(int i = 1; i < n; ++i)
    {
        int j = prev[i];
        if(j + 1 <= i - 1)
            dp[i] = get(1, 0, n - 1, j + 1, i - 1) + b[i];
        dp[i] = max(dp[i], pref[i].second);
        dp[i] = max(dp[i - 1] + b[i], dp[i]);
        if(j >= 0)
            dp[i] = max(dp[i], dp[j]);
        if(j >= 0)
            dp[i] = max(dp[i], dp[j] + b[i]);
        update(1, 0, n - 1, i, dp[i]);
        //if(i != n - 1)
        //    cout << dp[i] << ' ';
    }
    cout << dp[n - 1];
    return 0;
}

