#include<bits/stdc++.h>
using namespace std;
#define X first
#define Y second
#define sz(a) (int)a.size()
#define ll long long
const int N = 3e5;
ll Tree[4 * N], upd[N * 4];
void push(int v)
{
    Tree[v * 2] += upd[v];
    upd[v * 2] += upd[v];
    Tree[v * 2 + 1] += upd[v];
    upd[v * 2 + 1] += upd[v];
    upd[v] = 0;
}
void update(int v, int l, int r, int al, int ar, ll val)
{
    if(al > ar)
    {
        return;
    }
    if(l >= al && r <= ar)
    {
        Tree[v] += val;
        upd[v] += val;
    }
    else if(l <= ar && r >= al)
    {
        push(v);
        update(v * 2, l, (r + l) / 2, al, ar, val);
        update(v * 2 + 1, (r + l) / 2 + 1, r, al, ar, val);
        Tree[v] = max(Tree[v * 2], Tree[v * 2 + 1]);
    }
}
ll ans(int v, int l, int r, int al, int ar)
{
    if(al > ar)
    {
        return -1e18;
    }
    if(l >= al && r <= ar)
    {
        return Tree[v];
    }
    if(l <= ar && r >= al)
    {
        push(v);
        return max(ans(v * 2, l, (r + l) / 2, al, ar), ans(v * 2 + 1, (r + l) / 2 + 1, r, al, ar));
    }
    return -1e18;
}
signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    fill(Tree, Tree + 4 * N, 0);
    fill(upd, upd + 4 * N, 0);
    vector <int> h(n);
    vector <int> b(n);
    for(int i = 0; i < n; i++)
    {
        cin >> h[i];
    }
    for(int i = 0; i  < n; i++)
    {
        cin >> b[i];
    }
    vector <pair <int, int> > st;
    st.push_back({-1e9, -1});
    for(int i = 0; i < n; i++)
    {
        while(st.back().X > h[i])
        {
            int ind = st.back().Y;
            st.pop_back();
            update(1, 0, n - 1, max(st.back().Y, 0), ind - 1, -b[ind]);
        }
        update(1, 0, n - 1, st.back().Y, i - 1, b[i]);
        st.push_back({h[i], i});
        ll ns = ans(1, 0, n - 1, 0, i - 1);
        if(i == 0)
        {
            ns = b[0];
        }
        ns = max(ns, 1LL * b[st[1].Y]);
      //  cout << ns << " ";
        update(1, 0, n - 1, i, i, ns);
    }
    cout << ans(1, 0, n - 1, n - 1, n - 1);

    return 0;
}
