#include <bits/stdc++.h>

using namespace std;

#define int ll

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define print(x) {for (xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}

const int maxn = 2e5 + 5, intf = 2e9;
const ll inf = 2e18;


int n, N = 1;
vector <int> h, a;
vector <ll> tree, val, dp;

void push(int i) {
    if (i*2 + 1 < 2*N) {
        val[i*2] += val[i];
        val[i*2 + 1] += val[i];
    }
    val[i] = 0;
}

void upd(int i) {
    if (i*2 + 1 >= 2*N)
        return;
    tree[i] = max(tree[i*2] + val[i*2], tree[i*2 + 1] + val[i*2 + 1]);
}

void add(int L, int R, int l, int r, int i, int x) {
    if (r <= L || R <= l)
        return;
    if (L <= l && r <= R) {
        val[i] += x;
        return;
    }
    int mid = (l + r) / 2;
    push(i);
    add(L, R, l, mid, i*2, x);
    add(L, R, mid, r, i*2 + 1, x);
    upd(i);
}

ll get_max(int L, int R, int l, int r, int i) {
    if (r <= L || R <= l)
        return -inf;
    if (L <= l && r <= R) {
        return tree[i] + val[i];
    }
    int mid = (l + r) / 2;
    push(i);
    ll ans = max(get_max(L, R, l, mid, i*2), get_max(L, R, mid, r, i*2 + 1));
    upd(i);
    return ans;
}

void solve() {
    cin >> n;
    h.resize(n);
    for (auto &x : h)
        cin >> x;
    a.resize(n);
    for (auto &x : a)
        cin >> x;

    vector <int> pos(n, -1);
    vector <pii> pref(n);
    for (int i = 0; i < n; i++) {
        pref[i] = {h[i], a[i]};
        if (i > 0)
            pref[i] = min(pref[i], pref[i - 1]);
    }
    vector <pii> b(n);
    for (int i = 0; i < n; i++) {
        b[i] = {h[i], i};
    }
    sort(all(b));
    set <int> p;
    for (int i = 0; i < n; i++) {
        auto it = p.upper_bound(b[i].second);
        if (it != p.begin()) {
            it--;
            pos[b[i].second] = *it;
        }

        p.insert(b[i].second);
    }

    while (N < n)
        N *= 2;
    tree.resize(2*N, 0);
    val.resize(2*N, 0);
    dp.resize(n);
    vector < pair <pii, int> > segm;
    for (int i = 0; i < n; i++) {
        int l = pos[i], r = i - 1;
        l = max(l, 0LL);
        while (!segm.empty() && segm.back().first.first >= l) {
            add(segm.back().first.first, segm.back().first.second + 1, 0, N, 1, -segm.back().second);
            segm.pop_back();
        }
        if (!segm.empty() && segm.back().first.second >= l) {
            int L = l;
            int R = segm.back().first.second;
            add(L, R + 1, 0, N, 1, -segm.back().second);
            segm.back().first.second = l - 1;
        }
        segm.push_back({{l, r}, a[i]});
        add(l, r + 1, 0, N, 1, a[i]);
        if (i > 0) {
            dp[i] = get_max(0, i, 0, N, 1);
        }
        else {
            dp[i] = a[i];
        }

        dp[i] = max(dp[i], pref[i].second);

        add(i, i + 1, 0, N, 1, dp[i]);
    }
    cout << dp[n - 1] << '\n';
}

signed main() {
    #ifdef HERE
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);
    #endif // HERE

    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}
