#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 3e5 + 10, INF = 1e9 + 10, MOD = 1e9 + 7;
const ll LINF = ll(1e18) + 10;

int h[N], b[N];
ll dp[N], st[4*N];

int mn_left[N];

vector<int> dq;

void update_tree(int v, int l, int r, int id, ll nw) {
    if (l + 1 == r) {
        st[v] = nw;
    } else {
        int m = (l + r) / 2, vl = v*2 + 1, vr = vl + 1;
        if (id < m) {
            update_tree(vl, l, m, id, nw);
        } else {
            update_tree(vr, m, r, id, nw);
        }
        st[v] = max(st[vl], st[vr]);
    }
}

ll get_tree(int v, int l, int r, int s, int e) {
    if (s == e) return -LINF;
    if (l == s && r == e) {
        return st[v];
    }
    int m = (l + r) / 2, vl = v * 2 + 1, vr = vl + 1;

    ll x = get_tree(vl, l, m, min(s, m), min(m, e));
    ll y = get_tree(vr, m, r, max(s, m), max(m, e));

    return max(x, y);
}

void solve() {
    int n;
    cin >> n;
    dq.push_back(0);
    for (int i = 1; i <= n; i++) {
        cin >> h[i];
        while (h[dq.back()] > h[i]) {
            dq.pop_back();
        }
        mn_left[i] = dq.back();
        dq.push_back(i);
    }

    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }

    for (int i = 1; i <= n; i++) {
        int it = mn_left[i];
        dp[i] = get_tree(0, 0, n+1, it, i) + b[i];
        if (it != 0) {
            dp[i] = max(dp[i], dp[it]);
        }

        update_tree(0, 0, n+1, i, dp[i]);
    }

    cout << dp[n];
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

//    int t;
//    cin >> t;
//
//    while (t--)
        solve();

    return 0;
}