#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

int main(){
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  vector<int> h(n);
  for (int i = 0; i < n; ++i)
    cin >> h[i];
  vector<long long> b(n);
  for (int i = 0; i < n; ++i)
    cin >> b[i];
  vector<long long> dp(n + 1);
  vector<int> stack;
  vector<long long> mx_dp;
  vector<long long> best;
  for (int i = 0; i < n; ++i) {
    long long mx = dp[i];
    while (!stack.empty() && h[stack.back()] >= h[i]) {
      mx = max(mx, mx_dp.back());
      stack.pop_back();
      mx_dp.pop_back();
      best.pop_back();
    }
    stack.emplace_back(i);
    mx_dp.emplace_back(mx);
    if (!best.empty())
      best.push_back(max(best.back(), mx + b[i]));
    else
      best.emplace_back(mx + b[i]);
    dp[i + 1] = best.back();
  }
  cout << dp[n] << '\n';
  return 0;
}
