#include<bits/stdc++.h>
#define fi first
#define se second
#define len(x) (int)(x).size()
using namespace std;
typedef long long ll;

const ll inf = 1e18;
const int N = (int)3e5 + 10;
ll seg[4*N];
void build(int v , int tl , int tr){
    seg[v] = -inf;
    if(tl == tr){
        return;
    }
    int mid = (tl + tr) >> 1 , v1 = v << 1;
    build(v1 , tl  ,mid);
    build(v1|1 , mid + 1,  tr);
}
void upd(int v , int tl , int tr , int pos , ll val){
    if(tl == tr){
        seg[v] = val;
        return;
    }
    int mid = (tl + tr) >> 1 , v1 = v << 1;
    if(pos <= mid)
        upd(v1 , tl , mid , pos , val);
    else
        upd(v1|1 , mid + 1 , tr , pos , val);
    seg[v] = max(seg[v1] , seg[v1|1]);
}
ll get(int v , int tl , int tr , int l ,int r ){
    if(tl == l && tr == r)
        return seg[v];
    int mid = (tl + tr) >> 1 , v1 = v << 1;
    ll ans = -inf;
    if(l <= mid)
        ans = max(ans ,get(v1 , tl , mid , l ,min(r, mid)));
    if(r > mid)
        ans = max(ans , get(v1|1 , mid + 1 , tr , max(l , mid + 1) , r));
    return ans;
}
int main(){
    ios_base::sync_with_stdio(0) , cin.tie(0) , cout.tie(0);

    int n;
    cin >> n;
    build(1 , 0 , n);
    vector < int > h(n);
    for(auto &i : h)
        cin >> i;
    vector < int > b(n);
    for(auto &i : b)
        cin >> i;
    vector < int > left , L(n);
    for(int i = 0 ; i < n; ++i){
        while(!left.empty() && h[left.back()] > h[i])
            left.pop_back();
        if(!left.empty())
            L[i] = left.back();
        else
            L[i] = -1;
        left.push_back(i);
    }
    /// okay
    /// 0 , n
    vector < ll > dp(n + 1 , -inf);
    dp[0] = 0;
    upd(1 , 0 , n , 0 , 0);
    for(int i = 1; i <= n; ++i){
        /// okay
        int ps = L[i-1] + 1;
        if(ps != 0)
            dp[i] = max(dp[i] , dp[ps]);
        dp[i] = max(dp[i] , get(1 , 0 , n , ps, i) + b[i-1]);
        upd(1 ,0 , n , i , dp[i]);
    }
    cout << dp[n];
    return 0;
}
