#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 3e5 + 1;
const int inf = 1e18;
int t[maxn * 4];

void upd(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        t[v] = val;
    } else {
        int tm = (tl + tr) / 2;
        if (pos <= tm) {
            upd(v * 2, tl, tm, pos, val);
        } else {
            upd(v * 2 + 1, tm + 1, tr, pos, val);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
}

int get(int v, int tl, int tr, int l, int r) {
    if (tr < l || tl > r)return -inf;
    if (l <= tl && tr <= r)return t[v];
    int tm = (tl + tr) / 2;
    return max(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm + 1, tr, l, r));
}

vector<int> getlai(vector<int> a) {
    vector<int> ans(a.size(), -1);
    vector<int> st;
    for (int i = 0; i < a.size(); ++i) {
        while (st.size() != 0 && a[st.back()] >= a[i])st.pop_back();
        if (st.size() != 0)ans[i] = st.back();
        st.push_back(i);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int n;
    cin >> n;
    vector<int> h(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (int j = 0; j < n; ++j) {
        cin >> b[j];
    }
    vector<int> last = getlai(h);
    int dp[n + 1];
    for (int l = 0; l < n + 1; ++l) {
        dp[l] = 0;
    }
    dp[0] = 0;
    for (int k = 1; k < n + 1; ++k) {
        int l = last[k - 1] + 1;
        int r = k - 1;
        dp[k] = get(1, 0, n, l, r) + b[k - 1];
        if (last[k - 1] != -1) {
            dp[k] = max(dp[k], dp[l]);
        }
        upd(1, 0, n, k, dp[k]);
    }
    cout << dp[n];
}

