﻿#include <iostream>
#include <string>
#include <math.h>
#include <cstring>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <assert.h>
#include <istream>
#include <ostream>
#include <vector>
#include <algorithm>

#define ll long long
#define ld long double

#define int long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

#define all(a) a.begin(), a.end()
#define mysort(a) sort(all(a))
#define myreverse(a) reverse(all(a))
#define myunique(a) unique(all(a))
#define superunique(a) a.resize(myunique(a) - a.begin())

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define FOD(i, r, l) for (int i = r; i >= l; i--)


using namespace std;

template <class T1, class T2>
istream& operator>>(istream & in, pair<T1, T2>&val) {
    return in >> val.ft >> val.sd;
}

template <class T1, class T2>
ostream& operator<<(ostream & out, pair<T1, T2>&val) {
    return out << val.ft << ' ' << val.sd;
}

template <class T1>
istream& operator>>(istream& in, vector<T1>& val) {
    FOR(i, 0, val.size())
        in >> val[i];
    return in;
}

template <class T1>
ostream& operator<<(ostream& out, vector<T1>& val) {
    FOR(i, 0, val.size())
        out << val[i] << ' ';
    out << '\n';
    return out;
}

const int MAX_N = 4e5;
int maxx[MAX_N * 4];

void update(int ind) {
	maxx[ind] = max(maxx[2 * ind + 1], maxx[2 * ind + 2]);
}

void build(int ind = 0, int l = 0, int r = MAX_N) {
	if (r - l == 1)
		maxx[ind] = -1000000000;
	else {
		int m = (l + r) / 2;
		build(2 * ind + 1, l, m);
		build(2 * ind + 2, m, r);
		update(ind);
	}
}

void sett(int pos, int val, int ind = 0, int l = 0, int r = MAX_N) {
	if (r - l == 1)
		maxx[ind] = val;
	else {
		int m = (l + r) / 2;
		if (pos < m)
			sett(pos, val, 2 * ind + 1, l, m);
		else
			sett(pos, val, 2 * ind + 2, m, r);
		update(ind);
	}
}

int get(int l1, int r1, int ind = 0, int l = 0, int r = MAX_N) {
	if (l1 >= r || r1 <= l)
		return -1000000000;
	if (l >= l1 && r <= r1)
		return maxx[ind];
	int m = (l + r) / 2;
	return max(get(l1, r1, 2 * ind + 1, l, m), get(l1, r1, 2 * ind + 2, m, r));
}

struct Node {
    int val, ind;
    Node* next, * skip, * previous;
    Node() {}
};

void solve() {
    int n;
    cin >> n;
	vector<int> h(n);
	vector<int> b(n);
	cin >> h >> b;
	vector<int> ans(n + 1, -1000000000);
	ans[0] = 0;
	stack<int> st;
	st.push(-1);
	sett(0, 0);
	for (int i = 0; i < n; i++) {
		while (st.size() > 1 && h[st.top()] > h[i])
			st.pop();
		int last = st.top();
		if (st.size() > 1)
			ans[i + 1] = ans[last + 1];
		ans[i + 1] = max(ans[i + 1], get(last + 1, i + 1) + b[i]);
		sett(i + 1, ans[i + 1]);
		st.push(i);
	}
	cout << ans[n];
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}