#include <bits/stdc++.h>

using namespace std;

clock_t StartTime;

typedef long long ll;

const int INF = 1e9 + 5e7;
const ll LLINF = 1e18 + 5e7;
const int N = 2e6 + 3e2;
const int M = 555;

#define all(x) (x).begin(), (x).end()

int n;
int h[N], b[N];

ll dp[N];

int lf[N];

ll t[N];

ll get(int l, int r, int v = 1, int tl = 1, int tr = n){
    if (tl >= l && tr <= r) return t[v];
    if (tl > r || tr < l) return -LLINF;
    int tm = (tl + tr) >> 1;
    return max(get(l, r, v + v, tl, tm), get(l, r, v + v + 1, tm + 1, tr));
}

void update(int pos, int v = 1, int tl = 1, int tr = n){
    if (tl == tr){
        t[v] = dp[pos];
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos <= tm) update(pos, v + v, tl, tm); else
        update(pos, v + v + 1, tm + 1, tr);
    t[v] = max(t[v + v], t[v + v + 1]);
}

void solve(){
    cin >> n;

    for (int i = 1; i <= n; i++) cin >> h[i];
    for (int i = 1; i <= n; i++) cin >> b[i];

    vector<int> st = {0};
    h[0] = -INF;
    for (int i = 1; i <= n; i++){
        while (h[st.back()] > h[i]) st.pop_back();
        lf[i] = st.back() + 1;
        st.push_back(i);
    }

    fill(t, t + N, -LLINF);

    int mind = 1;

    dp[0] = 0;
    for (int i = 1; i <= n; i++){
        if (h[i] < h[mind]) mind = i;
        dp[i] = dp[i - 1] + b[i];

        int l = max(1, lf[i] - 1);
        dp[i] = max(dp[i], get(l, i - 1) + b[i]);
        if (lf[i] > 1) dp[i] = max(dp[i], dp[lf[i] - 1]);

        dp[i] = max(dp[i], 1ll * b[mind]);

        update(i);
    }

    cout << dp[n];

}

int main() {
    StartTime = clock();

    ios_base::sync_with_stdio(false);

#ifdef dxz05
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int TC = 1;
    //cin >> TC;

    while (TC--){
        solve();
    }

#ifdef dxz05
    cerr << endl << 1000.0 * (clock() - StartTime) / CLOCKS_PER_SEC << " ms";
#endif

    return 0;
}
