﻿#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define int long long

using namespace std;

const int INF = 1e16, MOD = 1e9 + 7;

int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }

vector<int> h, b, dp, g;
vector<vector<int>> up;
int n, logn;

void build() {
	for (int i = 0; i <= n; i++)
		up[i][0] = h[i];
	for (int i = 1; i <= logn; i++) {
		for (int j = 0; j <= n - (1 << (i - 1)); j++) {
			up[j][i] = min(up[j][i - 1], up[j + (1 << (i - 1))][i - 1]);
		}
	}
}
int get_min(int l, int r) {
	int c = log2(r - l + 1);
	return min(up[l][c], up[r - (1 << c) + 1][c]);
}
int get_max(int v, int tl, int tr, int l, int r) {
	if (l > r) return -INF;
	if (tl == l && tr == r) return g[v];
	int tm = (tl + tr) / 2;
	return max(get_max(v * 2, tl, tm, l, min(r, tm)), get_max(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}
void update(int v, int tl, int tr, int it) {
	if (tl == tr) return void(g[v] = dp[tl]);
	int tm = (tl + tr) / 2;
	if (it <= tm)
		update(v * 2, tl, tm, it);
	else
		update(v * 2 + 1, tm + 1, tr, it);
	g[v] = max(g[v * 2], g[v * 2 + 1]);
}
int find_first(int it) {
	int l = 0, r = it;
	while (r - l > 1) {
		int m = (l + r) / 2;
		int res = get_min(m, it);
		if (res == h[it]) {
			r = m;
		}
		else {
			l = m;
		}
	}
	return l;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");

	cin >> n;
	h.resize(n+1), b.resize(n+1), dp.resize(n+1);
	for (int i = 1; i <= n; i++) cin >> h[i];
	for (int i = 1; i <= n; i++) cin >> b[i];

	logn = ceil(log2(n + 1));
	up.resize(n+1, vector<int>(logn+1));
	build();
	
	g.resize(4 * n);

	for (int i = 1; i <= n; i++) {
		int it = find_first(i);
		if (!it) {
			dp[i] = b[i];
		}
		else
			dp[i] = max(dp[it], dp[it] + b[i]);
		if (it + 1 <= i - 1) {
			dp[i] = max(dp[i], get_max(1, 1, n, it + 1, i - 1) + b[i]);
		}
		update(1, 1, n, i);
	}
	//cout << get_min(1, 2) << '\n';
	//for (int i = 1; i <= n; i++)
	//	cout << dp[i] << ' ';
	//cout << '\n';
	cout << dp[n];
}