#include<iostream>
#include<vector>
#include<algorithm>
#include<map>
#include<set>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<numeric>
#include<cassert>
#include<random>
#include<bitset>
#include<stack>
#include<iomanip>
#include<string>

using namespace std;

stack<vector<long long>> s;

void add(int pos, long long d, long long val) {
	long long cur_mx = d + val;
	if (!s.empty()) {
		cur_mx = max(cur_mx, s.top()[0]);
	}
	s.push({ cur_mx, pos, d });
}

void upd(int pos, long long val) {
	long long d = -1e16;
	int cnt = 0;
	while (!s.empty() && s.top()[1] >= pos) {
		cnt++;
		auto cur = s.top();
		s.pop();
		d = max(d, cur[2]);
	}
	if (!cnt) return;
	add(pos, d, val);
}


void upd1(int pos, long long val, long long d) {
	while (!s.empty() && s.top()[1] >= pos) {
		auto cur = s.top();
		s.pop();
		d = max(d, cur[2]);
	}
	add(pos, d, val);
}

long long get() {
	return s.top()[0];
}

void print() {
	stack<vector<long long>> cur;
	while (!s.empty()) {
		cur.push(s.top());
		for (auto i : cur.top()) {
			cout << i << " ";
		}
		cout << endl;
		s.pop();
	}
	while (!cur.empty()) {
		s.push(cur.top());
		cur.pop();
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//cout << fixed << setprecision(30);
	int _ = 1;
	//cin >> _;
	while (_--) {
		int n;
		cin >> n;
		vector<long long> left(n, -1);
		stack<pair<int, int>> st;
		vector<long long> h(n);
		for (int i = 0; i < n; i++) {
			cin >> h[i];
			while (!st.empty() && st.top().first > h[i]) {
				st.pop();
			}
			if (!st.empty()) {
				left[i] = st.top().second;
			}
			st.push({ h[i], i });
		}
		vector<long long> b(n);
		for (int i = 0; i < n; i++) {
			cin >> b[i];
		}
		vector<long long> dp(n);
		s.push({ b[0], -1, 0 });
		dp[0] = b[0];
		for (int i = 1; i < n; i++) {
			//cout << "------ " << i << endl;
			int pos = left[i];
			upd1(pos, b[i], dp[i - 1]);
			dp[i] = get();
			//print();
			//cout << "dp: " << dp[i] << endl;
			//print();
		}
		cout << dp[n - 1] << endl;
	}
}
