#include <bits/stdc++.h>
#include <ext/rope>

#define len(x) (int)x.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fast_io ios_base::sync_with_stdio(0) , cin.tie(0) , cout.tie(0)
#define mkp make_pair
#define pb push_back
#define fs first
#define sc second

using namespace std;
using namespace __gnu_cxx;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll, ll> pll;

ll t[(int)2e6], p[(int)2e6];

void push(ll v){
    if(p[v] == 0) return;
    t[v*2] += p[v];
    t[v*2+1] += p[v];
    p[v*2] += p[v];
    p[v*2+1] += p[v];
    p[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, ll x){
    if(l > r) return;
    if(tl == l && tr == r){
        t[v] += x;
        p[v] += x;
        return;
    }
    push(v);
    int mid = (tl+tr)>>1;
    update(v*2, tl, mid, l, min(r, mid), x);
    update(v*2+1, mid+1, tr, max(mid+1, l),r , x);
    t[v] = max(t[v*2], t[v*2+1]);
}

ll get(int v, int tl, int tr, int l, int r){
    if(l > r) return -1e18;
    if(tl == l && tr == r){
        return t[v];
    }
    push(v);
    int mid = (tl+tr)>>1;
    return max(get(v*2, tl, mid, l, min(r, mid)), get(v*2+1, mid+1, tr, max(mid+1, l),r));
}

signed main()
{
    fast_io;
    ll n;
    cin >> n;
    fill(t, t+(int)16e5, 0);
    vector<ll> a(n+1);
    vector<ll> b(n+1);
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    for(int i = 1; i <= n; i++){
        cin >> b[i];
    }

    stack<pair<pll, ll>> s; s.push({{0, 0}, 1});
    update(1, 0, n, 0, 1, b[1]);

    for(int i = 2; i <= n; i++){
        while(!s.empty() && a[s.top().sc] > a[i]){
            pll z = s.top().fs; int ind = s.top().sc; s.pop();
            update(1, 0, n, z.fs, z.sc, b[i] - b[ind]);
        }
        if(s.empty()){
            s.push({{0, i-1}, i});
        }
        else{
            s.push({{s.top().fs.sc+1, i-1}, i});
        }
        update(1, 0, n, i-1, i-1, b[i]);
        ll x = get(1, 0, n, 0, i-1);
        update(1, 0, n, i, i, x);
    }

    cout << get(1, 0, n, n, n);

    return 0;
}

