#include <bits/stdc++.h>
using namespace std;

#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define F first
#define S second
#define PI 3.14159265
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef set<int> si;
typedef set<ll> sll;
typedef set<pii> spii;
typedef set<pll> spll;

mt19937 bruh(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2e6 + 2000;
const int M = 1;
const int mod = 1e9 + 7;
const int inf = 2e9;
const ll INF = 1e17;

int add(int a, int b) {
	if (a + b < 0) return a + b + mod;
	if (a + b >= mod) return a + b - mod;
	return a + b;		
}

int mul(int a, int b) {
	return a * 1LL * b % mod;
}

int binpow(int a, int n) {
	int ret = 1;
	while (n) {
		if (n & 1) ret = mul(ret, a);
		a = mul(a, a);
		n >>= 1;
	}
	return ret;
}

ll n, h[N], b[N];

struct tree {
	ll t[N], p[N];
	
	void push(int v, int tl, int tr) {	
		if (p[v] != 0) {
			if (tl != tr) {
				p[v * 2] += p[v];
				p[v * 2 + 1] += p[v];
			}
			t[v] += p[v];
			p[v] = 0;
		}
	}
	
	void upd(int l, int r, ll val, int v = 1, int tl = 1, int tr = n) {
		push(v, tl, tr);
		if (l <= tl && tr <= r) {
			p[v] += val;
			push(v, tl, tr);
			return;
		}
		if (r < tl || tr < l)
			return;
		int tm = tl + tr >> 1;
		upd(l, r, val, v * 2, tl, tm);
		upd(l, r, val, v * 2 + 1, tm + 1, tr);
		t[v] = max(t[v * 2], t[v * 2 + 1]);
	}
	
	ll get(int l, int r, int v = 1, int tl = 1, int tr = n) {
		push(v, tl, tr);
		if (l <= tl && tr <= r)
			return t[v];
		if (r < tl || tr < l)		
			return -INF;
		int tm = tl + tr >> 1;
		return max(get(l, r, v * 2, tl, tm), get(l, r, v * 2 + 1, tm + 1, tr));
	}
} t;

int main() {
	speed;
	cin >> n;
	for (int i = 1; i <= n; ++i)
		cin >> h[i];
	for (int i = 1; i <= n; ++i)
		cin >> b[i];
	stack <pll> st;
	st.push({-INF, 0});
	ll x = 0;
	for (int i = 1; i <= n; ++i) {
		while (st.top().F > h[i]) {
			int r = st.top().S;
			st.pop();
			int l = st.top().S + 1;
			t.upd(l, r, -b[r]);
		}
		int l = st.top().S + 1;
		st.push({h[i], i});
		t.upd(l, i, b[i]);
		x = t.get(1, i);
		t.upd(i + 1, i + 1, x);
	}
	cout << x << '\n';
}
