#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define F first
#define S second
#define ll long long
#define all(x) x.begin(), x.end()
//#define tree<long long, null_type, less<long long>, rb_tree_tag, tree_ordered_statistics_node_update> ordered_set
#define md(l, r) l + (r - l) / 2
#define ld long double
#define endl '\n'
#define min3(a, b, c) min(a, min(b, c))
#define max3(a, b, c) max(a, max(b, c))
//tree<long long, null_type, less<long long, rb_tree_tag, tree_ordered_node_statistics_update> a;

long long sqr(ll x) {
    return x * x;
}

long double dstSqrt(ld x, ld y, ld xx, ld yy) {
    return sqrt((x - xx) * (x - xx) + (y - yy) * (y - yy));
}

#define int long long

int lf[500500], a[500500], t[2002000], h[500500];
int n;
int dp[500500];
void bldLeft() {
    lf[1] = 0;
    stack<pair<int, int> > st;
    st.push({h[1], 0});
    for (int i = 2; i <= n; i++) {
        while (!st.empty() && st.top().F > h[i]) {
            lf[i] += st.top().S + 1;
            st.pop();
        }
        st.push({h[i], lf[i]});
    }
}

void update(int ver, int l, int r, int pos, int val) {
    if (l > pos || r < pos) {
        return;
    }
    if (l == r) {
        t[ver] = val;
        return;
    }
    int mid = md(l, r);
    update(ver * 2, l, mid, pos, val);
    update(ver * 2 + 1, mid + 1, r, pos, val);;
    t[ver] = max(t[ver * 2], t[ver * 2 + 1]);
}

int getMax(int ver, int l, int r, int nl, int nr) {
    if (l > r || l > nr || r < nl) {
        return -2e9;
    }
    if (l >= nl && r <= nr) {
        return t[ver];
    }
    int mid = md(l, r);
    return max(getMax(ver * 2, l, mid, nl, nr), getMax(ver * 2 + 1, mid + 1, r, nl, nr));
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> h[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    bldLeft();
    dp[1] = a[1];
    update(1, 1, n, 1, a[1]);
    dp[0] = -1e18;
    for (int i = 2; i <= n; i++) {
        int l = i - lf[i];
        if (l == 1) {
            dp[i] = max(0ll, getMax(1, 1, n, l, i - 1)) + a[i];
        } else {
            if (l == i) {
                dp[i] = max(dp[l - 1], dp[l - 1] + a[i]);
            } else
                dp[i] = max(dp[l - 1], getMax(1, 1, n, l, i - 1) + a[i]);
        }
        update(1, 1, n, i, dp[i]);
    }
    cout << dp[n] << endl;
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);
    int t;
    t = 1;
    for (int tt = 1; tt <= t; tt++) {
        solve();
    }
}
