//{
#include <bits/stdc++.h>
using namespace std;
template<typename t> inline void umin(t &a, const t b) {if(b < a) a = b;}
template<typename t> inline void umax(t &a, const t b) {if(b > a) a = b;}
#define bnd(f) (f).begin(), (f).end()
#define len(f) int((f).size())
#define _ <<' '<<
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ul;
typedef unsigned int ui;
typedef vector<int> vi;
ll time() {return chrono::system_clock().now().time_since_epoch().count();}
mt19937 rnd(time());
mt19937_64 rnd64(time());
const int inf = 1e9 + 5;
const ll inf64 = 4e18 + 5;
const int md = 998244353;
namespace MD {
    inline void add(int &a, const int b) {if((a += b) >= md) a -= md;}
    inline int sum(int a, const int b) {add(a, b); return a;}
    inline int prd(const int a, const int b) {return ll(a) * b % md;}
    inline void mlt(int &a, const int b) {a = prd(a, b);}
    inline void sub(int &a, const int b) {if((a -= b) < 0) a += md;}
    inline int pow(const int a, const int b) {
        ll ans = 1;
        for(int i = 1 << 30; i; i >>= 1) {
            (ans *= ans) %= md;
            if(i & b) (ans *= a) %= md;
        }
        return ans;
    }
};
//}

int n;
const int N = 3e5 + 5;
int h[N], b[N];
ll f[N];

struct tree {
    tree *l, *r;
    ll v {};
    tree(int tl = 0, int tr = n) {
        if(tl < tr) {
            int tm = tl + tr >> 1;
            l = new tree(tl, tm);
            r = new tree(tm + 1, tr);
        } else {
            l = r = 0;
        }
    }
    void upd(int i, int tl = 0, int tr = n) {
        if(tl == tr) {v = f[tl]; return;}
        int tm = tl + tr >> 1;
        i <= tm
            ? l->upd(i, tl, tm)
            : r->upd(i, tm + 1, tr);
        v = max(l->v, r->v);
    }
    ll get(int L, int R, int tl = 0, int tr = n) {
        if(L > R) return -inf64;
        if(L == tl && R == tr) return v;
        int tm = tl + tr >> 1;
        return max(l->get(L, min(R, tm), tl, tm),
                   r->get(max(tm + 1, L), R, tm + 1, tr));
    }
};

struct dp {
    int h, b, l, r;
    ll opt;
};

void solve() {
    cin >> n;
    for(int i = 0; i < n; ++i) cin >> h[i];
    for(int i = 0; i < n; ++i) cin >> b[i];
    f[0] = 0;
    tree t {};
    stack<dp> s;
    for(int i = 0; i < n; ++i) {
        while(!s.empty() && s.top().h > h[i]) s.pop();
        dp v;
        v.h = h[i];
        v.b = b[i];
        v.r = i;
        if(s.empty()) {
            v.l = 0;
            v.opt = v.b + t.get(v.l, v.r);
        } else {
            dp &u = s.top();
            v.l = u.r + 1;
            v.opt = max(u.opt, v.b + t.get(v.l, v.r));
        }
        s.push(v);
        f[i + 1] = v.opt;
        t.upd(i + 1);
    }
    cout << f[n] << '\n';
}

signed main() {
#ifndef KEK
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//    cout.precision(15); cout << fixed;
#else
    system("color a");
    freopen("in.txt", "r", stdin);
    int t; cin >> t; while(t--)
#endif // KEK
    solve();
}
