#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 3e5 + 5;

int n;
int h[N];
int b[N];
int prv[N];
int nxt[N];

ve<ll> del[N];
multiset<ll> s;

ll t[4 * N];

ll get(int v, int tl, int tr, int l, int r) {
    if(l > r) {
        return -1e18;
    }
    if(tl == l && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) >> 1;
    return max(get(v << 1, tl, tm, l, min(r, tm)), get(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r));
}

ll get(int l, int r) {
    if(l == -1) {
        return max(0LL, get(1, 0, n - 1, l + 1, r));
    } else {
        return get(1, 0, n - 1, l, r);
    }
}

void upd(int v, int tl, int tr, int pos, ll x) {
    if(tl == tr) {
        t[v] = x;
        return;
    }
    int tm = (tl + tr) >> 1;
    if(pos <= tm) {
        upd(v << 1, tl, tm, pos, x);
    } else {
        upd(v << 1 | 1, tm + 1, tr, pos, x);
    }
    t[v] = max(t[v << 1], t[v << 1 | 1]);
}

void upd(int pos, ll x) {
    upd(1, 0, n - 1, pos, x);
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

    fr(i, 0, n - 1) cin >> h[i];

    fr(i, 0, n - 1) cin >> b[i];

    {
        fr(i, 0, n - 1) prv[i] = -1;
        ve<pii> st;
        rf(i, n - 1, 0) {
            while(sz(st) && st.back().fi > h[i]) {
                prv[st.back().se] = i;
                st.pop_back();
            }
            st.pb({h[i], i});
        }
        fr(i, 0, n - 1) nxt[i] = n;
        st.clear();
        fr(i, 0, n - 1) {
            while(sz(st) && st.back().fi > h[i]) {
                nxt[st.back().se] = i;
                st.pop_back();
            }
            st.pb({h[i], i});
        }
    }

    fr(i, 0, n - 1) {
        ll best = get(prv[i], i - 1) + b[i];
        // i, nxt[i] - 1
        del[nxt[i]].pb(best);

        s.insert(best);

        fe(x, del[i]) {
            s.erase(s.find(x));
        }

        upd(i, *s.rbegin());
        // cout << *s.rbegin() << " " << get(i, i) << "\n";
        // cout << best << " ";
    }
    // cout << "\n";

    cout << get(n - 1, n - 1) << "\n";

    return 0;
}