#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>


#define int long long
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define sz(a) a.size()



using namespace std;


int t_n;
vector<int> t;


void build(int n) {
	t_n = 1;
	while (t_n < n) {
		t_n = (t_n << 1);
	}
	t.resize(t_n * 2, 0);
}


void t_set(int i, int x) {
	i += t_n;
	t[i] = x;
	for (i /= 2; i > 0; i /= 2) {
		t[i] = max(t[i + i], t[i + i + 1]);
	}
}


int get(int l, int r) {
	int res = -1e18;
	l += t_n;
	r += t_n;
	while (l < r) {
		if (l & 1) {
			res = max(res, t[l++]);
		}
		if (r & 1) {
			res = max(res, t[--r]);
		}
		l /= 2;
		r /= 2;
	}
	return res;
}


int n;
vector<int> h;
vector<int> b;
vector<int> s;
vector<int> dp;


void cnt_smlr(){
	deque<int> d;
	s.resize(n);
	for (int i = 0; i < n; ++i) {
		while (!d.empty() && h[d.back()] > h[i]) {
			d.pop_back();
		}
		if (d.empty()) {
			s[i] = -1;
		}
		else {
			s[i] = d.back();
		}
		d.push_back(i);
	}
}

int32_t main() {
	cin >> n;
	h.resize(n);
	b.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> h[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	cnt_smlr();
	build(n + 1);
	dp.resize(n + 1, -1e18);
	dp[0] = 0;
	for (int i = 0; i < n; ++i) {
		int mx = get(s[i] + 1, i + 1);
		dp[i + 1] = mx + b[i];
		if (s[i] != -1) {
			dp[i + 1] = max(dp[i + 1], dp[s[i] + 1]);
		}
		t_set(i + 1, dp[i + 1]);
	}
	cout << dp[n] << "\n";
	return 0;
}