#include <bits/stdc++.h>

using namespace std;
#define ll long long
const ll INF = 1e15;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <vector <ll>> f(n, vector <ll> (n));
    auto g = f;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            f[i][j] = INF;
            g[i][j] = -1;
            if (i == j) f[i][j] = 0;
        }
    }
    for (int i = 0; i < m; ++i) {
        int x, y, l;
        cin >> x >> y >> l;
        g[x - 1][y - 1] = f[x - 1][y - 1] = l;
        g[y - 1][x - 1] = f[y - 1][x - 1] = l;
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                f[i][j] = min(f[i][k] + f[k][j], f[i][j]);
            }
        }
    }
    auto flex = g;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            flex[i][j] = -INF;
        }
    }
    int q;
    cin >> q;
    int all[q][3];
    for (int i = 0; i < q; ++i) {
        for (int j = 0; j < 3; ++j) {
            cin >> all[i][j];
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < q; ++j) {
            flex[i][all[j][0] - 1] = max(flex[i][all[j][0] - 1], all[j][2] - f[i][all[j][1] - 1]);
            flex[i][all[j][1] - 1] = max(flex[i][all[j][1] - 1], all[j][2] - f[i][all[j][0] - 1]);
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (g[i][j] == -1) continue;
            for (int k = 0; k < n; ++k) {
                if (f[k][i] + g[i][j] <= flex[j][k]) {
                    ++ans;
                    break;
                }
            }
        }
    }
    cout << ans / 2;
}
