#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb emplace_back
#define pii pair<int, int>

const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<ll>> dist(n, vector<ll>(n, INF));
    vector<pii> e(m);
    vector<int> weight(m);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        e[i] = {a, b};
        weight[i] = w;
        dist[a][b] = dist[b][a] = w;
    }
    for (int i = 0; i < n; i++) dist[i][i] = 0;
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    int ans = 0;
    vector<vector<ll>> mn(n, vector<ll>(n, INF));
    int q;
    cin >> q;
    while (q--) {
        int v, u, l;
        cin >> v >> u >> l;
        v--; u--;
        for (int a = 0; a < n; a++) mn[v][a] = min(mn[v][a], dist[u][a] - l);
        for (int a = 0; a < n; a++) mn[u][a] = min(mn[u][a], dist[v][a] - l);
    }
    for (int i = 0; i < m; i++) {
        int w = weight[i];
        bool ok = 0;
        for (int u = 0; u < n && !ok; u++) {
            if (dist[u][e[i].fi] + w + mn[u][e[i].se] <= 0) ok = 1;
        }
        ans += ok;
    }
    cout << ans;
    return 0;
}
