#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<ll, ll>
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)

const ll INF = 2e9;
const ll inf = 2e18;
const ll MAXN = 600 + 10;

istream& operator >>(istream &in, pii x) {
    in >> x.first >> x.second;
    return in;
}

template <class T>
istream& operator >>(istream &in, vector<T> &a) {
    for (T &i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> a) {
    for (T i : a) {
        out << i << " ";
    }
    out << "\n";
    return out;
}

ll matr[MAXN][MAXN];
ll best_path[MAXN][MAXN];
ll best_len[MAXN][MAXN];
ll dp[MAXN][MAXN];
bool ok[MAXN][MAXN];

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            if (i == j) continue;
            matr[i][j] = inf;
        }
    }
    for (int i = 0; i < m; ++i) {
        ll v, u, w; cin >> v >> u >> w;
        --v, --u;
        mn(matr[v][u], w);
        mn(matr[u][v], w);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            dp[i][j] = matr[i][j];
        }
    }
    for (int k = 0; k < n; ++k) {
        for (int v = 0; v < n; ++v) {
            for (int u = 0; u < n; ++u) {
                mn(dp[v][u], dp[v][k] + dp[k][u]);
            }
        }
    }
    int q; cin >> q;
    for (int i = 0; i < q; ++i) {
        ll v, u, l; cin >> v >> u >> l;
        --v, --u;
        mx(best_path[v][u], l);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                mx(best_len[i][j], best_path[i][k] - dp[j][k]);
            }
            for (int k = 0; k < n; ++k) {
                if (best_len[i][j] >= matr[j][k] + dp[i][k]) ok[j][k] = 1, ok[k][j] = 1;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            ans += ok[i][j];
        }
    }
    cout << ans / 2 << "\n";
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif

    // ll t; cin >> t;
    // while (t--)
    solve();

    return 0;
}