#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <bitset>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <cmath>
#include <time.h>
#include <random>
#include <chrono>
#include <cassert>
#include <limits>

using namespace std;

#define int long long 
#define pb push_back
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define ld long double

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else 
	#define dbg(x) 
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 610;

int n, m, q;
int g[N][N];
int g1[N][N];
int good[N][N];
int ask[N][N];

int d[N], used[N];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			g[i][j] = INF;
			g1[i][j] = INF;
			ask[i][j] = -INF;
		}
		g[i][i] = 0;
		ask[i][i] = 0;
	}
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		g[u][v] = g[v][u] = w;
		g1[u][v] = g1[v][u] = w;
	}
	cin >> q;
	for (int i = 0; i < q; i++) {
		int u, v, l;
		cin >> u >> v >> l;
		u--, v--;
		ask[u][v] = ask[v][u] = l;
	}
	for (int k = 0; k < n; k++) {
		for (int u = 0; u < n; u++) {
			for (int v = 0; v < n; v++) {
				chkmin(g[u][v], g[u][k] + g[k][v]);
			}
		}
	}
	for (int v = 0; v < n; v++) {
		for (int i = 0; i < n; i++) {
			d[i] = ask[v][i];
			used[i] = 0;
		}
		int vv;
		for (int i = 0; i < n; i++) {
			vv = -1;
			for (int j = 0; j < n; j++) {
				if (used[j]) continue;
				if (vv == -1 || d[j] > d[vv]) {
					vv = j;
				}
			}
			if (vv == -1) break;
			used[vv] = 1;
			for (int j = 0; j < n; j++) {
				chkmax(d[j], d[vv] - g1[vv][j]);
			}
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (d[i] - g1[i][j] >= g[j][v]) {
					good[i][j] = 1;
				}
			}
		}
		// if (v == 5) {
		// 	for (int i = 0; i < n; i++) {
		// 		cout << d[i] << " ";
		// 	}
		// 	cout << "\n";
		// }
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ans += good[i][j];
		}
	}
	cout << ans << "\n";
}
/*
6 6
6 3 1 
1 4 4 
5 4 1 
1 3 3 
2 3 3 
3 4 1 
2
6 5 4 
3 4 1 
correct :
3
wrong :
1
*/