#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <chrono>
#include <random>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <set>
#include <map>
using namespace std;
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fastio ios::sync_with_stdio(false), cin.tie(0)
bool space = true, newLine = false, newLineA = false;
template<class T>
istream& operator>>(istream & in, vector<T>&v) {
	for (auto& i : v) in >> i;
	return in;
}
template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	for (const auto& i : v) {
		out << i;
		if (newLine) cout << '\n';
		else if (space) cout << ' ';
	}
	if (newLineA && !newLine) cout << '\n';
	return out;
}
template<class T, class U>
istream& operator>>(istream& in, pair<T, U>& p) {
	in >> p.first >> p.second;
	return in;
}
template<class T, class U>
ostream& operator<<(ostream& out, const pair<T, U>& p) {
	out << p.first << ' ' << p.second;
	return out;
}
// mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
mt19937 rnd(1234);
int randnum(int l, int r) {
	return l + rnd() % (r - l + 1);
}
typedef long long ll;

signed main() {
	fastio;
	int n, m;
	cin >> n >> m;

	vector<pair<pair<int, int>, ll>> e;
	vector<vector<ll>> d(n, vector<ll>(n, 1e18));
	forn(i, n) d[i][i] = 0;

	forn(i, m) {
		int a, b;
		ll w;
		cin >> a >> b >> w;
		a--, b--;

		e.push_back(make_pair(make_pair(a, b), w));
		e.push_back(make_pair(make_pair(b, a), w));
		d[a][b] = w;
		d[b][a] = w;
	}

	forn(k, n) {
		forn(i, n) {
			forn(j, n) {
				d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
			}
		}
	}

	int q;
	cin >> q;
	vector<pair<pair<int, int>, ll>> t(q);
	cin >> t;
	for (auto& i : t) i.first.first--, i.first.second--;

	vector<vector<pair<int, ll>>> ot(n);
	for (auto i : t) {
		ot[i.first.first].push_back(make_pair(i.first.second, i.second));
	}

	vector<vector<ll>> s(n, vector<ll>(n, -1e18));
	forn(i, n) {
		forn(f, n) {
			for (auto j : ot[f]) {
				s[f][i] = max(s[f][i], j.second - d[i][j.first]);
			}
		}
	}

	vector<bool> good;
	for (auto i : e) {
		bool flag = false;
		/*for (auto j : t) {
			if (d[i.first.first][j.first.first] + i.second <= j.second - d[i.first.second][j.first.second]) {
				flag = true;
				break;
			}
		}*/
		forn(f, n) {
			if (d[i.first.first][f] + i.second <= s[f][i.first.second]) {
				flag = true;
				break;
			}
		}
		good.push_back(flag);
	}

	int ans = 0;
	forn(i, e.size() / 2) ans += good[2 * i] || good[2 * i + 1];

	cout << ans;
	return 0;
}