#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define fi first
#define se second
#define int long long

using namespace std;

// void build(int v, int tl, int tr) {
//     add[v] = inf;
//     if (tl == tr) {
//         t[v] = a[tl];
//         return;
//     }
//     int tm = (tl + tr)>>1;
//     build((v << 1), tl, tm);
//     build(((v << 1)|1), tm + 1, tr);
//     t[v] = t[(v << 1)] + t[((v << 1)|1)];
// }

// void push(int v, int tl, int tm, int tr) {
//     if (tl == tr || add[v] == inf)
//         return;
//     t[(v << 1)] += (tm - tl + 1) * add[v];
//     t[((v << 1)|1)] += (tr - tm) * add[v];
//     if (add[(v << 1)] == inf)
//         add[(v << 1)] = add[v];
//     else
//         add[(v << 1)] += add[v];
//     if (add[((v << 1)|1)] == inf)
//         add[((v << 1)|1)] = add[v];
//     else
//         add[((v << 1)|1)] += add[v];
//     add[v] = inf;
// }

// void upd(int v, int tl, int tr, int l, int r, int x) {
//     if (r < tl || tr < l)
//         return;
//     if (l <= tl && tr <= r) {
//         t[v] += (tr - tl + 1) * x;
//         if (add[v] == inf)
//             add[v] = x;
//         else
//             add[v] += x;
//         return;
//     }
//     int tm = (tl + tr)>>1;
//     push(v, tl, tm, tr);
//     upd((v << 1), tl, tm, l, r, x);
//     upd(((v << 1)|1), tm + 1, tr, l, r, x);
//     t[v] = t[(v << 1)] + t[((v << 1)|1)];
// }

// int get(int v, int tl, int tr, int l, int r) {
//     if (r < tl || tr < l)
//         return 0;
//     int tm = (tl + tr)>>1;
//     push(v, tl, tm, tr);
//     if (l <= tl && tr <= r)
//         return t[v];
//     return get((v << 1), tl, tm, l, r) + get(((v << 1)|1), tm + 1, tr, l, r);
// }

// struct node {
//     node *l, *r;
//     int key, sm, pr;
//     node(int x, int y) {
//         key = x; pr = y; sm = 1;
//         l = r = NULL;
//     }
// };

// typedef node* pn;

// int getsm(pn v) {
//     if (!v) return 0;
//     return v->sm;
// }

// void upd(pn v) {
//     if (!v) return;
//     v->sm = 1 + getsm(v->l) + getsm(v->r);
// }

// pair<pn, pn> split(pn v, int key) {
//     if (!v) return {v, v};
//     pair<pn, pn> res;
//     if (v->key <= key) {
//         res = split(v->r, key);
//         v->r = res.fi;
//         res.fi = v;
//     } else {
//         res = split(v->l, key);
//         v->l = res.se;
//         res.se = v;
//     }
//     upd(res.fi); upd(res.se);
//     return res;
// }

// pn merge(pn v, pn u) {
//     if (!v) return u;
//     if (!u) return v;
//     if (v->pr < u->pr) {
//         u->l = merge(v, u->l);
//         upd(u);
//         return u;
//     } else {
//         v->r = merge(v->r, u);
//         upd(v);
//         return v;
//     }
// }

const int MAXN = 610, inf = 2e9;
const ll INF = 1e14;

int n, m, q;
ll d[MAXN][MAXN], mn[MAXN][MAXN];
bool vis[MAXN];
vector <pair<int, ll>> g[MAXN], gr[MAXN];
vector <pair<pair<int, int>, ll>> edges;

void djk(int u) {
    d[u][u] = 0;
    for (int i = 1; i <= n; i++)
        vis[i] = false;
    for (int i = 1; i <= n; i++) {
        pair<int, int> mn = {INF, INF};
        for (int j = 1; j <= n; j++)
            if (!vis[j])
                mn = min(mn, {d[u][j], j});
        int v = mn.se;
        vis[v] = true;
        for (pair<int, ll> to : gr[v])
            d[u][to.fi] = min(d[u][to.fi], d[u][v] + to.se);
    }
}

main() {
    ios_base::sync_with_stdio(NULL); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            mn[i][j] = d[i][j] = INF;
    for (int i = 1; i <= m; i++) {
        int u, v; ll w;
        cin >> u >> v >> w;
        gr[u].pb({v, w});
        gr[v].pb({u, w});
        edges.pb({{u, v}, w});
    }
    for (int i = 1; i <= n; i++)
        djk(i);
    // for (int i = 1; i <= n; i++)
    //     for (int j = 1; j <= n; j++)
    //         cout << i << " " << j << " " << d[i][j] << endl;
    cin >> q;
    for (int i = 1; i <= q; i++) {
        int u, v; ll w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++) {
            for (pair<int, ll> to : g[i])
                mn[i][j] = min(mn[i][j], d[to.fi][j] - to.se);
        }
    int ans = 0;
    for (pair<pair<int, int>, ll> to : edges) {
        int u = to.fi.fi, v = to.fi.se; ll w = to.se;
        bool flag = false;
        for (int i = 1; i <= n; i++)
            if (d[u][i] + w + mn[i][v] <= 0)
                flag = true;
        if (flag)
            ans++;
    }
    cout << ans;
}