#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define pb push_back
#define sc second
#define fs first
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pp pop_back
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

int dist[600][600];
int umax[600][600];

int main()
{
    fast_io
    ll n, m;
    cin >> n >> m;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            dist[i][j] = 1e9+5;
            umax[i][j] = 0;
        }
    }

    for(int i = 0; i < n; i++) dist[i][i] = 0;

    vector<pair<pii, int> > edges(m);

    for(int i = 0; i < m; i++){
        int x, y, w;
        cin >> x >> y >> w; x--; y--;
        dist[x][y] = min(dist[x][y], w);
        dist[y][x] = min(dist[y][x], w);
        edges[i] = {{x, y}, w};
    }

    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            for(int p = 0; p < n; p++){
                if(dist[j][i] + dist[i][p] >= 1e9+5) continue;
                dist[j][p] = min(dist[j][p], dist[j][i] + dist[i][p]);
            }
        }
    }

    int q;
    cin >> q;
    while(q--){
        int x, y, l;
        cin >> x >> y >> l; x--; y--;
        for(int i = 0; i < n; i++){
            umax[x][i] = max(umax[x][i], l - dist[i][y]);
        }
    }

    int ans = 0;

    for(auto u:edges){
        int t = 0;
        for(int j = 0; j < n; j++){
            if(dist[j][u.fs.fs] + u.sc <= umax[j][u.fs.sc]) t = 1;
            if(dist[j][u.fs.sc] + u.sc <= umax[j][u.fs.fs]) t = 1;
        }
        ans += t;
    }


    cout << ans;
}
