#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using vvi = vector<vi>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, true : false; }

mt19937 rng(1337228);

struct RC {
    int32_t H = 1337228;

    template<class T>
    friend RC& operator >> (RC& rin, T& x) {
        cin >> x;
        return rin;
    }

    friend RC& operator >> (RC& rin, int& x) {
        cin >> x;
        rin.H ^= x * 1337;
        rin.H *= 3;
        return rin;
    }

    friend RC& operator >> (RC& rin, ll& x) {
        cin >> x;
        rin.H ^= x * 229;
        rin.H *= 7;
        return rin;
    }

    friend RC& operator >> (RC& rin, string& s) {
        cin >> s;
        static const int P = 97;
        for (char c : s) {
            rin.H = rin.H * P ^ c;
        }
        return rin;
    }
} rin;

void initRandom() {
    rng.seed(rin.H);
}

const int N = 605;
const int M = N*N;



int n, m, wa[M], wb[M], wl[M], used[M];
ll d[N][N], nd[N];
vector<pi> mt[N];

const ll LINF = 1e18;

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        fill(d[i], d[i]+n, LINF);
    }

    for (int i = 0; i < m; ++i) {
        cin >> wa[i] >> wb[i] >> wl[i];
        wa[i]--, wb[i]--;
        d[wa[i]][wb[i]] = d[wb[i]][wa[i]] = wl[i];
    }
    for (int i = 0; i < n; ++i) d[i][i] = 0;

    for (int k = 0; k < n; ++k) 
    for (int i = 0; i < n; ++i)
    for (int j = 0; j < n; ++j)       
        ckmin(d[i][j], d[i][k] + d[k][j]);

    int q; cin >> q;
    while (q--) {
        int u, v, l; cin >> u >> v >> l;
        --u, --v;
        mt[u].eb(v, l);
        mt[v].eb(u, l);
    }

    for (int i = 0; i < n; ++i) {
        vector<pi> edg;
        if (mt[i].empty()) continue;
        for (int j = 0; j < n; ++j) {
            nd[j] = LINF;
            for (auto [t, l] : mt[i]) {
                ckmin(nd[j], d[j][t] - l);
            }
        }
        for (int j = 0; j < m; ++j) {
            if (d[i][wa[j]] + nd[wb[j]] + wl[j] <= 0) {
                used[j] = 1;
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < m; ++i) ans += used[i];

    cout << ans << '\n';
}