#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <string>
#include <tuple>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define int ll
#define double ld
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second
#define mkp make_pair
#define mkt make_tuple
#define all(x) begin(x), end(x)
#define pb push_back

const int N = 700, INF = 2e18;

int dist[N][N], len[N][N], mx[N][N];

void floyd(int n) {
    loop(w, n)
        loop(u, n)
            loop(v, n)
                dist[u][v] = min(dist[u][v], dist[u][w] + dist[w][v]);
}

void solve() {
    loop(i, N)
        loop(j, N)
            dist[i][j] = INF * (i != j);
    int n, m;
    cin >> n >> m;
    vector <ti> edges(m);
    loop(i, m) {
        int u, v, l;
        cin >> u >> v >> l;
        --u, --v;
        dist[u][v] = dist[v][u] = l;
        edges[i] = mkt(u, v, l);
    }
    floyd(n);
    int q; cin >> q;
    loop(i, q) {
        int u, v, l;
        cin >> u >> v >> l;
        --u, --v;
        len[u][v] = len[v][u] = l;
    }
    loop(v, n)
        loop(u, n)
            loop(w, n)
                mx[v][u] = max(mx[v][u], len[v][w] - dist[u][w]);
    int ans = 0;
    loop(i, m) {
        int u, v, l;
        tie(u, v, l) = edges[i];
        loop(w, n) {
            int c = dist[v][w] + l;
            if (mx[w][u] >= c) {
                ++ans; break;
            }
        }
    }
    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //int t; cin >> t; loop(i, t)
    solve();
    return 0;
}