#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 607;
const int M = N * (N - 1) / 2;
const ll INF = 1e18;

int n, m, q;
int a[M], b[M];
ll w[M];

int u[M], v[M];
ll l[M];

ll d[N][N];

void floyd() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            d[i][j] = INF;
        }
    }
    for (int i = 0; i < m; ++i) d[a[i]][b[i]] = d[b[i]][a[i]] = w[i];
    for (int i = 0; i < n; ++i) d[i][i] = 0;
    for (int t = 0; t < n; ++t) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                d[i][j] = min(d[i][j], d[i][t] + d[t][j]);
            }
        }
    }
}

ll L[N];
ll mn[N];
bool good[M];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a[i] >> b[i] >> w[i];
        --a[i];
        --b[i];
    }
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> u[i] >> v[i] >> l[i];
        --u[i];
        --v[i];
    }
    
    floyd();
    
    for (int t = 0; t < n; ++t) {
        for (int i = 0; i < n; ++i) L[i] = -1;
        for (int i = 0; i < q; ++i) {
            if (u[i] == t) L[v[i]] = l[i];
            if (v[i] == t) L[u[i]] = l[i];
        }
        
        for (int i = 0; i < n; ++i) {
            mn[i] = INF;
            for (int j = 0; j < n; ++j) {
                if (d[i][j] < INF && L[j] != -1) mn[i] = min(mn[i], d[i][j] - L[j]); 
            }
        }
        
        for (int i = 0; i < m; ++i) {
            if (d[t][a[i]] < INF && mn[b[i]] < INF && d[t][a[i]] + mn[b[i]] + w[i] <= 0) good[i] = true;
            if (d[t][b[i]] < INF && mn[a[i]] < INF && d[t][b[i]] + mn[a[i]] + w[i] <= 0) good[i] = true;  
        }
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        if (good[i]) ++ans;
    }
    cout << ans << endl;
    return 0;
}
