#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
istream &operator>>(istream &is, pair<T, T> &v) {
    is >> v.first >> v.second;
    return is;
}

template<typename T>
void operator<<(ostream &os, vector<T> &v) {
    for (auto &i : v) {
        os << i << ' ';
    }
}

template<typename T>
void operator<<(ostream &os, pair<T, T> &v) {
    os << v.first << ' ' << v.second;
}

#define pb push_back
#define all(a) a.begin(), a.end()
#define sqr(a) ((a) * (a))
#define nl '\n'
#define forn(i, n) for (int i = 0; i < n; i++)

typedef vector<int> vi;
typedef pair<int, int> pi;
typedef vector<pair<int, int>> vpi;
typedef long long ll;
typedef long double ld;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    cout << fixed << setprecision(10);
}

const int MAXN = 1e5 + 10;
const int MAXE = 1e5 + 10;
const int K = 100 + 5;

#define int ll

void Solve() {
    int a, b;
    cin >> a >> b;
    cout << a * b << nl;
}

signed main() {
    IO();
    int t = 1;
    cin >> t;
    while (t--) {
        Solve();
    }
    return 0;
}