#include <bits/stdc++.h>

using namespace std;
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune=native")
#pragma optimaze("O3")

// #define int long long

typedef long long ll;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

ll mod = 1e9 + 7;

ll mul(ll a, ll b) {
    return (a * b) % mod;
}

ll sm(ll a, ll b) {
    if (a + b < mod) return a + b;
    return (a + b - mod);
}

ll divv(ll a, ll b) {
    if (a >= b) return a - b;
    return a - b + mod;
}

ll pw(ll a, ll k) {
    if (k == 0) return 1;
    if (k % 2) return mul(a, pw(a, k - 1));
    return pw(mul(a, a), k / 2);
}



int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;  cin >> t;
    while (t--) {
        ll a, b; cin >> a >> b;
        cout << a * b << endl;
    }


    return 0;
}
