import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int t = nextInt();
//        int t = 1;
        for (int qq = 0; qq < t; qq++) {
            int a = nextInt();
            int b = nextInt();
            ans = 0;
            rec(a, b);
            pw.println(ans);
        }
        pw.close();
    }

    static int ans;
    static void rec(int a , int b){
        if (a == 1 || b == 1){
            ans += max(a, b);
        }else if (a == 2 || b == 2){
            ans += 2 * (a + b) - 4;
        }else{
            ans += 2 * (a + b) - 4;
            rec(a - 2, b - 2);
        }
    }

    static StringTokenizer st = new StringTokenizer("");
    static BufferedReader br;
    static PrintWriter pw;

    static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    static long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}

class Pair {
    int first, second;

    public Pair(int first, int second) {
        this.first = first;
        this.second = second;
    }
}

class PairSort implements Comparator<Pair> {
    @Override
    public int compare(Pair o1, Pair o2) {
        if (o1.first == o2.first) return Integer.compare(o1.second, o2.second);
        return Integer.compare(o1.first, o2.first);
    }
}