#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define ff first
#define ss second

struct segtree {

    int sz;
    vector<int> t;

    void init(int n) {
        sz = 1;
        while (sz < n)
            sz *= 2;
        t.assign(sz, 0);
    }

    void build(int x, int l, int r, vector<int> a) {
        if (r < a.size()) {
            if (l == r) {
                t[x] = a[l];
            }
        }
        int m = (l + r) / 2;
        build(2 * x + 1, l, m, a);
        build(2 * x + 2, m, r, a);
        t[x] = max(t[2 * x + 1], t[2 * x + 2]);
    }

    void build(vector<int> a) {
        build(0, 0, sz, a);
    }

    int mx(int x, int lx, int rx, int l, int r) {
        if (lx >= l && rx <= r) {
            return t[x];
        }
        if (lx >= r || rx <= l) {
            return -2e9;
        }
        int m = (lx + rx) / 2;
        return max(mx(2 * x + 1, lx, m, l, r), mx(2 * x + 2, m, rx, l, r));
    }

    int mx(int l, int r) {
        return mx(0, 0, sz, l, r);
    }

};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _;
    for (cin >> _; _--;) {
        int a, b;
        cin >> a >> b;
        cout << a * b << '\n';
    }
    return 0;
}
