#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <utility>
#include <cassert>
#include <random>
#include <chrono>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <list>
#include <array>

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int& x : a) {
		cin >> x;
	}
	if (n == 1) {
		cout << 0 << '\n';
		return;
	}
	int d = -1;
	for (int i = 1; i < n; ++i) {
		if (a[i] >= a[i - 1]) {
			d = a[i] - a[i - 1];
		}
	}
	if (d != -1) {
		bool flag = true;
		for (int i = 1; i < n; ++i) {
			if (a[i] - a[i - 1] != d) {
				flag = false;
			}
		}
		if (flag) {
			cout << 0 << '\n';
			return;
		}
		int m = -1;
		for (int i = 0; i < n - 1; ++i) {
			if (a[i] > a[i + 1]) {
				m = a[i] - a[i + 1] + d;
			}
		}
		if (m == -1) {
			cout << -1 << '\n';
			return;
		}
		flag = true;
		for (int i = 1; i < n; ++i) {
			if (a[i] != (a[i - 1] + d) % m) {
				flag = false;
			}
		}
		if ((flag) && (m > *max_element(a.begin(), a.end()))) {
			cout << m << ' ' << d << '\n';
		} else {
			cout << -1 << '\n';
		}
		return;
	}
	d = a[0] - a[1];
	bool flag = true;
	for (int i = 0; i < n - 1; ++i) {
		if (a[i] - a[i + 1] != d) {
			flag = false;
		}
	}
	if (flag) {
		cout << 0 << '\n';
	} else {
		cout << -1 << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		solve();
	}

	return 0;
}