#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll alp = 26;

#define ff first
#define ss second
#define pb push_back
#define vec vector
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fopen(a, b) freopen(a, "r", stdin); freopen(b, "w", stdout)

void run() {
	ll n;
	cin >> n;
	vi a(n);
	for (auto &v : a) 
		cin >> v;
	ll fl = 1;
	for (ll i = 1; i < n; ++i) {
		if (a[i] < a[i - 1] || a[i] - a[i - 1] != a[1] - a[0])
			fl = 0;
	}
	if (fl) {
		cout << 0;
		return;
	}
	fl = 1;
	for (ll i = 1; i < n; ++i) {
		if (a[i] == a[i - 1]) {
			cout << -1;
			return;
		}
	}
	ll up = -1, down = -1;
	for (ll i = 1; i < n; ++i) {
		if (a[i] > a[i - 1]) {
			if (up != -1 && up != a[i] - a[i - 1]) {
				cout << -1;
				return;
			}
			up = a[i] - a[i - 1];
		}
		else {
			if (down != -1 && down != a[i - 1] - a[i]) {
				cout << -1;
				return;
			}
			down = a[i - 1] - a[i];
		}
	}
	if (down == -1 || up == -1) {
		cout << 0;
		return;
	}
	ll m = -1;
	for (ll i = 1; i < n; ++i) {
		if (a[i] < a[i - 1]) {
			m = a[i - 1] + up - a[i];
			if (m <= a[i - 1]) {
				cout << -1;
				return;
			}
			break;
		}
	}
	for (ll i = 1; i < n; ++i) {
		if (a[i] != (a[0] + up*i)%m) {
			cout << -1;
			return;
		}
	}
	cout << m << ' ' << up;
}

signed main() {
	// fopen("input.txt", "output.txt");
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll kk = 0, tkk = 1;
	cin >> tkk;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}