//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("section-anchors")
//#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
//#pragma GCC optimize("vpt")
//#pragma GCC optimize("rename-registers")
//#pragma GCC optimize("move-loop-invariants")
//#pragma GCC optimize("unswitch-loops")
//#pragma GCC optimize("function-sections")
//#pragma GCC optimize("data-sections")
//#pragma GCC optimize("branch-target-load-optimize")
//#pragma GCC optimize("branch-target-load-optimize2")
//#pragma GCC optimize("btr-bb-exclusive")

#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <stack>
#include <bitset>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <random>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#if DEBUG
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    solve();
}

#define int long long

const int N = 2e5 + 100, INF = 1e18, MOD = 998244353, BASE = 228, MOD1 = 1e9 + 7, BASE1 = 131;// 998244353
const double EPS = 0.0000001;

int t, n, a[N];

void solve() {
    cin >> t;
    while (t--) {
        cin >> n;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        if (n <= 2) {
            cout << 0 << '\n';
            continue;
        }
        bool ok = true;
        int v1 = -INF, v2 = INF;
        for (int i = 1; i < n; i++) {
            if (a[i] - a[i - 1] >= 0) {
                if (v1 == -INF) {
                    v1 = a[i] - a[i - 1];
                } else {
                    if (v1 != a[i] - a[i - 1]) {
                        ok = false;
                        break;
                    }
                }
            } else {
                if (v2 == INF) {
                    v2 = a[i] - a[i - 1];
                } else {
                    if (v2 != a[i] - a[i - 1]) {
                        ok = false;
                        break;
                    }
                }
            }

        }
        if (!ok) {
            cout << -1 << '\n';
            continue;
        }
        if (v1 == -INF || v2 == INF) {
            cout << 0 << '\n';
            continue;
        }
        int m = -v2 + v1;
        int c = v1;
        if (a[0] % m != a[0]) {
            ok = false;
        }
        if (c >= m) {
            ok = false;
        }
        for (int i = 1; i < n; i++) {
            if ((a[i - 1] + c) % m != a[i]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            cout << -v2 + v1 << " " << v1 << '\n';
        } else {
            cout << -1 << '\n';
        }
    }
}