﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
using namespace std;


void solve() {
	int n;
	cin >> n;
	vector<long long>all(n);
	long long int mn = 2000000000;
	long long int mx = 0;
	for (int i = 0; i < n; i++) {
		cin >> all[i];
		mn = min(mn, all[i]);
		mx = max(mx, all[i]);
	}
	if (n == 1) {
		cout << 0 << '\n';
		return;
	}
	if (mn == mx) {
		cout << 0 << '\n';
		return;
	}
	long long c = -1;
	for (int i = 1; i < n; i++) {
		if (all[i] > all[i - 1]) {
			if (all[i] - all[i - 1] != c && c != -1) {
				cout << -1 << '\n';
				return;
			}
			c = all[i] - all[i - 1];
		}
		if (all[i] == all[i - 1]) {
			cout << -1 << '\n';
			return;
		}
	}
	if (c != -1) {
		long long m = -1;
		for (int i = 1; i < n; i++) {
			if (all[i] < all[i - 1]) {
				if (all[i - 1] + c - all[i] != m && m != -1) {
					cout << -1 << '\n';
					return;
				}
				m = all[i - 1] + c - all[i];
			}
		}
		if (m == -1) {
			cout << 0 << '\n';
			return;
		}
		for (int i = 0; i < n; i++) {
			if (all[i] >= m) {
				cout << -1 << '\n';
				return;
			}
		}
		cout << m << ' ' << c << '\n';
	}
	else {
		long long int k = all[0] - all[1];
		for (int i = 1; i + 1 < n; i++) {
			if (all[i] - all[i + 1] != k) {
				cout << -1 << '\n';
				return;
			}
		}
		cout << 0 << '\n';
	}
}


int main() {
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
	int t;
	cin >> t;
	//t = 1;
	while (t) {
		t--;
		solve();
	}
}