#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

/*
голубой :(((
*/

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

template <typename T>
using oset = tree<T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename T>
using omset = tree<T, null_type, less_equal <T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll mod = 1e9 + 7;
const int maxn = 2e5 + 10;

ll binpow (ll a, ll p) {
    ll ret = 1;
    while (p) {
        if (p & 1) {
            p--;
            ret *= a;
            ret %= mod;
        }
        p >>= 1;
        a *= a;
        a %= mod;
    }
    return ret;
}

bool is_prime (ll a) {
    if (a < 2) {
        return false;
    }
    for (ll i = 2; i * i <= a; i++) {
        if (a % i == 0) {
            return false;
        }
    }
    return true;
}

pair <int, int> brute (vector <int> a) {
    for (int m = 100; m > *max_element(all(a)); m--) {
        for (int c = 0; c < m; c++) {
            bool ok = true;
            for (int i = 1; i < a.size(); i++) {
                if ((a[i - 1] + c) % m != a[i]) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                return {m, c};
            }
        }
    }
    return {-1, -1};
}

void solve () {
    int n; cin >> n;
    vector <int> a (n);
    set <int> tmp;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        tmp.insert(a[i]);
    }
    if (tmp.size() == 1) {
        cout << "0\n";
        return;
    }
    bool OK = true;
    int d = a[1] - a[0];
    for (int i = 1; i < n; i++) {
        if (a[i] - a[i - 1] != d) {
            OK = false;
            break;
        }
    }
    if (OK) {
        cout << "0\n";
        return;
    }

    for (int i = 1; i < n; i++) {
        if (a[i] == a[i - 1]) {
            cout << "-1\n";
            return;
        }
    }

    ll c, m;
    for (int i = 1; i < n; i++) {
        if (a[i - 1] < a[i]) {
            c = a[i] - a[i - 1];
            break;
        }
    }
    for (int i = 1; i < n; i++) {
        if (a[i - 1] > a[i]) {
            m = a[i - 1] + c - a[i];
            break;
        }
    }
    if (a[0] >= m) {
        cout << "-1\n";
        return;
    }
    if (c >= m) {
        cout << "-1\n";
        return;
    }
    for (int i = 1; i < n; i++) {
        if ((a[i - 1] + c) % m != a[i]) {
            cout << "-1\n";
            return;
        }
    }
    cout << m << " " << c << endl;
}

auto rnd = bind(uniform_int_distribution<int>(1, 5), mt19937(time(0)));

int main()
{
    ios_base::sync_with_stdio(0);
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
5 1
-1
5 1 2 3
*/
