#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.setf(ios::fixed);
    cout.precision(10);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

signed main() {
    input();
    int t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector<int> a(n);
        int mx = 0;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            mx = max(mx, a[i]);
        }
        ll g = 0;
        for (int i = 1; i < n - 1; i++) {
            g = gcd(g, 2 * a[i] - a[i - 1] - a[i + 1]);
        }
        if (g == 0) {
            cout << 0;
        } else if (g <= mx) {
            cout << -1;
        } else {
            cout << g << " " << (a[1] - a[0] + g) % g;
        }
        cout << "\n";
    }
    return 0;
}