#include <iostream>
#include <map>
#include <algorithm>
#include <queue>
#include <set>
#include <cstring>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <random>
#include <iomanip>
#include <cassert>
#include <bitset>
#include <deque>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;

mt19937 rnd(time(nullptr));

inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    if (n <= 2) {
        cout << "0\n";
        return;
    }
    vector<int> delta(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        delta[i] = (v[i + 1] - v[i]);
    }
    int maxm = abs(delta[1] - delta[0]);
    for (int i = 0; i < n - 2; ++i) {
       maxm = gcd(maxm, abs(delta[i + 1] - delta[i]));
    }
    if (maxm == 0) {
        cout << "0\n";
        return;
    }
    if (maxm <= *max_element(all(v))) {
        cout << "-1\n";
        return;
    }
    cout << maxm << ' ' << ((delta[0] % maxm) + maxm) % maxm << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}