﻿#include<bits/stdc++.h>
using namespace std;
typedef int s32;
typedef unsigned int u32;
typedef long long s64;
typedef unsigned long long u64;
typedef long double ld;

//#include<random>
//mt19937_64 rnd(42);
//
//template<typename T>
//struct tree {
//    struct node;
//    typedef node* pnode;
//
//    struct node {
//        T val;
//
//        int sz;
//
//        pnode l, r;
//
//        s64 prior;
//
//        node(T nval) {
//            val = nval;
//            sz = 1;
//            l = r = nullptr;
//            prior = rnd();
//        }
//    };
//
//    int size(pnode b) {
//        return b ? b->sz : 0;
//    }
//
//    void upd(pnode b) {
//        if (b) {
//            b->sz = size(b->l) + size(b->r) + 1;
//        }
//    }
//
//    void split(pnode b, pnode& A, pnode& B, int key) {
//        if (!b) {
//            A = B = nullptr;
//        }
//        else if (key <= size(b->l)) {
//            split(b->l, A, b->l, key);
//            B = b;
//        }
//        else {
//            split(b->r, b->r, B, key - size(b->l) - 1);
//            A = b;
//        }
//        upd(b);
//    }
//
//    void merge(pnode& b, pnode A, pnode B) {
//        if (!A || !B) {
//            b = A ? A : B;
//        }
//        else if(A->prior < B->prior) {
//            merge(B->l, A, B->l);
//            b = B;
//        }
//        else {
//            merge(A->r, A->r, B);
//            b = A;
//        }
//        upd(b);
//    }
//
//    pnode find(pnode b, int key) {
//        if (key <= size(b->l)) {
//            return find(b->l, key);
//        }
//        else {
//            key -= size(b->l);
//
//            if (key == 0) {
//                return b;
//            }
//            else {
//                return find(b->r, key - 1);
//            }
//        }
//    }
//
//};
//
//s64 gcd(s64 a, s64 b) {
//    if (a > b) {
//        swap(a, b);
//    }
//    while (a != 0) {
//        b %= a;
//        swap(a, b);
//    }
//    return b;
//}
//
//s64 gcd(s64 a, s64 b, s64& x, s64& y) {
//    if (a == 0) {
//        x = 0;
//        y = 1;
//        return b;
//    }
//    else {
//        s64 gx, gy;
//        s64 z = gcd(b % a, a, gx, gy);
//
//        x = gy - (b / a) * gx;
//        y = gx;
//        return z;
//    }
//}
//
//s64 lcm(s64 a, s64 b) {
//    return (a / gcd(a, b)) * b;
//}
//
//s64 epow(s64 a, s64 n) {
//    if (n == 0) {
//        return 1;
//    }
//    else {
//        s64 z = epow(a, n / 2);
//        z *= z;
//
//        if (n % 2 == 1) {
//            z *= a;
//        }
//        return z;
//    }
//}
//
//s64 epow(s64 a, s64 n, s64 mod) {
//    if (n == 0) {
//        return 1;
//    }
//    else {
//        s64 z = epow(a, n / 2);
//        z = (z * z) % mod;
//
//        if (n % 2 == 1) {
//            z = (z * a) % mod;
//        }
//        return z;
//    }
//}
//
//s64 inv(s64 a, s64 mod) {
//    s64 x, y;
//    s64 res = gcd(a, mod, x, y);
//    x = (x % mod + mod) % mod;
//
//    if ((a * x) % mod != 1) {
//        throw "error";
//    }
//
//    return x;
//}
//
//vector<s64> sieve(s64 n) {
//    vector<bool> Vis(n + 1, false);
//    vector<s64> primes;
//    for (s64 i = 2; i <= n; i++) {
//        if (!Vis[i]) {
//
//            primes.push_back(i);
//
//            for (s64 j = 2 * i; j <= n; j += i) {
//                Vis[j] = true;
//            }
//        }
//    }
//    return primes;
//}
//
//bool is_prime(s64 n) {
//    for (s64 i = 2; i * i <= n; i++) {
//        if (n % i == 0) {
//            return false;
//        }
//    }
//    return true;
//}
//
//// (a, p) = a^p
//vector<pair<s64, s64>> factor(s64 n) {
//    vector<pair<s64, s64>> p;
//    for (s64 i = 2; i * i <= n; i++) {
//        if (n % i == 0) {
//            p.push_back(make_pair(i, 0));
//            while (n % i == 0) {
//                p.back().second++;
//                n /= i;
//            }
//        }
//    }
//    if (n != 1) {
//        p.push_back(make_pair(n, 1));
//    }
//    return p;
//}

// =======================
// =====solve problem=====
// =======================

void solve(istream& cin) {
    s64 n;
    cin >> n;

    vector<s64> A(n);
    for (auto& it : A) {
        cin >> it;
    }

    vector<s64> v;
    for (int i = 0; i + 1 < n; i++) {
        v.push_back(A[i + 1] - A[i]);
        //cout << v.back() << " ";
    }
    //cout << "\n";

    auto verify = [&](s64 mod, s64 c) -> bool {
        for(s64 i = 0; i < n; i++) {
            if (A[i] != (A[0] + c * i) % mod) {
                return false;
            }
        }
        return true;
    };

    s64 mx = LLONG_MIN;
    s64 mn = LLONG_MAX;
    for (int i = 0; i < n - 1; i++) {
        mx = max(mx, v[i]);
        mn = min(mn, v[i]);
    }

    if (n != 1) {
        if (mx - mn == 0) {
            cout << "0\n";
        }
        else if (verify(mx - mn, mx)) {
            cout << mx - mn << " " << mx << "\n";
        }
        else {
            cout << "-1\n";
        }
    }
    else {
        cout << "0\n";
    }
}

int main() {
    //ifstream cin("input.txt");
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve(cin);
    }

    return 0;
}