﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void sol() {
    long long n, c, m = -1;
    cin >> n;
    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n == 1) {
        cout << 0 << '\n';
        return;
    }
    c = a[1] - a[0];
    for (int i = 2; i < n; ++i) {
        if (a[i] == a[i - 1] + c) {
            continue;
        }
        if (c == 0) {
            cout << -1 << '\n';
            return;
        }
        if (c > 0) {
            if (m == -1) {
                m = a[i - 1] + c - a[i];
            } else if (m != a[i - 1] + c - a[i]) {
                cout << -1 << '\n';
                return;
            }
        } else {
            if (m == -1) {
                m = a[i] - c - a[i - 1];
            } else if (m != a[i] - c - a[i - 1]) {
                cout << -1 << '\n';
                return;
            }
        }
    }
    if (m == -1) {
        cout << 0 << '\n';
        return;
    }
    if (*max_element(a.begin(), a.end()) >= m) {
        cout << -1 << '\n';
        return;
    }
    cout << m << ' ' << (c + m) % m << '\n';
}

int main() {
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
    return 0;
}
