#include <bits/stdc++.h>

using namespace std;

clock_t StartTime;

typedef long long ll;

const int N = 5e5 + 3e2;
const int M = 555;

int a[N];

bool check(int n, int m, int c){
    if (m == 0) return false;
    for (int i = 2; i <= n; i++){
        if (a[i] != (a[i - 1] + c) % m) return false;
    }
    return a[1] < m;
}

void solve(){
    int n;
    cin >> n;

    for (int i = 1; i <= n; i++){
        cin >> a[i];
    }

    if (max_element(a + 1, a + n + 1) == min_element(a + 1, a + n + 1)){
        cout << 0 << endl;
        return;
    }

    set<int> cc, mm;

    for (int i = 2; i <= n; i++){
        if (a[i] == a[i - 1]){
            cout << -1 << endl;
            return;
        }
        if (a[i] > a[i - 1]) cc.insert(a[i] - a[i - 1]); else
            mm.insert(a[i - 1] - a[i]);
    }

    if (cc.size() > 1 || mm.size() > 1){
        cout << -1 << endl;
        return;
    }

    if (mm.empty() && cc.size() == 1){
        cout << 0 << endl;
        return;
    }

    int c = 0, m = 1;

    if (cc.size() == 1) {
        c = *cc.begin();
        for (int i = 1; i < n; i++){
            if (a[i] > a[i + 1]){
                m = a[i] - a[i + 1] + c;
            }
        }
    }

    if (cc.empty()){
        cout << (mm.size() == 1 ? 0 : -1) << endl;
        return;
    }

    if (check(n, m, c)) cout << m << ' ' << c << endl; else
        cout << -1 << endl;

}

int main() {
    StartTime = clock();

    ios_base::sync_with_stdio(false);

#ifdef dxz05
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int TC = 1;
    cin >> TC;

    while (TC--){
        solve();
    }

#ifdef dxz05
    cerr << endl << 1000.0 * (clock() - StartTime) / CLOCKS_PER_SEC << " ms";
#endif

    return 0;
}
