#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int N = 1e5 + 2;
const long long inf = 1e18;

int n;
int a[N];

void solve() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	long long c = a[1] - a[0], m = inf;
	for (int i = 2; i < n; i++) {
		int d = a[i] - a[i - 1];
		if (c * d >= 0) {
			if(c != d){
				cout << -1 << endl;
				return;
			}
		}
		else {
			if (m == inf) {
				m = abs(c) + abs(d);
			}
			else {
				if (m != abs(c) + abs(d)) {
					cout << -1 << endl;
					return;
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (a[i] > m) {
			cout << -1 << endl;
			return;
		}
	}
	if (m != inf) {
		cout << m << " " << (c + m) % m << endl;
	}
	else {
		cout << 0 << endl;
	}
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}