#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);



int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        vector<ll> a(n);
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
        }

        if (n == 1)
        {
            cout << 0 << endl;
            continue;
        }

        ll c = -1;
        ll del = -1;
        for (int i = 1; i < n; i++)
        {
            if (a[i] >= a[i - 1])
            {
                c = a[i] - a[i - 1];
            }
            else
            {
                del = a[i - 1] - a[i];
            }
        }

        if (c == -1)
        {
            bool good = 1;
            for (int i = 1; i < n; i++)
            {
                if (a[i - 1] - a[i] != del)
                {
                    good = 0;
                    break;
                }
            }

            if (good)
                cout << 0 << endl;
            else
                cout << -1 << endl;
        }
        else if (del == -1)
        {
            bool good = 1;
            for (int i = 1; i < n; i++)
            {
                if (a[i] - a[i - 1] != c)
                {
                    good = 0;
                    break;
                }
            }

            if (good)
                cout << 0 << endl;
            else
                cout << -1 << endl;
        }
        else
        {
            ll m = c + del;
            bool good = 1;
            for (int i = 1; i < n; i++)
            {
                if ((a[i] >= a[i - 1] && a[i] - a[i - 1] != c) || (a[i] < a[i - 1] && a[i - 1] - a[i] != del))
                {
                    good = 0;
                    break;
                }
            }
            for (int i = 0; i < n; i++)
            {
                if (a[i] >= m)
                {
                    good = 0;
                    break;
                }
            }
            if (c == 0)
            {
                good = 0;
            }

            if (!good)
            {
                cout << -1 << endl;
                continue;
            }
            
            cout << m << " " << c << endl;
        }
    }

    return 0;
}