#include <iostream>
#include <vector>
using namespace std;

vector<int> arr;
int t, n, temp, defined_m;
bool raising, mono_up, mono_down, ok;

int main() {
    cin >> t;
    while (t--) {
        cin >> n;
        if (n == 1) {
            cout << 0 << endl;
            continue;
        }
        arr.resize(n);
        for (int i = 0; i < n; i++) cin >> arr[i];

        raising = true;
        temp = arr[1] - arr[0];
        for (int i = 2; i < n; i++) {
            if (arr[i] - arr[i - 1] != temp) {
                raising = false;
                break;
            }
        }
        if (raising) {
            cout << 0 << endl;
            continue;
        }

        mono_up = mono_down = true;
        for (int i = 1; i < n; i++) {
            if (arr[i] > arr[i - 1]) mono_down = false;
            if (arr[i] < arr[i - 1]) mono_up = false;
        }
        if ((mono_down or mono_up) and !raising) {
            cout << -1 << endl;
            continue;
        }

        for (int i = 1; i < n; i++) {
            if (arr[i] > arr[i - 1]) {
                temp = arr[i] - arr[i - 1];
                break;
            }
        }
        for (int i = 1; i < n; i++) {
            if (arr[i] < arr[i - 1]) {
                defined_m = arr[i - 1] - arr[i] + temp;
                break;
            }
        }

        ok = true;
        for (int i = 1; i < n; i++) {
            if (arr[i] != (arr[i - 1] + temp) % defined_m) {
                ok = false;
                break;
            }
        }
        if (ok and arr[0] < defined_m) cout << defined_m << " " << temp << endl;
        else cout << -1 << endl;
    }
}
