#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <iomanip>

using namespace std;

#define v vector
#define int long long

int n;
v<int> a;

int c, l, max_num;

void init() {
    c = -1;
    l = -1;
    max_num = -1e18;
    a.clear();
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        max_num = max(max_num, a[i]);
    }
}

bool get_move() {
    for (int i = 1; i < n; i++) {
        if (a[i] >= a[i - 1]) {
            if (c == -1) {
                c = a[i] - a[i - 1];
            } else if (a[i] - a[i - 1] != c) {
                return false;
            }
        }
    }
    return true;
}

bool get_l() {
    for (int i = 1; i < n; i++) {
        if (a[i] < a[i - 1]) {
            if (l == -1) {
                l = a[i - 1] - a[i];
            } else if (a[i - 1] - a[i] != l) {
                return false;
            }
        }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    for (int test = 0; test < t; test++) {
        init();
        if (!get_move()) {
            cout << -1 << "\n";
            continue;
        }
        if (!get_l()) {
            cout << -1 << "\n";
            continue;
        }
        if ((c != -1 && l != -1) && c + l <= max_num) {
            cout << -1 << "\n";
            continue;
        }
        if (c != -1 && l != -1) {
            cout << c + l << " " << c << "\n";
            continue;
        }
        cout << 0 << "\n";
    }
    return 0;
}
