#include <iostream>
#include <algorithm>
#include <vector>

#define ll long long
#define int long long
#define debug(x) cerr << #x << " = " << x << endl

using namespace std;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while(t--) {
		int n;
		cin >> n;
		vector<int> a(n);
		for(int& i : a)
			cin >> i;

		if(n == 1) {
			cout << 0 << "\n";
			continue;
		}
		int cur = a[1] - a[0];
		bool ok = true;
		for(int i = 1; i < n; ++i) {
			if(a[i] - a[i - 1] != cur) {
				ok = false;
				break;
			}
		}
		if(ok) {
			cout << 0 << "\n";
			continue;
		}
		int c = -1;
		int C = INT32_MIN;
		
		for(int i = 1; i < n; ++i) {
			if(a[i] > a[i - 1]) {
				if(c != -1 && a[i] - a[i - 1] != c) {
					cout << -1 << "\n";
					goto next;
				}
				c = a[i] - a[i - 1];
			} else {
				if(C != INT32_MIN && C != a[i - 1] - a[i]) {
					cout << -1 << "\n";
					goto next;
				}
				C = a[i - 1] - a[i];
			}
		}

		{
			int m = c + C;
			if(m < *max_element(a.begin(), a.end()))
				cout << -1 << "\n";
			else
				cout << m << " " << c << "\n";
		}

		next:;
	}

	// system("pause");
}
