#include <iostream>
#include <bitset>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <algorithm>

#define vc vector
#ifdef kOk
#else
#include <bits/extc++.h>
#endif

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vc<ll> vll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;
typedef vc<vpll> vvpll;

template<typename T>
void sort(T &a) {
    sort(a.begin(), a.end());
}

template<typename T>
void reverse(T &a) {
    reverse(a.begin(), a.end());
}

template<typename T>
void unique(T &a) {
    a.resize(unique(a.begin(), a.end()) - a.begin());
}

bool check(vll a, ll m, ll c) {
    if (a[0] % m != a[0]) {
        return false;
    }
    for (ll i = 0; i + 1 < a.size(); ++i) {
        if ((a[i] + c) % m != a[i + 1]) {
            return false;
        }
    }
    return true;
}

int main() {
    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vll a(n);
        for (auto &i : a) {
            cin >> i;
        }
        if (n == 1) {
            cout << 0 << '\n';
            continue;
        }
        set<ll> x;
        set<ll> y;
        for (ll i = 0; i + 1 < n; ++i) {
            if (a[i] <= a[i + 1]) {
                x.insert(a[i + 1] - a[i]);
            } else {
                y.insert(a[i] - a[i + 1]);
            }
        }
        if (x.size() > 1 || y.size() > 1) {
            cout << -1 << '\n';
            continue;
        }
        if (x.size() == 1 && y.size() == 1) {
            if (check(a, (*x.begin()) + (*y.begin()), *x.begin())) {
                cout << (*x.begin()) + (*y.begin()) << ' ' << *x.begin() << '\n';
            } else {
                cout << -1 << '\n';
            }
            continue;
        }
        if (x.size() == 1 || y.size() == 1) {
            cout << 0 << '\n';
        }
    }
}