#include <iostream>
#include <set>

using namespace std;

inline int sign(int a)
{
	if (a > 0)
		return 1;
	if (a < 0)
		return -1;
	return 0;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int t;
	cin >> t;
	for (int t1 = 0; t1 < t; t1++)
	{
		int n;
		cin >> n;
		set<int> d;
		int a1, a2;
		cin >> a1;
		int mx = a1;
		for (int i = 1; i < n; i++)
		{
			cin >> a2;
			d.insert(a2 - a1);
			a1 = a2;
			mx = max(mx, a1);
		}
		if (d.size() < 2)
		{
			cout << 0 << "\n";
			continue;
		}
		else if (d.size() > 2)
		{
			cout << -1 << "\n";
			continue;
		}
		int d1 = *d.begin();
		d.erase(d.begin());
		int d2 = *d.begin();
		if (sign(d1) * sign(d2) >= 0)
		{
			cout << -1 << "\n";
			continue;
		}
		int c = (sign(d1) > 0 ? d1 : d2);
		int m = abs(d1) + abs(d2);
		if (m <= mx)
		{
			cout << -1 << "\n";
			continue;
		}
		cout << m << " " << c << "\n";
	}
}
