#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    int T;
    cin >> T;
    for(int I = 0; I < T; I++)
    {{
        int n;
        cin >> n;
        vector<int> data(n);
        for(int i = 0; i < n; i++)
            cin >> data[i];
        set<int> diffs;
        for(int i = 1; i < n; i++)
        {
            diffs.insert(data[i] - data[i-1]);
            if(diffs.size() > 2)
                goto fail;
        }
        if(diffs.size() < 2)
            cout << "0\n";
        else
        {
            int a = *diffs.begin();
            int b = *--diffs.end();
            if(a >= 0 || b <= 0)
                goto fail;
            int ans = b - a;
	    if(data[0] >= ans)
                goto fail;
            for(int i = 1; i < n; i++)
                if(data[i] != (data[i-1] + b) % ans)
                    goto fail;
            cout << ans << ' ' << b << endl;
        }
        continue;
    }
    fail:
        cout << "-1\n";
    }
    return 0;
}
