#include <bits/stdc++.h>

#define int long long

// typedef long long llong;

using namespace std;

bool check(vector<int> &a, int n, int m, int c) {
    if (a[0] % m != a[0]) return false;
    for (int i = 1; i < n; i++) {
        int need = (a[i - 1] + c) % m;
        if (need != a[i]) return false;
    }
    return true;
}

void solve_test() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (n <= 2) {
        cout << 0 << "\n";
        return;
    } else {
        set<int> arr;
        for (int i = 1; i + 1 < n; i++) arr.insert(abs(2 * a[i] - a[i - 1] - a[i + 1]));
        for (int m : arr) {
            vector<int> toCheck = {abs(a[1] - a[0]), m - abs(a[1] - a[0]),
                                   abs(a[2] - a[1]), m - abs(a[2] - a[1]),
                                   abs(m - abs(a[1] - a[0])), abs(m - abs(a[2] - a[1]))};
            for (int it : toCheck) {
                //cout << m << " " << it << "!\n";
                if (it < 0) continue;
                if (it >= m) break;
                if (check(a, n, m, it)) {
                    cout << m << " " << it << "\n";
                    return;
                }
            }
        }
        if (*(arr.begin()) == 0 && (int)(arr.size()) == 1) {
            cout << 0 << "\n";
            return;
        }
    }
    cout << -1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve_test();
    }

    return 0;
}
