#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <stack>
#include <queue>
#include <deque>
using namespace std;
#define int long long

vector <int> divisors(int n) {
    vector <int> ans;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            ans.push_back(i);
            ans.push_back(n / i);
        }
    }
    sort(ans.rbegin(), ans.rend());
    return ans;
}

int gcd(int a, int b) {
    return b == 0 ? a : gcd(b, a % b);
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    bool ok = true;
    for (int i = 0; i + 1 < n; ++i) {
        if (a[i + 1] - a[i] != a[1] - a[0]) {
            ok = false;
        }
    }
    if (ok) {
        cout << "0\n";
        return;
    }
    // n >= 3
    vector <int> arr;
    for (int i = 1; i + 1 < n; ++i) {
        if (abs((a[i + 1] - a[i]) - (a[i] - a[i - 1])) != 0) {
            arr.push_back(abs((a[i + 1] - a[i]) - (a[i] - a[i - 1])));
        }
    }
    int m = arr[0];
    for (int i = 0; i < arr.size(); ++i) {
        m = gcd(m, arr[i]);
    }
    int c = ((a[1] - a[0]) % m + m) % m;
    int s = a[0] % m;
    bool ok2 = true;
    for (int j = 0; j < n && ok2; ++j) {
        if (s != a[j]) ok2 = false;
        s = (s + c) % m;
    }
    if (ok2 == false) {
        cout << "-1";
    }  else {
        cout << m << " " << ((a[1] - a[0]) % m + m) % m;
    }
//    cout << "?\n";
}

int32_t main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
        cout << "\n";
    }
}