#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>

using namespace std;

typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	ll t, n, m, k;
	bool w;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		vector <vector <ll>> f(m);
		vector <vector<ll>> day(n + 1);
		vector <ll> Count(n + 1);
		vector <ll> ans(m);
		for (ll i = 0; i < m; i++) {
			cin >> k;
			f[i].resize(k);
			for (ll j = 0; j < k; j++) {
				cin >> f[i][j];
			}
			day[f[i][0]].push_back(i);
			Count[f[i][0]]++;
			ans[i] = f[i][0];
		}
		bool ok = true;
		for (ll i = 1; i <= n; i++) {
			if (day[i].size() > (m + 1) / 2) {
				ll j = day[i].size() - 1;
				while (j >= 0 && Count[i] > (m + 1) / 2) {
					if (f[day[i][j]].size() >= 2) {
						Count[f[day[i][j]][1]]++;
						Count[i]--;
						ans[day[i][j]] = f[day[i][j]][1];
					}
					j--;
				}
				if (Count[i] > (m + 1) / 2) {
					ok = false;
				}
				break;
			}
		}
		if (ok) {
			cout << "YES\n";
			for (auto elem : ans) {
				cout << elem << " ";
			}
			cout << "\n";
		}
		else {
			cout << "NO\n";
		}
	}
}