#include <bits/stdc++.h>

using namespace std;

#define se second
#define fi first

typedef long long ll;
typedef long double ld;

long long T(long long n){ return n * (n + 1) >> 1; }
long long MOD(long long a, long long mod){ return (a % mod + mod) % mod; }
long long gcd(long long a, long long b) { return (b == 0 ? a : gcd(b, a % b)); }

long long fpow(long long a, long long b, long long mod){
    if(b == 0)
        return 1;
    if(b == 1)
        return a;
    if(b & 1)
        return fpow(a, b ^ 1, mod) * a % mod;

    long long res = fpow(a, b >> 1, mod);
    return res * res % mod;
}

long long fpow(long long a, long long b){
    if(b == 0)
        return 1;
    if(b == 1)
        return a;
    if(b & 1)
        return fpow(a, b ^ 1) * a;

    long long res = fpow(a, b >> 1);
    return res * res;
}

const int INF32 = 2e9;
const long long INF64 = 4e18;
const int SZ = 2e5 + 11;
const int mod = 1e9 + 7;

#define int ll

void Solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n + 1);

    for(int i = 1; i <= m; i++){
        int k; cin >> k;

        for(int j = 1; j <= k; j++){
            int v; cin >> v;
            g[v].push_back({k, i});
        }
    }

    vector<pair<int, int>> a;

    for(int i = 1; i <= n; i++){
        a.push_back({g[i].size(), i});
        sort(g[i].begin(), g[i].end());
    }

    sort(a.begin(), a.end());

    vector<int> was(m + 1, -1);

    for(auto p : a){
        int cnt = 0;
        int x = p.se;

        for(int i = 0; i < g[x].size() && cnt + 1 <= (m + 1) / 2; i++){
            int u = g[x][i].se;

            if(was[u] == -1){
                cnt++;
                was[u] = x;
            }
        }
    }

    bool ny = 1;

    for(int i = 1; i <= m; i++)
        ny &= (was[i] != -1);

    if(ny){
        cout << "YES\n";

        for(int i = 1; i <= m; i++)
            cout << was[i] << ' ';
        cout << '\n';
    }else{
        cout << "NO\n";
    }
}

/*
1
2 6
2 1 2
2 1 2
2 1 2
2 1 2
1 1
1 2

YES
1 1 2 2 1 2

*/

signed main(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
    srand(time(NULL));
    cout << fixed << setprecision(10);

    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "r", stdout);

    int test = 1;
    cin >> test;

    for(int i = 1; i <= test; i++){
        Solve();
    }
}