#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

template <class T> bool ckmin(T &a,T b){ return a > b ? a=b, true : false;}
template <class T> bool ckmax(T &a,T b){ return a < b ? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple

const int N = 2e5 + 500;
const int mod = 1e9 + 7;//988244353
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;
const ld eps = 1e-9;

void solve(){
    int n,m; cin>>n>>m;
    vector<vector<int>> v(m);
    vector<int> cnt(n+1,0), ans(m);
    for(int i=0;i<m;i++){
        int k; cin>>k;
        v[i].resize(k);
        for(int j=0;j<k;j++){
            cin>>v[i][j];
        }
        ans[i] = v[i][0];
        cnt[v[i][0]]++;
    }
    int x = -1;
    for(int i=1;i<=n;i++) if(cnt[i] > (m+1)/2){
        x = i;
    }
    if(x > 0){
        for(int i=0;i<m && cnt[x] > (m+1)/2;i++) if(ans[i] == x && sz(v[i]) > 1){
            cnt[x]--;
            ans[i] = v[i][1];
        }
        if(cnt[x] > (m+1)/2){
            cout<<"NO\n"; return;
        }
    }
    cout<<"YES\n";
    for(auto e:ans) cout<<e<<' '; cout<<'\n';
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt","w", stdout);
    cout<<fixed<<setprecision(20);
    int t = 1; cin>>t;
    while(t--) solve();
    return 0;
}
