#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
#define endl "\n"

#define int long long
#define double long double

#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

void solve() {
    int n, m;
    cin >> n >> m;
    set<int> a[m];
    vector<int> da[n];
    set<pair<int, int>> days;
    int res[m];
    for (int i = 0; i < m; i++) {
        res[i] = -1;
        int k;
        cin >> k;
        days.emplace(k, i);
        for (int j = 0; j < k; j++) {
            int v;
            cin >> v;
            v--;
            a[i].insert(v);
            da[v].push_back(i);
        }
    }

    int hmtu[n];
    memset(hmtu, 0, sizeof(hmtu));
    const int tum = m % 2 == 0 ? m / 2 : m / 2 + 1;

    while (!days.empty()) {
        auto ddd = days.begin();
        int d = ddd->second;
        days.erase(ddd);

        if (a[d].empty()) {
            cout << "NO\n";
            return;
        }
        int h = *a[d].begin();
        res[d] = h;
        hmtu[h]++;
        if (hmtu[h] + 1 > tum) {
            for (int dd : da[h]) {
                if (days.find({a[dd].size(), dd}) == days.end()) {
                    continue;
                }
                days.erase({a[dd].size(), dd});
                a[dd].erase(h);
                days.insert({a[dd].size(), dd});
            }
        }
    }
    cout << "YES\n";
    for (int i = 0; i < m; i++) {
        cout << res[i] + 1 << (i == m - 1 ? endl : " ");
    }
}

#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("./in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t T_;
    cin >> T_;
    for (int32_t T_i = 0; T_i < T_; T_i++) {
#endif
        solve();
#ifdef MULTITEST
    }
#endif
    return 0;
}
