#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <cstring>
#include <immintrin.h>
#include <cstdint>
#include <iomanip>
#include <random>
#include <queue>
#include <stack>

int main() {
    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0; t < num_tests; t++) {
	int32_t n, m;
	std::cin >> n >> m;

	std::map<int32_t, std::vector<int32_t> > per_friend;
	std::vector<int32_t>* per_day = new std::vector<int32_t>[m];
	for(int32_t i = 0; i < m; i++) {
	    int32_t k;
	    std::cin >> k;

	    for(int32_t j = 0 ;j < k; j++) {
		int32_t x;
		std::cin >> x;

		per_friend[x].push_back(i);
		per_day[i].push_back(x);
	    }
	}

	int32_t most_freq = -1, occ = 0;
	for(auto it = per_friend.begin(); it != per_friend.end(); it++) {
	    if(it->second.size() > occ) {
		occ = it->second.size();
		most_freq = it->first;
	    }
	}

	int32_t limit = (m + 1) / 2;
	int32_t* answers = new int32_t[m];
	for(int32_t i = 0 ; i < m ; i++)
	    answers[i] = -1;
	for(int32_t i = 0; i < m; i++)
	    if(per_day[i].size() == 1) {
		answers[i] = per_day[i][0];
		if(per_day[i][0] == most_freq)
		    limit--;
	    }

	int32_t top_put = std::min(limit, occ);
	for(int32_t i = 0; i < per_friend[most_freq].size(); i++) {
	    if(top_put <= 0)
		break;
	    if(answers[per_friend[most_freq][i]] != -1)
		continue;
	    answers[per_friend[most_freq][i]] = most_freq;
	    top_put--;
	}

	bool ok = true;
	for(int32_t i = 0 ; i < m ; i++) {
	    if(answers[i] == -1) {
		for(int32_t j = 0 ; j < per_day[i].size(); j++)
		    if(per_day[i][j] != most_freq) {
			answers[i] = per_day[i][j];
			break;
		    }
	    }
	    if(answers[i] == -1) {
		ok = false;
		break;
	    }
	}

	if(!ok)
	    std::cout << "NO" << "\n";
	else {
	    std::map<int32_t, int32_t> real;
	    for(int32_t i = 0; i  < m ; i++)
		real[answers[i]]++;
	    for(auto it = real.begin(); it != real.end(); it++)
		if(it->second > (m + 1) / 2) {
		    ok = false;
		    break;
		}

	    if(!ok)
		std::cout << "NO" << "\n";
	    else {
		std::cout << "YES" << "\n";
		for (int32_t i = 0; i < m; i++)
		    std::cout << answers[i] << " ";
		std::cout << "\n";
	    }
	}

    }
    return 0;
}










