#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <assert.h>

#define ll long long
#define ld long double
#define sz(x) (int)x.size()
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define all(x) x.begin(),x.end()
#define in insert
#define F first
#define S second

using namespace std;

const int N = (int)3e5 + 123;
const int mod = (int)1e9 + 7;
const ll inf = (ll)3e18 + 123;

int n, m, k[N], ans[N];
vector <int> f[N], pos[N];

inline void boost () {
   ios_base :: sync_with_stdio(0);
   cin.tie(0);
   cout.tie(0);
}

int main () {
   //freopen ("input", "r", stdin);
   boost ();
   int t;
   cin >> t;
   while (t --) {
      cin >> n >> m;
      for (int i = 1; i <= max (n, m); i ++) pos[i].clear (), ans[i] = 0;
      int mx = (m + 1) / 2;
      for (int i = 1; i <= m; i ++) {
         cin >> k[i];
         f[i].clear ();
         for (int j = 0; j < k[i]; j ++) {
            int x;
            cin >> x;
            f[i].pb (x);
            pos[f[i][j]].pb (i);
         }
      }
      bool ok = 1;
      for (int i = 1; i <= n; i ++) {
         if (sz (pos[i]) <= mx) {
            for (auto it : pos[i]) ans[it] = i;
         }
         else {
            int cur = 0;
            for (auto it : pos[i]) {
               cur += (k[it] == 1);      
            }
            if (cur > mx) {
               ok = 0;
            }
            else {
               int can = mx;
               for (auto it : pos[i]) {
                  if (k[it] == 1)
                     ans[it] = i, can --;
               }
               for (auto it : pos[i]) {
                  if (!ans[it] && can)
                     can --, ans[it] = i;   
               }
            }
         }
      }
      if (!ok) cout << "NO\n";
      else {
         cout << "YES\n";
         for (int i = 1; i <= m; i ++) cout << ans[i] << ' ', assert(ans[i] != 0);
         cout << endl;
      }
   }
   return 0;
}