#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
using namespace std;
#define int int64_t


signed main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  int t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> day(m + 1);
    vector<int> fr(n + 1, 0);
    int lim = ceil(double (m) / 2.0);

    for (int j = 1; j <= m; ++j) {
      int k;
      cin >> k;
      day[j].assign(k, 0);
      for (int i = 0; i < k; ++i) {
        cin >> day[j][i];
        ++fr[day[j][i]];
      }
    }

    int cnt1 = 0, fir = 0;
    for (int i = 1; i <= n; ++i) {
      if (fr[i] > lim) {
        ++cnt1;
        fir = i;
      }
    }

    if (cnt1 == 1) {
      vector<int> ans(m + 1);
      int cnt = 0;
      for (int j = 1; j <= m; ++j) {
        if (day[j].size() == 1 && day[j][0] == fir) {
          ++cnt;
          ans[j] = fir;
        } else {
          for (auto p : day[j]) {
            if (p == fir) continue;
            ans[j] = p;
            break;
          }
        }
      }

      if (cnt > lim) {
        cout << "NO\n";
      } else {
        cout << "YES\n";
        for (int i = 1; i <= m; ++i) {
          cout << ans[i] << " ";
        }
        cout << "\n";
      }
    } else {
      cout << "YES\n";
      vector<int> ans(m + 1, -1);
      vector<int> cnt(n + 1, 0);

      for (int j = 1; j <= m; ++j) {
        if (day[j].size() == 1) {
          ans[j] = day[j][0];
          cnt[day[j][0]] += 1;
        }
      }

      for (int j = 1; j <= m; ++j) {
        if (ans[j] != -1) continue;
        for (auto p : day[j]) {
          if (cnt[p] < lim) {
            ans[j] = p;
            cnt[p] += 1;
            break;
          }
        }
      }

      for (int i = 1; i <= m; ++i) {
        cout << ans[i] << " ";
      }

      cout << "\n";
    }
  }
  return 0;
}
