#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll alp = 26;

#define ff first
#define ss second
#define pb push_back
#define vec vector
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fopen(a, b) freopen(a, "r", stdin); freopen(b, "w", stdout)

void run() {
	ll n, m;
	cin >> n >> m;
	vec<set<ll>> g(n);
	vec<set<ll>> pl(m);
	vi cnt(n, (m - 1)/2 + 1);
	vi ans(m, -1);
	for (ll i = 0; i < m; ++i) {
		ll k;
		cin >> k;
		for (ll j = 0; j < k; ++j) {
			ll x;
			cin >> x;
			x--;
			pl[i].insert(x);
			g[x].insert(i);
		}
	}
	ll id = -1;
	for (ll i = 0; i < n; ++i) {
		if (g[i].size() > cnt[i]) {
			id = i;
			break;
		}
	}
	if (id == -1) {
		for (ll i = 0; i < m; ++i)
			ans[i] = *pl[i].begin();
		cout << "YES\n";
		for (auto v : ans)
			cout << v + 1 << ' ';
		return;
	}
	for (auto v : g[id]) {
		if (pl[v].size() == 1) {
			cnt[id]--;
			ans[v] = id;
			pl[v].clear();
		}
	}
	if (cnt[id] < 0) {
		cout << "NO";
		return;
	}
	for (auto v : g[id]) {
		if (cnt[id] == 0)
			break;
		if (!pl[v].empty()) {
			pl[v].clear();
			ans[v] = id;
			cnt[id]--;
		}
	}
	for (ll i = 0; i < n; ++i) {
		if (cnt[i] <= 0)
			continue;
		for (auto v : g[i]) {
			if (cnt[i] == 0)
				break;
			if (!pl[v].empty()) {
				pl[v].clear();
				ans[v] = i;
				cnt[i]--;
			}
		}
	}
	cout << "YES\n";
	for (auto v : ans)
		cout << v + 1 << ' ';
}

signed main() {
	// fopen("input.txt", "output.txt");
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll kk = 0, tkk = 1;
	cin >> tkk;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}