#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(x) int32_t(x.size())
#define pii pair < int, int >
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define se second
#define fi first
//#define int ll

using namespace __gnu_pbds;
using namespace std;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int mod = (int)1e9 + 7;
const int N = (int)3e5 + 15;

int dx[] = { 1, -1, 0, 0 };
int dy[] = { 0, 0, -1, 1 };

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int q = 1;
    cin >> q;
    while (q--) {
        int n, m;
        cin >> n >> m;
        vector < int > f[m + 1];
        for(int i = 1; i <= m; i++) {
            int k;
            cin >> k;
            while(k--) {
                int x;
                cin >> x;
                f[i].push_back(x);
            }
        }

        set < int > st[n + 1];

        for(int i = 1; i <= m; i++) {
            for(auto j : f[i]) {
                st[j].insert(i);
            }
        }

        vector < int > c(n + 1, 0);
        vector < int > cnt(n + 1, 0);

        int k = 0;
        for(int i = 1; i <= m; i++) {
            k += (sz(f[i]) > 1);
        }

        int mx = 0;
        vector < int > answ(m + 1, -1);
        for(int i = 1; i <= m; i++) {
            if(sz(f[i]) == 1) {
                answ[i] = f[i][0];
                cnt[f[i][0]]++;
                mx = max(mx, cnt[f[i][0]]);
            }
        }

        if(mx > (m + 1) / 2) {
            cout << "NO\n";
            continue;
        }

        for(int i = 1; i <= m; i++) {
            if(answ[i] == -1) {
                int mn = INT_MAX, cur;
                for(auto j : f[i]) {
                    if(cnt[j] < mn) {
                        mn = cnt[j]; cur = j;
                    }
                }
                cnt[cur]++; answ[i] = cur;
            }
        }

        cout << "YES\n";
        for(int i = 1; i <= m; i++) {
            cout << answ[i] << ' ';
        }
        cout << '\n';
    }
    return 0;
}
