#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()
#define rall(a) a.rebgin(), a.rend()
#define SOLVE int t; cin >> t; while (t--) solve();
#define int long long
#define max(a, b) (a > b ? a : b)
#define min(a, b) (a < b ? a : b)

using namespace std;

void print(vector<int> &a) {
    for (int i : a)
        cout << i << ' ';
    cout << '\n';
}

void print(vector<pair<int, int>> &a) {
    for (auto i : a)
        cout << i.first << ':' << i.second << ' ';
    cout << '\n';
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> used(m);
    vector<int> cnt(n);
    vector<vector<int>> k(n);
    vector<vector<int>> who(m);
    for (int i = 0; i < m; ++i) {
        int c;
        cin >> c;
        for (int j = 0; j < c; ++j) {
            int a;
            cin >> a;
            k[a - 1].push_back(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (k[i].size() <= (m + 1) / 2) {
            for (int j = 0; j < (int) k[i].size(); ++j) {
                if (!used[k[i][j]]) {
                    used[k[i][j]] = i + 1;
                }
            }
        } else {
           for (int j = 0; j < (int) k[i].size(); ++j) {
               who[k[i][j]].push_back(i + 1);
           }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!used[i] && who[i].size() == 1) {
            used[i] = who[i][0];
            ++cnt[who[i][0] - 1];
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            pair<int, int> mn = {1e9, 0};
            for (int j : who[i])
                mn = min(mn, make_pair(cnt[j - 1], j));
            ++cnt[mn.second - 1];
            used[i] = mn.second;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (cnt[i] > (m + 1) / 2) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (used[i] == 0) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    print(used);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    SOLVE
}
