#include <bits/stdc++.h>

using namespace std;
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune=native")
#pragma optimaze("O3")

#define int long long

typedef long long ll;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

ll mod = 1e9 + 7;

ll mul(ll a, ll b) {
    return (a * b) % mod;
}

ll sm(ll a, ll b) {
    if (a + b < mod) return a + b;
    return (a + b - mod);
}

ll divv(ll a, ll b) {
    if (a >= b) return a - b;
    return a - b + mod;
}

ll pw(ll a, ll k) {
    if (k == 0) return 1;
    if (k % 2) return mul(a, pw(a, k - 1));
    return pw(mul(a, a), k / 2);
}



int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;  cin >> t;
    while (t--) {
        int n, m; cin >> n >> m;
        vector<int> cnt(n);
        vector<vector<int> > f(m);
        vector<int> ans(m);
        bool fl = true;
        for (int i = 0; i < m; i++) {
            int k; cin >> k;
            for (int j = 0; j < k; j++) {
                int a; cin >> a; a--;
                f[i].push_back(a);
            }
            if (k == 1) {
                cnt[f[i][0]]++;
                ans[i] = f[i][0] + 1;
            }
        }
        int maxv = (m + 1) / 2;
        for (int i = 0; i < m; i++) {
            if (f[i].size() > 1) {
                if (cnt[f[i][0]] < maxv) {
                    ans[i] = f[i][0] + 1;
                    cnt[f[i][0]]++;
                } else {
                    ans[i] = f[i][1] + 1;
                    cnt[f[i][1]]++;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (cnt[i] > maxv) {
                fl = false;
            }
        }
        if (!fl) {
            cout << "NO" << endl;
        } else {
            cout << "YES" << endl;
            for (auto el : ans) cout << el << " ";
            cout << endl;
        }





    }


    return 0;
}
