#include <bits/stdc++.h>

//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

//#define int long long

typedef long long ll;
typedef long double ld;

#define pii pair<int, int>
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;
//using namespace __gnu_pbds;
//
//#define ord_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

int32_t main() {
//  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int T;
    cin >> T;

    while(T--) {
        int n, m;
        cin >> n >> m;

        vector<int> f[m+1];
        int cnt[n+1] = {0};

        for(int i = 1; i <= m; i++) {
            int k;
            cin >> k;

            for(int j = 0; j < k; j++) {
                int x;
                cin >> x;

                f[i].push_back(x);
                cnt[x]++;
            }
        }

        int mx = *max_element(cnt, cnt+n+1);

        int need_optimize = 0;

        if(mx > (m+1)/2)
            need_optimize = 1;

        int prior, prior_cnt = 0;

        for(int i = 1; i <= n; i++)
            if(cnt[i] == mx)
                prior = i;

        int marked_by_prior[m+1] = {0};

        for(int i = 1; i <= m; i++) {
            for(int x : f[i])
                if(x == prior)
                    marked_by_prior[i] = 1;
        }

        int leftmost_prior = 0;

        int opt[m+1] = {0};

        for(int i = 1; i <= m; i++) {
            if(!need_optimize) {
                opt[i] = f[i][0];
                continue;
            }
            if(!marked_by_prior[i]) {
                opt[i] = f[i][0];
                continue;
            }

            opt[i] = prior;
            prior_cnt++;

            while(leftmost_prior <= i && prior_cnt > (m+1)/2) {
                if(!marked_by_prior[leftmost_prior]) {
                    leftmost_prior++;
                    continue;
                }
                if(f[leftmost_prior].size() <= 1) {
                    leftmost_prior++;
                    continue;
                }

                prior_cnt--;
                for(int x : f[leftmost_prior]) {
                    if(x != prior) {
                        opt[leftmost_prior] = x;
                        break;
                    }
                }
                leftmost_prior++;
            }
        }

        if(prior_cnt > (m+1)/2)
            cout << "NO\n";
        else {
            cout << "YES\n";
            for(int i = 1; i <= m; i++)
                cout << opt[i] << ' ';
            cout << '\n';
        }
    }

    return 0;
}
