#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>
#include <random>


#define speed ios_base::sync_with_stdio(0);
#pragma warning(disable:4996)
#define ll long long

using namespace std;
mt19937_64 rnd(228);

int main() {

	speed;

	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int t;
	cin >> t;
	for (int test = 0; test < t; test++) {
		int n, m;
		cin >> n >> m;


		vector <vector <int>> v(m);
		vector <int> u(n);
		vector <int> used(n);
		vector <int> ans(m, -1);

		for (int i = 0; i < m; i++) {
			int k;
			cin >> k;
			v[i].resize(k);
			for (int j = 0; j < k; j++) {
				cin >> v[i][j];
				v[i][j]--;
			}
			if (k == 1)
			{
				u[v[i][0]]++;
				used[v[i][0]]++;
				ans[i] = v[i][0];
			}
		}

		bool flag = true;
		for (int i = 0; i < n; i++)
			if (u[i] > (m + 1) / 2) {
				cout << "NO\n";
				flag = false;
				break;
			}
		if (flag) {
			cout << "YES\n";

			for (int i = 0; i < m; i++)
				{
					if (ans[i] == -1) {
						for (int j = 0; j < v[i].size(); j++)
							if (used[v[i][j]] < (m + 1) / 2) {
								used[v[i][j]]++;
								ans[i] = v[i][j];
								break;
							}
				}
				cout << ans[i] + 1 << ' ';
			}
			cout << '\n';
		}
				


	}

	return 0;
}
