#include <iostream>
#include <string>
#include <vector>
#include <climits>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <algorithm>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair <ll, ll>;

const ll INF = 88005553535;
const ld PI = 3.141592653589793;

vector <ll> used;
bool comp(ll a, ll b) {
	return used[a - 1] < used[b - 1];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t-- > 0) {
		ll n, m;
		cin >> n >> m;
		vector <vector <ll>> arr(m);
		used.assign(n, 0);
		for (ll i = 0; i < m; ++i) {
			ll k;
			cin >> k;
			for (ll j = 0; j < k; ++j) {
				ll d;
				cin >> d;
				arr[i].push_back(d);
			}
		}
		ll cnt = 0;
		bool flag = false;
		vector <ll> ans(m, -1);
		while (!flag && cnt < 100) {
			flag = true;
			for (ll i = 0; i < m; ++i) {
				sort(arr[i].begin(), arr[i].end(), comp);
				if (ans[i] != -1) {
					--used[ans[i] - 1];
				}
				++used[arr[i][0] - 1];
				ans[i] = arr[i][0];
				if (used[arr[i][0] - 1] > m / 2 + m % 2) {
					flag = false;
				}
			}
			++cnt;
		}
		if (flag) {
			cout << "YES\n";
			for (auto el : ans) {
				cout << el << ' ';
			}
			cout << '\n';
		}
		else {
			cout << "NO\n";
		}
	}
	return 0;
}

/*
2
3 8
1 1
1 1
2 1 2
2 1 3
1 3
1 3
1 3
1 3
*/