#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <stack>
#include <queue>

using namespace std;

const int inf = 1e9;

bool comp(pair<int, vector<int>> a, pair<int, vector<int>> b){
    return a.second.size() < b.second.size();
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;
    while(q --){
        vector<int> who;
        vector<pair<int, vector<int>>> can;
        vector<int> how;
        int n, m;
        cin >> n >> m;
        who.resize(m);
        can.resize(m);
        how.resize(n + 10);
        for(int i = 0; i < m; i ++){
            int k;
            cin >> k;
            can[i].first = i;
            can[i].second.resize(k);
            for(int j = 0; j < k; j ++)
                cin >> can[i].second[j];
        }

        sort(can.begin(), can.end(), comp);

        int want = m / 2;
        if (m % 2 == 1)
            want ++;
        bool CAN = 1;

        for(int i = 0; i < m; i ++){
            int mi = inf;
            int mik;
            for(int j = 0; j < can[i].second.size(); j ++){
                if (how[can[i].second[j]] < mi){
                    mi = how[can[i].second[j]];
                    mik = can[i].second[j];
                }
            }
            if (mi == inf || mi + 1 > want){
                CAN = 0;
                break;
            }
            how[mik] ++;
            who[can[i].first] = mik;
        }

        if (!CAN){
            cout << "NO\n";
            continue;
        }

        cout << "YES\n";
        for(int i = 0; i < m; i ++)
            cout << who[i] << ' ';
        cout << '\n';
    }
}

/*
1
4 6
1 1
2 1 2
3 1 2 3
4 1 2 3 4
2 2 3
1 3
*/
