#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

typedef long long ll;
typedef long double ld;

using namespace std;

void solve() {
	int n, m, l, mx = 0;
	cin >> n >> m;
	vector<vector<int>> k(m);
	vector<int> used(n, 0);
	for(int i = 0; i < m; ++i) {
		cin >> l;
		k[i].resize(l);
		for(int j = 0; j < l; ++j) {
			cin >> k[i][j];
			k[i][j] --;
		}
		if(l == 1) {
			used[k[i][0]]++;
			mx = max(mx, used[k[i][0]]);
		}
	}
	if(mx > (m + 1) / 2) {
		cout << "NO";
		return;
	}
	cout << "YES\n";
	for(int i = 0; i < m; ++i) {
		if(used[k[i][0]] + 1 <= (m + 1) / 2 || k[i].size() == 1) {
			cout << k[i][0] + 1 << ' ';
			if(k[i].size() > 1) {
				used[k[i][0]]++;
			}
		}
		else {
		    cout << k[i][1] + 1 << ' ';
		}
	}
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while(t--) {
		solve();
		cout << '\n';
	}
	return 0;
}