#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e9;
const ll INFF = 1e18;

struct point {
	int x, y;
	point (int x_ = 0, int y_ = 0) {
		x = x_;
		y = y_;
	}
};

bool comp (pair<int, vector<int>> &a, pair<int, vector<int>> &b) {
	return a.second.size() < b.second.size();
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<pair<int, vector<int>>> a(m);
	for (int i = 0; i < m; i++) {
		int x; cin >> x;
		a[i].first = i;
		a[i].second.resize(x);
		for (auto &j : a[i].second) cin >> j;
	}
	sort(all(a), comp);
	vector<int> cnt(n + 1, 0), ans(m);
	for (int i = 0; i < m; i++) {
		
		int mn = m, val = -1;
		for (int j = 0; j < a[i].second.size(); j++) {
			if (cnt[a[i].second[j]] < mn) {
				mn = cnt[a[i].second[j]];
				val = a[i].second[j];
			}
		}
		if (mn >= (m + 1) / 2) {
				cout << "NO\n";
				return;
			}
			else {
				cnt[val]++;
				ans[a[i].first] = val;
			}
//		for (auto it : cnt) {
//			cout << it << ' ';
//		}
//		cout << '\n';
	}
	cout << "YES\n";
	for (auto it : ans) {
		cout << it << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t; cin >> t;
	while (t--) {
		solve();
	}
	
}
