#include <bits/stdc++.h>

using namespace std;

const int N = 100000;

int cnt[N + 20];

void solve() {
	int n, m;
	cin >> n >> m;
	vector<pair<int,vector<int>>> arr(m);
	for (int i = 0; i < m; i++) {
		int x; cin >> x;
		arr[i].second.resize(x);
		arr[i].first = i;
		for (size_t j = 0; j < arr[i].second.size(); j++) {
			cin >> arr[i].second[j];
			arr[i].second[j]--;
		}
	}
	sort(arr.begin(), arr.end(),
		[](pair<int,vector<int>> a, pair<int,vector<int>> b){
			if (a.second.size() != b.second.size()) {
				return a.second.size() < b.second.size();
			}
			for (int i = 0; i < a.second.size(); i++) {
				if (a.second[i] != b.second[i])
					return a.second[i] < b.second[i];
			}
			return false;
	});
	fill(cnt, cnt + n + 1, 0);
	vector<int> ans(m);
	bool ok = true;
	for (int i = 0; i < m; i++) {
		int idx = arr[i].second[0];
		for (size_t j = 0; j < arr[i].second.size(); j++) {
			//cout << arr[i].second[j]+1 << ' ';
			if (cnt[arr[i].second[j]] < cnt[idx])
				idx = arr[i].second[j];
		}
		//cout << '\n';
		ans[arr[i].first] = idx+1;
		cnt[idx]++;
		if (cnt[idx] > (m+1)/2)
			ok = false;
	}
	if (ok) {
		cout << "YES\n";
		for (int i = 0; i < m; i++) {
			cout << ans[i] << ' ';
		}
		cout << '\n';
	} else {
		cout << "NO\n";
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int q;
	cin >> q;
	while (q --) {
		solve();
	}
	return 0;
}