#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <string>
#include <tuple>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define int ll
#define double ld
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second
#define mkp make_pair
#define mkt make_tuple
#define all(x) begin(x), end(x)

void solve() {
    int n, m;
    cin >> n >> m;
    vector <int> cnt_bad(n), cnt_good(n);
    vector <vector <int> > a(m);
    loop(i, m) {
        int k; cin >> k;
        a[i].resize(k);
        loop(j, k) {
            cin >> a[i][j];
            --a[i][j];
            ++cnt_good[a[i][j]];
        }
        if (k == 1)
            ++cnt_bad[a[i][0]];
    }
    int mx = 0;
    loop(i, n) {
        if (cnt_bad[i] > (m + 1) / 2) {
            cout << "NO\n"; return;
        }
        if (cnt_good[i] > cnt_good[mx])
            mx = i;
    }
    cout << "YES\n";
    vector <bool> ans(m);
    int cnt = 0;
    loop(i, m)
        if (a[i].size() == 1 && a[i][0] == mx)
            ans[i] = 1, ++cnt;
    for (int i = 0; i < m && cnt < (m + 1) / 2; ++i) {
        if (ans[i]) continue;
        bool ok = 0;
        for (int x : a[i])
            if (x == mx) {
                ok = 1; break;
            }
        if (ok)
            ans[i] = 1, ++cnt;
    }
    loop(i, m) {
        if (ans[i])
            cout << mx + 1 << " ";
        else if (a[i][0] != mx)
            cout << a[i][0] + 1 << " ";
        else
            cout << a[i][1] + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t; loop(i, t)
    solve();
    return 0;
}