#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <iomanip>

using namespace std;

#define v vector
#define int long long

int n, m;
v<v<int>> lst, pos;
v<int> cnt;
v<int> ans;

int opt_id = -1;
int T;

void init() {
    cin >> n >> m;
    lst.clear();
    cnt.clear();
    lst.resize(m);
    cnt.resize(n, 0);
    pos.clear();
    pos.resize(n);
    ans.clear();
    opt_id = -1;
    T = (m + 1) / 2;
    for (int i = 0; i < m; i++) {
        int k; cin >> k;
        lst[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> lst[i][j];
            lst[i][j]--;
            cnt[lst[i][j]]++;
            pos[lst[i][j]].push_back(i);
        }
    }
}

bool check() {
    for (int i = 0; i < n; i++) {
        if (cnt[i] > T) {
            opt_id = i;
            return true;
        }
    }
    return false;
}

bool proccess() {
    ans.resize(m, -1);
    int c = 0;
    for (auto j : pos[opt_id]) {
        if (lst[j].size() == 1) {
            ans[j] = opt_id;
            c++;
        }
    }
    if (c > T) return false;
    for (auto j : pos[opt_id]) {
        if (ans[j] != -1) continue;
        if (c == T) break;
        ans[j] = opt_id;
        c++;
    }
    for (int i = 0; i < m; i++) {
        if (ans[i] != -1) continue;
        for (auto j : lst[i]) {
            if (j != opt_id) {
                ans[i] = j;
                break;
            }
        }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    for (int test = 0; test < t; test++) {
        init();
        if (!check()) {
            cout << "YES\n";
            for (int i = 0; i < m; i++) {
                cout << lst[i][0] + 1 << " ";
            }
            continue;
        }
        if (!proccess()) {
            cout << "NO\n";
            continue;
        }
        cout << "YES\n";
        for (auto j : ans) {
            cout << j + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}
