#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define fastio ios_base::sync_with_stdio(0), cin.tie(), cout.tie()
#define fileio freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout)
#define endl "\n"
#define bench cerr << "Time: " << clock() << endl
#define debug(x)

#ifndef ONLINE_JUDGE
#define debug(x) cerr << #x << ": " << x << endl
#endif

using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int solve() {
    int n, m;
    cin >> n >> m;
    vector<int> cnt(n + 1);
    vector<vector<int>> f(m);
    vector<int> res(m);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        f[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> f[i][j];
        }
        if (k == 1) {
            cnt[f[i][0]]++;
            res[i] = f[i][0];
        }
    }
    for (int i = 0; i < m; i++) {
        if (f[i].size() == 1)
            continue;
        bool g = 0;
        for (int j : f[i]) {
            if (cnt[j] < (int)ceil(m / 2.)) {
                res[i] = j;
                cnt[j]++;
                g = 1;
                break;
            }
        }
        if(!g) {
            cout << "NO" << endl;
            return 0;
        }
    }
    for (int i : cnt) {
        if (i > (int)ceil(m / 2.)) {
            cout << "NO" << endl;
            return 0;
        }
    }
    cout << "YES" << endl;
    for (int i : res)
        cout << i << " ";
    cout << endl;
    return 0;
}

signed main() {
    fastio;
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}