#include <iostream>
#include <bits/stdc++.h>

using namespace std;

vector <int> dijkstra(vector <vector <pair <int, int>>>& g, int start){
    vector <int> d(g.size() + 1, 1000000000);
    d[start] = 0;
    set <pair <int, int>> s;
    s.insert(make_pair(0, start));
    while (!s.empty()){
        int len = s.begin()->first;
        int u = s.begin()->second;
        s.erase(s.begin());
        for (auto v: g[u]){
            if (len + v.second < d[v.first]){
                s.erase(make_pair(d[v.first], v.first));
                d[v.first] = len + v.second;
                s.insert(make_pair(d[v.first], v.first));
            }
        }
    }
    return d;
}

bool cmp(pair <vector <int>, int>& x, pair <vector <int>, int>& y){
    return x.first.size() < y.first.size();
}


main(){
    int t, n, k, m;
    cin >> t;
    for (; t > 0; --t){
        cin >> n >> m;
        vector <pair<vector <int>, int>> days(m);
        bool possible = true;
        for (int i = 0; i < m; ++i){
            cin >> k;
            days[i].first.resize(k);
            for (int j = 0; j < k; ++j) cin >> days[i].first[j];
            days[i].second = i;
        }
        sort(days.begin(), days.end(), cmp);
        vector <vector <int>> id_of_days(n + 1);
        int a = -1;
        for (int i = 0; i < m; ++i){
            for (auto j: days[i].first){
                id_of_days[j].push_back(i);
                if (id_of_days[j].size() >= (m / 2 + (m % 2 != 0)) && a == -1) a = j;
            }
        }
        vector <int> ans(m, -1);
        if (a != -1){
            for (int i = 0; i < m / 2 + (m % 2 != 0) && i < id_of_days[a].size(); ++i){
                ans[days[id_of_days[a][i]].second] = a;
            }
            vector <int> used_cnt(n + 1, 0);
            used_cnt[a] = m / 2 + (m % 2 != 0);
            for (auto i: days){
                if (ans[i.second] != -1) continue;
                bool pt = false;
                for (auto j: i.first){
                    if (used_cnt[j] < m / 2 + (m % 2 != 0)){
                        used_cnt[j]++;
                        ans[i.second] = j;
                        pt = true;
                        break;
                    }
                }
                if (!pt){
                    possible = false;
                    break;
                }
            }
        }
        else {
            vector <int> used_cnt(n + 1, 0);
            for (auto i: days){
                if (ans[i.second] != -1) continue;
                bool pt = false;
                for (auto j: i.first){
                    if (used_cnt[j] < m / 2 + (m % 2 != 0)){
                        used_cnt[j]++;
                        ans[i.second] = j;
                        pt = true;
                        break;
                    }
                }
                if (!pt){
                    possible = false;
                    break;
                }
            }
        }
        if (!possible) cout << "NO\n";
        else {
            cout << "YES\n";
            for (auto i: ans) cout << i << " ";
            cout << "\n";
        }
    }
}