#include <bits/stdc++.h>
using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define dbg(x) cout << #x << " = " << x << '\n';
#define SOLVE int t; cin >> t; while(t--) solve()
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve(){
    int n, m; cin >> n >> m;
    vector<vi> a(m), b(n);
    FOR(i, 0, m){
        int k; cin >> k;
        FOR(j, 0, k){
            int x; cin >> x;
            x--;
            a[i].push_back(x);
            b[x].push_back(i);
        }
    }
    int z = (m + 1) / 2;
    vi c(m, -1), d(n, 0);
    vi p(n);
    iota(all(p), 0);
    sort(all(p), [&](int lhs, int rhs){
        return sz(b[lhs]) < sz(b[rhs]);
    });
    FOR(i, 0, n){
        sort(all(b[i]), [&](int lhs, int rhs){
            return sz(a[lhs]) < sz(a[rhs]);
        });
    }
    for(int i : p){
        for(int j : b[i]){
            if(c[j] == -1){
                c[j] = i;
                d[i]++;
            }else if(d[c[j]] > z){
                d[c[j]]--;
                c[j] = i;
                d[i]++;
            }
        }
    }
    if(*max_element(all(d)) > z){
        cout << "NO\n";
    }else{
        cout << "YES\n";
        for(int i : c){
            cout << i + 1 << ' ';
        }
        cout << '\n';
    }
}

int main(){
    #ifndef LOCAL
    ios::sync_with_stdio(false); cin.tie(nullptr);
    #endif
    SOLVE;
    // solve();
}
