#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
using namespace std;
#define int long long
#define ii pair <int, int> 
#define ll long long
#define vi vector <int>
#define debug(x) cerr << #x << ": " << x << endl;
#define mp make_pair
void ckmin(int &a, int b) { a = min(a, b); }
void ckmax(int &a, int b) { a = max(a, b); }
int gcd(int a, int b) {
    while (b) {
        int t = a%b;
        a = b;
        b = t;
    }
    return a;
}
signed main() {
    #ifdef LOCAL
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #define endl '\n'
    #endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;

        vector <vi> can(m + 1);
        vector <int> cnt(n + 1);

        vi ans(m + 1);

        for (int i = 1; i <= m; ++i) {
            int sz;
            cin >> sz;
            can[i].resize(sz);
            for (int j = 0; j < sz; ++j)
                cin >> can[i][j];
            cnt[can[i][0]]++;
            ans[i] = can[i][0];
        }

        int up = (m + 1) / 2;

        int fat = -1;
        for (int i = 1; i <= n; ++i) {
            if (cnt[i] > up) {
                fat = i;
                break;
            }
        }

        if (fat != -1) {
            for (int i = 1; i <= m && cnt[fat] > up; ++i) {
                if (ans[i] == fat && can[i].size() > 1) {
                    ans[i] = can[i][1];
                    cnt[fat]--;
                }
            }
        }

        if (fat != -1 && cnt[fat] > up) {
            cout << "NO" << endl;
        }
        else {
            cout << "YES" << endl;
            for (int i = 1; i <= m; ++i) {
                cout << ans[i] << ' ';
            }
            cout << endl;
        }
    }
}