#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 500010;
const int MOD = 1000000007;

int cnt[N];

signed main() {
	
	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int t;

	cin >> t;

	while (t--) {
		int n, m;
		cin >> n >> m;
		fill(cnt, cnt + n + 1, 0);
		vector < int > res(m);
		vector < vector < int > > zp(m);
		for (int i = 0; i < m; ++i) {

			int k;
			cin >> k;
			zp[i].resize(k);
			for (int j = 0; j < k; ++j) {
				int f;
				cin >> f;
				zp[i][j] = f;
				
			}
			if (k == 1) {
				res[i] = zp[i][0];
				cnt[zp[i][0]]++;
			}
		}
		for (int i = 0; i < m; ++i) {
			int k = zp[i].size();
			if (k == 1)
				continue;
			pair < int, int > Min = { MOD, MOD };
			for (int j = 0; j < k; ++j) {
				int f = zp[i][j];
				Min = min(Min, { cnt[f], f });
			}
			res[i] = Min.second;
			cnt[Min.second]++;
		}
		bool ok = true;
		for (int i = 1; i <= n; ++i) {
			if (cnt[i] > (m + 1) / 2) {
				ok = false;
			}
		}
		if (ok) {
			cout << "YES\n";
			for (int j : res)
				cout << j << ' ';
			cout << '\n';
		}
		else {
			cout << "NO\n";
		}
	}
}