#include <bits/stdc++.h>

using namespace std;

#define int long long


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;

	for(int i = 0; i < t; i++) {
		int n, m;
		cin >> n >> m;

		vector< vector<int> > a(m);
		for(int j = 0; j < m; j++) {
			int k;
			cin >> k;
			a[j].resize(k);
			for(int jj = 0; jj < k; jj++) {
				cin >> a[j][jj];
				a[j][jj]--;
			}
		}

		vector<int> ans(m);
		for(int j = 0; j < m; j++) {
			ans[j] = a[j][0];
		}

		vector< vector<int> > day_by_person(n);
		for(int j = 0; j < m; j++) {
			day_by_person[ans[j]].push_back(j);
		}

		bool ok = true;
		for(int j = 0; j < n; j++) {
			if(day_by_person[j].size() > (m + 1) / 2) {
				int cnt = day_by_person[j].size();
				for(int jj = 0; jj < day_by_person[j].size() && cnt > (m + 1) / 2; jj++) {
					int day = day_by_person[j][jj];
					if(a[day].size() >= 2) {
						ans[day] = a[day][0] == j ? a[day][1] : a[day][0];
						cnt--;
					}
				}
				if(cnt > (m + 1) / 2) {
					ok = false;
					break;
				}
			}
		}

		if(ok) {
			cout << "YES\n";
			for(int x: ans) {
				cout << x + 1 << " ";
			}
			cout << "\n";
		} else {
			cout << "NO\n";
		}
	}

	return 0;
}