#include<bits/stdc++.h>

using namespace std;
#define int ll
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

void solve();

signed main() {
#ifdef STRONG
    freopen("a.in", "r", stdin);
#endif

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        solve();
        cout << '\n';
    }
}

#define fi first
#define se second

bool comp(const pair<int, unordered_set<int>>& a, const pair<int, unordered_set<int>>& b) {
    return a.se.size() < b.se.size();
}

void solve() {
    int fr, days;
    cin >> fr >> days;
    int imax = (days + 1) / 2;

    vector<pair<int, unordered_set<int>>> v(days);
    vi out(days), c(fr + 1);

    for (int i = 0; i < days; ++i) {
        v[i].first = i;
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            v[i].se.insert(x);
        }
    }
    sort(v.begin(), v.end(), comp);

    bool ok = true;

    for (int i = 0; i < days; ++i) {
        unordered_set<int>& now = v[i].se;
        bool yes = false;
        for (int val : now) {
            if (c[val] < imax) {
                c[val]++;
                out[v[i].fi] = val;
                yes = true;
                break;
            }
        }
        if (!yes) {
            ok = false;
            break;
        }
    }

    if (!ok) {
        cout << "NO";
        return;
    } else {
        cout << "YES\n";
    }
    for (int i = 0; i < days; ++i) {
        cout << out[i] << ' ';
    }
}