#include <iostream>
#include <vector>
#include <cmath>
#define int long long
#define pb push_back;

using namespace std;

int mod(int x, int m)
{
    int ans = x % m;
    if (ans < 0)
    {
        ans += m;
    }
    return ans;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector <vector <int> > fr;
    vector <int> no_var(n + 1, 0);
    for (int i = 0; i < m; i++)
    {
        vector <int> temp;
        fr.push_back(temp);
        int k = 0;
        cin >> k;
        for (int j = 0; j < k; j++)
        {
            int f;
            cin >> f;
            fr[i].push_back(f);
        }
        if (k == 1)
        {
            no_var[fr[i][0]]++;
        }
    }
    int mx = m / 2 + m % 2;
    for (auto x : no_var)
    {
        if (x > mx)
        {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    for (int i = 0; i < m; i++)
    {
        if (fr[i].size() == 1)
        {
            cout << fr[i][0] << " ";
            continue;
        }
        for (int j = 0; j < fr[i].size(); j++)
        {
            if (no_var[fr[i][j]] != mx)
            {
                no_var[fr[i][j]]++;
                cout << fr[i][j] << " ";
                break;
            }
        }
    }
    cout << endl;
}

int32_t main()
{
    int t;
    cin >> t;
    for (int k = 0; k < t; k++)
    {
        solve();
    }
    return 0;
}
/*
2
2 6
1 1
1 1
1 1
2 1 2
2 1 2
2 1 2
2 6
1 1
1 1
1 1
1 1
2 1 2
2 1 2
*/
