#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <time.h>

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define pb push_back
#define forin for(int i = 0; i < n; ++i)

const bool is_debug = true;
#define debug(x) if(is_debug) cout << x << '\n'

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<class T>
ostream& operator << (ostream &a, vector<T> x) {
    for(auto element: x) {
        a << element << ' ';
    }
    return a;
}

template<class T>
istream& operator >> (istream &a, vector<T> x) {
    for(auto &element: x) {
        a >> x;
    }
    return a;
}

mt19937 rnd(time(0));

signed main() {
    int t;
    cin >> t;
    for(int q = 0; q < t; ++q) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> a(m);
        vector<int> cnt(n, 0);
        for(int i = 0; i < m; ++i) {
            int k;
            cin >> k;
            a[i].resize(k);
            for(int j = 0; j < k; ++j) {
                cin >> a[i][j]; --a[i][j];
                cnt[a[i][j]] ++;
            }
        }
        //cout << "nice\n";
        int maxcnt = 0;
        for(int i = 0; i < n; ++i) maxcnt = max(maxcnt, cnt[i]);
        int k = (m / 2) + (m % 2);
        if(maxcnt <= k) {
            cout << "YES\n";
            for(int i = 0; i < m; ++i) cout << a[i][0] + 1 << ' ';
            cout << '\n';
            continue;
        }
        int s;
        for(int i = 0; i < n; ++i) {
            if(cnt[i] == maxcnt) {
                s = i;
                break;
            }
        }



        vector<int> ans(m, -1);
        int count = 0;
        for(int i = 0; i < m; ++i) {
            if(a[i][0] == s && a[i].size() == 1) {
                ans[i] = s;
                count++;
            }
        }
        if(count > k) {
            cout << "NO\n";
            continue;
        }

        for(int i = 0; i < m; ++i) {
            if(ans[i] != -1) continue;
            int p = -1, q;
            for(auto x: a[i]) {
                if(x == s) {
                    p = s;
                }else{
                    q = x;
                }
            }
            if(p == -1) {
                ans[i] = q;
            }else if(count < k) {
                ans[i] = s;
                count ++;
            }else{
                ans[i] = q;
            }
        }

        cout << "YES\n";
        for(int i = 0; i < m; ++i) cout << ans[i] + 1 << ' ';
        cout << '\n';
    }
    return 0;
}
