#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree <
int,
null_type,
less<int>, 
rb_tree_tag,
tree_order_statistics_node_update> orset;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	
	int t;
	cin >> t;
	
	while(t--) {
		int n, m;
		cin >> n >> m;
		int lim = m/2+1;
		if(m%2) lim++;
				
		vector<int> stcnt(n+1);
		vector<int> cnt(n+1, lim-1);
		vector<int> ans(m, -1);
		vector<vector<int> > days(n+1);
		vector<vector<int> > a(m);
		
		for(int i = 0; i < m; i++) {
			int sz;
			cin >> sz;
			for(int j = 0; j < sz; j++) {
				int x;
				cin >> x;
				days[x].push_back(i);
				stcnt[x]++;
				a[i].push_back(x);
			}	
		}
		
	
		for(int i = 0; i < m; i++) {
			if(a[i].size() == 1) {
				cnt[a[i][0]]--;
				ans[i] = a[i][0];
			}
		}
		
		for(int i = 1; i <= n; i++) {
			if(stcnt[i] >= lim) continue;
			for(int j = 0; j < days[i].size(); j++) {
				ans[days[i][j]] = i;
			}
		}
		
		
		for(int i = 1; i <= n; i++) {
			if(stcnt[i] < lim) continue;
			for(int j = 0; j < days[i].size(); j++) {
				if(cnt[i] > 0 && ans[days[i][j]] == -1) {
					cnt[i]--; ans[days[i][j]] = i;
				}
			}
		}
		
		bool flag = true;
		for(int i = 0; i < m; i++) {
			if(ans[i] == -1) flag = false;
		}
		for(int i = 1; i <= n; i++) if(cnt[i] < 0) flag = false;
		
		if(!flag) cout << "NO" << "\n";
		else {
			cout << "YES" << "\n";
			for(int i = 0; i < m; i++) cout << ans[i] << " ";
			cout << "\n";
		}
	}
}
