#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;


typedef int32_t Index;
typedef int32_t Count;

#define for_range(i, n) for (Index (i) = 0; (i) < (n); (i)++)

typedef Index Friend;


int32_t main() {
    Count t_n;
    cin >> t_n;
    for_range(i_t, t_n) {
        Count friends_n, m;
        cin >> friends_n >> m;
        Count max_usages_n = (m + 1) / 2;
        vector< vector<Friend> > friends_by_days;
        vector<Count> friend_used_ns(friends_n, 0);
        vector<Friend> answer(m, -1);
        
        for_range(i_m, m) {
            Count k;
            cin >> k;
            friends_by_days.push_back({});
            for_range(i_k, k) {
                Friend x;
                cin >> x;
                x -= 1;
                friends_by_days[friends_by_days.size()-1].push_back(x);
                if (k == 1) {
                    answer[i_m] = x;
                    friend_used_ns[x] += 1;
                }
            }
        }
        
        for_range(day, m) {
            if (answer[day] == -1) {
                Friend selected_friend = friends_by_days[day][0];
                if (friend_used_ns[selected_friend] + 1 > max_usages_n) {
                    selected_friend = friends_by_days[day][1];
                }
                answer[day] = selected_friend;
                friend_used_ns[selected_friend] += 1;
            }
        }
        
        bool can = true;
        for (auto n : friend_used_ns) {
            if (n > max_usages_n) {
                can = false;
                break;
            }
        }
        
        if (can) {
            cout << "YES" << endl;
            for_range(day, answer.size()) {
                cout << answer[day]+1;
                if (day != answer.size() - 1) {
                    cout << " ";
                }
            }
            cout << endl;
        }
        else {
            cout << "NO" << endl;
        }
    }
    return 0;
}
