#include <iostream>
#include <vector>
#include <cmath>
#include <set>
//#include <ext/pb_ds/assoc_container.hpp>

//using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define x first
#define y second

typedef pair <int, int> pii;
//typedef tree <int, null_type, less <>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

void solve()
{
    int n, m;
    cin >> n >> m;
    int ma = (m + 1) / 2;
    vector <int> ans(m);
    vector <vector <int>> days(n + 1);
    vector <int> has(n + 1);
    vector <int> really_has(n + 1);
    set <pii> amount;
    for (int i = 0; i < m; ++i)
    {
        int k;
        cin >> k;
        if (k == 1)
        {
            int tmp;
            cin >> tmp;
            ++has[tmp];
            ++really_has[tmp];
            ans[i] = tmp;
        }
        else
        {
            for (int j = 0; j < k; ++j)
            {
                int tmp;
                cin >> tmp;
                days[tmp].push_back(i);
                ++has[tmp];
            }
        }
    }
    for (int i = 1; i <= n; ++i)
        amount.insert({has[i], i});
    for (int i = 0; i < n; ++i)
    {
        if (amount.begin() -> x == 0)
        {
            amount.erase(amount.begin());
            continue;
        }
        int dude = amount.begin() -> y;
        for (int day : days[dude])
        {
            if (really_has[dude] == ma)
                break;
            if (ans[day])
                continue;
            ans[day] = dude;
            ++really_has[dude];
        }
        amount.erase(amount.begin());
    }
    for (int i = 1; i <= n; ++i)
    {
        if (really_has[i] > ma)
        {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < m; ++i)
        if (!ans[i])
        {
            cout << "NO\n";
            return;
        }
    cout << "YES\n";
    for (int i = 0; i < m; ++i)
        cout << ans[i] << ' ';
    cout << endl;

}

int32_t main()
{
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_)
        solve();
    return 0;
}