#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <map>
// @princebelkovetz
// plz god help me D:
using namespace std;
#define int long long
#define ld long double
#define debug(x) cout << #x << " is " << x << '\n';
struct segtree {
	int size;
	vector <int> tree;
	segtree(int n) {
		size = 1;
		while (size < n) size *= 2;
		tree.resize(2 * size - 1);
	}
	int get(int v, int lx, int rx, int l, int r) {
		if (l <= lx and rx <= r) return tree[v];
		if (rx <= l or r <= lx) return 0;
		int m = (lx + rx) / 2;
		int s1 = get(2 * v + 1, lx, m, l, r);
		int s2 = get(2 * v + 2, m, rx, l, r);
		return s1 + s2;
	}
	int get(int l, int r) {
		return get(0, 0, size, l, r);
	}
	void upd(int v, int lx, int rx, int i, int x) {
		if (lx + 1 == rx) {
			tree[v] = x;
			return;
		}
		int m = (lx + rx) / 2;
		if (i < m) upd(2 * v + 1, lx, m, i, x);
		else upd(2 * v + 2, m, rx, i, x);
		tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
	}
	void upd(int i, int x) {
		upd(0, 0, size, i, x);
	}
};
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);
	int tt; cin >> tt;
	while (tt --> 0) {
		int n, m; cin >> n >> m;
		vector <vector <int>> a(m);
		for (auto& x : a) {
			int k; cin >> k;
			x.resize(k);
			for (auto& y : x) cin >> y;
		}
		vector <int> ans(m);
		map <int, int> cnt;
		int mx = (m + 1) / 2 + 1;
		bool c = true;
		for (int i = 0; i < m; ++i) {
			if (a[i].size() == 1) {
				ans[i] = a[i][0];
				cnt[a[i][0]]++;
				if (cnt[a[i][0]] >= mx)
					c = false;
			}
		}
		if (c) {
			cout << "YES\n";
			for (int i = 0; i < m; ++i) {
				if (ans[i]) cout << ans[i] << ' ';
				else {
					for (auto x : a[i]) {
						if (cnt[x] + 1 < mx) {
							cout << x << ' ';
							cnt[x]++;
							break;
						}
					}
				}
			}
			cout << '\n';
		}
		else cout << "NO\n";
	}
}