#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <map>
#include <iomanip>
#include <queue>

#define int long long

using namespace std;

int gcd(int a, int b){
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

signed main(){
    int t;
    cin >> t;
    while (t--){
        int n, m;
        cin >> n >> m;
        vector<vector<int>> v(m);
        vector<int> cnt(n);
        vector<vector<int>> d(n);
        vector<vector<int>> da(n);
        for (int i = 0; i < m; ++i){
            int k;
            cin >> k;
            v[i].resize(k);
            for (int j = 0; j < k; ++j){
                cin >> v[i][j];
                v[i][j]--;
                d[v[i][j]].push_back(i);
                if (k == 1){
                    cnt[v[i][j]]++;
                    da[v[i][j]].push_back(i);
                }
            }
        }
        bool no = false;
        for (int i = 0; i < n; ++i){
            if (da[i].size() > ((m + 1) / 2)){
                cout << "NO\n";
                no = true;
                break;
            }
        }
        if (no){
            continue;
        }
        vector<int> ans(m, -1);
        for (int i = 0; i < n; ++i){
            for (int day : da[i]){
                ans[day] = i;
            }
        }
        for (int i = 0; i < m; ++i){
            if (ans[i] == -1){
                if (cnt[v[i][0]] < ((m + 1) / 2)){
                    cnt[v[i][0]]++;
                    ans[i] = v[i][0];
                } else {
                    cnt[v[i][1]]++;
                    ans[i] = v[i][1];
                }
            }
        }
        cout << "YES\n";
        for (int i = 0; i < m; ++i){
            cout << ans[i] + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}
