#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

const int INF = 1e9 + 13;
const int M = 1e9 + 7;
const int N = 1e5 + 13;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(m);
    vector<int> ans(m, -1), cnt(n, 0);
    for(int i = 0; i < m; i++) {
        int k;
        cin >> k;

        a[i].resize(k);
        for(int j = 0; j < k; j++) {
            cin >> a[i][j];
            a[i][j]--;
        }

        if(k == 1) {
            ans[i] = a[i][0];
            cnt[a[i][0]]++;
        }
    }



    for(int i = 0; i < m; i++) {
        if(ans[i] == -1) {
            int x = a[i][0], y = a[i][1];
            if(cnt[x] < cnt[y]) {
                cnt[x]++;
                ans[i] = x;
            } else {
                cnt[y]++;
                ans[i] = y;
            }
        }
    }

    int mx = 0;
    for(int i = 0; i < n; i++) {
        mx = max(mx, cnt[i]);
    }

    if(mx > (m + 1) / 2) {
        cout << "NO" << '\n';
    } else {
        cout << "YES" << '\n';
        for(int i = 0; i < m; i++) {
            cout << ans[i] + 1 << ' ';
        }
        cout << '\n';
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;

    while(t--)
        solve();
}
