#include <bits/stdc++.h>
#define fr first
#define sc second
using namespace std;

typedef long long ll;
typedef pair<int,int> pii;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int>> days(n+1);
    vector<int> p(n), ans(m+1), cnt(m+1);
    iota(p.begin(), p.end(), 1);
    for (int i = 1, k, f; i <= m; ++i) {
        cin >> k;
        while (k--) {
            cin >> f;
            days[f].push_back(i);
            cnt[i]++;
        }
    }
    sort(p.begin(), p.end(), [&](int a, int b){return days[a].size() < days[b].size();});
    int lim = (m + 1) / 2;
    for (int x: p) {
        vector<int> ds;
        for (int i: days[x]) {
            if (ans[i] == 0)
                ds.push_back(i);
        }
        sort(ds.begin(), ds.end(), [&](int a, int b){return cnt[a] < cnt[b];});
        for (int i = 0; i < int(ds.size()); ++i) {
            cnt[ds[i]]--;
            if (i < lim)
                ans[ds[i]] = x;
        }
    }
    for (int i = 1; i <= m; ++i) {
        if (ans[i] == 0) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    for (int i = 1; i <= m; ++i)
        cout << ans[i] << " ";
    cout << "\n";
}

int main()
{
    #ifdef LOCAL_RUN
        freopen("input.txt", "r", stdin);
    #else
        ios::sync_with_stdio(false);
        cin.tie(0);
    #endif

    int q;
    cin >> q;
    while (q--)
        solve();

    return 0;
}
