#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <vector>

#define int long long
#define f first
#define s second
#define pb push_back
#define pii pair <int, int>

using namespace std;

const int N = 1e6 + 5;
const int INF = 1e18 + 7;

map <int, int> cnt;
vector <int> v[N];
pii a[N];
int ans[N];

bool cmp (pii a, pii b){
    return a.f < b.f;
}

signed main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    int t;
    cin >> t;
    while (t--){
        cnt.clear();

        int n, m;
        bool f = true;
        cin >> n >> m;

        for (int i = 0; i < m; i++){
            int k;
            cin >> k;

            for (int j = 0; j < k; j++){
                int x;
                cin >> x;
                v[i].pb(x);
            }

            a[i] = {k, i};
        }

        sort(a, a + m, cmp);

        for (int i = 0; i < m; i++){
            int pos = a[i].s, num = -1;
            for (int j = 0; j < a[i].f; j++){
                if (num == -1)
                    num = v[pos][j];
                else
                    if (cnt[num] > cnt[v[pos][j]])
                        num = v[pos][j];
            }

            if (cnt[num] + 1 > m / 2 + m % 2){
                f = false;
                break;
            }
            cnt[num]++;
            ans[pos] = num;
        }

        if (!f)
            cout << "NO\n";
        else{
            cout << "YES\n";
            for (int i = 0; i < m; i++)
                cout << ans[i] << ' ';
            cout << '\n';
        }
        
        for (int i = 0; i < m; i++){
            v[i].clear();
            ans[i] = 0;
            a[i].f = a[i].s = 0;
        }
    }
    return 0;
}