#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long
const int SZ = 1e5 + 4;

int n, m;
set<int> a[SZ];

void read() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        a[i].clear();
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            --x;
            a[i].insert(x);
        }
    }
}

void solve() {
    vector<vector<int>> cnt(n);
    vector<vector<int>> cnt2(n);
    for (int i = 0; i < m; ++i) {
        for (int x : a[i]) {
            cnt[x].push_back(i);
            if (a[i].size() == 1) {
                cnt2[x].push_back(i);
            }
        }
    }

    int kek = -1;
    for (int i = 0; i < n; ++i) {
        if (cnt2[i].size() > (m + 1) / 2) {
            cout << "NO\n";
            return;
        }
        if (kek == -1) {
            if (cnt[i].size() > (m + 1) / 2) {
                kek = i;
            }
        }
    }

    vector<int> ans(m, -1);
    if (kek != -1) {
        set<int> s;
        for (int x : cnt2[kek]) {
            ans[x] = kek;
            s.insert(x);
        }

        for (int x : cnt[kek]) {
            if (s.size() == (m + 1) / 2) break;
            ans[x] = kek;
            s.insert(x);
        }
    }

    for (int i = 0; i < m; ++i) {
        if (ans[i] == -1) {
            for (int x : a[i]) {
                if (x == kek) continue;
                ans[i] = x;
                break;
            }
        }
    }

    cout << "YES\n";
    for (int i : ans) {
        cout << i + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        read();
        solve();
    }

    return 0;
}