#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <ctime>
#include <climits>

using namespace std;

#pragma warning (disable : 4996)

bool cmp(pair<vector<int>, int> &a, pair<vector<int>, int> & b) {
    return a.first.size() < b.first.size();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> v(n, 0);
    vector<pair<vector<int>, int>> d(m);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        d[i].first.resize(k);
        d[i].second = i + 1;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            x--;
            d[i].first[j] = x;
            v[x]++;
        }
    }
    sort(d.begin(), d.end(), cmp);
    vector<int> ans(m);
    vector<int> used(n, 0);
    for (int i = 0; i < d.size(); i++) {
        for (int j : d[i].first) {
            if (used[j] < m / 2 + m % 2) {
                ans[d[i].second - 1] = j + 1;
                used[j]++;
                break;
            }
        }
        if (ans[d[i].second - 1] == 0) {
            cout << "NO";
            return;
        }
    }
    cout << "YES\n";
    for (int i : ans)
        cout << i << " ";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}