﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>


using namespace std;
#define int long long

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

	int tt;
	cin >> tt;
	while (tt--) {
		int n, m;
		cin >> n >> m;
		vector <vector <int>> v(m), p(n);
		vector <int> an(m, -1);
		for (int i = 0; i < m; i++)
		{
			int k;
			cin >> k;
			v[i].resize(k);
			for (int j = 0; j < k; j++)
			{
				cin >> v[i][j];
				v[i][j]--;
				p[v[i][j]].push_back(i);
			}
		}
		int ma = 0, big = 0;
		for (int i = 0; i < n; i++)
		{
			if (ma < (int)p[i].size()) big = i;
			ma = max(ma, (int)p[i].size());
		}
		bool f = true;
		multiset <int> st;
		for (int i = 0; i < min((m + 1) / 2, (int)p[big].size()); i++)
		{
			an[p[big][i]] = big + 1;
			st.insert(p[big][i]);
		}
		for (int i = 0; i < m; i++)
		{
			if (an[i] != -1) continue;
			if (v[i].size() == 0) {
				f = false;
				break;
			}
			else if (v[i].size() == 1 && v[i][0] == big) {
				int tmp = -1;
				while (st.size() > 0 && v[*st.begin()].size() == 1) {
					st.erase(st.begin());
				}
				if (st.size() == 0) {
					f = false;
					break;
				}
				int j = *st.begin();
				st.erase(st.begin());
				
				if (v[j][0] == big) an[j] = v[j][1] + 1;
				else an[j] = v[j][0] + 1;
				an[i] = big + 1;
				st.insert(i);
			}
			else {
				if (v[i][0] == big) an[i] = v[i][1] + 1;
				else an[i] = v[i][0] + 1;
			}
			
		}
		for (int i = 0; i < m; i++)
		{
			if (an[i] == -1) {
				f = false;
			}
		}
		if (!f) cout << "NO\n";
		else {
			cout << "YES\n";
			for (int i = 0; i < m; i++)
			{
				cout << an[i] << " ";
			}cout << "\n";
		}

	}

	return 0;
}