/*
 ''''' '  ' '''' '''' '''' '''' '''' ''''
   '   '  ' '       '    ' '  ' '       '
   '   '  ' '''' '''' '''' '''' '''' ''''
   '   '  ' '    '    '    '  ' '  ' '  '
   '   '''' '''' '''' '''' '''' '''' ''''
 */

#ifdef lolipop
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <cstddef>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <deque>
#include <utility>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld double
#define forn(i, x, n) for (int i = x; i < n; i++)

using namespace std;

inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define endl '\n'

/*
void upd(int id, int l, int r, int val, int i) {
    if (r-l == 1) {
        ++a[id];
        return;
    }
    int m = (l+r)/2;
    if (i < m) upd(id*2+1, l, m, val, i); else upd(id*2+2, m, r, val, i);
    a[id] = min(a[id*2+1], a[id*2+2]);
}

int get_min(int id, int l, int r) {
    if (r-l == 1) return l;
    int m = (l+r)/2;
    if (a[id*2+1] < a[id*2+2]) return get_min(id*2+1, l, m); else return get_min(id*2+2, m, r);
}
*/
void solve() {
    int n, m;
    cin >> n >> m;
    vector <int> a;
    a.assign(n, 0);
    vector <vector <int> > b(m);
    vector <int> ans(m);
    vector <int> c;
    c.assign(n, 0);
    bool t = true;
    forn (i, 0, m) {
        int k;
        cin >> k;
        forn (j, 0, k) {
            int x;
            cin >> x;
            b[i].push_back(x-1);
            ++a[x-1];
        }
        if (k == 1) {
            ans[i] = b[i][0];
            ++c[b[i][0]];
            if (c[b[i][0]] > (m+1)/2) t = false;
            --a[b[i][0]];
        }
    }
    forn (i, 0, m) {
        if (b[i].size() == 1) continue;
        if (c[b[i][0]] + 1 > (m+1)/2) {
            ans[i] = b[i][1];
            ++c[b[i][1]];
        } else {
            ans[i] = b[i][0];
            ++c[b[i][0]];
        }
    }

    if (t) {
        cout << "YES\n";
        forn (i, 0, m) {
            cout << ans[i]+1 << " ";
        }
        cout << "\n";
    } else cout << "NO\n";
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}