#include <bits/stdc++.h>

#ifndef KEK
    #pragma GCC optimize("Ofast")
#endif

using namespace std;

#define int long long
int n, m, k;

void solve() {
    cin >> n >> m;
    vector <pair <int, int>> a;
    vector <vector <int>> d(m + 1);
    vector <int> kd(n + 10);

    for (int i = 0; i < m; ++i) {
        int cnt;
        cin >> cnt;
        a.push_back({cnt, i});

        while (cnt--) {
            int val;
            cin >> val;
            d[i].push_back(val);
        }
    }

    sort(a.begin(), a.end());
    vector <int> ans(m);

    for (auto &i : a) {
        bool good = false;

        for (auto &j : d[i.second]) {
            if (kd[j] < (m + 1) / 2) {
                ans[i.second] = j;
                kd[j]++;
                good = true;
                break;
            }
        }

        if (!good) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    for (auto &i : ans) {
        cout << i << ' ';
    }
    cout << '\n';
}

void files() {
#ifdef KEK
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    files();
    fastio();
    int qq = 1;
    cin >> qq;
    while (qq--) {
        solve();
    }
}