#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <stack>
#include <queue>
#include <deque>
using namespace std;
#define int long long

vector <int> divisors(int n) {
    vector <int> ans;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            ans.push_back(i);
            ans.push_back(n / i);
        }
    }
    sort(ans.rbegin(), ans.rend());
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <int> whotaken(m), cnt(n);
    vector <vector <int>> w(m);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        w[i].resize(k);
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            --x;
            w[i][j] = x;
        }
    }
    for (int i = 0; i < m; ++i) {
        ++cnt[w[i][0]];
        whotaken[i] = w[i][0];
    }
    int mx = -1;
    for (int i = 0; i < n; ++i) {
        if (cnt[i] > (m + 1) / 2) {
            mx = i;
        }
    }
    if (mx == -1) {
        cout << "YES\n";
        for (int i = 0; i < m; ++i) {
            cout << whotaken[i] + 1 << " ";
        }
        cout << "\n";
    } else {
        for (int i = 0; i < m; ++i) {
            if (w[i].size() != 1 && cnt[mx] > (m + 1) / 2 && w[i][0] == mx) {
                --cnt[mx];
                ++cnt[w[i][1]];
                whotaken[i] = w[i][1];
            }
        }
        mx = -1;
        for (int i = 0; i < n; ++i) {
            if (cnt[i] > (m + 1) / 2) {
                mx = i;
            }
        }
        if (mx == -1) {
            cout << "YES\n";
            for (int i = 0; i < m; ++i) {
                cout << whotaken[i] + 1 << " ";
            }
            cout << "\n";
        } else {
            cout << "NO\n";
        }
    }
}

int32_t main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int test = 1;
    cin >> test;
    while (test--) {
        solve();
        cout << "\n";
    }
}