#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <stdio.h>
#include <queue>
#include <iomanip>

#define f first
#define s second
#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

int MN = 100000007;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int w = 0; w < t; w++)
    {
        int n, m;
        cin >> n >> m;
        vector <vector <int > > v;
        v.resize(m);
        for (int i = 0; i < m; i++)
        {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++)
            {
                int x;
                cin >> x;
                v[i].pb(x - 1);
            }
        }
        int cnt[n], used[m];
        set <pair<int, int> > st;
        for (int i = 0; i < n; i++){
            cnt[i] = 0;
        }
        for (int i = 0; i < m; i++){
            used[i] = -1;
            st.insert(mp(v[i].size(), i));
        }
        set<pair<int, int> > :: iterator i = st.begin();
        int err = 0;
        for (; i != st.end(); i++)
        {
            int mn = cnt[v[i->s][0]], cur = v[i->s][0];
            for (int j = 1; j < v[i->s].size(); j++)
                if (cnt[v[i->s][j]] < mn)
                {
                    mn = cnt[v[i->s][j]];
                    cur = v[i->s][j];
                }
            cnt[cur]++;
            if (cnt[cur] > (m / 2 + m % 2))
            {
                err++;
                break;
            }
            used[i->s] = cur;
        }
        if (err)
        {
            cout << "NO" << endl;
        }
        else
        {
            cout << "YES" << endl;
            for (int i = 0; i < m; i++)
                cout << used[i] + 1 << ' ';
            cout << endl;
        }
    }
    return 0;
}
