#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <iomanip>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int gcd(int a, int b) {
	if (!b)
		return a;
	return gcd(b, a % b);
}

void solve() {

	int n;
	cin >> n;
	vi a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vi next(n);
	for (int i = 0; i < n; ++i)
		next[i] = i + 1;
	next[n - 1] = 0;
	set<int> s;
	for (int i = 0; i < n; ++i) {
		if (gcd(a[next[i]], a[i]) == 1)
			s.insert(i);
	}
	int cur = 0;
	vi d;
	vc used(n);
	while (!s.empty()) {
		auto it = s.lower_bound(cur);
		if (it == s.end())
			it = s.begin();
		cur = *it;
		d.push_back(next[cur] + 1);
		s.erase(next[cur]);
		s.erase(cur);
		used[next[cur]] = 1;
		next[cur] = next[next[cur]];
		if (!used[cur] && gcd(a[next[cur]], a[cur]) == 1)
			s.insert(cur);
		cur = next[cur];
	}
	cout << d.size() << ' ';
	for (int i = 0; i < d.size(); ++i)
		cout << d[i] << ' ';
	cout << endl;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();

	return 0;
}