#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <algorithm>
#include <stack>
#include <map>
#include <string>
#include <ctime>
#include <queue>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

int inf = 1e9 + 7;

int gcd(int a, int b){
    if (b == 0){
        return a;
    }
    return gcd(b, a % b);
}

struct point{
    int i, j;
};

int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    /*
    cout.setf(ios::fixed);
    cout.precision(10);
    */
    int t = 1;
    cin >> t;
    for (int ctr = 0 ;ctr < t; ctr++){
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; i++){
            cin >> a[i];
        }
        queue<point> q;
        point p;
        vector<int> left(n);
        vector<int> right(n);
        for (int i = 0; i <n; i++){
            right[i] = (i + 1) % n;
            left[i] = (i - 1 + n) % n;
        }
        for (int i = 0; i < n; i++){

            if (i == n - 1){
                if (gcd(a[i], a[0]) == 1){
                    p.i = i;
                    p.j = 0;
                    q.push(p);
                    i++;
                }
                continue;
            }
            if (gcd(a[i], a[i + 1]) == 1){
                p.i = i;
                p.j = i + 1;
                //cout << a[i] << ' ' << a[i + 1] << "!!!" << endl;
                q.push(p);
                i++;
            }
        }
        vector<int> ans;
        vector<bool> used(n);
        while (!q.empty()){
            auto now = q.front();
            q.pop();

            if (used[now.i]){
                continue;
            }
            used[now.j] = 1;

            ans.push_back(now.j);
            right[now.i] = right[now.j];
            left[right[now.j]] = now.i;
            if (gcd(a[now.i], a[right[now.i]])  == 1){
                p.i = now.i;
                p.j = right[now.i];
                q.push(p);
            }
        }
        cout  << ans.size() << ' ';
        for (int i = 0; i < ans.size(); i++){
            cout << ans[i] + 1 << ' ';
        }
        cout << endl;
    }

    return 0;
}
