#include <bits/stdc++.h>

using namespace std;

#define rank poggers

int parent[100000 + 100], rank[100000 + 10];

int getId(int v) {
    if (parent[v] == v) {
        return v;
    }
    return parent[v] = getId(parent[v]);
}

void mergeSet(int u, int v) {
    v = getId(v), u = getId(u);
    if (u == v) {
        return;
    }
    parent[v] = u;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        iota(parent, parent + n + 10, 0);
        int a[n];
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        int nextNd[n], id[n], gHead[n];
        for (int i = 0; i < n; i++) {
            nextNd[i] = (i + 1) % n;
            id[i] = i;
            gHead[i] = i;
        }
        vector<int> ans;
        int ind = 0;
        while (true) {
            if (getId(ind) == getId(nextNd[ind])) {
                ind = gHead[getId(ind)];
            }
            int nxt = nextNd[ind];
            if (__gcd(a[ind], a[nxt]) == 1) {
                ans.push_back(nxt);
                if (nxt == ind) {
                    break;
                }
                nextNd[ind] = nextNd[nxt];
                ind = nextNd[ind];
            } else {
                if (getId(ind) == getId(nxt) && ind == gHead[getId(nxt)]) {
                    break;
                }
                mergeSet(nxt, ind);
                ind = gHead[getId(ind)];
            }
        }
        cout << ans.size() << " ";
        for (auto x : ans) {
            cout << x + 1 << " ";
        }
        cout << "\n";
    }
}
