#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <random>
#include <chrono>
#define int long long
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define put(a) cout << (a) << "\n"
#define rep(a, b, c) for (int a = b; a < c; ++a)
#define asd(n) rep(i, 0, n)
#define jkl(n) rep(j, 0, n)
#define len(a) ((int)(a).size())
#define mp make_pair
#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...) 
#endif
inline bool chkmax(int &a, int b) {
	if (a < b) {
		a = b;;
		return true;
	}
	return false;
}
inline bool chkmin(int &a, int b) {
	if (a > b) {
		a = b;;
		return true;
	}
	return false;
}
mt19937 rng;
inline int gcd(int a, int b) {
	return (b ? gcd(b, a % b) : a);
}
const int N = 1e5 + 2;
const int INF = 1e9;
int a[N];
struct node {
	int pr;
	int sz;
	int l, r;
	int x, y;
	int min1;
	node(int x, int y) : pr(rng()), sz(1), l(0), r(0), x(x), y(y) {
		if (gcd(a[x], a[y]) == 1) {
			min1 = 0;
		} else {
			min1 = INF;
		}
	}
};
vector<node> nds;
int add_node(int x, int y) {
	nds.pb(node(x, y));
	return len(nds) - 1;
}
int get_sz(int x) {
	return (x ? nds[x].sz : 0);
}
int get_min(int v) {
	return (v ? nds[v].min1 : INF);
}
void recalc(int v) {
	nds[v].sz = get_sz(nds[v].l) + get_sz(nds[v].r) + 1;
	nds[v].min1 = get_min(nds[v].l);
	if (gcd(a[nds[v].x], a[nds[v].y]) == 1) chkmin(nds[v].min1, get_sz(nds[v].l));
	chkmin(nds[v].min1, get_sz(nds[v].l) + 1 + get_min(nds[v].r));
}
pii split(int r, int x) {
	if (!r) return {0, 0};
	if (get_sz(nds[r].l) >= x) {
		auto t = split(nds[r].l, x);
		nds[r].l = t.second;
		recalc(r);
		return {t.first, r};
	}
	auto t = split(nds[r].r, x - get_sz(nds[r].l) - 1);
	nds[r].r = t.first;
	recalc(r);
	return {r, t.second};
}
int merge(int l, int r) {
	if (!l) return r;
	if (!r) return l;
	if (nds[l].pr > nds[r].pr) {
		nds[l].r = merge(nds[l].r, r);
		recalc(l);
		return l;
	}
	nds[r].l = merge(l, nds[r].l);
	recalc(r);
	return r;
}
void rotate(int &root, int x) {
	pii t = split(root, x);
	root = merge(t.second, t.first);
}
void print(int root) {
	// if (!root) return;
	// print(nds[root].l);
	// cout << nds[root].x << " " << nds[root].y << " " << nds[root].min1 << "\n";
	// print(nds[root].r);
}
void solve() {
	nds.clear();
	int n;
	cin >> n;
	asd(n) cin >> a[i];
	add_node(0, 0);
	int root = 0;
	asd(n) {
		root = merge(root, add_node(i, (i + 1) % n));
	}
	vi ans;
	while (root && nds[root].min1 < n) {
		dbg(nds[root].min1);
		int x = nds[root].min1;
		rotate(root, x);
		dbg(get_sz(root));
		if (get_sz(root) > 1) {
			pii t = split(root, 2);
			// print(t.first);
			// put("");
			pii t2 = split(t.first, 1);
			dbg(nds[t2.second].x, nds[t2.second].y);
			ans.eb(nds[t2.first].y);
			int cur = add_node(nds[t2.first].x, nds[t2.second].y);
			root = merge(cur, t.second);
			rotate(root, 1);

		} else {
			ans.eb(nds[root].y);
			break;
		}
		print(root);
			put("");
	}
	cout << len(ans) << " ";
	for (int x : ans) cout << x + 1 << " ";
	put("");
}
signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int q = 1;
	cin >> q;
	while (q--) solve();
}