#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <assert.h>

#define ll long long
#define ld long double
#define sz(x) (int)x.size()
#define pb push_back
#define ppb pop_back
#define pf push_front
#define lb lower_bound
#define pii pair <int, int>
#define ppf pop_front
#define all(x) x.begin(),x.end()
#define in insert
#define F first
#define S second

using namespace std;

const int N = (int)3e5 + 123;
const int mod = (int)1e9 + 7;
const ll inf = (ll)3e18 + 123;

int n, a[N], pre[N], nxt[N];
bool used[N];
vector <int> ans, v, ch;
set < pair <int, int> > s;

int gcd (int a, int b) {
   if (!b) return a;
   return gcd (b, a % b);
}

inline void boost () {
   ios_base :: sync_with_stdio(0);
   cin.tie(0);
   cout.tie(0);
}

int main () {
   //freopen ("input", "r", stdin);
   boost ();
   int tt;
   cin >> tt;
   while (tt --) {
      cin >> n;
      for (int i = 1; i <= n; i ++) cin >> a[i], used[i] = 0;
      ans.clear ();
      v.clear ();
      ch.clear ();
      for (int i = 1; i <= n; i ++) v.pb (i);
      for (int i = 1; i <= n; i ++) {
         pre[i] = (i == 1 ? n : i - 1);
         nxt[i] = (i == n ? 1 : i + 1);
         if (gcd (a[i], a[nxt[i]]) == 1) s.in ({i, nxt[i]});
      }
      int it = 1;
      while (sz (s)) {
         if (s.lb ({it, 0}) == s.end ()) it = 1;
         auto w = *s.lb ({it, 0});
         int x = w.F, y = w.S;
         s.erase (w);
         if (used[x] || used[y]) continue;
         ans.pb (y);
         used[y] = 1;
         pre[nxt[y]] = x;
         nxt[x] = nxt[y];
         if (!used[nxt[x]] && !used[x] && nxt[x] && gcd (a[x], a[nxt[x]]) == 1) s.in ({x, nxt[x]});
         it = nxt[y];
         
      }
      cout << sz (ans) << ' ';
      for (auto it : ans) cout << it << ' ';
      cout << endl;
   }
   return 0;
}