#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
using namespace std;
#define int int64_t

struct node {
  int val = 0;
  int to_end = -1;
  int next = -1;
  int prev = -1;
};

int gcd(int a, int b) {
  while (b) {
    a %= b;
    swap(a, b);
  }
  return a;
}

signed main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  int t;
  cin >> t;
  while (t--) {
    int n;
    cin >> n;
    vector<int> ans;
    vector<node> a(n);
    for (int i = 0; i < n; ++i) {
      cin >> a[i].val;
      a[i].next = (i + 1) % n;
      a[i].to_end = i;
      a[i].prev = (i + n - 1) % n;
    }

    int cnt = 0, i = 0;
    for (int q = 1; q <= 2 * n; ++q) {
      if (ans.size() == n) break;
      int k = a[i].to_end;
      int j = a[k].next;
      //cout << k << " " << j << "\n";
      //if (k == j) break;
      if (gcd(a[k].val, a[j].val) == 1) {
        ans.push_back(j + 1);
        a[k].next = a[j].next;
        ///a[a[k].next].prev = k;
        if (a[j].to_end != j) {
          a[a[j].next].to_end = a[j].to_end;
        }
        i = a[j].next;
      } else {
        a[i].to_end = a[j].to_end;
      }
    }

    cout << ans.size() << " ";
    for (auto p : ans) {
      cout << p << " ";
    }
    cout << "\n";
  }
  return 0;
}
