#include <iostream> 
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <random>

#define ll long long 
#define all(v) v.begin(), v.end()
#define fr(i, n) for (int i = 0; i < (n); ++i)
#define fl(i, l, n) for (int i = (l); i < (n); ++i)
#define cinv(v) for (auto& x: v) cin >> x;
#define fi first
#define se second
#define pb push_back
#define sz(v) (int)v.size()

// #define int ll

using namespace std;

// tg: @runningcherry
// один манул
// кто еще был на коцерте айко вчера ????
// я видел все ребят - Влада Айко, Андрея Инспейса, Костю Катану, Юру Ангела, Глеба Три Дня Дождя и Роки ))))))
// Андрей Пирокинезис не смог прийти, у него был концерт в Питере, но все равно включили Никто не говорит почему )
// а парт Андрюши был под фонограмму

#ifdef LOCAL
	#define dbg(x) cerr << #x << " : " << x << endl;
#else
	#define dbg(x)
#endif

template <typename T1, typename T2>
inline bool chkmin (T1& a, const T2 b) {
	if (a > b) {
		a = b;
		return 1;
	}
	return 0;
}

template <typename T1, typename T2>
inline bool chkmax (T1& a, const T2 b) {
	if (a < b) {
		a = b;
		return 1;
	}
	return 0;
}

template <typename T>
ostream& operator<< (ostream& out, const vector<T>& v) {
	for (auto& x: v) out << x << ' ';
	return out;
}

template <typename T1, typename T2>
ostream& operator<< (ostream& out, const pair<T1, T2>& v) {
	return out << v.fi << ' ' << v.se;
}

template <typename T1, typename T2>
istream& operator>> (istream& in, pair<T1, T2>& v) {
	return in >> v.fi >> v.se;
}

random_device rd;
mt19937 rnd(rd ());

struct tree {
	int pos;
	int priority;
	int sz;
	int value;
	tree* left;
	tree* right;

	tree (int i, int x) {
		pos = i;
		value = x;
		sz = 1;
		priority = rnd ();
		left = right = nullptr;
	}
};

inline int get_sz (tree* t) {
	if (t == nullptr) return 0;
	return t->sz;
}

inline void render (tree* t) {
	if (t == nullptr) return;
	t->sz = get_sz (t->left) + get_sz (t->right) + 1;
}

tree* merge (tree* l, tree* r) {
	if (l == nullptr) return r;
	if (r == nullptr) return l;
	if (l->priority >= r->priority) {
		l->right = merge (l->right, r);
		render (l);
		return l;
	} else {
		r->left = merge (l, r->left);
		render (r);
		return r;
	}
}

tree* erase (tree* t, int k) {
	if (t == nullptr) return nullptr;
	if (get_sz (t->left) + 1 == k) {
		auto tt = merge (t->left, t->right);
		delete t;
		return tt;
	} else if (get_sz (t->left) >= k) {
		t->left = erase (t->left, k);
	} else {
		t->right = erase (t->right, k - get_sz (t->left) - 1);
	}
	render (t);
	return t;
}

tree* get (tree* t, int k) {
	// if (t == nullptr) return t;
	// dbg (t->value);
	// dbg (k);
	if (get_sz (t->left) + 1 == k) return t;
	if (get_sz (t->left) >= k) return get (t->left, k);
	return get (t->right, k - get_sz (t->left) - 1);
}

tree* add (tree* t, int i, int x) {
	tree* a = new tree (i, x);
	return merge (t, a);
}

void dfs (tree* t) {
	if (t == nullptr) return;
	dfs (t->left);
	dbg (t->value);
	dbg (t->pos);
	dbg (t->sz);
	if (t->left != nullptr) dbg (t->left->value);
	if (t->right != nullptr) dbg (t->right->value);
	dfs (t->right);
}

tree* root = nullptr;

void clear (tree* t) {
	if (t == nullptr) return;
	clear (t->left);
	clear (t->right);
	delete t;
}

struct fenw {
	vector<int> t;

	fenw (int n) {
		t = vector<int> (n);
	}

	inline void add (int i, int x) {
		for (; i < sz (t); i += i & -i) t[i] += x;
	}

	inline int get (int i) {
		int res = 0;
		for (; i > 0; i -= i & -i) res += t[i];
		return res;
	}
};

void solve () {
	clear (root);
	root = nullptr;
	int n;
	cin >> n;
	vector<int> goo (n);
	cinv (goo);
	// if (n == 1) {
	// 	cout << "0\n";
	// 	return;
	// }
	fenw moo (n + 1);
	fr (i, n) {
		root = add (root, i, goo[i]);
		moo.add (i + 1, 1);
	}
	set <int> kek;
	fl (i, 1, n) {
		if (__gcd (goo[i], goo[i - 1]) == 1) kek.insert (i);
	}
	if (__gcd (goo.front (), goo.back ()) == 1) kek.insert (0);
	int last = 0;
	vector<int> ans;
	while (sz (kek)) {
		// dfs (root);
		// dbg (last);
		auto it = kek.upper_bound (last);
		if (it == kek.end ()) {
			last = -1;
			continue;
		}
		int x = *it;
		// dbg (x);
		ans.pb (x + 1);
		if (get_sz (root) == 1) break;
		auto pos = moo.get (x + 1);
		// dbg (pos);
		// dbg (get_sz (root));
		tree* nx = nullptr;
		if (pos == get_sz (root)) nx = get (root, 1);
		else nx = get (root, pos + 1);
		// dbg (nx->pos);
		// dbg (nx->value);
		tree* prev = nullptr;
		if (pos == 1) prev = get (root, get_sz (root));
		else prev = get (root, pos - 1);
		// dbg (prev->pos);
		// dbg (prev->value);
		moo.add (x + 1, -1);
		root = erase (root, pos);
		kek.erase (nx->pos);
		if (__gcd (nx->value, prev->value) == 1) kek.insert (nx->pos);
		kek.erase (it);
		last = nx->pos;
	}
	cout << sz (ans) << ' ' << ans << endl;






}

signed main () {
	ios_base::sync_with_stdio (0);
	cin.tie (0);
	int q = 1;
	cin >> q;
	while (q--) solve ();




}