#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef pair<int, int> pii;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define all(x) (x).begin(), (x).end()
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - x.begin())

const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ll INFLL = 1e18;

ll inq(ll x, ll y)
{
    if (y == 0) return 1;
    ll l = inq(x, y / 2);
    l = l * l % MOD;
    if (y % 2) l = l * x % MOD;
    return l;
}

void solve()
{
    int n;
    cin >> n;
    set<pii> s;
    vector<int> a(n);
    forn(i, n)
    {
        cin >> a[i];
        s.insert({i, a[i]});
    }

    vector<int> ans;

    vector<int> exp;
    for (int i = 1; i < n; i++)
    {
        if (__gcd(a[i], a[i - 1]) == 1)
            exp.push_back(i);
    }
    if (__gcd(a[0], a[n - 1]) == 1)
        exp.push_back(0);

    vector<int> r(n);
    vector<int> inexp(n);
    forn(i, exp.size()) inexp[exp[i]] = 1;
    int not_touch = -1;
    for (int i = 0; i < exp.size(); i++)
    {
        //cout << "Check " << exp[i] + 1 << endl;
        int id = exp[i];
        inexp[id]--;
        if (r[id]) continue;
        if (id == not_touch)
        {
            not_touch = -1;
            if (inexp[id] == 0) exp.push_back(id), inexp[id]++;
            if (s.size() == 1 && a[id] != 1) break;
            continue;
        }
        if (s.size() == 1)
        {
            ans.push_back(id);
            break;
        }
        auto it = s.find({id, a[id]});
        auto it_prev = it;
        auto it_next = it;
        if (it == s.begin())
        {
            it_prev = s.end();
        }
        it_prev--;
        it_next++;
        if (it_next == s.end())
        {
            it_next = s.begin();
        }
        int id0 = (*it_prev).first;
        int id2 = (*it_next).first;
        if (__gcd(a[id0], a[id]) == 1)
        {
            ans.push_back(id);
            r[id] = 1;
            s.erase({id, a[id]});
            //cout << "Remove id = " << id + 1 << endl;
            //cout << "Protect = " << id2 + 1 << endl;
            not_touch = id2;
            if (__gcd(a[id0], a[id2]) == 1)
            {
                //cout << "Added = " << id2 + 1 << endl;
                if (inexp[id2] == 0) exp.push_back(id2), inexp[id2]++;
            }
        }
    }

    cout << ans.size() << " ";
    forn(i, ans.size()) cout << ans[i] + 1 << " "; cout << "\n";
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t = 1;
    cin >> t;
    cout << "\n";
    while (t--)
    {
        solve();
    }
}
