#include <bits/stdc++.h>
#include <ostream>

using ll = long long;
using namespace std;

int n;

int solve() {
    if (!(cin >> n))
        return 1;
    vector<int> as(n);
    for (int i = 0; i < n; ++i) {
        cin >> as[i];
    }
    vector<int> next_ind(n);
    vector<int> safe_end(n);
    int cur_safe = -1;
    for (int i = 0; i < n; ++i) {
        next_ind[i] = (i + 1) % n;
        safe_end[i] = i;
    }
    int cur_ind = 0;
    vector<int> deleted;
    while (true) {
        int nex = next_ind[cur_ind];
        if (nex == cur_ind) {
            if (as[nex] == 1) {
                deleted.emplace_back(nex);
            }
            break;
        }
        if (safe_end[cur_ind] != cur_ind) {
            if (cur_safe == -1) {
                cur_safe = cur_ind;
            }
            cur_ind = safe_end[cur_ind];
            continue;
        }
        if (gcd(as[cur_ind], as[nex]) != 1) {
            if (cur_safe == -1) {
                cur_safe = cur_ind;
            }
            safe_end[cur_safe] = nex;
            if (cur_safe == safe_end[cur_safe]) break;
            cur_ind = next_ind[cur_ind];
        } else {
            if (safe_end[nex] != nex)
                safe_end[next_ind[nex]] = safe_end[nex];    // here can be bug
            deleted.emplace_back(nex);
            next_ind[cur_ind] = next_ind[nex];
            cur_ind = next_ind[cur_ind];
            cur_safe = -1;
        }
    }

    cout << deleted.size() << ' ';
    for (int e : deleted) {
        cout << e + 1 << ' ';
    }
    cout << '\n';
    return 0;
}

signed main() {

#ifdef LOCAL
    freopen("D.in", "r", stdin);
#endif

    iostream::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1e9;
    cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "--------------------\n";
#endif
    }
}
