//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse42,avx,bmi,popcnt")
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <cstdio>
#include <climits>
#include <cmath>
#include <vector>
#include <array>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

int gcd(int a, int b)
{
	if(a == 0 || b == 0) return a+b;
	return gcd(b, a%b);
}
std::vector<int> ans;
struct list
{
	int val;
	int oi;
	list* next;
	bool alive = true;
	bool try_del()
	{
		if(gcd(val, next->val) != 1) return false;
		next->alive = false;
		ans.push_back(next->oi);
		next = next->next;
		//delete next;
		return true;
	}
};
int main()
{
	int t; std::cin >> t;
	while(t --> 0)
	{
		//counterexample for o(n^2): 2 2 ... 2 2 6 3
		//each loop removes a single 2 from the beginning
		//find places with gcd 1 in the loop
		//repeatedly remove the next item, or remove the 'gap' pointer from the list
		int n; std::cin >> n;
		ans = std::vector<int>();
		std::vector<int> a(n);
		for(int& x : a) scanf("%d", &x);
		std::vector<list> lst_v(n);
		for(int i = 0; i < n; i++)
			lst_v[i].val = a[i],
			lst_v[i].oi = i,
			lst_v[i].next = &lst_v[-~i%n];
		std::set<int> to_try;
		for(int i = 0; i < n; i++)
			to_try.insert(i);
		while(!to_try.empty())
		{
			std::vector<std::set<int>::iterator> to_erase;
			for(auto it = to_try.begin(); it != to_try.end();)
			{
				if(lst_v[*it].alive == false)
				{
					to_erase.push_back(it);
					++it;
					continue;
				}
				bool del = lst_v[*it].try_del();
				if(!del)
					to_erase.push_back(it);
				++it;
			}
			for(auto it : to_erase)
				to_try.erase(it);
		}
		printf("%d", ans.size());
		for(int el : ans) printf(" %d", el + 1);
		printf("\n");
	}
}
