#include <bits/stdc++.h>

#define X first
#define Y second
#define MP make_pair
#define ll long long

using namespace std;

const int N = 1e5 + 12;
const ll INF = 1e18;

int a[N], t[N * 4], dsu[N], dsu2[N], n;
vector< int > ans;

int get_pr(int x){
	if(dsu[x] == x)
		return x;
	return dsu[x] = get_pr(dsu[x]);
}
void merge(int x, int y){
	x = get_pr(x), y = get_pr(y);
	dsu[x] = y;
}
int get_pr2(int x){
	if(dsu2[x] == x)
		return x;
	return dsu2[x] = get_pr2(dsu2[x]);
}
void merge2(int x, int y){
	x = get_pr2(x), y = get_pr2(y);
	dsu2[x] = y;
}
void build(int v, int tl, int tr){
	if(tl == tr){
		if(tl != 1){
			t[v] = __gcd(a[tl], a[tl - 1]) == 1;
		}
		else{
			t[v] = __gcd(a[tl], a[n]) == 1;
		}	
		return;
	}
	int tm = (tl + tr) / 2;
	build(v * 2, tl, tm);
	build(v * 2 + 1, tm + 1, tr);
	t[v] = t[v * 2] + t[v * 2 + 1];
}
void upd(int v, int tl, int tr, int pos, int val){
	if(tl > pos || pos > tr)
		return;
	if(tl == tr){
		t[v] = val;
		return;
	}
	int tm = (tl + tr) / 2;
	upd(v * 2, tl, tm, pos, val);
	upd(v * 2 + 1, tm + 1, tr, pos, val);
	t[v] = (t[v * 2] + t[v * 2 + 1]);
}
int get(int v, int tl, int tr, int pos){
	if(tl == tr){
		return !t[v] + tl;
	}
	int tm = (tl + tr) / 2;
	if(pos > tm){
		return get(v * 2 + 1, tm + 1, tr, pos);
	}
	else{
		if(t[v] == 0){
			return tr + 1;
		}
		if(t[v * 2] == 0){
			return get(v * 2 + 1, tm + 1, tr, pos);
		}
		int left = get(v * 2, tl, tm, pos);
		if(left == tm + 1 && t[v * 2 + 1])
			return get(v * 2 + 1, tm + 1, tr, pos);
		else if(left == tm + 1 && !t[v * 2 + 1])
			return tr + 1;
		return left;
	}
}


void solve(){
	ans.clear();
	cin >> n;
	for(int i = 1;i <= n;i++){
		dsu[i] = dsu2[i] = i;
	}          
	for(int i = 1;i <= n;i++)
		cin >> a[i];
	build(1, 1, n);
	bool run = 1;
	int last = 1;
	while(run){
		run = 0;
		int pos = get(1, 1, n, last + 1);
		if(last + 1 == n + 1)
			pos = n + 1;
		if(pos == n + 1){
			pos = get(1, 1, n, 1);
		}
		if(pos != n + 1){
			run = 1;
			ans.push_back(pos), upd(1, 1, n, pos, 0);
			int left, right;
			if(pos != n)
				merge(pos, pos + 1), right = get_pr(pos + 1);
			else
				merge(pos, 1), right = get_pr(1);
			if(pos != 1)
				merge2(pos, pos - 1), left = get_pr2(pos - 1);
			else
				merge2(pos, n), left = get_pr2(n);
			int val = __gcd(a[left], a[right]) == 1;
			if(right != pos)
				upd(1, 1, n, right, val);
			last = right;
		}	
	}
	cout << ans.size() << " ";
	for(int x: ans)
		cout << x << " ";
	cout << "\n";
}                           

int main () {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int T;
	cin >> T;
	while(T--)
		solve();
}