#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10, INF = 1e9 + 10, MOD = 1e9 + 7;
const ll LINF = ll(1e18) + 10;

vector<int> ans;
set<int> st;
deque<pair<int,int>> dq;
int arr[N];

int gcd(int a, int b) {
    return a == 0 ? b : gcd(b % a, a);
}

int deleted[N];

void solve() {
    int n;
    cin >> n;
    ans.resize(n);
    ans.clear();
    st.clear();
    dq.clear();

    for (int i = 1; i <= n; i++) {
        cin >> arr[i];
        st.insert(i);
        if (i > 1 && gcd(arr[i-1], arr[i]) == 1) {
            dq.push_back({i-1, i});
        }
        deleted[i] = 0;
    }

    if (gcd(arr[n], arr[1]) == 1) {
        dq.push_back({n, 1});
    }

    while (!dq.empty()) {
        int x = dq.front().first, y = dq.front().second;
        dq.pop_front();
        if (deleted[x] || deleted[y]) {
            continue;
        }
        deleted[y] = 1;
        ans.push_back(y);
        auto it = st.lower_bound(y);
        auto it1 = it;
        x = (it == st.begin() ? *(--st.end()) : *(--it1));
        it1 = it;
        y = (it == --st.end() ? *st.begin() : *(++it1));
        st.erase(it);
        if (gcd(arr[x], arr[y]) == 1) {
            dq.push_back({x, y});
        }
    }

    cout << ans.size() << " ";
    for (auto i : ans) {
        cout << i << " ";
    }
    cout << "\n";
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}