﻿#include <iostream>
#include <string>
#include <math.h>
#include <cstring>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <assert.h>
#include <istream>
#include <ostream>
#include <vector>
#include <algorithm>

#define ll long long
#define ld long double

#define int long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

#define all(a) a.begin(), a.end()
#define mysort(a) sort(all(a))
#define myreverse(a) reverse(all(a))
#define myunique(a) unique(all(a))
#define superunique(a) a.resize(myunique(a) - a.begin())

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define FOD(i, r, l) for (int i = r; i >= l; i--)


using namespace std;

template <class T1, class T2>
istream& operator>>(istream & in, pair<T1, T2>&val) {
    return in >> val.ft >> val.sd;
}

template <class T1, class T2>
ostream& operator<<(ostream & out, pair<T1, T2>&val) {
    return out << val.ft << ' ' << val.sd;
}

template <class T1>
istream& operator>>(istream& in, vector<T1>& val) {
    FOR(i, 0, val.size())
        in >> val[i];
    return in;
}

template <class T1>
ostream& operator<<(ostream& out, vector<T1>& val) {
    FOR(i, 0, val.size())
        out << val[i] << ' ';
    out << '\n';
    return out;
}

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

struct Node {
    int val, ind;
    Node* next, * skip, * previous;
    Node() {}
};

void solve() {
    int n;
    cin >> n;
    vector<int> val(n), next(n), previous(n), group(n);
    vector<int> begin(n), end(n), sz(n);
    cin >> val;
    for (int i = 0; i < n; i++) {
        group[i] = i;
        next[i] = (i + 1) % n;
        previous[i] = (i - 1 + n) % n;
        sz[i] = 1;
        begin[i] = end[i] = i;
    }
    int groupcnt = n;
    int cur = 0;
    vector<int> ans;
    while (groupcnt > 1) {
        int curgroup = group[cur];
        cur = end[curgroup];
        int next_ = next[cur];
        int nextgroup = group[next[cur]];
        if (gcd(val[next_], val[cur]) == 1) {
            ans.push_back(next_ + 1);
            next[cur] = next[next_];
            previous[next[next_]] = cur;
            sz[nextgroup]--;
            begin[nextgroup] = next[begin[nextgroup]];
            if (sz[nextgroup] == 0) {
                groupcnt--;
            }
        }
        else {
            groupcnt--;
            if (sz[nextgroup] <= sz[curgroup]) {
                for (int node = next_; group[node] == nextgroup; node = next[node])
                    group[node] = curgroup;
                end[curgroup] = end[nextgroup];
                sz[curgroup] += sz[nextgroup];
            }
            else {
                for (int node = begin[curgroup]; group[node] == curgroup; node = next[node])
                    group[node] = nextgroup;
                begin[nextgroup] = begin[curgroup];
                sz[nextgroup] += sz[curgroup];
            }
        }
        cur = next[cur];
    }
    int onlygroup = group[cur];
    while (groupcnt != 0 && gcd(val[begin[onlygroup]], val[end[onlygroup]]) == 1) {
        ans.push_back(begin[onlygroup] + 1);
        sz[onlygroup]--;
        begin[onlygroup] = next[begin[onlygroup]];
        if (sz[onlygroup] == 0) {
            groupcnt--;
        }
    }
    cout << ans.size() << ' ' << ans;
    int zero = 0;
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}