#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
//#define int ll
#define ull unsigned long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define pb push_back
#define pii pair<int, int>

#pragma GCC optimaze("Ofast")

tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

mt19937 gen(time(0));

#ifdef SashOK
    const int M = 1e3 + 7;
#else
    const int M = 1e5 + 7;
#endif // SashOK
const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const ull HESH = 31;


struct node{
    int l, r;
    int x, y;
    int k;
    int last_l, last_r;
    int koll;
    int id;
    node(int x_ = 0, int id_ = 0){
        x = x_;
        id = id_;
        y = gen();
        koll = 0;
        last_l = x;
        last_r = x;
        k = 1;
        l = -1;
        r = -1;
    }
};

vector<node> g;
int root = -1;

void out(int v){
    if(v == -1)return;
    out(g[v].l);
    cout << g[v].x << ' ';
    out(g[v].r);
}

void out_cerr(int v){
    if(v == -1)return;
    out_cerr(g[v].l);
    cerr << g[v].x << ' ';
    out_cerr(g[v].r);
}

void out(){
    out(root);
    cout << endl;
}

void update(int v){
    if(v == -1)return;
    g[v].k = 1 + (g[v].l == -1? 0: g[g[v].l].k) + (g[v].r == -1? 0: g[g[v].r].k);
    g[v].koll = (g[v].l == -1? 0: g[g[v].l].koll + (int)(__gcd(g[g[v].l].last_r, g[v].x) == 1)) + (g[v].r == -1? 0: g[g[v].r].koll + (int)(__gcd(g[g[v].r].last_l, g[v].x) == 1));
//    g[v].koll += (g[v].l == -1? 0: );
//    g[v].koll += (g[v].r == -1? 0: );
    g[v].last_l = g[v].x;
    g[v].last_r = g[v].x;
    g[v].last_l = (g[v].l == -1? g[v].last_l: g[g[v].l].last_l);
    g[v].last_r = (g[v].r == -1? g[v].last_r: g[g[v].r].last_r);
}

int merg(int v1, int v2){
    if(v1 == -1)return v2;
    if(v2 == -1)return v1;
    if(g[v1].y > g[v2].y){
        g[v1].r = merg(g[v1].r, v2);
        update(v1);
        return v1;
    }
    else{
        g[v2].l = merg(v1, g[v2].l);
        update(v2);
        return v2;
    }
}

pii split(int v, int x){
    if(v == -1)return {-1, -1};
    int szl = (g[v].l == -1? 0: g[g[v].l].k);
    if(x <= szl){
        pii p = split(g[v].l, x);
        g[v].l = p.S;
        update(v);
        return {p.F, v};
    }
    else{
        pii p = split(g[v].r, x - szl - 1);
        g[v].r = p.F;
        update(v);
        return {v, p.S};
    }
}

void add(int x, int id){
    int v = g.size();
    g.pb({x, id});
    root = merg(root, v);
}

int SPLIT(int v, int k = 0){
    if(v == -1)return -1;
    if(g[v].l != -1 && g[g[v].l].koll != 0)return k + SPLIT(g[v].l, 0);
    if(g[v].l != -1 && __gcd(g[v].x, g[g[v].l].last_r) == 1)return k + g[g[v].l].k + 1;
    if(g[v].r != -1 && __gcd(g[v].x, g[g[v].r].last_l) == 1)return k + (g[v].l == -1? 0: g[g[v].l].k) + 2;
    else return SPLIT(g[v].r, k + (g[v].l == -1? 0: g[g[v].l].k) + 1);
}

void solve(){
    int n;
    cin >> n;
    g.clear();
    root = -1;
    for(int i = 0; i < n; i++){
        int x;
        cin >> x;
        add(x, i + 1);
    }
    int v = 1;
    vector<int> otv;
    while(1){
//        cerr << "LOL " << root << endl;
//        cout << "!!! " << v << "  ";out();cout << endl;
        if(n == 0 || (g[root].koll == 0 && __gcd(g[root].last_l, g[root].last_r) != 1))break;
        if(n == 1){
            otv.pb(g[root].id);
            break;
        }
        int l = v, r = n;
        pii p = split(root, l - 1);
        int ans = SPLIT(p.S);
        if(ans != -1)ans += v - 1;
//        cerr << v << "  ";out_cerr(root);cerr << endl;
//        cout << v << endl;
        /*
        while(l <= r){
            int mid = (l + r) / 2;
            pii q = split(p.S, mid - v + 1);
//            cout << mid << ' ' << g[q.F].koll << "| ";out(q.F);cout << "  ";out(q.S);cout << endl;
            if(g[q.F].koll > 0){
                ans = mid;
                r = mid - 1;
            }
            else{
                l = mid + 1;
            }
            p.S = merg(q.F, q.S);
        }
        */
//        cout << ans << endl;
//        cout << endl;
        root = merg(p.F, p.S);
//        out();
        if(ans == -1){
            pii p = split(root, n - 1);
            root = merg(p.S, p.F);
            v = 1;
        }
        else{
            pii p = split(root, ans);
            pii q = split(p.F, ans - 1);
//            out_cerr(q.S);cerr << endl;
//            cerr << "id1\n";
            if(q.S != -1){
//                cerr << "id2\n";
                otv.pb(g[q.S].id);
            }
            root = merg(q.F, p.S);
            v = ans;
            if(ans == n)v = 1;
            n--;
        }
    }
//    cerr << endl;
    cout << otv.size() << ' ';for(auto to:otv)cout << to << ' ';cout << endl;
//    cout << "LOL\n";
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef SashOK
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // SashOK
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}
