#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;
int gcd(int a, int b) {
    int r;
    while (b) {
        r = a % b;
        a = b;
        b = r;
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> L(n), R(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) {
        L[i] = (i - 1 + n) % n;
        R[i] = (i + 1) % n;
    }

    vector <int> ans(n, -1);
    vector <int> st;
    for (int i = 0; i < n; i++) st.push_back(i);
    int now = 0;
    while (!st.empty()) {
        vector <int> v;
        for (int i = 0; i < st.size(); i++) {
            int ind = st[i];
            if (ans[ind] != -1) continue;
            if (gcd(a[ind], a[R[ind]]) == 1) {
                ans[R[ind]] = now++;
                R[ind] = R[R[ind]];
                v.push_back(ind);
            }
        }
        st = v;
    }
    vector <pair <int, int> > res;
    for (int i = 0; i < n; i++) {
        if (ans[i] != -1) res.push_back({ans[i], i});
    }
    sort(res.begin(), res.end());
    cout << res.size() << " ";
    for (auto x : res) cout << x.second + 1 << " ";
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}

