#include <iostream>
#include <fstream>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <ctime>
#include <chrono>
#include <algorithm>
#include <queue>

#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define fill(v, n) for(int i = 0;i<n;i++)cin>>v[i];
#define sqr(x) (x)*(x)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int gcd(int a, int b) {
	if (a < b)
		swap(a, b);
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

int main() {
	fast;
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> v(n), ans, deleted(n);
		fill(v, n);
		queue<pii> order;
		for (int i = 0; i < n - 1; i++) {
			if (gcd(v[i], v[i + 1]) == 1) {
				order.push({ i, i + 1 });
				i++;
			}
		}
		if (gcd(v[n - 1], v[0]) == 1)
			order.push({ n - 1, 0 });
		while (!order.empty()) {
			pii cur = order.front();
			order.pop();
			if (deleted[cur.first])
				continue;
			ans.push_back(cur.second);
			deleted[cur.second] = 1;
			int next = (cur.second + 1) % n;
			if (cur.first == cur.second)
				break;
			while (deleted[next]) {
				next++;
				next %= n;
			}
			if (gcd(v[next], v[cur.first]) == 1)
				order.push({ cur.first, next });
		}
		cout << ans.size() << " ";
		for (int i = 0; i < ans.size(); i++)
			cout << ans[i] + 1 << " ";
		cout << "\n";
	}
}