#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define all(a) (a).begin(), (a).end()
#define ld long double
#define pii pair<int, int>

struct node {
	int val, l, r, y;
	node() {}
	node(int val_) {
		l = 0, r = 0, y = rand();
		val = val_;
	}
};

const int maxn = 1e5 + 10;
int c = 1;
node tree[maxn];

int merge(int a, int b) {
	if (a == 0) return b;
	if (b == 0) return a;
	if (tree[a].y > tree[b].y) {
		tree[a].r = merge(tree[a].r, b);
		return a;
	} else {
		tree[b].l = merge(a, tree[b].l);
		return b;
	}
}

int right(int top) {
	if (tree[top].r == 0) return top;
	return right(tree[top].r);
}
pii left(int top) {
	if (tree[top].l == 0) {
		int r = tree[top].r;
		tree[top].r = 0;
		return {top, r};
	}
	pii p = left(tree[top].l);
	tree[top].l = p.second;
	return {p.first, top};
}

void show(int top) {
	if (top == 0) return;
	show(tree[top].l);
	cout << tree[top].val << ' ';
	show(tree[top].r);
}


int gcd(int a, int b) {
	if (a == 0) return b;
	return gcd(b % a, a);
}


void solve() {
	c = 1;

	int n;
	vector<int> a;

	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) cin >> a[i];

	deque<int> r;

	for (int i = 0; i < n; i++) {
		r.push_back(c++);
		tree[r.back()] = node(i);
	}

	vector<int> dl;
	int last = -1;


	// cout << "here" << endl;


	while (1) {
		if (r.size() == 0) break;

		// cout << "r.size() = " << r.size() << endl;
		// for (auto i : r) {
		// 	cout << i << " : " << endl;
		// 	show(i);
		// 	cout << endl;
		// }
		// cout << endl;


		if (last == -1) {
			last = a[tree[right(r.front())].val];
			r.push_back(r.front());
			r.pop_front();
		} else {
			// cout << "left : ";
			// show(r.front());
			// cout << " -> " << endl;
			pii p = left(r.front());
			// show(p.first);
			// cout << " | ";
			// show(p.second);
			// cout << endl;


			if (gcd(last, a[tree[p.first].val]) == 1) {
				dl.push_back(tree[p.first].val + 1);

				r.pop_front();
				if (p.second != 0) {
					r.push_back(p.second);
					last = a[tree[right(p.second)].val];
				} else {
					last = -1;
				}
				// last = -1;
			} else {
				int r1 = merge(p.first, p.second);
				r.pop_front();
				if (r.size() == 0) break;
				r.back() = merge(r.back(), r1);
				last = a[tree[right(r.back())].val];
			}
		}
	}

	cout << dl.size() << ' ';
	for (auto i : dl) cout << i << ' ';
	cout << '\n';
}



signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int t;
	cin >> t;
	while (t--) solve();

	return 0;
}
