#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <stack>
#include <set>
#include <map>

typedef long long ll;
typedef long double ld;

using namespace std;

ll gcd(ll a, ll b) {
	if(a == 0)
		return b;
	if(b == 0)
		return a;
	return gcd(b % a, a);
}

void solve() {
	int n, n_s;
	cin >> n;
	vector<pair<int, int>> a(n);
	vector<int> ans;
	set<int> ost;
	for(int i = 0; i < n; ++i) {
		cin >> a[i].first;
		a[i].second = i;
		ost.insert(i);
	}
	
	set<pair<int, int>> p;
	for(int i = 1; i <= n; ++i) 
		p.insert(make_pair(i - 1, i % n));
	while(p.size() > 0) {
		set<int> v;
		for(auto i:p) {
			if(v.find(i.first) == v.end() && v.find(i.second) == v.end() &&  gcd(a[i.first].first, a[i.second].first) == 1) {
				ost.erase(i.second);
				v.insert(i.second);
			}
		}
		p.clear();
		int k = 0, zz = 0;
		n_s = a.size() - v.size();
		bool ff = false;
		if(v.size() == 0)
			break;
		if(ost.size() == 0) {
			for(auto i:v) {
				if(i != *v.begin())
					ans.push_back(i);
			}
			ans.push_back(*v.begin());
			break;
		}
		for(auto i:v) {
			if(i > *v.begin() || i > *ost.begin())
				ans.push_back(i);
			auto zzz = ost.upper_bound(i);
			if(zzz == ost.end()) 
				zzz = ost.begin();
			int kzz = *zzz;
			if(zzz == ost.begin()) {
				zzz = ost.end();
				zzz--;
			}
			else
				zzz--;
			p.insert(make_pair(*zzz, kzz));
		}

		if(*v.begin() < *ost.begin())
		    ans.push_back(*v.begin());
	}
	
	cout << ans.size() << ' ';
	for(int i = 0; i < ans.size(); ++i) 
		cout << ans[i] + 1 << ' ';
	return;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while(t--) {
		solve();
		cout << '\n';
	}
	return 0;
}