﻿// Задача Плейлист.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include<vector>

using namespace std;

int n;
vector<int> used, link;

int find(int a) {
    if (used[link[a]])
        return link[a] = find(link[a]);
    return link[a];
}

int gcd(int a, int b) {
    if (a < b) swap(a, b);
    if (b == 0) return a;
    return gcd(b, a%b);
}

void solve() {
    int n;
    cin >> n;
    link.resize(n);
    used.assign(n, false);
    vector<int> val(n);
    for (int i = 0; i < n; i++)
        cin >> val[i];
    for (int i = 0; i < n; i++)
        link[i] = (i + 1) % n;
    int i = 0;
    if (n == 1) {
        if (val[0] != 1) {
            cout << "0\n";
        }
        else {
            cout << "1 1\n";
        }
        return;
    }
    vector<int> conflict;
    vector<int> res;
    while (true) {
        int a = i, b = find(i);
        if (gcd(val[a], val[b]) == 1) {
            used[b] = true;
            conflict.push_back(a);
            res.push_back(b+1);
        }
        int s = find(i);
        if (s <= i)
            break;
        i = s;
    }
    while (!conflict.empty()) {
        vector<int> conflict_;
        for (int i = 0; i < conflict.size(); i++) {
            int a = conflict[i], b;
            if (used[a]) continue;
            b = find(a);
            if (gcd(val[a], val[b]) == 1) {
                conflict_.push_back(a);
                res.push_back(b + 1);
                used[b] = true;
            }
        }
        conflict = conflict_;
    }
    cout << res.size() << ' ';
    for (auto c : res)
        cout << c << ' ';
    cout << '\n';
}

int main()
{
    int t;
    cin >> t;
    while (t--)
        solve();
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
