#include <algorithm>
#include <iostream>
#include <math.h>
#include <vector>
#include <bitset>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define int ll

//#define x first
//#define y second

#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define vs vector<string>
#define pipii pair<int, pii>
#define piipi pair<pii, int>

const int inf = 1e9;
const ll INF = 1e18;
const ld PI = 3.1415926535;
const int N = 1e5;
const ll M = 1e9 + 7; //92359417

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

vi cnt, ans;
void solve() {
    int n; cin >> n;
    vi a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    set<int> l;
    for (int i = 0; i < n; ++i) {
        l.insert(i);
    }
    set<int> cand;
    for (int i = 0; i < n; ++i) {
        if (i != n - 1) {
            if (gcd(a[i], a[i + 1]) == 1) cand.insert(i);
        }
        else {
            if (gcd(a[0], a[n - 1]) == 1) cand.insert(i);
        }
    }
    if (!cand.size()) {
        cout << "0\n";
        return;
    }
    int id = *cand.begin();
    vi ans;
    while (cand.size() && l.size()) {
        auto todel = l.upper_bound(id);
        if (todel == l.end()) {
            todel = l.begin();
        }
        int del = *todel;
        cand.erase(del);
        l.erase(del);
        ans.push_back(del);
        if (!l.size()) break;
        auto f = l.upper_bound(id);
        if (f == l.end()) f = l.begin();
        del = *f;
        if (gcd(a[del], a[id]) != 1) {
            cand.erase(id);
        }
        if (!cand.size()) break;
        auto nxt = cand.upper_bound(id);
        if (nxt == cand.end()) nxt = cand.begin();
        id = *nxt;
    }
    cout << ans.size() << ' ';
    for (auto a : ans) cout << a + 1 << ' ';
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}