#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <string>
#include <tuple>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define int ll
#define double ld
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second
#define mkp make_pair
#define mkt make_tuple
#define all(x) begin(x), end(x)
#define pb push_back

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n; cin >> n;
    vector <int> a(n), ans, nxt(n);
    set <int> bad;
    loop(i, n) {
        cin >> a[i];
        nxt[i] = (i == n - 1 ? 0 : i + 1);
    }
    loop(i, n)
        if (gcd(a[i], a[nxt[i]]) == 1)
            bad.insert(i);
    int lst = -1;
    while (!bad.empty()) {
        auto it = bad.upper_bound(lst);
        if (it == bad.end()) {
            lst = -1; continue;
        }
        int cur = *it, del = nxt[cur];
        ans.pb(del + 1);
        bad.erase(cur);
        bad.erase(del);
        nxt[cur] = nxt[del];
        if (cur != del && gcd(a[cur], a[nxt[cur]]) == 1)
            bad.insert(cur);
        lst = del;
    }
    cout << ans.size() << " ";
    for (int x : ans)
        cout << x << " ";
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t; loop(i, t)
    solve();
    return 0;
}