#pragma GCC target ("avx2")
#pragma GCC optimize ("03")
#pragma GCC optimize ("unroll-loops")
#include <bits/stdc++.h>

#define ar array
#define int long long

using namespace std;
using ll=long long;

int n;
vector<int> a;

int gcd(int a, int b) {
	if (!b) return a;
	return gcd(b,a%b);
}
struct dsu {
	vector<int> p, sz;
	vector<deque<int>> cmp;
	dsu(int n) {
		sz.assign(n,1);
		p.resize(n);
		cmp.resize(n);
		for (int i=0; i<n; ++i) {
			p[i]=i;
			cmp[i]={i};
		}
	}
	int get(int a) {
		return p[a]=(p[a]==a?a:get(p[a]));
	}
	void unite(int a, int b) {
		a=get(a); b=get(b);
		if (a==b) return;
		if (sz[a]>sz[b]) {
			while(!cmp[b].empty()) {
				cmp[a].push_back(cmp[b].front());
				cmp[b].pop_front();
			}
			p[b]=a;
			sz[a]+=sz[b];
		}
		else {
			while(!cmp[a].empty()) {
				cmp[b].push_front(cmp[a].back());
				cmp[a].pop_back();
			}
			p[a]=b;
			sz[b]+=sz[a];
		}
	}
};

void solve() {
	cin >> n;
	a.resize(n);
	for (int i=0; i<n; ++i) {
		cin >> a[i];
	}
	dsu row(n);
	vector<int> ans(0), next(n);
	for (int i=0; i<n; ++i) {
		next[i]=(i+1)%n;
	}
	int pos=0;
	while(1) {
		pos=row.cmp[row.get(pos)].back();
		if (gcd(a[pos],a[next[pos]])==1) {
			if (pos==next[pos]) {
				ans.push_back(pos);
				break;
			}
			int cur=next[pos];
			next[pos]=next[next[pos]];
			row.cmp[row.get(cur)].pop_front();
			ans.push_back(cur);
			pos=next[pos];
		}
		else {
			if (row.get(pos)==row.get(next[pos])) break;
			row.unite(pos,next[pos]);
		}
	}
	cout << ans.size() << " ";
	for (auto x : ans) cout << x+1 << " ";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);cout.tie(0);
#ifdef disastah
	cout << "\nOutput\n\n";
#endif
	int test_case=1;
	cin >> test_case;
	for (int i=0; i<test_case; ++i) {
		solve();
		cout << "\n";
	}
}
