#include <bits/stdc++.h>

using namespace std;
#define all(o) o.begin(), o.end()
using ll = long long;

#define MULTITASK 1


void warm_up() {

}


struct Song {
    int id, genre;
};


void solve() {
    int n;
    cin >> n;
    vector<Song> songs;
    vector<int> next(n);
    vector<int> prev(n);
    for (int i = 0; i < n; ++i) {
        int v; cin >> v;
        songs.push_back({i, v});
        next[i] = (i + 1) % n;
        prev[i] = (i + 1 - n) % n;
    }
    queue<pair<int, int>> interesting;
    for (int i = 0; i < n; ++i) {
        interesting.push({i, next[i]});
    }

    vector<int> order;
    vector<bool> deleted(n, false);

    while (!interesting.empty()) {
        int i = interesting.front().first;
        int j = interesting.front().second;
        interesting.pop();
        if (deleted[i] || deleted[j]) continue;
        Song s = songs[i];
        Song ns = songs[j];
        if (gcd(s.genre, ns.genre) == 1) {
            order.push_back(j);
            deleted[j] = true;
            next[i] = next[j];
            interesting.push({i, next[j]});
            if (interesting.front().first == j) {
                interesting.pop();
            }
        }
    }

    cout << order.size();
    for (int e : order) {
        cout << " " << e + 1;
    }
    cout << "\n";
}


int main() {
#if ELT
    freopen("../D/input.txt", "r", stdin);
#endif
#if MULTITASK
    warm_up();
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
#else
    warm_up();
    solve();
#endif
}
