#include <iostream>
#include <stdio.h>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <numeric>
#include <utility>
#include <random>
#include <cmath>
#include <algorithm>

using namespace std;

typedef int64_t ll;
#define endl "\n"

int gcd(int a, int b) {
    return (a == 0 ? b : gcd(b % a, a));
}

int fnd(int x, set<int>& ss) {
    auto it = ss.upper_bound(x);
    if (it == ss.end()) {
        return *ss.begin();
    } else {
        return *it;
    }
}

int fndp(int x, set<int>& ss) {
    auto it = ss.lower_bound(x);
    if (it == ss.begin()) {
        return *prev(ss.end());
    } else {
        return *prev(it);
    }
}

void solve() {
    int n; cin >> n;
    vector<int> ar(n);
    for (auto& it : ar) cin >> it;
    set<int> nms;
    set<int> al;
    for (int i = 0; i < n; ++i) {
        al.insert(i);
        int nx = (i + 1) % n;
        if (gcd(ar[i], ar[nx]) == 1) nms.insert(i);
    }
    int cur = -1;
    vector<int> ans;
    while (nms.size() && al.size()) {
        cur = fnd(cur, nms);
        nms.erase(cur);
        int nxt = fnd(cur, al);
        ans.push_back(nxt + 1);
        al.erase(nxt);
        nms.erase(nxt);
        if (al.empty()) break;
        int nwnxt = fnd(cur, al);
        if (gcd(ar[cur], ar[nwnxt]) == 1) {
            nms.insert(cur);
        }
        int nwnpr = fndp(cur, al);
        if (gcd(ar[cur], ar[nwnpr]) == 1) {
            nms.insert(nwnpr);
        }
    }
    cout << ans.size() << " ";
    for (auto& it : ans) cout << it << " ";
    cout << endl;
    return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q; cin >> q;
    while (q--) solve();
}


