#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>


using namespace  std;
#define  ll long long
int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int q;
    cin >> q;
    while (q--) {
        int n;
        cin >> n;
        vector<int> a(n);
        vector<bool> used(n, 1);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        vector<pair<int, int>> c;
        for (int i = 0; i < n;) {
            int j = i;
            while (j + 1 < n && gcd(a[j], a[j + 1]) != 1)
                j++;
            c.push_back({i, j});
            i = j + 1;
        }
        vector<int> ans;
        while ( c.size() > 1) {
            int k = c.size();
            vector<pair<int, int>> c1, c2;
            for (int i = 0; i < k; ++i) {
                int l = c[i].first, r = c[i].second;
                while (used[l] == 0 && l + 1 <= r)
                    l++;
                while (used[r] == 0 && r - 1 >= l)
                    r--;
                if ((l == r && used[l] == 0) || (l > r))
                    continue;
                c1.push_back({l, r});
            }
            k = c1.size();
            if (c1.size() == 1) {
                swap(c, c1);
                break;
            }
            for (int i = 0; i < k - 1; ++i) {
                int l = c1[i].first, r = c1[i].second;
                if (l > r)
                    continue;
                if (gcd(a[r], a[c1[i + 1].first]) == 1) {
                    used[c1[i + 1].first] = 0;
                    ans.push_back(c1[i + 1].first);
                    c1[i + 1].first++;
                    c2.push_back({l, r});
                } else {
                    c1[i + 1].first = l;
                }
            }

            if (c1.back().first <= c1.back().second) {
                if (!c2.empty()) {
                    if (gcd(a[c2[0].first], a[c1.back().second]) == 1) {
                        used[c2[0].first] = 0;
                        ans.push_back(c2[0].first);
                        c2[0].first++;
                    }
                }
                c2.push_back(c1.back());
            }
            swap(c, c2);
        }
        if (c.size() == 1) {
            int l = c[0].first, r = c[0].second;
            while (true) {
                while (used[l] == 0 && l + 1 <= r)
                    l++;
                while (used[r] == 0 && r - 1 >= l)
                    r--;
                c[0] = {l, r};
                if (l < r) {
                    if (gcd(a[l], a[r]) == 1)
                        used[l] = 0, ans.push_back(l);
                    else
                        break;
                } else
                {
                    if(l==r)
                    {
                        if(a[l]==1)
                            ans.push_back(l);
                    }
                    break;
                }
            }
        }

        cout << ans.size() << ' ';
        for (auto u:ans)
            cout << u + 1 << ' ';
        cout << '\n';
    }
    return 0;
}