//{
#include <bits/stdc++.h>
using namespace std;
template<typename t> inline void umin(t &a, const t b) {if(b < a) a = b;}
template<typename t> inline void umax(t &a, const t b) {if(b > a) a = b;}
#define bnd(f) (f).begin(), (f).end()
#define len(f) int((f).size())
#define _ <<' '<<
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ul;
typedef unsigned int ui;
typedef vector<int> vi;
ll time() {return chrono::system_clock().now().time_since_epoch().count();}
mt19937 rnd(time());
mt19937_64 rnd64(time());
const int inf = 1e9 + 5;
const ll inf64 = 4e18 + 5;
const int md = 998244353;
namespace MD {
    inline void add(int &a, const int b) {if((a += b) >= md) a -= md;}
    inline int sum(int a, const int b) {add(a, b); return a;}
    inline int prd(const int a, const int b) {return ll(a) * b % md;}
    inline void mlt(int &a, const int b) {a = prd(a, b);}
    inline void sub(int &a, const int b) {if((a -= b) < 0) a += md;}
    inline int pow(const int a, const int b) {
        ll ans = 1;
        for(int i = 1 << 30; i; i >>= 1) {
            (ans *= ans) %= md;
            if(i & b) (ans *= a) %= md;
        }
        return ans;
    }
};
//}

const int N = 1e5 + 5;
int a[N], n, nx[N];
bool mk[N];

int get(int i) {
    return mk[nx[i]] ? nx[i] = get(nx[i]) : nx[i];
}

vector<int> ans;

void del(int i) {
    mk[i] = true;
    ans.push_back(i + 1);
}

struct tree {
    tree *l, *r;
    int v {};
    tree(int tl = 0, int tr = n - 1) {
        if(tl < tr) {
            int tm = tl + tr >> 1;
            l = new tree(tl, tm);
            r = new tree(tm + 1, tr);
        } else {
            l = r = 0;
        }
    }
    void add(int i, int s, int tl = 0, int tr = n - 1) {
        v += s;
        if(tl == tr) return;
        int tm = tl + tr >> 1;
        i <= tm
            ? l->add(i, s, tl, tm)
            : r->add(i, s, tm + 1, tr);
    }
//    int get(int i, int tl = 0, int tr = n - 1) {
//        if(tl == tr) return v;
//        int tm = tl + tr >> 1;
//        return i <= tm
//            ? l->get(i, tl, tm)
//            : r->get(i, tm + 1, tr);
//    }
    int first(int tl = 0, int tr = n - 1) {
        if(!v) return -1;
        if(tl == tr) return tl;
        int tm = tl + tr >> 1;
        return l->v ? l->first(tl, tm)
                    : r->first(tm + 1, tr);
    }
    int first_from(int i, int tl = 0, int tr = n - 1) {
        if(tl >= i) return first(tl, tr);
        if(!v || i > tr) return -1;
        int tm = tl + tr >> 1;
        if(i > tm) return r->first_from(i, tm + 1, tr);
        int j = l->first_from(i, tl, tm);
        return j < 0 ? r->first(tm + 1, tr) : j;
    }
};

void solve() {
    cin >> n;
    for(int i = 0; i < n; ++i)
        cin >> a[i];
    memset(mk, 0, n);
    iota(nx, nx + n, 1);
    nx[n - 1] = 0;
    ans.clear();
    tree t {};
    for(int i = 0; i < n; ++i)
        if(__gcd(a[i], a[nx[i]]) == 1)
            t.add(i, +1);
    int i = 0;
    while(t.v) {
        int j = t.first_from(i);
        if(j < 0) j = t.first();
        assert(j >= 0);
        i = j;
        j = get(i);
        int k = get(j);
        if(__gcd(a[j], a[k]) == 1)
            t.add(j, -1);
        del(j);
        if(__gcd(a[i], a[k]) > 1)
            t.add(i, -1);
        i = k;
    }
    cout << len(ans);
    for(int i : ans) cout _ i;
    cout << '\n';
}

signed main() {
#ifndef KEK
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//    cout.precision(15); cout << fixed;
#else
    system("color a");
    freopen("in.txt", "r", stdin);
#endif // KEK
    int t; cin >> t; while(t--)
    solve();
}
