#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define gcd __gcd

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        if (n == 1) {
            int x;
            cin >> x;
            if (x == 1) {
                cout << "1 1\n";
            } else {
                cout << "0\n";
            }
            continue;
        }
        set<pair<int, int>> arr;
        set<int> id;
        for (int i = 0; i < n; i++) {
            int x;
            cin >> x;
            arr.emplace(i, x);
            auto it = prev(arr.end());
            if (it != arr.begin() && gcd(prev(it)->second, x) == 1) {
                id.emplace(prev(it)->first);
            }
        }
        if (gcd(arr.rbegin()->second, arr.begin()->second) == 1) {
            id.emplace(n - 1);
        }
//        cout << id.size() << '\n';
        int cur = -1;
        vector<int> ans;
        while (!id.empty() && arr.size() > 2) {
            auto it = id.upper_bound(cur);
            if (it == id.end()) {
                it = id.begin();
            }
            cur = *it;
            auto A = arr.lower_bound({*it, 0}), B = next(A);
            id.erase(it);
            if (B == arr.end()) {
                B = arr.begin();
            }
            ans.emplace_back(B->first + 1);
            auto C = next(B);
            if (C == arr.end()) {
                C = arr.begin();
            }
            id.erase(B->first);
            arr.erase(B);
            if (gcd(A->second, C->second) == 1) {
                id.emplace(A->first);
            }
            // for (auto &x : arr) {
            //     cout << x.second << ' ';
            // }
            // cout << '\n';
        }
        if (!id.empty()) {
            auto it = id.upper_bound(cur);
            if (it == id.end()) {
                it = id.begin();
            }
            // for (auto &x : arr) {
            //     cout << x.second << ' ';
            // }
            // cout << '\n';
            // cout << *it << '\n';
            auto x = arr.begin();
            if (x->first == *it) {
                ans.emplace_back(next(x)->first + 1);
                arr.erase(next(x));
            } else {
                ans.emplace_back(x->first + 1);
                arr.erase(x);
            }
            if (arr.begin()->second == 1) {
                ans.emplace_back(arr.begin()->first + 1);
            }
        }
        cout << ans.size() << ' ';
        for (auto &x : ans) {
            cout << x << ' ';
        }
        cout << '\n';
    }
    return 0;
}
