#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> b(n);
    vector<int> next(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        b[i] = a[i].first;
        a[i].second = i;
        next[i] = (i + 1) % n;
    }
    vector<int> ans;
    vector<int> d(n);
    for (int i = 0; i < a.size(); ++i) {
        if (d[a[i].second] == 0 && gcd(a[i].first, b[next[a[i].second]]) == 1) {
            ans.push_back(next[a[i].second]);
            d[next[a[i].second]] = 1;
            next[a[i].second] = next[next[a[i].second]];
            a.push_back(a[i]);
        }
    }
    cout << ans.size() << " ";
    for (auto i : ans) {
        cout << i + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}