#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int INF = (int) 1e9;
int now = INF;

struct ST {
    vector<int> st;

    ST(int n) {
        st.resize(4 * n);
    }

    void upd(int i, int l, int r, int pos, int qd) {
        if (l + 1 == r) {
            st[i] = qd;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            upd(i * 2 + 1, l, m, pos, qd);
        } else {
            upd(i * 2 + 2, m, r, pos, qd);
        }
        st[i] = max(st[i * 2 + 1], st[i * 2 + 2]);
    }

    void ind(int i, int l, int r, int ql, int qr) {
        if (now < ql) {
            return;
        }
        if (l + 1 == r && st[i]) {
            now = min(now, l);
            return;
        }
        if (l == ql && r == qr) {
            if (st[i] == 0) {
                return;
            }
            int m = (l + r) / 2;
            if (st[i * 2 + 1]) {
                return ind(i * 2 + 1, l, m, ql, m);
            } else {
                return ind(i * 2 + 2, m, r, m, qr);
            }
        }
        int m = (l + r) / 2;
        if (qr <= m) {
            ind(i * 2 + 1, l, m, ql, qr);
        } else if (ql >= m) {
            ind(i * 2 + 2, m, r, ql, qr);
        } else {
            ind(i * 2 + 1, l, m, ql, m);
            ind(i * 2 + 2, m, r, m, qr);
        }
    }
};

void sol() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &el : a) {
        cin >> el;
    }
    ST st(n);
    for (int i = 0; i < n; i++) {
        if (__gcd(a[i], a[(i - 1 + n) % n]) == 1) {
            st.upd(0, 0, n, i, 1);
        }
    }
    vector<int> used(n);
    vector<int> next_l(n), next_r(n);
    for (int i = 0; i < n; i++) {
        next_r[i] = (i + 1) % n;
        next_l[i] = (i - 1 + n) % n;
    }
    int ind = 0;
    vector<int> res;
    while (st.st[0]) {
        int ql = ind + 1;
        if (ql < n) {
            now = INF;
            st.ind(0, 0, n, ql, n);
            if (now < INF) {
                res.push_back(now);
                if ((int) res.size() == n) {
                    break;
                }
                st.upd(0, 0, n, now, 0);
                used[now] = 1;
                int nr = now, nl = now;
                vector<int> stack;
                while (used[nr]) {
                    stack.push_back(nr);
                    nr = next_r[nr];
                }
                for (int el : stack) {
                    next_r[el] = nr;
                }
                stack = {};
                while (used[nl]) {
                    stack.push_back(nl);
                    nl = next_l[nl];
                }
                for (int el : stack) {
                    next_l[el] = nl;
                }
                st.upd(0, 0, n, nr, 0);
                if (__gcd(a[nl], a[nr]) == 1) {
                    st.upd(0, 0, n, nr, 1);
                }
                ind = nr;
                continue;
            }
        }
        now = INF;
        st.ind(0, 0, n, 0, n);
        if (now < INF) {
            res.push_back(now);
            if ((int) res.size() == n) {
                break;
            }
            st.upd(0, 0, n, now, 0);
            used[now] = 1;
            int nr = now, nl = now;
            vector<int> stack;
            while (used[nr]) {
                stack.push_back(nr);
                nr = next_r[nr];
            }
            for (int el : stack) {
                next_r[el] = nr;
            }
            stack = {};
            while (used[nl]) {
                stack.push_back(nl);
                nl = next_l[nl];
            }
            for (int el : stack) {
                next_l[el] = nl;
            }
            st.upd(0, 0, n, nr, 0);
            if (__gcd(a[nl], a[nr]) == 1) {
                st.upd(0, 0, n, nr, 1);
            }
            ind = nr;
        }
    }
    cout << res.size() << ' ';
    for (int el : res) {
        cout << el + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        sol();
    }
}