#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
template<typename T> void mdebug_out(T* a, int n) { for (int i = 0; i < n; ++i) cerr << a[i] << ' '; cerr << endl; }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a) { for (auto &x : a) stream << x << ' '; return stream; }
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2> &p) { return stream << p.first << ' ' << p.second; }

int gcd(int a, int b)
{
    if (!a) return b;
    if (!b) return a;
    return __gcd(a, b);
}

int md(int a, int m)
{
    a %= m;
    if (a < 0)
        a += m;
    return a;
}

int a[100005];
set<int> alive, uno;

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int tests;
    cin >> tests;
    while (tests--)
    {
        int n;
        cin >> n;
        for (int i = 1; i <= n; ++i) cin >> a[i];
        alive.clear();
        uno.clear();
        for (int i = 1; i <= n; ++i) alive.insert(i);

        auto next_alive = [&](int i) -> int
        {
            auto it = alive.upper_bound(i);
            if (it == alive.end())
                return *alive.begin();
            return *it;
        };
        auto prev_alive = [&](int i) -> int
        {
            auto it = alive.lower_bound(i);
            if (it != alive.begin())
                return *prev(it);
            return *prev(alive.end());
        };

        auto chkadd = [&](int i)
        {
            if (!alive.count(i)) throw;
            int j = prev_alive(i);
            if (gcd(a[j], a[i]) == 1)
                uno.insert(i);
        };
        if (gcd(a[n], a[1]) == 1)
            uno.insert(1);
        for (int i = 2; i <= n; ++i)
            if (gcd(a[i], a[i - 1]) == 1)
                uno.insert(i);
        vector<int> ans;
        while (!uno.empty())
        {
            int ptr = *alive.begin() + 1;
            while (ptr <= n)
            {
                auto it = uno.lower_bound(ptr);
                if (it == uno.end()) break;
                int i = *it;
                uno.erase(i);
                alive.erase(i);
                ans.push_back(i);

                if (alive.empty())
                {
                    ptr = n + 2;
                    break;
                }

                int j = next_alive(i);
                if (uno.count(j))
                    uno.erase(j);
                chkadd(j);

                if (j == *alive.begin())
                {
                    ptr = n + 2;
                    break;
                }
                chkmax(ptr, j + 1);
            }
            if (ptr <= n + 1 && !alive.empty() && uno.count(*alive.begin()))
            {
                int i = *alive.begin();
                uno.erase(i);
                alive.erase(i);
                ans.push_back(i);
                if (!alive.empty())
                {
                    int j = next_alive(i);
                    if (uno.count(j))
                        uno.erase(j);
                    chkadd(j);
                }
            }
        }
        cout << ans.size() << ' ' << ans << '\n';
    }

    return 0;
}