#include <bits/stdc++.h>
using namespace std;

const int N = 1e5 + 7;

int n, a[N];
set<int> all, bad;

void mod(int &i) {
    i %= n;
    if (i < 0) i += n;
}

int L(set<int> &s, int x) {
    mod(x);
    auto it = s.upper_bound(x);
    if (it == s.begin()) return *s.rbegin();
    return *prev(it);
}

int R(set<int> &s, int x) {
    mod(x);
    auto it = s.lower_bound(x);
    if (it == s.end()) return *s.begin();
    return *it;
}

void del(int x) {
    mod(x);
    int i = L(all, x - 1);
    if (gcd(a[i], a[x]) == 1) bad.erase(i);
    int j = R(all, x + 1);
    if (gcd(a[x], a[j]) == 1) bad.erase(x);
    all.erase(x);
    if (gcd(a[i], a[j]) == 1) bad.insert(i); 
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a[i];
    all.clear();
    bad.clear();
    for (int i = 0; i < n; ++i) all.insert(i);
    for (int i = 0; i < n; ++i) {
        int id = R(all, i + 1);
        if (gcd(a[id], a[i]) == 1) bad.insert(i);
    }
    vector<int> ans;
    int cur = 0;
    while (all.size() > 1 && !bad.empty()) {
        int x = R(bad, cur);
        int y = R(all, x + 1);
        cur = (y + 1) % n;
        ans.push_back(y);
        del(y);
    }
    if (all.size() == 1 && a[*all.begin()] == 1) ans.push_back(*all.begin());
    cout << ans.size() << " ";
    for (int x : ans) cout << x + 1 << " ";
    cout << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
