#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define fr(i, a, b) for(int (i) = (a); (i) < (b); i++)
#define endl "\n";

const int N = 3e5 + 100;

int tree[4 * N];
int mod[4 * N];

void push(int u){
	mod[2 * u + 1] += mod[u];
	mod[2 * u + 2] += mod[u];
	tree[2 * u + 1] += mod[u];
	tree[2 * u + 2] += mod[u];
	mod[u] = 0;
}

void add(int u, int l, int r, int ql, int qr, int v){
	if(qr <= l || r <= ql) return;
	if(ql <= l && r <= qr){
		mod[u] += v;
		tree[u] += v;
		return;
	}
	push(u);
	int m = (l + r) >> 1;
	add(2 * u + 1, l, m, ql, qr, v);
	add(2 * u + 2, m, r, ql, qr, v);
	tree[u] = max(tree[2 * u + 1], tree[2 * u + 2]);

}

int get(int u, int l, int r, int ql, int qr){
	if(qr <= l || r <= ql) return -1e18;
	if(ql <= l && r <= qr) return tree[u];
	push(u);
	int m = (l + r) >> 1;
	return max(get(2 * u + 1, l, m, ql, qr), get(2 * u + 2, m, r, ql, qr));
}

void solve(){
	int n;
	cin >> n;
	vector<int> h(n + 1), b(n + 1), dp(n + 1);
	fr(i, 1, n + 1) cin >> h[i];
	fr(i, 1, n + 1) cin >> b[i];
	vector<pair<int, int>> st;
	st.push_back({0, 1});
	fr(i, 1, n + 1){
		while(st.back().first > h[i]){
			int l = st[st.size() - 2].second, r = st.back().second;
			add(0, 0, n + 3, l, r, -b[r - 1]);
			// cout << -b[r - 1];
			st.pop_back();
		}
		int l = st.back().second, r = i + 1;
		// cout << l << ' ' << r << endl;
		st.push_back({h[i], i + 1});
		add(0, 0, n + 3, l, r, b[i]);
		// fr(i, 0, n + 1) cout << get(0, 0, n + 3, i, i + 1) << ' ';
		// cout << endl;
		dp[i] = get(0, 0, n + 3, 1, i + 1);
		add(0, 0, n + 3, i + 1, i + 2, dp[i]);
	}
	// cout << dp[2];
	// cout << get(0, 0, n + 3, 1, n + 1);
	cout << dp[n];
}

signed main(){
	#ifndef LOCAL
// 		freopen("input.txt", "r", stdin);
// 		freopen("output.txt", "w", stdout);
	#endif
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	// cin >> t;
	while(t--) {solve();}

	return 0;	
}