#include<bits/stdc++.h>

using namespace std;

#define int long long
int const maxn = 3e5 + 5;
int h[maxn], b[maxn];
int l[maxn], r[maxn];
int in[(1 << 21)], psh[(1 << 21)];
int inf = 1e18;

void build(int i, int l, int r) {
    psh[i] = -inf;
    if (r - l == 1) {
        if (l == 0) in[i] = 0;
        else in[i] = -inf;
    }
    else {
        int m = (r + l) / 2;
        build(2 * i + 1, l, m);
        build(2 * i + 2, m, r);
        in[i] = max(in[2 * i + 1], in[2 * i + 2]);
    }
}

inline void push(int i) {
    in[i] = max(in[i], psh[i]);
    psh[2 * i + 1] = max(psh[2 * i + 1], psh[i]);
    psh[2 * i + 2] = max(psh[2 * i + 2], psh[i]);
}

void add(int i, int l, int r, int lq, int rq, int x) {
    push(i);
    if (lq >= r || l >= rq) return;
    if (lq <= l && r <= rq) {
        psh[i] = max(x, psh[i]);
        push(i);
        return;
    }
    int m = (r + l) / 2;
    add(2 * i + 1, l, m, lq, rq, x);
    add(2 * i + 2, m, r, lq, rq, x);
    in[i] = max(in[2 * i + 1], in[2 * i + 2]);
}

int get(int i, int l, int r, int lq, int rq) {
    push(i);
    if (lq >= r || l >= rq) return -inf;
    if (lq <= l && r <= rq) return in[i];
    int m = (r + l) / 2;
    return max(get(2 * i + 1, l, m, lq, rq), get(2 * i + 2, m, r, lq, rq));
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> h[i];
    for (int i = 1; i <= n; ++i) {
        cin >> b[i];
    }
    build(0, 0, n + 1);
    vector < int > top;
    for (int i = 1; i <= n; ++i) {
        while ((int)top.size() && h[top.back()] > h[i]) top.pop_back();
        if ((int)top.size() == 0) l[i] = 1;
        else l[i] = top.back() + 1;
        top.push_back(i);
    }
    top = {};
    for (int i = n; i >= 1; --i) {
        while ((int)top.size() && h[top.back()] > h[i]) top.pop_back();
        if ((int)top.size() == 0) r[i] = n;
        else r[i] = top.back() - 1;
        top.push_back(i);
    }
    for (int i = 1; i <= n; ++i) {
        add(0, 0, n + 1, i, r[i] + 1, get(0, 0, n + 1, l[i] - 1, i) + b[i]);
    }
    cout << get(0, 0, n + 1, n, n + 1);
    return 0;
}

