#include <bits/stdc++.h>

#define x first
#define y second
#define ndl '\n'
#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;


const ll INF = 1e18;
const int inf = 1e9+123;
const int N = 3e5 + 123;

int h[N], b[N], n;

ll t[N*4], tadd[N*4], dp[N];

void push(int v, int len){
    t[v] += tadd[v];
    if (len > 1){
        tadd[v+v+1] += tadd[v];
        tadd[v+v+2] += tadd[v];
    }
    tadd[v] = 0;
}

void upd(int l, int r, ll x, int v = 0, int tl = 0, int tr = n+1){
    push(v, tr-tl);
    if (l >= tr || tl >= r) return;
    if (l <= tl && tr <= r){
        tadd[v] += x;
        push(v, tr-tl);
        return;
    }
    int tm = (tl+tr) >> 1;
    upd(l, r, x, v+v+1, tl, tm);
    upd(l, r, x, v+v+2, tm, tr);
    t[v] = max(t[v+v+1], t[v+v+2]);
}


void solve(){
    cin >> n;
    for (int i = 1; i <= n; i++){
        cin >> h[i];
    }
    for (int i = 1; i <= n; i++){
        cin >> b[i];
    }
    vector<pii> v;
    for (int i = 1; i <= n; i++){
        upd(i-1, i, dp[i-1]);

        int l = i-1;
        while (!v.empty() && h[v.back().y] > h[i]){
            upd(v.back().x, l, -b[v.back().y]);
            l = v.back().x;

            v.pop_back();
        }
        v.pb({l, i});
        
        upd(l, i, b[i]);

        upd(0, i, INF);

        dp[i] = t[0] - INF;

        upd(0, i, -INF);
       // cout << dp[i] << ndl;

    }
    cout << dp[n];
}

int main(){
    #ifndef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    while (t--){
        solve();
    }
    return 0;
}