#include <bits/stdc++.h>
#define int long long

#define all(x) (x).begin(), (x).end()

using namespace std;

const int N = 3e5 + 100, INF = LLONG_MIN / 3;
int tree[4 * N];

void upd(int v, int l, int r, int ind, int val) {
    if (r - l == 1) {
        tree[v] = val;
        return;
    }

    int m = (l + r) / 2;
    if (ind < m)
        upd(v * 2 + 1, l, m, ind, val);
    else
        upd(v * 2 + 2, m, r, ind, val);
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql)
        return INF;

    int m = (l + r) / 2;
    return max(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}

void solve() {
    int n;
    cin >> n;
    vector <int> h(n), b(n);
    for (int& i : h)
        cin >> i;
    for (int& i : b)
        cin >> i;

    vector <pair <int, int>> st = {{h[0], 0}};
    upd(0, 0, n, 0, b[0]);

    for (int i = 1; i < n; i++) {
        while (!st.empty() && st.back().first > h[i])
            st.pop_back();

        if (st.empty()) {
            int ans = max(0LL, get(0, 0, n, 0, i)) + b[i];
            upd(0, 0, n, i, ans);
        } else {
            int ans = get(0, 0, n, st.back().second, i) + b[i];
            upd(0, 0, n, i, max(ans, get(0, 0, n, st.back().second, st.back().second + 1)));
        }
        st.emplace_back(h[i], i);
    }
    cout << get(0, 0, n, n - 1, n) << endl;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}
