#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#define int long long
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;

#define all(a) (a).begin(), (a).end()
#define pb push_back
#define eb emplace_back
#define put(a) cout << (a) << "\n"
#define rep(a, b, c) for (int a = b; a < c; ++a)
#define asd(n) rep(i, 0, n)
#define jkl(n) rep(j, 0, n)
#define len(a) ((int)(a).size())
#define mp make_pair
#ifdef LOCAL
#include "debug.h"
#else
#define dbg(...) 
#endif
const int INF = 1e18;
inline bool chkmax(int &a, int b) {
	if (a < b) {
		a = b;;
		return true;
	}
	return false;
}
const int N = 131072 * 4;
int t[N * 2];
int add[N * 2];
int max_dp[N * 2];
int dp[N];
void push(int v) {
	if (add[v] != INF) {
		add[v * 2] = add[v * 2 + 1] = add[v];
		add[v] = INF;
	}
}
int get(int v) {
	if (add[v] == INF) return t[v];
	return max_dp[v] + add[v];
}
void rec(int v) {
	t[v] = max(get(v * 2), get(v * 2 + 1));
	max_dp[v] = max(max_dp[v * 2], max_dp[v * 2 + 1]);
}
void build(int v, int lv, int rv) {
	if (rv - lv == 1) {
		max_dp[v] = dp[lv];
		t[v] = dp[lv];
		return;
	}
	int mv = (rv + lv) / 2;
	build(v * 2, lv, mv);
	build(v * 2 + 1, mv, rv);
	rec(v);
}
int get(int v, int lv, int rv, int l, int r) {
	if (lv >= l && rv <= r) {
		return get(v);
	}
	if (lv >= r || rv <= l) return -INF;
	int mv = (rv + lv) / 2;
	push(v);
	auto q1 = get(v * 2, lv, mv, l, r);
	auto q2 = get(v * 2 + 1, mv, rv, l, r);
	rec(v);
	return max(q1, q2);
}
void upd2(int v, int lv, int rv, int i, int x) {
	if (i >= rv || i < lv) return;
	if (rv - lv == 1) {
		dp[lv] = x;
		max_dp[v] =  dp[lv];
		t[v] = dp[lv];
		if (add[v] != INF) t[v] += add[v];
		add[v] = INF;
		return;
	}
	int mv = (rv + lv) / 2;
	push(v);
	upd2(v * 2, lv, mv, i, x);
	upd2(v * 2 + 1, mv, rv, i, x);
	rec(v);
}
void upd(int v, int lv, int rv, int l, int r, int x) {
	if (lv >= l && rv <= r) {
		add[v] = x;
		return;
	}
	if (lv >= r || rv <= l) return;
	int mv = (rv + lv) / 2;
	push(v);
	upd(v * 2, lv, mv, l, r, x);
	upd(v * 2 + 1, mv, rv, l, r, x);
	rec(v);
}
void solve() {
	asd(N * 2) add[i] = INF;
	int n;
	cin >> n;
	vi h(n);
	asd(n) cin >> h[i];
	vi c(n);
	asd(n) cin >> c[i];
	asd(n + 1) dp[i] = -INF;
	dp[0] = 0;
	vi le(n, -1);
	vi st;
	for (int i = n - 1; i >= 0; --i) {
		while (len(st) && h[st.back()] > h[i]) {
			le[st.back()] = i;
			st.pop_back();
		}
		st.eb(i);
	}
	vi add(n + 1);
	build(1, 0, n + 1);
	rep(i, 1, n + 1) {
		upd(1, 0, n + 1, le[i - 1] + 1, i, c[i - 1]);
		upd2(1, 0, n + 1, i, get(1, 0, n + 1, 0, i));
	}
	put(get(1, 0, n + 1, n, n + 1));
}
signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int q = 1;
	// cin >> q;
	while (q--) solve();
}