#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define double long double
#define pb push_back
#define in insert
#define u_set unorered_set
#define u_map unordered_map
#define f first
#define s second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()
#define vec vector
#define mp make_pair
#define endl '\n'

template <typename A, typename B> bool mini(A &el1, const B el2) {
    if (el2 < el1) {
        el1 = el2;
        return true;
    }
    return false;
}

template <typename A, typename B> bool maxi(A &el1, const B el2) {
    if (el2 > el1) {
        el1 = el2;
        return true;
    }
    return false;
}

const int inf = 1e18;

const int maxN = 3 * 1e5 + 1000;

int t[4 * maxN];
int t_min[4 * maxN];

void upd(int i, int l, int r, int pos, int val) {
    if (pos < l || pos >= r) {
        return;
    }
    if (r - l == 1) {
        t[i] = val;
        return;
    }
    int mid = (l + r) / 2;
    upd(i * 2 + 1, l, mid, pos, val);
    upd(i * 2 + 2, mid, r, pos, val);
    t[i] = max(t[i * 2 + 1], t[i * 2 + 2]);
}

int get(int i, int l, int r, int qL, int qR) {
    if (l >= qR || r <= qL) {
        return -inf;
    }
    if (l >= qL && r <= qR) {
        return t[i];
    }
    int mid = (l + r) / 2;
    return max(get(i * 2 + 1, l, mid, qL, qR), get(i * 2 + 2, mid, r, qL, qR));
}

int get(int i, int l, int r, int val) {
    if (r - l == 1) {
        return l;
    }
    int mid = (l + r) / 2;
    if (t_min[i * 2 + 2] < val) {
        return get(i * 2 + 2, mid, r, val);
    } else {
        return get(i * 2 + 1, l, mid, val);
    }
}

void upd_t_min(int i, int l, int r, int pos, int val) {
    if (pos < l || pos >= r) {
        return;
    }
    if (r - l == 1) {
        t_min[i] = val;
        return;
    }
    int mid = (l + r) / 2;
    upd_t_min(i * 2 + 1, l, mid, pos, val);
    upd_t_min(i * 2 + 2, mid, r, pos, val);
    t_min[i] = min(t_min[i * 2 + 1], t_min[i * 2 + 2]);
}

void solve() {

    for (int i = 0; i < 4 * maxN; i++) {
        t[i] = -inf;
        t_min[i] = inf;
    }

    int n;
    cin >> n;
    vec<int> a(n + 1);
    a[0] = -inf;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    vec<int> cost(n + 1);
    cost[0] = 0;
    for (int i = 1; i <= n; i++) {
        cin >> cost[i];
    }

    vec<int> pos(n + 1, 0);

    upd_t_min(0, 0, maxN, 0, a[0]);

    for (int i = 1; i <= n; i++) {
        int ans = get(0, 0, maxN, a[i]);
        pos[i] = ans;
        upd_t_min(0, 0, maxN, i, a[i]);
    }

//    for (auto now : pos) {
//        cout << now << ' ';
//    }
//    cout << endl;


    vec<int> dp(n + 1, -inf);
    dp[0] = 0;

    upd(0, 0, maxN, 0, dp[0]);

    for (int i = 1; i <= n; i++) {
//        int j = i;
//        while (j >= 0 && a[j] >= a[i]) {
//            maxi(dp[i], dp[j - 1] + cost[i]);
//            j--;
//        }

        int j = pos[i];

        // [j, i)
        maxi(dp[i], get(0, 0, maxN, j, i) + cost[i]);

        // a[j] < a[i]
        if (j != 0) maxi(dp[i], dp[j]);

        upd(0, 0, maxN, i, dp[i]);
    }

    cout << dp[n] << endl;

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}

