#include <bits/stdc++.h>

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int)(a).size()

#define x first
#define y second

#define pub push_back
#define pob pop_back

#define puf push_front
#define pof pop_front

using namespace std;

typedef pair<int, int> pii;


const int NMAX = 300010;

const long long INF = (long long)2e18 + 109;

int h[NMAX];
long long b[NMAX];
long long dp[NMAX];
int prv[NMAX];

vector<int> v;


const int TREE_SZ = 4 * NMAX;

struct NODE {
    long long max_;

    NODE(long long x) {
        max_ = x;
    }

    NODE() {}
};

NODE tree[TREE_SZ];

long long query(int v, int l, int r, int ql, int qr) {
    //cout << "QQQQ " << v << " " << l << " " << r << " " << ql << " " << qr << "\n";

    if (l == ql && r == qr) {
        return tree[v].max_;
    }

    int m = (l + r) >> 1;
    if (qr <= m) {
        return query(2 * v + 1, l, m, ql, qr);
    } else if (ql >= m) {
        return query(2 * v + 2, m, r, ql, qr);
    }

    long long a = query(2 * v + 1, l, m, ql, m), b = query(2 * v + 2, m, r, m, qr);
    return max(a, b);
}


void inc(int v, int l, int r, int ind) {
    if (l + 1 == r) {
        tree[v].max_ = dp[l];
        return;
    }

    int m = (l + r) >> 1;

    if (ind < m) {
        inc(2 * v + 1, l, m, ind);
    } else {
        inc(2 * v + 2, m, r, ind);
    }

    tree[v].max_ = max(tree[2 * v + 1].max_, tree[2 * v + 2].max_);
}



void solve_solve_solve() {
    int n;
    cin >> n;

    h[0] = -1;
    for (int i = 1; i <= n; i++) {
        cin >> h[i];
    }

    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }


    v = {0};
    for (int i = 1; i <= n; i++) {
        while (h[v.back()] > h[i]) {
            v.pob();
        }

        prv[i] = v.back();
        v.pub(i);
    }


    fill(tree, tree + TREE_SZ, NODE(-INF));

    dp[0] = 0;

    prv[0] = -1;

    for (int i = 1; i <= n; i++) {
        if (prv[i] == 0) {
            dp[i] = b[i];
        } else {
            dp[i] = dp[prv[i]];
        }

        dp[i] = max(dp[i], query(0, 0, NMAX, prv[i], i) + b[i]);

        inc(0, 0, NMAX, i);
    }


    long long ans = dp[n];
    cout << ans << "\n";

}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    solve_solve_solve();

    return 0;
}
