#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll alp = 26, mx1 = 3e5 + 10, inff = 1e18;

#define ff first
#define ss second
#define pb push_back
#define vec vector
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fopen(a, b) freopen(a, "r", stdin); freopen(b, "w", stdout)

ll gcd(ll a, ll b) {
	return b ? gcd(b, a%b) : a;
}

void run() {
	ll n;
	cin >> n;
	vi h(n), b(n);
	for (auto &v : h)
		cin >> v;
	for (auto &v : b)
		cin >> v;
	vec<pll> stk;
	stk.pb({0, b[0]});
	vec<ll> dp(n + 1, -inff);
	set<pll> tt;
	dp[0] = b[0];
	tt.insert({-b[0], 0});
	for (ll i = 1; i < n; ++i) {
		pll tmp = {dp[i - 1], -inff};
		while (!stk.empty() && h[stk.back().ff] >= h[i]) {
			tmp.ff = max(tmp.ff, max(stk.back().ss - b[stk.back().ff], dp[stk.back().ff]));
			tt.erase({-dp[stk.back().ff], stk.back().ff});
			stk.pop_back();
		}
		if (tt.empty() || tmp.ff + b[i] > -tt.begin()->ff) {
			dp[i] = tmp.ff + b[i];
			tt.insert({-dp[i], i});
		}
		else {
			dp[i] = -tt.begin()->ff;
		}
		stk.pb({i, tmp.ff + b[i]});
	}
	cout << dp[n - 1];
}

signed main() {
	// fopen("input.txt", "output.txt");
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll kk = 0, tkk = 1;
	// cin >> tkk;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}