#pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,sse4")
// #pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long
#define ull unsigned long long
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define all(a) (a).begin(), (a).end()
#define gsz(a) ((int)(a).size())
#define orset tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
// #define LOCAL
#ifdef LOCAL
#define dbg(x) cerr << #x << ": " << (x) << endl
#define print(x) cerr << (x) << endl
#else
#define dbg(x) 0
#define print(x) 0
#endif

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 1e6 + 10;
const int inf = 1e18 + 10;
const int mod = 1e9 + 7;

int n;
int h[N];
int b[N];

struct node{
	mutable int val;
	int h;
	mutable int b;
	mutable int pmx;

	bool operator<(const node &o) const
	{
		return h < o.h;
	}

	bool operator<(int o) const
	{
		return h < o;
	}
};

int32_t main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n;

	for(int i = 0; i < n; ++i)
		cin >> h[i];

	for(int i = 0; i < n; ++i)
		cin >> b[i];

	set<node, less<>> st;

	st.insert({0, inf, 0, -inf});

	int lst = 0;

	for(int i = 0; i < n; ++i)
	{
		auto it = st.lower_bound(h[i]);

		if(it != st.end())
		{
			int mx = -inf;

			while(it != st.end())
			{
				mx = max(mx, it->val);
				it = st.erase(it);
			}

			it = st.end();
			int pmx = -inf;

			if(it != st.begin())
			{
				--it;
				pmx = it->pmx;
			}

			st.insert({mx, h[i], b[i], max(pmx, mx + b[i])});
		}

		lst = st.rbegin()->pmx;
		st.insert({st.rbegin()->pmx, inf, -inf, st.rbegin()->pmx});
	}

	cout << lst << endl;
}

