#include "bits/stdc++.h"
using namespace std;
using ll = long long;
#define int ll
using pii = pair<int, int>;
using vpii = vector<pii>;
using vint = vector<int>;
using ar3 = array<int, 3>;
using va3 = vector<ar3>;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define pob pop_back
#define _bp __builtin_popcount
#define all(arr) (arr).begin(), (arr.end())
#define range(i, n) for (int i = 0; i < n; ++i)
#define sz(arr) (arr).size()
#define sort stable_sort
const int N = 1e5+5;
const int Inf = 1e9+7;
const ll inf = 1e18+7;

// #define cerr if (0) cerr

int n;

struct seg_t {
	int n, s, e;
	vint t;
	ll val;
	void build(int nn) {
		n = nn;
		t.assign(4 * n, 0);
	}
	void upd_t(int v, int vl, int vr) {
		t[v] = max(t[vl], t[vr]);
	}
	ll get(int l, int r) {
		s = l;
		e = r;
		val = -inf;
		get_t(1, 0, n);
		return val;
	}
	void get_t(int v, int l, int r) {
		if (s <= l && r <= e) {
			val = max(val, t[v]);
			return;
		}
		if (s >= r || l >= e || l >= r)
			return;
		int m = (l + r) >> 1, vl = v << 1, vr = vl ^ 1;
		get_t(vl, l, m);
		get_t(vr, m, r);
	}
	void set(int ind, int vl) {
		s = ind;
		val = vl;
		set_t(1, 0, n);
	}
	void set_t(int v, int l, int r) {
		if (r - l == 1) {
			t[v] = val;
			return;
		}
		int m = (l + r) >> 1, vl = v << 1, vr = vl ^ 1;
		if (s < m)
			set_t(vl, l, m);
		else
			set_t(vr, m, r);
		upd_t(v, vl, vr);
	}
};

void solve() {
	cin >> n;
	vint a(n), b(n);
	range(i, n)
		cin >> a[i];
	range(i, n)
		cin >> b[i];
	vint ans(n + 1, 0);
	vint st;
	seg_t sgt;
	sgt.build(n);
	for (int i = 0; i < n; ++i) {
		ans[i + 1] = ans[i] + b[i]; 
		while (sz(st) && a[st.back()] > a[i]) {
			// auto t = st.back();
			// cerr << t << " -> " << i << '\n';
			// ans[i + 1] = max(ans[i + 1], ans[t] + b[i]);
			st.pob();
			// ms.pob();
		}
		int ind = 0;
		if (sz(st)) {
			ind = st.back();
			// cerr << st.back() << " -> " << i << '\n';
			ans[i + 1] = max(ans[i + 1], ans[st.back() + 1]);
		} else {
			ans[i + 1] = max(ans[i + 1], b[i]);
		}
		// cerr << ind << ' '  << i << '\n';
		if (i - ind > 0) {
			// cerr << "A: " << sgt.get(ind, i) << ' ' << b[i] << '\n';
			ans[i + 1] = max(ans[i + 1], sgt.get(ind, i) + b[i]);
		}
		st.pb(i);
		sgt.set(i, ans[i + 1]);
	}
	// range(i, n)
	// 	cerr << ans[i + 1] << ' '; 
	cout << ans[n] << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}