#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef pair<int, int> pii;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define all(x) (x).begin(), (x).end()
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - x.begin())

const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ll INFLL = 1e18;

ll inq(ll x, ll y)
{
    if (y == 0) return 1;
    ll l = inq(x, y / 2);
    l = l * l % MOD;
    if (y % 2) l = l * x % MOD;
    return l;
}

const int N = 4e5;

ll T[4 * N];

void Set(int pos, ll x, int L = 0, int R = N, int V = 0)
{
    if (L + 1 == R)
    {
        T[V] = x;
        return;
    }
    int M = (L + R) / 2;
    if (pos < M) Set(pos, x, L, M, 2 * V + 1);
    else Set(pos, x, M, R, 2 * V + 2);
    T[V] = max(T[2 * V + 1], T[2 * V + 2]);
}

ll Get(int l, int r, int L = 0, int R = N, int V = 0)
{
    if (r <= L || R <= l) return -INFLL;
    if (l <= L && R <= r) return T[V];
    int M = (L + R) / 2;
    return max(Get(l, r, L, M, 2 * V + 1), Get(l, r, M, R, 2 * V + 2));
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; i++) cin >> p[i], p[i]--;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<pair<int, int> > st;
    st.push_back({-1, -INF});
    for (int i = 0; i < n; i++)
    {
        while (st.back().second > p[i])
            st.pop_back();
        ll dp = -INFLL;
        st.push_back({i, p[i]});
        for (int j = 0; j + 1 < st.size(); j++)
        {
            dp = max(dp, Get(st[j].first + 1, st[j + 1].first + 1) + a[st[j + 1].first]);
        }
        //cout << dp << endl;
        if (i + 1 == n)
            cout << dp << "\n";
        Set(i + 1, dp);
    }
}
