#include <bits/stdc++.h>

using namespace std;
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune=native")
#pragma optimaze("O3")

#define int long long

typedef long long ll;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

ll mod = 1e9 + 7;

ll mul(ll a, ll b) {
    return (a * b) % mod;
}

ll sm(ll a, ll b) {
    if (a + b < mod) return a + b;
    return (a + b - mod);
}

ll divv(ll a, ll b) {
    if (a >= b) return a - b;
    return a - b + mod;
}

ll pw(ll a, ll k) {
    if (k == 0) return 1;
    if (k % 2) return mul(a, pw(a, k - 1));
    return pw(mul(a, a), k / 2);
}


int maxn = 3e5 + 1;

int inf = 1e18;
vector<int> t(4 * maxn, -inf);


int get(int v, int l, int r, int ll, int rr) {
    if (l >= rr || r <= ll) {
        return -inf;
    }
    if (l >= ll && r <= rr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ll, rr),
               get(2 * v + 2, m, r, ll, rr));
}

void upd(int v, int l, int r, int pos, int val) {
    if (l > pos || r <= pos) return;
    if (l + 1 == r) {
        t[v] = val;
        return;
    }
    int m = (l + r) / 2;
    upd(2 * v + 1, l, m, pos, val);
    upd(2 * v + 2, m, r, pos, val);
    t[v] = max(t[2 * v + 1], t[ 2 * v + 2]);
    return;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;  // cin >> t;
    while (t--) {
        int n; cin >> n;
        vector<int> h(n);
        vector<int> a(n);
        vector<int> dp(n + 1);
        vector<int> st;
        for (int i = 0; i < n; i++) {
            cin >> h[i];
        }
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        dp[0] = 0;
        upd(0, 0, n + 1, 0, dp[0]);
        for (int i = 0; i < n; i++) {
            while (!st.empty() && h[st.back()] > h[i]) {
                st.pop_back();
            }
            if (st.empty()) {
                dp[i + 1] = get(0, 0, n + 1, 0, i + 1) + a[i];
            } else {
                int j = st.back();
                dp[i + 1] = max(dp[j + 1], get(0, 0, n + 1, j + 1, i + 1) + a[i]);
            }
            upd(0, 0, n + 1, i + 1, dp[i + 1]);
            st.push_back(i);
        }
        cout << dp[n] << endl;




    }


    return 0;
}
