#include<bits/stdc++.h>

using namespace std;

string tostr(string s) {
    string res = "";
    res.push_back('"');
    res += s;
    res.push_back('"');
    return res;
}

string tostr(char c) {
    string res = "";
    res += "'";
    res.push_back(c);
    res += "'";
    return res;
}

string tostr(long long x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + (x % 10));
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

string tostr(int x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + x % 10);
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

template<typename A, typename B>
string tostr(pair<A, B> a) {
    return "{" + tostr(a.first) + ", " + tostr(a.second) + "}";
}

template<typename A>
string tostr(vector<A> a) {
    string res = "{";
    bool f = false;
    for (auto x : a) {
        if (!f) {
            f = true;
        }
        else {
            res += ", ";
        }
        res += tostr(x);
    }
    res += "}";
    return res;
}

#define debug(x) cout << #x << " = " << tostr(x) << endl
#define int long long
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
#define ld long double
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int) (a).size()

vector<int> t;

void update(int v, int l, int r, int i, int x) {
    if (l + 1 == r) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) update(v * 2 + 1, l, m, i, x);
    else update(v * 2 + 2, m, r, i, x);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int l, int r, int l1, int r1) {
    if (l1 >= r || l >= r1) return -1e18;
    if (l1 <= l && r <= r1) return t[v];
    int m = (l + r) / 2;
    return max(get(v * 2 + 1, l, m, l1, r1), get(v * 2 + 2, m, r, l1, r1));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> h(n), b(n);
    for (int i = 0; i < n; i++) cin >> h[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    vector<int> dp(n + 1, 0);
    vector<int> mn, l, r;
    multiset<int> z;
    t.resize(4 * (n + 1), -1e18);
    update(0, 0, n + 1, 0, 0);
    for (int i = 0; i < n; i++) {
        //debug(i);
        //debug(mn);
        //debug(l);
        //debug(r);
        //debug(z);
        while (sz(mn) && h[mn.back()] > h[i]) {
            z.erase(z.find(b[mn.back()] + get(0, 0, n + 1, l.back(), r.back() + 1)));
            mn.pop_back();
            l.pop_back();
            r.pop_back();
        }
        //debug(i);
        int L = 0;
        if (sz(mn)) L = r.back() + 1;
        int R = i;
        mn.pb(i);
        l.pb(L);
        r.pb(R);
        z.insert(b[mn.back()] + get(0, 0, n + 1, l.back(), r.back() + 1));
        dp[i + 1] = *z.rbegin();
        update(0, 0, n + 1, i + 1, dp[i + 1]);
    }
    //debug(dp);
    cout << dp[n];
}
