#ifdef _LOCAL_MSVC
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")*/

using namespace std;
using ll = long long;
using ld = long double;
constexpr int MAXN = (int)3e5;
constexpr ll INF = (ll)4e18;

ll h[MAXN], b[MAXN], dp[MAXN + 1];
ll t[4 * (MAXN + 1)], op[4 * (MAXN + 1)];

void upd(int v, int l, int r, int pos, ll val) {
	if (r - l == 1) {
		t[v] = val;
	} else {
		int m = (l + r) >> 1;
		if (pos < m)
			upd(2 * v + 1, l, m, pos, val);
		else
			upd(2 * v + 2, m, r, pos, val);
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	}
}

ll get(int v, int l, int r, int ql, int qr) {
	if (l >= qr || r <= ql)
		return -INF;
	if (l >= ql && r <= qr)
		return t[v];

	int m = (l + r) >> 1;
	return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	if (argc > 1)
		freopen(argv[1], "r", stdin);
	if (argc > 2)
		freopen(argv[2], "w", stdout);

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> h[i];
	for (int i = 0; i < n; ++i)
		cin >> b[i];

	dp[0] = 0;
	fill(dp + 1, dp + n + 1, -INF);
	stack<int> st;
	stack<ll> val;

	for (int i = 0; i < n; ++i) {
		while (!st.empty() && h[st.top()] > h[i]) {
			st.pop();
			val.pop();
		}
		dp[i + 1] = get(0, 0, n + 1, st.empty() ? 0 : st.top() + 1, i + 1) + b[i];
		if (!val.empty())
			dp[i + 1] = max(dp[i + 1], val.top());

		upd(0, 0, n + 1, i + 1, dp[i + 1]);
		st.push(i);
		val.push(val.empty() ? dp[i + 1] : max(dp[i + 1], val.top()));
	}

	cout << dp[n];

	return 0;
}