#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define endl '\n'
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define mp make_pair
typedef pair<int, int> pii;
typedef long long ll;
typedef double db;
typedef long double ldb;

ll t[1200000];
struct segment_tree {
    int n;

    segment_tree(int n) : n(n) {}

    void pull(int v) {
        t[v] = max(t[v << 1], t[(v << 1) + 1]);
    }

    void set(int v, int vl, int vr, int ind, ll val) {
        if (ind < vl || ind >= vr) {
            return;
        }
        if (vl + 1 == vr) {
            t[v] = val;
            return;
        }
        int m = (vl + vr) >> 1;
        set(v << 1, vl, m, ind, val);
        set((v << 1) + 1, m, vr, ind, val);
        pull(v);
    }

    void set(int ind, ll val) {
        set(1, 0, n, ind, val);
    }

    ll q_max(int v, int vl, int vr, int l, int r) {
        if (l >= r) {
            return -1e18;
        }
        if (vl == l && vr == r) {
            return t[v];
        }
        int m = (vl + vr) >> 1;
        ll r1 = q_max(v << 1, vl, m, l, min(r, m));
        ll r2 = q_max((v << 1) + 1, m, vr, max(l, m), r);
        return max(r1, r2);
    }

    ll q_max(int l, int r) {
        return q_max(1, 0, n, l, r);
    }
};

int h[300000], b[300000];

signed main() {
    fastream;
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    segment_tree dp(n + 1);
    vector<int> st;
    for (int i = 0; i < n; i++) {
        while (!st.empty() && h[i] < h[st.back()]) {
            st.pop_back();
        }
        if (st.empty()) {
            // cout << dp.q_max(0, i + 1) + b[i] << ' ';
            dp.set(i + 1, dp.q_max(0, i + 1) + b[i]);
        } else {
            int mn = st.back();
            // cout << max(dp.q_max(mn + 1, mn + 2), dp.q_max(mn + 2, i + 1) + b[i]) << ' ';
            dp.set(i + 1, max(dp.q_max(mn + 1, mn + 2), dp.q_max(mn + 1, i + 1) + b[i]));
        }
        st.push_back(i);
    }
    // cout << endl;
    cout << dp.q_max(n, n + 1) << endl;
}
