#include<bits/stdc++.h>

#define fi first
#define se second
#define ll long long

using namespace std;

const int N = 3e5 + 7;

int n;
ll h[N];
ll b[N];
ll d[N];
ll f[4 * N];
ll t[4 * N];
ll lz[4 * N];

void push(int x)
{
    if(lz[x] == -1e18)return;
    lz[x + x] = lz[x + x + 1] = lz[x];
    t[x + x] = f[x + x] + lz[x];
    t[x + x + 1] = f[x + x + 1] + lz[x];
    lz[x] = -1e18;
}

void upd(int x , int l , int r , int tl , int tr , ll val)
{
    if(tl > tr)return;
    if(l == tl && r == tr){
        t[x] = val + f[x];
        lz[x] = val;
        return;
    }
    int m = (l + r) / 2;
    push(x);
    upd(x + x , l , m , tl , min(tr , m) , val);
    upd(x + x + 1 , m + 1 , r , max(tl, m + 1) , tr , val);
    t[x] = max(t[x + x] , t[x + x + 1]);
}

void upd1(int x , int l , int r , int p , ll val)
{
    if(l == r){
        f[x] = val;
        return;
    }
    int m = (l + r) / 2;
    push(x);
    if(p <= m)upd1(x + x , l , m , p , val);
    else upd1(x + x + 1 , m + 1 , r , p , val);
    f[x] = max(f[x + x] , f[x + x + 1]);
}

void solve()
{
    cin >> n;
    for(int i = 1; i <= n; i++){
        cin >> h[i];
    }
    for(int i = 1; i <= n; i++){
        cin >> b[i];
    }
    for(int i = 1; i <= 4 * n; i++)lz[i] = t[i] = -1e18;
    stack<int> st;
    for(int i = 1; i <= n; i++){
        while(!st.empty() && h[st.top()] > h[i]){
            st.pop();
        }
        int ls = 1;
        if(!st.empty())ls = st.top() + 1;
        st.push(i);
        upd(1, 0 , n , ls , i , b[i]);
        d[i] = t[1];
        if(i < n)upd1(1 , 0 , n , i + 1 , d[i] );
    }
    cout << d[n];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int T = 1;
    //cin >> T;
    while(T--){
        solve();
    }
}
