#include <bits/stdc++.h>
#define int long long

using namespace std;

const int N = 2e6;
const int MIN = -1e18;

int t[N];

void build(int i, int l, int r) {
    t[i] = MIN;
    if (l + 1 == r) return;
    build(2 * i + 1, l, (l + r) / 2);
    build(2 * i + 2, (l + r) / 2, r);
}

void upd(int i, int l, int r, int qi, int x) {
    if (qi == l && l + 1 == r) {
        t[i] = x;
        return;
    }
    if (qi < l || qi >= r) {
        return;
    }
    upd(2 * i + 1, l, (l + r) / 2, qi, x);
    upd(2 * i + 2, (l + r) / 2, r, qi, x);
    t[i] = max(t[2 * i + 1], t[2 * i + 2]);
}

int get_max(int i, int l, int r, int ql, int qr) {
    if (qr <= l || ql >= r) {
        return MIN;
    }
    if (ql <= l && r <= qr) {
        return t[i];
    }
    return max(get_max(2 * i + 1, l, (l + r) / 2, ql, qr), get_max(2 * i + 2, (l + r) / 2, r, ql, qr));
}

signed main() {
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    vector <int> h(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    build(0, 0, n + 1);
    vector <int> left(n, 0);
    vector <int> s; int l = 0;
    for (int i = n - 1; i >= 0; --i) {
        while (l > 0 && h[s.back()] > h[i]) {
            left[s.back()] = i + 1;
            s.pop_back();
            l--;
        }
        s.push_back(i);
        l++;
    }
    int dp[n + 1];
    dp[0] = 0;
    upd(0, 0, n + 1, 0, 0);
    for (int i = 1; i <= n; ++i) {
        dp[i] = MIN;
        if (left[i - 1] != 0) {
            dp[i] = dp[left[i - 1]];
            dp[i] = max(dp[i], get_max(0, 0, n + 1, left[i - 1], i) + b[i - 1]);
        } else {
            dp[i] = max(dp[i], get_max(0, 0, n + 1, 0, i) + b[i - 1]);
        }
        upd(0, 0, n + 1, i, dp[i]);
        //cout << dp[i] << "\n";
    }
    cout << dp[n] << "\n";
}
