#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int R = 1 << 19, inf = 1e16;
int t[R * 2];
int get(int ql, int qr, int node = 1, int nl = 0, int nr = R) {
    if (ql <= nl && nr <= qr) {
        return t[node];
    }
    if (qr <= nl || nr <= ql) {
        return -inf;
    }
    int nm = (nl + nr) / 2;
    return max(get(ql, qr, node * 2, nl, nm), get(ql, qr, node * 2 + 1, nm, nr));
}

void change(int pos, int val) {
    pos += R;
    t[pos] = val;
    for (pos /= 2; pos > 0; pos /= 2) {
        t[pos] = max(t[pos * 2], t[pos * 2 + 1]);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<int> l(n, -1), st;
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && h[st.back()] > h[i]) {
            l[st.back()] = i;
            st.pop_back();
        }
        st.pb(i);
    }
    vector<int> dp(n + 1);
    for (int i = 0; i < n; ++i) {
        dp[i + 1] = get(l[i] + 1, i + 1) + b[i];
        if (l[i] != -1) {
            dp[i + 1] = max(dp[i + 1], dp[l[i] + 1]);
        }
        change(i + 1, dp[i + 1]);
    }
    cout << dp[n];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}