#include <bits/stdc++.h>
#include <immintrin.h>

using namespace std;

void IO(){
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

template <typename T, typename D>
istream& operator>>(istream& in, pair<T, D>& a) {
    in >> a.first >> a.second;
    return in;
}

template <typename T, typename D>
ostream& operator<<(ostream& out, const pair<T, D>& a) {
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}


typedef long long ll;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define sz(x) ((int)x.size())
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>
#define ti tuple<int,int,int>
#define mod(x, m) ((x % m + m) % m)
#define eb emplace_back
#define maxq(a, b) a = max(a, (b))
#define minq(a, b) a = min(a, (b))

const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const long double PI = acos(-1);
auto seed = time(NULL);
mt19937 rnd(seed);

#define int ll

const int MAXN = 3e5 + 15;

int t[4 * MAXN];

void Update(int v, int vl, int vr, int pos, int val) {
    maxq(t[v], val);
    if (vl == vr) {
        return;
    }
    int vm = vl + (vr - vl) / 2;
    if (pos <= vm) {
        Update(2 * v + 1, vl, vm, pos, val);
    } else {
        Update(2 * v + 2, vm + 1, vr, pos, val);
    }
}

int Get(int v, int vl, int vr, int l, int r) {
    if (vr < l || vl > r) {
        return nINFL;
    }
    if (vl >= l && vr <= r) {
        return t[v];
    }
    int vm = vl + (vr - vl) / 2;
    return max(Get(2 * v + 1, vl, vm, l, r), Get(2 * v + 2, vm + 1, vr, l, r));
}

void Solve() {
    memset(t, 128, sizeof(t));
    int n;
    cin >> n;
    vi h(n), b(n);
    cin >> h >> b;
    vi dp(n);
    vi k;
    vi val;
    multiset <int> q;
    forn(i, n) {
        while(!k.empty() && h[k.back()] > h[i]) {
            q.erase(q.find(val.back()));
            val.pop_back();
            k.pop_back();
        }
        int l = 0;
        if (!k.empty()) {
            l = k.back() + 1;
        }
        k.eb(i);
        int now = 0;
        if (i >= max(l, 1ll)) {
            now = Get(0, 0, n - 1, max(l, 1ll), i);
        }
        if (l == 0) {
            maxq(now, 0ll);
        }
        val.eb(b[i] + now);
        q.insert(val.back());
        dp[i] = *prev(q.end());
        if (i != n - 1) {
            Update(0, 0, n - 1, i + 1, dp[i]);
        }
    }
    cout << dp[n - 1];
}

signed main() {
    int start = clock();
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
#ifdef DIVAN
    cout << '\n' << "Time: " << (clock() - start + 999) / 1000 << '\n';
#endif
}
