// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast,unroll-all-loops")
#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define pb push_back
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define all(a) a.begin(), a.end()
#define mp make_pair

using namespace std;

const int max_n = 3e5 + 5;
const int inf = 1e9;
const int log_n = 21;

struct node{
    int mx = 0;
    int add = 0;
};

struct ST {
    vector<node> t;

    ST() {
        t.resize(4 * max_n);
    }

    void push(int v) {
        int add = t[v].add;
        t[2 * v + 1].add += add;
        t[2 * v + 2].add += add;
        t[2 * v + 1].mx += add;
        t[2 * v + 2].mx += add;
        t[v].add = 0;
    }

    void update(int lq, int rq, int val, int v = 0, int vl = 0, int vr = max_n) {
        if (lq >= vr || vl >= rq) return;
        if (lq <= vl && vr <= rq) {
            t[v].add += val;
            t[v].mx += val;
            return;
        }
        push(v);
        int vm = (vl + vr) / 2;
        update(lq, rq, val, 2 * v + 1, vl, vm);
        update(lq, rq, val, 2 * v + 2, vm, vr);
        t[v].mx = max(t[2 * v + 1].mx, t[2 * v + 2].mx);
    }

    int get(int lq, int rq, int v = 0, int vl = 0, int vr = max_n) {
        if (lq >= vr || vl >= rq) return -inf;
        if (lq <= vl && vr <= rq) return t[v].mx;
        push(v);
        int vm = (vl + vr) / 2;
        return max(get(lq, rq, 2 * v + 1, vl, vm), get(lq, rq, 2 * v + 2, vm, vr));
    }
};

void run() {
    int n;
    cin >> n;
    vector<int> h(n + 1);
    vector<int> b(n + 1);
    h[0] = -inf;
    b[0] = 0;
    rep(i, n) {
        cin >> h[i + 1];
    }
    rep(i, n) {
        cin >> b[i + 1];
    }

    vector<int> dp(n + 1, -inf);
    dp[0] = 0;
    ST st;
    // st.update(0, 1, 0);
    vector<int> stack;
    stack.pb(0);
    // multiset<int> q;
    // int mn = inf;
    // int id = -1;
    rep(i, n + 1) {
        if (i == 0) continue;
        // int it = i - 1;
        // if (h[i] < mn) {
        //     mn = h[i];
        //     id = i;
        // }
        // int last = i;
        // rep(j, i) {
        //     cerr << st.get(j, j + 1) << ' ';
        // }
        // cerr << '\n';
        // bool ok = 1;
        while (!stack.empty() && h[stack.back()] >= h[i]) {
            // ok = 0;
            // q.erase(q.find(dp[stack.back()] + b[stack.back()]));
            int cur = stack.back();
            stack.pop_back();
            int prev = -1;
            if (stack.size() > 0) prev = stack.back();
            st.update(prev, cur, -b[cur] + b[i]);
        }
        st.update(i - 1, i, b[i]);
        // int last = stack.back();
        stack.pb(i);
        // q.insert(dp[i - 1] + b[it]);
        // dp[i] = b[id];
        dp[i] = max(dp[i], st.get(0, i));
        st.update(i, i + 1, dp[i]);
        // if (q.size() > 0) dp[i] = max(dp[i], *(--q.end()));
    }
    cout << dp[n] << '\n';
}

signed main() {
    #ifndef ONLINE_JUDGE
        // files("input.txt", "output.txt");
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        run();
    }
    return 0;
}