#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 3e5 + 7;

int dp[MAXN];

int t[4 * MAXN];

const int INF = 1e18 + 118;

void update(int v, int tl, int tr, int pos, int val)
{
    if (pos >= tr || tl >= pos + 1)
    {
        return;
    }
    if (pos <= tl && tr <= pos + 1)
    {
        t[v] = val;
        return;
    }
    update(2 * v + 1, tl, (tl + tr) / 2, pos, val);
    update(2 * v + 2, (tl + tr) / 2, tr, pos, val);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    return;
}

int get(int v, int tl, int tr, int l, int r)
{
    if (l >= tr || tl >= r)
    {
        return -INF;
    }
    if (l <= tl && tr <= r)
    {
        return t[v];
    }
    int ans1 = get(2 * v + 1, tl, (tl + tr) / 2, l, r);
    int ans2 = get(2 * v + 2, (tl + tr) / 2, tr, l, r);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    return max(ans1, ans2);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
    }
    vector<int> num(n);
    num[0] = 0;
    vector<int> q = {0};
    for (int i = 1; i < n; ++i)
    {
        while (!q.empty() && a[i] < a[q.back()])
        {
            q.pop_back();
        }
        if (q.empty())
        {
            num[i] = 0;
        }
        else
        {
            num[i] = q.back() + 1;
        }
        q.push_back(i);
    }
    dp[0] = 0;
    for (int i = 0; i < n; ++i)
    {
        dp[i + 1] = -INF;
        if (num[i] > 0)
        {
            dp[i + 1] = dp[num[i]];
        }
        dp[i + 1] = max(dp[i + 1], get(0, 0, MAXN, num[i], i + 1) + b[i]);
        update(0, 0, MAXN, i + 1, dp[i + 1]);
    }
    cout << dp[n] << endl;
    return 0;
}

