#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define f first
#define s second
#define pb push_back

using namespace std;

typedef long long ll;

const ll oo = 1e18;
const ll N = 3e5 + 10;
ll v[N * 4];

void Make_Tree(ll l, ll r, ll cnt)
{
    v[cnt] = -oo;
    if (l == r) return;
    ll mdl = (l + r) >> 1;
    Make_Tree(l, mdl, cnt * 2);
    Make_Tree(mdl + 1, r, cnt * 2 + 1);
}

void Insert(ll l, ll r, ll nom, ll val, ll cnt)
{
    if (l > nom || r < nom) return;
    v[cnt] = max(v[cnt], val);
    if (l == r) return;
    ll mdl = (l + r) >> 1;
    Insert(l, mdl, nom, val, cnt * 2);
    Insert(mdl + 1, r, nom, val, cnt * 2 + 1);
}

ll Find_Max(ll l, ll r, ll l1, ll r1, ll cnt)
{
    if (l1 > r1) return -oo;
    if (l == l1 && r == r1) return v[cnt];
    ll mdl = (l + r) >> 1;
    return max(Find_Max(l, mdl, l1, min(mdl, r1), cnt * 2), Find_Max(mdl + 1, r, max(mdl + 1, l1), r1, cnt * 2 + 1));
}

int main()
{
    ll n;
    cin >> n;
    ll h[n + 1];
    for (ll i = 1; i <= n; i++) cin >> h[i];
    ll a[n + 1];
    for (ll i = 1; i <= n; i++) cin >> a[i];


    Make_Tree(0, n, 1);
    ll dp[n + 1];
    Insert(0, n, 0, 0, 1);
    dp[0] = 0;
    h[0] = 0;

    stack <ll> ps;
    ps.push(0);
    for (ll i = 1; i <= n; i++)
    {
        while (h[ps.top()] >= h[i]) ps.pop();
        ll x = ps.top();
        ps.push(i);
        if (x == 0)
        {
            dp[i] = Find_Max(0, n, 0, i - 1, 1) + a[i];
        }
        else
        {
            dp[i] = max(Find_Max(0, n, x, i - 1, 1) + a[i], dp[x]);
        }
        Insert(0, n, i, dp[i], 1);
    }
    cout << dp[n];
}
