#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int mxN = 1e6 + 5;
const ll inf = 1e18;

int n, a[mxN], b[mxN], L[mxN], R[mxN];

ll t[mxN * 4], Mod[mxN * 4];

void Push(int v, int tl, int tr) {
	if (Mod[v] != -inf) {
		t[v] = max(t[v], Mod[v]);
		if (tl != tr) {
			Mod[v * 2] = max(Mod[v * 2], Mod[v]);
			Mod[v * 2 + 1] = max(Mod[v * 2 + 1], Mod[v]);
		}
		Mod[v] = -inf;
	}
}

void Upd(int l, int r, ll x, int v = 1, int tl = 1, int tr = n) {
	Push(v, tl, tr);
	if (tl > r || tr < l) return;
	if (l <= tl && tr <= r) {
		Mod[v] = max(Mod[v], x);
		Push(v, tl, tr);
		return;
	}
	int tm = (tl + tr) / 2;
	Upd(l, r, x, v * 2, tl, tm); Upd(l, r, x, v * 2 + 1, tm + 1, tr);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}

ll Get(int l, int r, int v = 1, int tl = 1, int tr = n) {
	Push(v, tl, tr);
	if (l > tr || r < tl) return -inf;
	if (l <= tl && tr <= r) return t[v];
	int tm = (tl + tr) / 2;
	ll left = Get(l, r, v * 2, tl, tm);  
	ll right = Get(l, r, v * 2 + 1, tm + 1, tr);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
	return max(left, right);
}

void Build(int v = 1, int tl = 1, int tr = n) {
	t[v] = Mod[v] = -inf;
	if (tl == tr) return;
	int tm = (tl + tr) / 2;
	Build(v * 2, tl, tm); Build(v * 2 + 1, tm + 1, tr);
}

int main() {
	ios :: sync_with_stdio(false), cin.tie(nullptr); 	
	cin >> n;
	for (int i = 1; i <= n; ++i) cin >> a[i];
	for (int i = 1; i <= n; ++i) cin >> b[i];
	Build();
	vector <int> vec;
	for (int i = 1; i <= n; ++i) {
		while (!vec.empty() && a[vec.back()] > a[i])
			vec.pop_back();
		if (vec.empty()) L[i] = 1;
		else L[i] = vec.back() + 1;
		vec.push_back(i);
	}
	vec.clear();
	for (int i = n; i >= 1; i--) {
		while (!vec.empty() && a[vec.back()] > a[i])
			vec.pop_back();
		if (vec.empty()) R[i] = n;
		else R[i] = vec.back() - 1;
		vec.push_back(i);
	}
	for (int i = 1; i <= n; ++i) cin >> b[i];
	for (int i = 1; i <= n; ++i) {
		//cout << L[i] << ' ' << R[i] << '\n';
		ll go = -inf;
		if (L[i] == 1) go = 0;
		go = max(go, Get(L[i] - 1, i - 1));
		Upd(i, R[i], go + b[i]);
	}
	cout << Get(n, n);
	return 0;
}