#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <iomanip>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e16 + 10;
const int MOD = (int)1e9 + 7;

void solve() {

	int n, m;
	cin >> n >> m;
	vector<vii> a(n);
	vvi d(n, vi(n, INF));
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u; --v;
		d[u][v] = d[v][u] = w;
		a[u].push_back({ v, w });
		a[v].push_back({ u, w });
	}
	for (int i = 0; i < n; ++i)
		d[i][i] = 0;
	for (int k = 0; k < n; ++k) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
			}
		}
	}
	vvi c(n, vi(n, 0));
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int u, v, l;
		cin >> u >> v >> l;
		--u; --v;
		c[u][v] = c[v][u] = l;
	}
	vector<vc> ans(n);
	for (int i = 0; i < n; ++i)
		ans[i].resize(a[i].size());

	for (int y = 0; y < n; ++y) {
		for (int u = 0; u < n; ++u) {
			int mx = 0;
			for (int v = 0; v < n; ++v)
				mx = max(mx, c[u][v] - d[y][v]);
			for (int i = 0; i < a[y].size(); ++i) {
				int x = a[y][i].first, w = a[y][i].second;
				if (d[u][x] + w <= mx)
					ans[y][i] = 1;
			}
		}
	}

	int cnt = 0;
	for (int i = 0; i < n; ++i)
		for (auto x : ans[i])
			if (x)
				++cnt;
	cout << cnt / 2;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}