#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
using namespace std;


#define ll long long
#define ull unsigned long long
#define pii pair<int,int>
#define pll pair<long long, long long>
#define pb push_back
#define ppb pop_back
#define cntbit(x) __builtin_popcount(x)
#define mp make_pair
#define f first
#define se second
#define endl '\n'

//typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template <typename T> void Min(T &a, T b) {
	a = min(a, b);
}

template <typename T> void Max(T &a, T b) {
	a = max(a, b);
}

#define int long long

const ll INF = 1e18;
const int mod = 998244353;
const int inf = 0x3f3f3f3f;
const int N = 6e2 + 15;
int n, m, q;
int d[N][N];
int g[N][N];
int mx[N][N];

struct edge {
	int u, v, w;
} e[N * N];

main() {
	memset(g, 0x3f, sizeof(g));
	memset(d, 0x3f, sizeof(d));
	for(int i = 0; i < N; ++i)
		for(int j = 0; j < N; ++j)
			g[i][j] = d[i][j] = INF, mx[i][j] = -INF;
	ios_base::sync_with_stdio(0); cout.tie(0); cin.tie(0);
	cin >> n >> m;
	for(int i = 1; i <= m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		Min(g[u][v], w);
		Min(g[v][u], w);
		e[i] = {u, v, w};
	}
	for(int i = 1; i <= n; ++i)
		g[i][i] = 0;
	memcpy(d, g, sizeof(d));
	for(int k = 1; k <= n; ++k)
		for(int i = 1; i <= n; ++i)
			for(int j = 1; j <= n; ++j)
				Min(d[i][j], d[i][k] + d[k][j]);
	cin >> q;
	for(int i = 1; i <= q; ++i) {
		int u, v, l;
		cin >> u >> v >> l;
		for(int x = 1; x <= n; ++x) {
			Max(mx[u][x], l - d[v][x]);
			Max(mx[v][x], l - d[u][x]);
		}
	}
	int ans = 0;
	for(int i = 1; i <= m; ++i) {
		int x = e[i].u, y = e[i].v, w = e[i].w;
		for(int v = 1; v <= n; ++v) {
			if(w + d[y][v] <= mx[v][x]) {
				++ans;
				break;
			}
		}
	}
	cout << ans << endl;
	return 0;
}