#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 610, INF = 1e18;
int d[MAXN][MAXN];
vector<array<int, 2>> g[MAXN];
vector<array<int, 2>> e[MAXN];

int used[MAXN][MAXN];

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            d[i][j] = INF;
        }
        d[i][i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        d[u][v] = d[v][u] = w;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    for (int k = 0; k < n; ++k) {
        for (int u = 0; u < n; ++u) {
            for (int v = 0; v < n; ++v) {
                if (d[u][k] == INF || d[k][v] == INF) {
                    continue;
                }
                d[u][v] = min(d[u][v], d[u][k] + d[k][v]);
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int u, v, l;
        cin >> u >> v >> l;
        u--; v--;
        e[u].push_back({v, l});
        e[v].push_back({u, l});
    }
    int cnt = 0;
    for (int v = 0; v < n; ++v) {
        for (int a = 0; a < n; ++a) {
            int val = -INF;
            for (auto elem : e[v]) {
                if (d[elem[0]][a] == INF) {
                    continue;
                }
                int cur = elem[1] - d[elem[0]][a];
                val = max(val, cur);
            }
            if (val == -INF) {
                continue;
            }
                for (auto el : g[a]) {
                if (d[el[0]][v] == INF) {
                    continue;
                }
                int z = el[1] + d[el[0]][v];
                if (z <= val) {
                    /// cout << a << " " << el[0] << endl;
                    used[a][el[0]] = used[el[0]][a] = 1;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            cnt += used[i][j];
        }
    }
    cout << cnt;
    return 0;
}
