#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define pii pair<int, int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define dist dist666
#define prev prev666
#define left left666
#define right right666
#define tm tm666

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18 + 10;
const int inf = 1e9 + 10, N = 600 + 10, P = 1e9 + 7, X = 2007;
const ld EPS = 1e-9;
int n, m, dist[N][N], val[N], q, g[N][N], cool[N][N];
vector<pair<int, int> > qr[N];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n ; i++) {
        for(int j = 0; j < n; j++) {
            if (i != j) {
                dist[i][j] = INF;
            }
        }
    }
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        dist[v][u] = w;
        dist[u][v] = w;
        g[v][u] = w;
        g[u][v] = w;
    }
    cin >> q;
    for (int i = 0; i < q; i++) {
        int v, u, l;
        cin >> v >> u >> l;
        v--;
        u--;
        qr[v].push_back({u, l});
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (dist[i][k] + dist[k][j] < dist[i][j]) {
                    dist[i][j] = dist[i][k] + dist[k][j];
                }
            }
        }
    }
    for (int v = 0; v < n; v++) {
        for (int y = 0; y < n; y++) {
            val[y] = -INF;
        }
        for (pair<int, int> p : qr[v]) {
            int u = p.first, l = p.second;
            for (int y = 0; y < n; y++) {
                if (dist[u][y] < INF) {
                    val[y] = max(val[y], l - dist[u][y]);
                }
            }
        }
        for (int x = 0; x < n; x++) {
            for (int y = 0; y < n; y++) {
                if (x != y && g[x][y] != 0) {
                    if (g[x][y] + dist[v][x] <= val[y]) {
                        cool[x][y] = 1;
                        cool[y][x] = 1;
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (cool[i][j]) {
                ans++;
            }
        }
    }
    cout << ans << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    //cout << setprecision(15) << fixed;
    solve();
    return 0;
}
