#include<bits/stdc++.h>
using namespace std;
#define X first
#define Y second
#define sz(a) (int)a.size()
#define ll long long

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector <vector <int> > wer(m);
    vector <bool> used(m);
    vector <pair <int, int> > g[n];
    for(int i = 0; i < m; i++)
    {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        wer[i] = {u, v, w};
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    int q;
    cin >> q;
    vector <pair <int, int> > adds[n];
    for(int i = 0; i < q; i++)
    {
        int u, v, w;
        cin >> u >>  v>> w;
        u--;
        v--;
        adds[u].push_back({v, w});
        adds[v].push_back({u, w});
    }
    vector <int> maxdist(n);
    int a, b, w1;
    vector <vector <int> > dist(n, vector <int> (n, 1e9 + 10));
    for(int i = 0; i < n; i++)
    {
        dist[i][i] = 0;
    }
    for(int i = 0; i < m; i++)
    {
        dist[wer[i][0]][wer[i][1]] = wer[i][2];
        dist[wer[i][1]][wer[i][0]] = wer[i][2];
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j <n; j++)
        {
            for(int k = 0; k < n; k++)
            {
                dist[j][k] = min(dist[j][k], dist[j][i] + dist[i][k]);
            }
        }
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            maxdist[j] = -1e9;
        }
        for(auto to : adds[i])
        {
            int gh = to.Y;
            maxdist[to.X] = max(maxdist[to.X], gh);
        }
        for(int j = 0; j < n; j++)
        {
            for(int t = 0; t < n; t++)
            {
                maxdist[t] = max(maxdist[t], maxdist[j] - dist[j][t]);
            }
        }
        for(int j = 0; j < m; j++)
        {
            a = wer[j][0];
            b = wer[j][1];
            w1 = wer[j][2];
            if(dist[i][a] + w1 <= maxdist[b] || maxdist[a] >= dist[i][b] + w1)
            {
                used[j] = 1;
            }
        }
    }
    int ans = 0;
    for(int i = 0; i < m; i++)
    {
        if(used[i])
        {
            ans++;
        }
    }
    cout << ans;
    return 0;
}
