#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
typedef long double ld;

using namespace std;

const int maxN = 605;
const int INFi = 2e9;
const ll INF = 1e18;
const int md = 1e9 + 7;

ll dist[maxN][maxN];
const int maxE = 605 * 605 + 1;
ll w[maxE];
bool good[maxE];
vector<pair<int, int>> g[maxN];
vector<pair<int, int>> from[maxN];

void solve() {
    int n, m; cin >> n >> m;
    range(i, n) range(j, n) dist[i][j] = INF;
    range(i, m) {
        int u, v; cin >> u >> v;
        u--; v--;
        cin >> w[i];
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
        dist[u][v] = dist[v][u] = w[i];
    }
    range(i, n) dist[i][i] = 0;
    int q; cin >> q;
    range(_, q) {
        int u, v, l; cin >> u >> v >> l;
        u--;
        v--;
        from[u].emplace_back(v, l);
    }
    range(k, n) {
        range(i, n) {
            range(j, n) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    int ans = 0;
    range(start, n) {
        vector<ll> mx(n, -INF);
        range(i, n) {
            for(auto &[ended, l] : from[start]) {
                mx[i] = max(mx[i], l - dist[i][ended]);
            }
        }
        range(v, n) {
            for(auto &[u, i] : g[v]) {
                if (good[i]) continue;
                if (dist[start][v] + w[i] <= mx[u]) {
                    good[i] = true;
                    ans++;
                }
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    //cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}