#include <bits/stdc++.h>


#pragma GCC optimize("Ofast")
// #pragma GCC target("avx2,avx")

typedef long long ll;
typedef long double ld;

using namespace std;

#define int ll
#define pii pair<int, int>
#define f first
#define s second
#define vi vector<int>
#define vp vector<pii>
#define pb push_back
mt19937 rnd(time(0));


const int maxn = 610;
vector<pii> r[maxn];

void solve() {
	int n, m;
	cin >> n >> m;
	vector<pii> e;
	for (int i = 0; i < m; ++i) {
		int a, b, w;
		cin >> a >> b >> w;
		a--;
		b--;
		e.pb({a, b});
		r[a].pb({b, w});
		r[b].pb({a, w});
	}
	
	auto dk = [&] (int v) {
		vector<int> d(n, 1e15);
		d[v] = 0;
		int used[n];
		memset(used, 0, sizeof(used));
		while (1) {
			int v = -1;
			for (int i = 0; i < n; ++i) {
				if (!used[i] && (v == -1 || d[i] < d[v])) {
					v = i;
				}
			}
			if (v == -1)
				break;
			used[v] = 1;
			for (auto &u : r[v]) {
				if (d[u.f] > d[v] + u.s) {
					// cout << d[u.f] << ' ' << d[v] << ' ' << u.s << '\n';
					d[u.f] = d[v] + u.s;
				}
			}
		}
		return d;
	};
	vi d[n];
	for (int i = 0; i < n; ++i) {
		d[i] = dk(i);
	}
	int q;
	cin >> q;
	struct qr {
		int u, v, l;
		qr(int u, int v, int l) : u(u), v(v), l(l) {}
	};
	vector<qr> qs;
	vector<qr> qs2[n];
	for (int i = 0; i < q; ++i) {
		int a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		qs2[a].pb({a, b, c});
		qs2[b].pb({b, a, c});
	}
	int dp[n][n];
	memset(dp, 0, sizeof(dp));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (auto &k : qs2[i]) {
				dp[i][j] = max(dp[i][j], k.l - d[k.v][j]);
			}
		}
	}
	
	int ok[n][n];
	memset(ok, 0, sizeof(ok));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (auto &u : r[i]) {
				if (d[i][j] + u.s <= dp[j][u.f]) {
					// cout << i << '? ' << j << ' ' << u.f << '\n';
					// cout << d[i][j] << ' ' << dp[j][u.f] << '\n';
					ok[i][u.f] |= 1;
				}
			}
		}
	}
	int ans = 0;
	for (auto &i : e) {
		ans += ok[i.f][i.s] || ok[i.s][i.f];
	}
	cout << ans << '\n';
	// exit(0);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	// freopen("input.txt", "r", stdin);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}