#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

const li INF = 1e18 + 13;
const int M = 1e9 + 7;
const int N = 600 + 13;

int g[N][N];
li d[N][N];
int l[N][N];

li mx[N][N];

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<pair<pii, int>> e;
    for(int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;

        v--;
        u--;

        g[v][u] = g[u][v] = w;
        e.emplace_back(make_pair(v, u), w);
    }

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            d[i][j] = (g[i][j] == 0 ? INF : g[i][j]);
        }
        d[i][i] = 0;
    }

    for(int k = 0; k < n; k++) {
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < n; j++) {
                d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
            }
        }
    }

    int q;
    cin >> q;

    for(int i = 0; i < q; i++) {
        int v, u, w;
        cin >> v >> u >> w;

        v--;
        u--;

        l[v][u] = l[u][v] = w;
    }


    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            mx[i][j] = -INF;
            for(int k = 0; k < n; k++) {
                mx[i][j] = max(mx[i][j], l[i][k] - d[j][k]);
            }
        }
    }

//    for(int i = 0; i < n; i++) {
//        for(int j = 0; j < n; j++)
//            cout << d[i][j] << ' ';
//        cout << endl;
//    }

    int ans = 0;
    for(auto p : e) {
        int v = p.f.f;
        int u = p.f.s;
        for(int i = 0; i < n; i++) {
            if(mx[i][u] - p.s - d[i][v] >= 0 || mx[i][v] - p.s - d[i][u] >= 0) {
                ans++;
//                cout << "good " << v << ' '<< u << endl;
                break;
            }
        }
    }

    cout << ans << endl;
}
