#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
template<typename T> void mdebug_out(T* a, int n) { for (int i = 0; i < n; ++i) cerr << a[i] << ' '; cerr << endl; }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a) { for (auto &x : a) stream << x << ' '; return stream; }
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2> &p) { return stream << p.first << ' ' << p.second; }

const ll INF64 = 1e18;
const int N = 605;
const int maxE = N * (N - 1) / 2;
int n, m, q;
struct Edge
{
    int u, v;
    ll w;
} edge[maxE];
ll D[N][N];
ll maxT[N][N];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    cin >> n >> m;
    for (int v = 0; v < n; ++v)
    {
        fill(D[v], D[v] + n, INF64);
        D[v][v] = 0;
    }
    for (int i = 0; i < m; ++i)
    {
        auto& e = edge[i];
        cin >> e.u >> e.v >> e.w;
        --e.u;
        --e.v;
        chkmin(D[e.u][e.v], e.w);
        chkmin(D[e.v][e.u], e.w);
    }
    for (int r = 0; r < n; ++r)
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                if (D[i][r] < INF64 && D[r][j] < INF64)
                    chkmin(D[i][j], D[i][r] + D[r][j]);
//    for (int i = 0; i < n; ++i)
//        mdebug(D[i], n);
    cin >> q;
    for (int v = 0; v < n; ++v)
        fill(maxT[v], maxT[v] + n, -INF64);
    for (int j = 0; j < q; ++j)
    {
        int u, v;
        ll l;
        cin >> u >> v >> l;
        --u;
        --v;
        for (int v2 = 0; v2 < n; ++v2)
        {
            if (D[v2][v] < INF64)
                chkmax(maxT[u][v2], l - D[v2][v]);
        }
    }
    int ans = 0;
    for (int i = 0; i < m; ++i)
    {
        auto &e = edge[i];
        for (int u = 0; u < n; ++u)
        {
            ll lhs = D[u][e.u] + e.w;
            if (lhs <= maxT[u][e.v])
            {
                ++ans;
                break;
            }
            lhs = D[u][e.v] + e.w;
            if (lhs <= maxT[u][e.u])
            {
                ++ans;
                break;
            }
        }
    }
    cout << ans << '\n';

    return 0;
}