#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 605;
const ll inf = 1e17;

vector<pair<ll, int>> g[N];

ll f[N][N], d[N][N], b[N];

int main(){
  ios_base :: sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  int n, m;
  cin >> n >> m;
  for(int i = 0; i < n; i ++)
    for(int j = 0; j < n; j ++)
      f[i][j] = 0,
      d[i][j] = inf;

  vector<pair<pair<int, int>, ll>> edges;
  for(int i = 0; i < m; i ++){
    int u, v; ll w;
    cin >> u >> v >> w;
    u --; v --;
    d[u][v] = min(d[u][v], w);
    d[v][u] = min(d[v][u], w);
    edges.push_back({{u, v}, w});
  }
  int q; cin >> q;
  while(q --){
    int u, v;
    ll len;
    cin >> u >> v >> len;
    u --; v --;
    f[u][v] = max(f[u][v], len);
    f[v][u] = max(f[v][u], len);
  }
  for(int k = 0; k < n; k ++)
    for(int i = 0; i < n; i ++)
      for(int j = 0; j < n; j ++)
        if(i != j) d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
  for(int k = 0; k < n; k ++){
    for(int i = 0; i < n; i ++){
      for(int j = 0; j < n; j ++){
        if(i != j && d[i][k] + d[k][j] <= f[i][j]){
          f[k][j] = max(f[k][j], f[i][j] - d[i][k]);
          f[i][k] = max(f[i][k], f[i][j] - d[k][j]);
        }
      }
    }
  }
  for(auto [x, y] : edges){
    if(f[x.first][x.second] >= y){
      b[x.first] = max(b[x.first], f[x.first][x.second] - y);
      b[x.second] = max(b[x.second], f[x.first][x.second] - y);
    }
  }
  int ans = 0;
  for(auto [x, y] : edges){
    if(f[x.first][x.second] >= y || b[x.first] >= 2LL * y || b[x.second] >= 2LL * y)
      ans ++;
  }
  cout << ans;

}
